/* Database.c generated by valac 0.56.17, the Vala compiler
 * generated from Database.vala, do not modify */

/*
 * Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_DATABASE_0_PROPERTY,
	SERVICES_DATABASE_NUM_PROPERTIES
};
static GParamSpec* services_database_properties[SERVICES_DATABASE_NUM_PROPERTIES];
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	SERVICES_DATABASE_OPENED_SIGNAL,
	SERVICES_DATABASE_RESET_SIGNAL,
	SERVICES_DATABASE_NUM_SIGNALS
};
static guint services_database_signals[SERVICES_DATABASE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ServicesDatabasePrivate {
	sqlite3* db;
	gchar* db_path;
	gchar* errormsg;
	gchar* sql;
	GeeHashMap* table_columns;
	JsonParser* parser;
};

static gint ServicesDatabase_private_offset;
static gpointer services_database_parent_class = NULL;
static ServicesDatabase* services_database__instance;
static ServicesDatabase* services_database__instance = NULL;

static void services_database_create_tables (ServicesDatabase* self);
static void services_database_create_triggers (ServicesDatabase* self);
static gboolean services_database_table_exists (ServicesDatabase* self,
                                         const gchar* table_name);
static gboolean services_database_table_columns_exists (ServicesDatabase* self,
                                                 const gchar* table,
                                                 GeeArrayList* columns);
static ObjectsSource* _services_database_fill_source (ServicesDatabase* self,
                                               sqlite3_stmt* stmt);
static gboolean services_database_get_parameter_bool (ServicesDatabase* self,
                                               sqlite3_stmt* stmt,
                                               gint col);
static void services_database_set_parameter_str (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          const gchar* val);
static void services_database_set_parameter_bool (ServicesDatabase* self,
                                           sqlite3_stmt* stmt,
                                           const gchar* par,
                                           gboolean val);
static void services_database_set_parameter_int (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          gint val);
static void services_database_set_parameter_int64 (ServicesDatabase* self,
                                            sqlite3_stmt* stmt,
                                            const gchar* par,
                                            gint64 val);
static GObject * services_database_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void services_database_finalize (GObject * obj);
static GType services_database_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
services_database_get_instance_private (ServicesDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesDatabase_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../core/Services/Database.vala"
	return self ? g_object_ref (self) : NULL;
#line 134 "Database.c"
}

ServicesDatabase*
services_database_get_default (void)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp2_;
	ServicesDatabase* _tmp3_;
	ServicesDatabase* result;
#line 35 "../core/Services/Database.vala"
	_tmp0_ = services_database__instance;
#line 35 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 148 "Database.c"
		ServicesDatabase* _tmp1_;
#line 36 "../core/Services/Database.vala"
		_tmp1_ = services_database_new ();
#line 36 "../core/Services/Database.vala"
		_g_object_unref0 (services_database__instance);
#line 36 "../core/Services/Database.vala"
		services_database__instance = _tmp1_;
#line 156 "Database.c"
	}
#line 39 "../core/Services/Database.vala"
	_tmp2_ = services_database__instance;
#line 39 "../core/Services/Database.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 39 "../core/Services/Database.vala"
	result = _tmp3_;
#line 39 "../core/Services/Database.vala"
	return result;
#line 166 "Database.c"
}

void
services_database_init_database (ServicesDatabase* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	sqlite3* _tmp3_ = NULL;
#line 170 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 171 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 171 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 171 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 171 "../core/Services/Database.vala"
	self->priv->db_path = _tmp1_;
#line 172 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db_path;
#line 172 "../core/Services/Database.vala"
	sqlite3_open (_tmp2_, &_tmp3_);
#line 172 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 172 "../core/Services/Database.vala"
	self->priv->db = _tmp3_;
#line 174 "../core/Services/Database.vala"
	services_database_create_tables (self);
#line 175 "../core/Services/Database.vala"
	services_database_create_triggers (self);
#line 176 "../core/Services/Database.vala"
	services_database_patch_database (self);
#line 177 "../core/Services/Database.vala"
	g_signal_emit (self, services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL], 0);
#line 202 "Database.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 231 "Database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 242 "Database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 248 "Database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 260 "Database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 264 "Database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 268 "Database.c"
}

static void
services_database_create_tables (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	gchar* _tmp12_;
	sqlite3* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gint _tmp16_;
	gchar* _tmp18_;
	sqlite3* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gint _tmp22_;
	gchar* _tmp24_;
	sqlite3* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	gint _tmp28_;
	gchar* _tmp30_;
	sqlite3* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gint _tmp34_;
	gchar* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_ = NULL;
	gint _tmp40_;
	gchar* _tmp42_;
	sqlite3* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_ = NULL;
	gint _tmp46_;
	gchar* _tmp48_;
	sqlite3* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_ = NULL;
	gint _tmp52_;
	gchar* _tmp54_;
	sqlite3* _tmp55_;
	const gchar* _tmp56_;
	gchar* _tmp57_ = NULL;
	gint _tmp58_;
	gchar* _tmp60_;
	sqlite3* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_ = NULL;
	gint _tmp64_;
#line 180 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 181 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Labels (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                color           TEXT,\n" \
"                item_order      INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_favorite     INTEGER,\n" \
"                backend_type    TEXT,\n" \
"                source_id       TEXT,\n" \
"                CONSTRAINT unique_label UNIQUE (name)\n" \
"            );\n" \
"        ");
#line 181 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 181 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 195 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 195 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 195 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 195 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 195 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 195 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 349 "Database.c"
		const gchar* _tmp5_;
#line 196 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 196 "../core/Services/Database.vala"
		g_warning ("Database.vala:196: %s", _tmp5_);
#line 355 "Database.c"
	}
#line 199 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Projects (\n" \
"                id                      TEXT PRIMARY KEY,\n" \
"                name                    TEXT NOT NULL,\n" \
"                color                   TEXT,\n" \
"                backend_type            TEXT,\n" \
"                inbox_project           INTEGER,\n" \
"                team_inbox              INTEGER,\n" \
"                child_order             INTEGER,\n" \
"                is_deleted              INTEGER,\n" \
"                is_archived             INTEGER,\n" \
"                is_favorite             INTEGER,\n" \
"                shared                  INTEGER,\n" \
"                view_style              TEXT,\n" \
"                sort_order              INTEGER,\n" \
"                parent_id               TEXT,\n" \
"                collapsed               INTEGER,\n" \
"                icon_style              TEXT,\n" \
"                emoji                   TEXT,\n" \
"                show_completed          INTEGER,\n" \
"                description             TEXT,\n" \
"                due_date                TEXT,\n" \
"                inbox_section_hidded    INTEGER,\n" \
"                sync_id                 TEXT,\n" \
"                source_id               TEXT\n" \
"            );\n" \
"        ");
#line 199 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 199 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 227 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 227 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 227 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 227 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 227 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 227 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 375 "Database.c"
		const gchar* _tmp11_;
#line 228 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 228 "../core/Services/Database.vala"
		g_warning ("Database.vala:228: %s", _tmp11_);
#line 381 "Database.c"
	}
#line 231 "../core/Services/Database.vala"
	_tmp12_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Sections (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                archived_at     TEXT,\n" \
"                added_at        TEXT,\n" \
"                project_id      TEXT,\n" \
"                section_order   INTEGER,\n" \
"                collapsed       INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_archived     INTEGER,\n" \
"                color           TEXT,\n" \
"                description     TEXT,\n" \
"                hidded          INTEGER,\n" \
"                FOREIGN KEY (project_id) REFERENCES Projects (id) ON D" \
"ELETE CASCADE\n" \
"            );\n" \
"        ");
#line 231 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 231 "../core/Services/Database.vala"
	self->priv->sql = _tmp12_;
#line 249 "../core/Services/Database.vala"
	_tmp13_ = self->priv->db;
#line 249 "../core/Services/Database.vala"
	_tmp14_ = self->priv->sql;
#line 249 "../core/Services/Database.vala"
	_tmp16_ = _sqlite3_exec (_tmp13_, _tmp14_, NULL, NULL, &_tmp15_);
#line 249 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 249 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp15_;
#line 249 "../core/Services/Database.vala"
	if (_tmp16_ != SQLITE_OK) {
#line 401 "Database.c"
		const gchar* _tmp17_;
#line 250 "../core/Services/Database.vala"
		_tmp17_ = self->priv->errormsg;
#line 250 "../core/Services/Database.vala"
		g_warning ("Database.vala:250: %s", _tmp17_);
#line 407 "Database.c"
	}
#line 253 "../core/Services/Database.vala"
	_tmp18_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Items (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                content             TEXT NOT NULL,\n" \
"                description         TEXT,\n" \
"                due                 TEXT,\n" \
"                added_at            TEXT,\n" \
"                completed_at        TEXT,\n" \
"                updated_at          TEXT,\n" \
"                section_id          TEXT,\n" \
"                project_id          TEXT,\n" \
"                parent_id           TEXT,\n" \
"                priority            INTEGER,\n" \
"                child_order         INTEGER,\n" \
"                checked             INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                day_order           INTEGER,\n" \
"                collapsed           INTEGER,\n" \
"                pinned              INTEGER,\n" \
"                labels              TEXT,\n" \
"                extra_data          TEXT,\n" \
"                item_type           TEXT\n" \
"            );\n" \
"        ");
#line 253 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 253 "../core/Services/Database.vala"
	self->priv->sql = _tmp18_;
#line 278 "../core/Services/Database.vala"
	_tmp19_ = self->priv->db;
#line 278 "../core/Services/Database.vala"
	_tmp20_ = self->priv->sql;
#line 278 "../core/Services/Database.vala"
	_tmp22_ = _sqlite3_exec (_tmp19_, _tmp20_, NULL, NULL, &_tmp21_);
#line 278 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 278 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp21_;
#line 278 "../core/Services/Database.vala"
	if (_tmp22_ != SQLITE_OK) {
#line 427 "Database.c"
		const gchar* _tmp23_;
#line 279 "../core/Services/Database.vala"
		_tmp23_ = self->priv->errormsg;
#line 279 "../core/Services/Database.vala"
		g_warning ("Database.vala:279: %s", _tmp23_);
#line 433 "Database.c"
	}
#line 282 "../core/Services/Database.vala"
	_tmp24_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Reminders (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                notify_uid          INTEGER,\n" \
"                item_id             TEXT,\n" \
"                service             TEXT,\n" \
"                type                TEXT,\n" \
"                due                 TEXT,\n" \
"                mm_offset           INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                FOREIGN KEY (item_id) REFERENCES Items (id) ON DELETE " \
"CASCADE\n" \
"            );\n" \
"        ");
#line 282 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 282 "../core/Services/Database.vala"
	self->priv->sql = _tmp24_;
#line 296 "../core/Services/Database.vala"
	_tmp25_ = self->priv->db;
#line 296 "../core/Services/Database.vala"
	_tmp26_ = self->priv->sql;
#line 296 "../core/Services/Database.vala"
	_tmp28_ = _sqlite3_exec (_tmp25_, _tmp26_, NULL, NULL, &_tmp27_);
#line 296 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 296 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp27_;
#line 296 "../core/Services/Database.vala"
	if (_tmp28_ != SQLITE_OK) {
#line 453 "Database.c"
		const gchar* _tmp29_;
#line 297 "../core/Services/Database.vala"
		_tmp29_ = self->priv->errormsg;
#line 297 "../core/Services/Database.vala"
		g_warning ("Database.vala:297: %s", _tmp29_);
#line 459 "Database.c"
	}
#line 300 "../core/Services/Database.vala"
	_tmp30_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Queue (\n" \
"                uuid       TEXT PRIMARY KEY,\n" \
"                object_id  TEXT,\n" \
"                query      TEXT,\n" \
"                temp_id    TEXT,\n" \
"                args       TEXT,\n" \
"                date_added TEXT\n" \
"            );\n" \
"        ");
#line 300 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 300 "../core/Services/Database.vala"
	self->priv->sql = _tmp30_;
#line 311 "../core/Services/Database.vala"
	_tmp31_ = self->priv->db;
#line 311 "../core/Services/Database.vala"
	_tmp32_ = self->priv->sql;
#line 311 "../core/Services/Database.vala"
	_tmp34_ = _sqlite3_exec (_tmp31_, _tmp32_, NULL, NULL, &_tmp33_);
#line 311 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 311 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp33_;
#line 311 "../core/Services/Database.vala"
	if (_tmp34_ != SQLITE_OK) {
#line 479 "Database.c"
		const gchar* _tmp35_;
#line 312 "../core/Services/Database.vala"
		_tmp35_ = self->priv->errormsg;
#line 312 "../core/Services/Database.vala"
		g_warning ("Database.vala:312: %s", _tmp35_);
#line 485 "Database.c"
	}
#line 315 "../core/Services/Database.vala"
	_tmp36_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS CurTempIds (\n" \
"                id          TEXT PRIMARY KEY,\n" \
"                temp_id     TEXT,\n" \
"                object      TEXT\n" \
"            );\n" \
"        ");
#line 315 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 315 "../core/Services/Database.vala"
	self->priv->sql = _tmp36_;
#line 323 "../core/Services/Database.vala"
	_tmp37_ = self->priv->db;
#line 323 "../core/Services/Database.vala"
	_tmp38_ = self->priv->sql;
#line 323 "../core/Services/Database.vala"
	_tmp40_ = _sqlite3_exec (_tmp37_, _tmp38_, NULL, NULL, &_tmp39_);
#line 323 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 323 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp39_;
#line 323 "../core/Services/Database.vala"
	if (_tmp40_ != SQLITE_OK) {
#line 505 "Database.c"
		const gchar* _tmp41_;
#line 324 "../core/Services/Database.vala"
		_tmp41_ = self->priv->errormsg;
#line 324 "../core/Services/Database.vala"
		g_warning ("Database.vala:324: %s", _tmp41_);
#line 511 "Database.c"
	}
#line 327 "../core/Services/Database.vala"
	_tmp42_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Attachments (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                item_id         TEXT,\n" \
"                file_type       TEXT,\n" \
"                file_name       TEXT,\n" \
"                file_size       TEXT,\n" \
"                file_path       TEXT,\n" \
"                FOREIGN KEY (item_id) REFERENCES Items (id) ON DELETE " \
"CASCADE\n" \
"            );\n" \
"        ");
#line 327 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 327 "../core/Services/Database.vala"
	self->priv->sql = _tmp42_;
#line 339 "../core/Services/Database.vala"
	_tmp43_ = self->priv->db;
#line 339 "../core/Services/Database.vala"
	_tmp44_ = self->priv->sql;
#line 339 "../core/Services/Database.vala"
	_tmp46_ = _sqlite3_exec (_tmp43_, _tmp44_, NULL, NULL, &_tmp45_);
#line 339 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 339 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp45_;
#line 339 "../core/Services/Database.vala"
	if (_tmp46_ != SQLITE_OK) {
#line 531 "Database.c"
		const gchar* _tmp47_;
#line 340 "../core/Services/Database.vala"
		_tmp47_ = self->priv->errormsg;
#line 340 "../core/Services/Database.vala"
		g_warning ("Database.vala:340: %s", _tmp47_);
#line 537 "Database.c"
	}
#line 343 "../core/Services/Database.vala"
	_tmp48_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS OEvents (\n" \
"                id                  INTEGER PRIMARY KEY AUTOINCREMENT," \
"\n" \
"                event_type          TEXT,\n" \
"                event_date          DATETIME DEFAULT (datetime('now','" \
"localtime')),\n" \
"                object_id           TEXT,\n" \
"                object_type         TEXT,\n" \
"                object_key          TEXT,\n" \
"                object_old_value    TEXT,\n" \
"                object_new_value    TEXT,\n" \
"                parent_item_id      TEXT,\n" \
"                parent_project_id   TEXT\n" \
"            );\n" \
"        ");
#line 343 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 343 "../core/Services/Database.vala"
	self->priv->sql = _tmp48_;
#line 358 "../core/Services/Database.vala"
	_tmp49_ = self->priv->db;
#line 358 "../core/Services/Database.vala"
	_tmp50_ = self->priv->sql;
#line 358 "../core/Services/Database.vala"
	_tmp52_ = _sqlite3_exec (_tmp49_, _tmp50_, NULL, NULL, &_tmp51_);
#line 358 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 358 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp51_;
#line 358 "../core/Services/Database.vala"
	if (_tmp52_ != SQLITE_OK) {
#line 557 "Database.c"
		const gchar* _tmp53_;
#line 359 "../core/Services/Database.vala"
		_tmp53_ = self->priv->errormsg;
#line 359 "../core/Services/Database.vala"
		g_warning ("Database.vala:359: %s", _tmp53_);
#line 563 "Database.c"
	}
#line 362 "../core/Services/Database.vala"
	_tmp54_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Sources (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                source_type         TEXT NOT NULL,\n" \
"                display_name        TEXT,\n" \
"                added_at            TEXT,\n" \
"                updated_at          TEXT,\n" \
"                is_visible          INTEGER,\n" \
"                child_order         INTEGER,\n" \
"                sync_server         INTEGER,\n" \
"                last_sync           TEXT,\n" \
"                data                TEXT\n" \
"            );\n" \
"        ");
#line 362 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 362 "../core/Services/Database.vala"
	self->priv->sql = _tmp54_;
#line 377 "../core/Services/Database.vala"
	_tmp55_ = self->priv->db;
#line 377 "../core/Services/Database.vala"
	_tmp56_ = self->priv->sql;
#line 377 "../core/Services/Database.vala"
	_tmp58_ = _sqlite3_exec (_tmp55_, _tmp56_, NULL, NULL, &_tmp57_);
#line 377 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 377 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp57_;
#line 377 "../core/Services/Database.vala"
	if (_tmp58_ != SQLITE_OK) {
#line 583 "Database.c"
		const gchar* _tmp59_;
#line 378 "../core/Services/Database.vala"
		_tmp59_ = self->priv->errormsg;
#line 378 "../core/Services/Database.vala"
		g_warning ("Database.vala:378: %s", _tmp59_);
#line 589 "Database.c"
	}
#line 381 "../core/Services/Database.vala"
	_tmp60_ = g_strdup ("PRAGMA foreign_keys = ON;");
#line 381 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 381 "../core/Services/Database.vala"
	self->priv->sql = _tmp60_;
#line 383 "../core/Services/Database.vala"
	_tmp61_ = self->priv->db;
#line 383 "../core/Services/Database.vala"
	_tmp62_ = self->priv->sql;
#line 383 "../core/Services/Database.vala"
	_tmp64_ = _sqlite3_exec (_tmp61_, _tmp62_, NULL, NULL, &_tmp63_);
#line 383 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 383 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp63_;
#line 383 "../core/Services/Database.vala"
	if (_tmp64_ != SQLITE_OK) {
#line 609 "Database.c"
		const gchar* _tmp65_;
#line 384 "../core/Services/Database.vala"
		_tmp65_ = self->priv->errormsg;
#line 384 "../core/Services/Database.vala"
		g_warning ("Database.vala:384: %s", _tmp65_);
#line 615 "Database.c"
	}
}

static void
services_database_create_triggers (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	gchar* _tmp12_;
	sqlite3* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gint _tmp16_;
	gchar* _tmp18_;
	sqlite3* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gint _tmp22_;
	gchar* _tmp24_;
	sqlite3* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	gint _tmp28_;
	gchar* _tmp30_;
	sqlite3* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gint _tmp34_;
	gchar* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_ = NULL;
	gint _tmp40_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	sqlite3* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_ = NULL;
	gint _tmp47_;
	gchar* _tmp49_;
	sqlite3* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_ = NULL;
	gint _tmp53_;
#line 388 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 389 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_insert_item\n" \
"            AFTER INSERT ON Items\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"insert\", NEW.id, \"item\", \"content\", NEW" \
".content,\n" \
"                    NEW.content, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 389 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 389 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 400 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 400 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 400 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 400 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 400 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 400 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 688 "Database.c"
		const gchar* _tmp5_;
#line 401 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 401 "../core/Services/Database.vala"
		g_warning ("Database.vala:401: %s", _tmp5_);
#line 694 "Database.c"
	}
#line 404 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_content_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.content != OLD.content\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"content\", OLD" \
".content,\n" \
"                    NEW.content, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 404 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 404 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 417 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 417 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 417 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 417 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 417 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 417 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 714 "Database.c"
		const gchar* _tmp11_;
#line 418 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 418 "../core/Services/Database.vala"
		g_warning ("Database.vala:418: %s", _tmp11_);
#line 720 "Database.c"
	}
#line 421 "../core/Services/Database.vala"
	_tmp12_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_description_item" \
"\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.description != OLD.description\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"description\"," \
" OLD.description,\n" \
"                    NEW.description, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 421 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 421 "../core/Services/Database.vala"
	self->priv->sql = _tmp12_;
#line 434 "../core/Services/Database.vala"
	_tmp13_ = self->priv->db;
#line 434 "../core/Services/Database.vala"
	_tmp14_ = self->priv->sql;
#line 434 "../core/Services/Database.vala"
	_tmp16_ = _sqlite3_exec (_tmp13_, _tmp14_, NULL, NULL, &_tmp15_);
#line 434 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 434 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp15_;
#line 434 "../core/Services/Database.vala"
	if (_tmp16_ != SQLITE_OK) {
#line 740 "Database.c"
		const gchar* _tmp17_;
#line 435 "../core/Services/Database.vala"
		_tmp17_ = self->priv->errormsg;
#line 435 "../core/Services/Database.vala"
		g_warning ("Database.vala:435: %s", _tmp17_);
#line 746 "Database.c"
	}
#line 438 "../core/Services/Database.vala"
	_tmp18_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_due_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.due != OLD.due\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"due\", OLD.due" \
",\n" \
"                    NEW.due, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 438 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 438 "../core/Services/Database.vala"
	self->priv->sql = _tmp18_;
#line 451 "../core/Services/Database.vala"
	_tmp19_ = self->priv->db;
#line 451 "../core/Services/Database.vala"
	_tmp20_ = self->priv->sql;
#line 451 "../core/Services/Database.vala"
	_tmp22_ = _sqlite3_exec (_tmp19_, _tmp20_, NULL, NULL, &_tmp21_);
#line 451 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 451 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp21_;
#line 451 "../core/Services/Database.vala"
	if (_tmp22_ != SQLITE_OK) {
#line 766 "Database.c"
		const gchar* _tmp23_;
#line 452 "../core/Services/Database.vala"
		_tmp23_ = self->priv->errormsg;
#line 452 "../core/Services/Database.vala"
		g_warning ("Database.vala:452: %s", _tmp23_);
#line 772 "Database.c"
	}
#line 455 "../core/Services/Database.vala"
	_tmp24_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_priority_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.priority != OLD.priority\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"priority\", OL" \
"D.priority,\n" \
"                    NEW.priority, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 455 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 455 "../core/Services/Database.vala"
	self->priv->sql = _tmp24_;
#line 468 "../core/Services/Database.vala"
	_tmp25_ = self->priv->db;
#line 468 "../core/Services/Database.vala"
	_tmp26_ = self->priv->sql;
#line 468 "../core/Services/Database.vala"
	_tmp28_ = _sqlite3_exec (_tmp25_, _tmp26_, NULL, NULL, &_tmp27_);
#line 468 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 468 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp27_;
#line 468 "../core/Services/Database.vala"
	if (_tmp28_ != SQLITE_OK) {
#line 792 "Database.c"
		const gchar* _tmp29_;
#line 469 "../core/Services/Database.vala"
		_tmp29_ = self->priv->errormsg;
#line 469 "../core/Services/Database.vala"
		g_warning ("Database.vala:469: %s", _tmp29_);
#line 798 "Database.c"
	}
#line 472 "../core/Services/Database.vala"
	_tmp30_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_labels_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.labels != OLD.labels\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"labels\", OLD." \
"labels,\n" \
"                    NEW.labels, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 472 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 472 "../core/Services/Database.vala"
	self->priv->sql = _tmp30_;
#line 485 "../core/Services/Database.vala"
	_tmp31_ = self->priv->db;
#line 485 "../core/Services/Database.vala"
	_tmp32_ = self->priv->sql;
#line 485 "../core/Services/Database.vala"
	_tmp34_ = _sqlite3_exec (_tmp31_, _tmp32_, NULL, NULL, &_tmp33_);
#line 485 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 485 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp33_;
#line 485 "../core/Services/Database.vala"
	if (_tmp34_ != SQLITE_OK) {
#line 818 "Database.c"
		const gchar* _tmp35_;
#line 486 "../core/Services/Database.vala"
		_tmp35_ = self->priv->errormsg;
#line 486 "../core/Services/Database.vala"
		g_warning ("Database.vala:486: %s", _tmp35_);
#line 824 "Database.c"
	}
#line 489 "../core/Services/Database.vala"
	_tmp36_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_pinned_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.pinned != OLD.pinned\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"pinned\", OLD." \
"pinned,\n" \
"                    NEW.pinned, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 489 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 489 "../core/Services/Database.vala"
	self->priv->sql = _tmp36_;
#line 502 "../core/Services/Database.vala"
	_tmp37_ = self->priv->db;
#line 502 "../core/Services/Database.vala"
	_tmp38_ = self->priv->sql;
#line 502 "../core/Services/Database.vala"
	_tmp40_ = _sqlite3_exec (_tmp37_, _tmp38_, NULL, NULL, &_tmp39_);
#line 502 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 502 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp39_;
#line 502 "../core/Services/Database.vala"
	if (_tmp40_ != SQLITE_OK) {
#line 844 "Database.c"
		const gchar* _tmp41_;
#line 503 "../core/Services/Database.vala"
		_tmp41_ = self->priv->errormsg;
#line 503 "../core/Services/Database.vala"
		g_warning ("Database.vala:503: %s", _tmp41_);
#line 850 "Database.c"
	}
#line 506 "../core/Services/Database.vala"
	_tmp42_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_checked_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.checked != OLD.checked\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"checked\", OLD" \
".checked,\n" \
"                    NEW.checked, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 506 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 506 "../core/Services/Database.vala"
	self->priv->sql = _tmp42_;
#line 519 "../core/Services/Database.vala"
	_tmp43_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_section_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.section_id != OLD.section_id\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"section\", OLD" \
".section_id,\n" \
"                    NEW.section_id, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 519 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 519 "../core/Services/Database.vala"
	self->priv->sql = _tmp43_;
#line 532 "../core/Services/Database.vala"
	_tmp44_ = self->priv->db;
#line 532 "../core/Services/Database.vala"
	_tmp45_ = self->priv->sql;
#line 532 "../core/Services/Database.vala"
	_tmp47_ = _sqlite3_exec (_tmp44_, _tmp45_, NULL, NULL, &_tmp46_);
#line 532 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 532 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp46_;
#line 532 "../core/Services/Database.vala"
	if (_tmp47_ != SQLITE_OK) {
#line 876 "Database.c"
		const gchar* _tmp48_;
#line 533 "../core/Services/Database.vala"
		_tmp48_ = self->priv->errormsg;
#line 533 "../core/Services/Database.vala"
		g_warning ("Database.vala:533: %s", _tmp48_);
#line 882 "Database.c"
	}
#line 536 "../core/Services/Database.vala"
	_tmp49_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_project_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.project_id != OLD.project_id\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"project\", OLD" \
".project_id,\n" \
"                    NEW.project_id, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 536 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 536 "../core/Services/Database.vala"
	self->priv->sql = _tmp49_;
#line 549 "../core/Services/Database.vala"
	_tmp50_ = self->priv->db;
#line 549 "../core/Services/Database.vala"
	_tmp51_ = self->priv->sql;
#line 549 "../core/Services/Database.vala"
	_tmp53_ = _sqlite3_exec (_tmp50_, _tmp51_, NULL, NULL, &_tmp52_);
#line 549 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 549 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp52_;
#line 549 "../core/Services/Database.vala"
	if (_tmp53_ != SQLITE_OK) {
#line 902 "Database.c"
		const gchar* _tmp54_;
#line 550 "../core/Services/Database.vala"
		_tmp54_ = self->priv->errormsg;
#line 550 "../core/Services/Database.vala"
		g_warning ("Database.vala:550: %s", _tmp54_);
#line 908 "Database.c"
	}
}

void
services_database_patch_database (ServicesDatabase* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 554 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 560 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Items", "pinned", 0);
#line 567 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "show_completed", 0);
#line 574 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "description", "");
#line 583 "../core/Services/Database.vala"
	services_database_add_item_label_column (self);
#line 584 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "color", "blue");
#line 585 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "description", "");
#line 592 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Items", "extra_data", "");
#line 593 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Sections", "hidded", 0);
#line 594 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "inbox_section_hidded", 0);
#line 601 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "sync_id", "");
#line 608 "../core/Services/Database.vala"
	_tmp0_ = item_type_to_string (ITEM_TYPE_TASK);
#line 608 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 608 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Items", "item_type", _tmp1_);
#line 608 "../core/Services/Database.vala"
	_g_free0 (_tmp1_);
#line 615 "../core/Services/Database.vala"
	services_database_add_project_labels_source_id (self);
#line 949 "Database.c"
}

void
services_database_clear_database (ServicesDatabase* self)
{
	gchar* db_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* db_file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 618 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 619 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 619 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 619 "../core/Services/Database.vala"
	db_path = _tmp1_;
#line 620 "../core/Services/Database.vala"
	_tmp2_ = db_path;
#line 620 "../core/Services/Database.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 620 "../core/Services/Database.vala"
	db_file = _tmp3_;
#line 622 "../core/Services/Database.vala"
	_tmp4_ = db_file;
#line 622 "../core/Services/Database.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 981 "Database.c"
		{
			GFile* _tmp5_;
#line 624 "../core/Services/Database.vala"
			_tmp5_ = db_file;
#line 624 "../core/Services/Database.vala"
			g_file_delete (_tmp5_, NULL, &_inner_error0_);
#line 624 "../core/Services/Database.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 990 "Database.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 623 "../core/Services/Database.vala"
			err = _inner_error0_;
#line 623 "../core/Services/Database.vala"
			_inner_error0_ = NULL;
#line 626 "../core/Services/Database.vala"
			_tmp6_ = err;
#line 626 "../core/Services/Database.vala"
			_tmp7_ = _tmp6_->message;
#line 626 "../core/Services/Database.vala"
			g_warning ("Database.vala:626: %s", _tmp7_);
#line 623 "../core/Services/Database.vala"
			_g_error_free0 (err);
#line 1012 "Database.c"
		}
		__finally0:
#line 623 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "../core/Services/Database.vala"
			_g_object_unref0 (db_file);
#line 623 "../core/Services/Database.vala"
			_g_free0 (db_path);
#line 623 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 623 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 623 "../core/Services/Database.vala"
			return;
#line 1027 "Database.c"
		}
	}
#line 618 "../core/Services/Database.vala"
	_g_object_unref0 (db_file);
#line 618 "../core/Services/Database.vala"
	_g_free0 (db_path);
#line 1034 "Database.c"
}

gboolean
services_database_verify_integrity (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gchar** tables = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gint tables_length1;
	gint _tables_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gboolean result;
#line 631 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 635 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            PRAGMA integrity_check;\n        ");
#line 635 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 635 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 639 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 639 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 639 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 639 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 639 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 639 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 639 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 639 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 641 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 641 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) == SQLITE_ROW) {
#line 1094 "Database.c"
		sqlite3_stmt* _tmp8_;
		const gchar* _tmp9_;
#line 642 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 642 "../core/Services/Database.vala"
		_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 0);
#line 642 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp9_, "ok") != 0) {
#line 643 "../core/Services/Database.vala"
			result = FALSE;
#line 643 "../core/Services/Database.vala"
			_sqlite3_finalize0 (stmt);
#line 643 "../core/Services/Database.vala"
			return result;
#line 1109 "Database.c"
		}
	}
#line 648 "../core/Services/Database.vala"
	_tmp10_ = g_strdup ("Attachments");
#line 648 "../core/Services/Database.vala"
	_tmp11_ = g_strdup ("CurTempIds");
#line 648 "../core/Services/Database.vala"
	_tmp12_ = g_strdup ("Items");
#line 648 "../core/Services/Database.vala"
	_tmp13_ = g_strdup ("Labels");
#line 648 "../core/Services/Database.vala"
	_tmp14_ = g_strdup ("OEvents");
#line 648 "../core/Services/Database.vala"
	_tmp15_ = g_strdup ("Projects");
#line 648 "../core/Services/Database.vala"
	_tmp16_ = g_strdup ("Queue");
#line 648 "../core/Services/Database.vala"
	_tmp17_ = g_strdup ("Reminders");
#line 648 "../core/Services/Database.vala"
	_tmp18_ = g_strdup ("Sections");
#line 648 "../core/Services/Database.vala"
	_tmp19_ = g_strdup ("Sources");
#line 648 "../core/Services/Database.vala"
	_tmp20_ = g_new0 (gchar*, 10 + 1);
#line 648 "../core/Services/Database.vala"
	_tmp20_[0] = _tmp10_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[1] = _tmp11_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[2] = _tmp12_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[3] = _tmp13_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[4] = _tmp14_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[5] = _tmp15_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[6] = _tmp16_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[7] = _tmp17_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[8] = _tmp18_;
#line 648 "../core/Services/Database.vala"
	_tmp20_[9] = _tmp19_;
#line 648 "../core/Services/Database.vala"
	tables = _tmp20_;
#line 648 "../core/Services/Database.vala"
	tables_length1 = 10;
#line 648 "../core/Services/Database.vala"
	_tables_size_ = tables_length1;
#line 651 "../core/Services/Database.vala"
	_tmp21_ = tables;
#line 651 "../core/Services/Database.vala"
	_tmp21__length1 = tables_length1;
#line 1164 "Database.c"
	{
		gchar** table_name_collection = NULL;
		gint table_name_collection_length1 = 0;
		gint _table_name_collection_size_ = 0;
		gint table_name_it = 0;
#line 651 "../core/Services/Database.vala"
		table_name_collection = _tmp21_;
#line 651 "../core/Services/Database.vala"
		table_name_collection_length1 = _tmp21__length1;
#line 651 "../core/Services/Database.vala"
		for (table_name_it = 0; table_name_it < table_name_collection_length1; table_name_it = table_name_it + 1) {
#line 1176 "Database.c"
			gchar* _tmp22_;
			gchar* table_name = NULL;
#line 651 "../core/Services/Database.vala"
			_tmp22_ = g_strdup (table_name_collection[table_name_it]);
#line 651 "../core/Services/Database.vala"
			table_name = _tmp22_;
#line 1183 "Database.c"
			{
				const gchar* _tmp23_;
#line 652 "../core/Services/Database.vala"
				_tmp23_ = table_name;
#line 652 "../core/Services/Database.vala"
				if (!services_database_table_exists (self, _tmp23_)) {
#line 653 "../core/Services/Database.vala"
					result = FALSE;
#line 653 "../core/Services/Database.vala"
					_g_free0 (table_name);
#line 653 "../core/Services/Database.vala"
					tables = (_vala_array_free (tables, tables_length1, (GDestroyNotify) g_free), NULL);
#line 653 "../core/Services/Database.vala"
					_sqlite3_finalize0 (stmt);
#line 653 "../core/Services/Database.vala"
					return result;
#line 1200 "Database.c"
				}
#line 651 "../core/Services/Database.vala"
				_g_free0 (table_name);
#line 1204 "Database.c"
			}
		}
	}
	{
		GeeIterator* _table_it = NULL;
		GeeHashMap* _tmp24_;
		GeeSet* _tmp25_;
		GeeSet* _tmp26_;
		GeeSet* _tmp27_;
		GeeIterator* _tmp28_;
		GeeIterator* _tmp29_;
#line 658 "../core/Services/Database.vala"
		_tmp24_ = self->priv->table_columns;
#line 658 "../core/Services/Database.vala"
		_tmp25_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp24_);
#line 658 "../core/Services/Database.vala"
		_tmp26_ = _tmp25_;
#line 658 "../core/Services/Database.vala"
		_tmp27_ = _tmp26_;
#line 658 "../core/Services/Database.vala"
		_tmp28_ = gee_iterable_iterator ((GeeIterable*) _tmp27_);
#line 658 "../core/Services/Database.vala"
		_tmp29_ = _tmp28_;
#line 658 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp27_);
#line 658 "../core/Services/Database.vala"
		_table_it = _tmp29_;
#line 658 "../core/Services/Database.vala"
		while (TRUE) {
#line 1234 "Database.c"
			GeeIterator* _tmp30_;
			gchar* table = NULL;
			GeeIterator* _tmp31_;
			gpointer _tmp32_;
			const gchar* _tmp33_;
			GeeHashMap* _tmp34_;
			const gchar* _tmp35_;
			gpointer _tmp36_;
			GeeArrayList* _tmp37_;
			gboolean _tmp38_;
#line 658 "../core/Services/Database.vala"
			_tmp30_ = _table_it;
#line 658 "../core/Services/Database.vala"
			if (!gee_iterator_next (_tmp30_)) {
#line 658 "../core/Services/Database.vala"
				break;
#line 1251 "Database.c"
			}
#line 658 "../core/Services/Database.vala"
			_tmp31_ = _table_it;
#line 658 "../core/Services/Database.vala"
			_tmp32_ = gee_iterator_get (_tmp31_);
#line 658 "../core/Services/Database.vala"
			table = (gchar*) _tmp32_;
#line 659 "../core/Services/Database.vala"
			_tmp33_ = table;
#line 659 "../core/Services/Database.vala"
			_tmp34_ = self->priv->table_columns;
#line 659 "../core/Services/Database.vala"
			_tmp35_ = table;
#line 659 "../core/Services/Database.vala"
			_tmp36_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp34_, _tmp35_);
#line 659 "../core/Services/Database.vala"
			_tmp37_ = (GeeArrayList*) _tmp36_;
#line 659 "../core/Services/Database.vala"
			_tmp38_ = !services_database_table_columns_exists (self, _tmp33_, _tmp37_);
#line 659 "../core/Services/Database.vala"
			_g_object_unref0 (_tmp37_);
#line 659 "../core/Services/Database.vala"
			if (_tmp38_) {
#line 660 "../core/Services/Database.vala"
				result = FALSE;
#line 660 "../core/Services/Database.vala"
				_g_free0 (table);
#line 660 "../core/Services/Database.vala"
				_g_object_unref0 (_table_it);
#line 660 "../core/Services/Database.vala"
				tables = (_vala_array_free (tables, tables_length1, (GDestroyNotify) g_free), NULL);
#line 660 "../core/Services/Database.vala"
				_sqlite3_finalize0 (stmt);
#line 660 "../core/Services/Database.vala"
				return result;
#line 1287 "Database.c"
			}
#line 658 "../core/Services/Database.vala"
			_g_free0 (table);
#line 1291 "Database.c"
		}
#line 658 "../core/Services/Database.vala"
		_g_object_unref0 (_table_it);
#line 1295 "Database.c"
	}
#line 664 "../core/Services/Database.vala"
	result = TRUE;
#line 664 "../core/Services/Database.vala"
	tables = (_vala_array_free (tables, tables_length1, (GDestroyNotify) g_free), NULL);
#line 664 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 664 "../core/Services/Database.vala"
	return result;
#line 1305 "Database.c"
}

static gboolean
services_database_table_exists (ServicesDatabase* self,
                                const gchar* table_name)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	gboolean result;
#line 667 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 667 "../core/Services/Database.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 670 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            SELECT name FROM sqlite_master WHERE type='table' AND name" \
"='%s';\n" \
"        ", table_name);
#line 670 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 670 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 674 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 674 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 674 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 674 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 674 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 674 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 674 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 674 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 676 "../core/Services/Database.vala"
	result = sqlite3_step (stmt) == SQLITE_ROW;
#line 676 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 676 "../core/Services/Database.vala"
	return result;
#line 1353 "Database.c"
}

static gboolean
services_database_table_columns_exists (ServicesDatabase* self,
                                        const gchar* table,
                                        GeeArrayList* columns)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean result;
#line 679 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 679 "../core/Services/Database.vala"
	g_return_val_if_fail (table != NULL, FALSE);
#line 679 "../core/Services/Database.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 682 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n            PRAGMA table_info(%s);\n        ", table);
#line 682 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 682 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 686 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 686 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 686 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 686 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 686 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 686 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 686 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 686 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 688 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 688 "../core/Services/Database.vala"
	sqlite3_step (_tmp7_);
#line 690 "../core/Services/Database.vala"
	while (TRUE) {
#line 1405 "Database.c"
		sqlite3_stmt* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
#line 690 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 690 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 690 "../core/Services/Database.vala"
			break;
#line 1415 "Database.c"
		}
#line 691 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 691 "../core/Services/Database.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 1);
#line 691 "../core/Services/Database.vala"
		if (!gee_abstract_collection_contains ((GeeAbstractCollection*) columns, _tmp10_)) {
#line 1423 "Database.c"
			sqlite3_stmt* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 692 "../core/Services/Database.vala"
			_tmp11_ = stmt;
#line 692 "../core/Services/Database.vala"
			_tmp12_ = (const gchar*) sqlite3_column_text (_tmp11_, 1);
#line 692 "../core/Services/Database.vala"
			_tmp13_ = g_strdup_printf ("Falta: %s: %s\n", table, _tmp12_);
#line 692 "../core/Services/Database.vala"
			_tmp14_ = _tmp13_;
#line 692 "../core/Services/Database.vala"
			g_print ("%s", _tmp14_);
#line 692 "../core/Services/Database.vala"
			_g_free0 (_tmp14_);
#line 693 "../core/Services/Database.vala"
			result = FALSE;
#line 693 "../core/Services/Database.vala"
			_sqlite3_finalize0 (stmt);
#line 693 "../core/Services/Database.vala"
			return result;
#line 1446 "Database.c"
		}
	}
#line 697 "../core/Services/Database.vala"
	result = TRUE;
#line 697 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 697 "../core/Services/Database.vala"
	return result;
#line 1455 "Database.c"
}

GeeArrayList*
services_database_get_sources_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 704 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 705 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 705 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 709 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Sources ORDER BY child_order;\n        ");
#line 709 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 709 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 713 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 713 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 713 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 713 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 713 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 713 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 713 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 713 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 715 "../core/Services/Database.vala"
	while (TRUE) {
#line 1502 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsSource* _tmp11_;
		ObjectsSource* _tmp12_;
#line 715 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 715 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 715 "../core/Services/Database.vala"
			break;
#line 1514 "Database.c"
		}
#line 716 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 716 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 716 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_source (self, _tmp10_);
#line 716 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 716 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 716 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 1528 "Database.c"
	}
#line 719 "../core/Services/Database.vala"
	result = return_value;
#line 719 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 719 "../core/Services/Database.vala"
	return result;
#line 1536 "Database.c"
}

static ObjectsSource*
_services_database_fill_source (ServicesDatabase* self,
                                sqlite3_stmt* stmt)
{
	ObjectsSource* return_value = NULL;
	ObjectsSource* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	ObjectsSource* _tmp3_;
	const gchar* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	ObjectsSource* _tmp7_;
	const gchar* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	ObjectsSource* _tmp11_;
	ObjectsSource* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSource* _tmp14_;
	const gchar* _tmp15_;
	ObjectsSource* _tmp16_;
	SourceType _tmp17_;
	SourceType _tmp18_;
	ObjectsSource* result;
#line 722 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 722 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 723 "../core/Services/Database.vala"
	_tmp0_ = objects_source_new ();
#line 723 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 724 "../core/Services/Database.vala"
	_tmp1_ = return_value;
#line 724 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 724 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp1_, _tmp2_);
#line 725 "../core/Services/Database.vala"
	_tmp3_ = return_value;
#line 725 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 725 "../core/Services/Database.vala"
	objects_source_set_source_type (_tmp3_, source_type_parse (_tmp4_));
#line 726 "../core/Services/Database.vala"
	_tmp5_ = return_value;
#line 726 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 726 "../core/Services/Database.vala"
	objects_source_set_display_name (_tmp5_, _tmp6_);
#line 727 "../core/Services/Database.vala"
	_tmp7_ = return_value;
#line 727 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 727 "../core/Services/Database.vala"
	objects_source_set_added_at (_tmp7_, _tmp8_);
#line 728 "../core/Services/Database.vala"
	_tmp9_ = return_value;
#line 728 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 728 "../core/Services/Database.vala"
	objects_source_set_updated_at (_tmp9_, _tmp10_);
#line 729 "../core/Services/Database.vala"
	_tmp11_ = return_value;
#line 729 "../core/Services/Database.vala"
	objects_source_set_is_visible (_tmp11_, services_database_get_parameter_bool (self, stmt, 5));
#line 730 "../core/Services/Database.vala"
	_tmp12_ = return_value;
#line 730 "../core/Services/Database.vala"
	objects_source_set_child_order (_tmp12_, sqlite3_column_int (stmt, 6));
#line 731 "../core/Services/Database.vala"
	_tmp13_ = return_value;
#line 731 "../core/Services/Database.vala"
	objects_source_set_sync_server (_tmp13_, services_database_get_parameter_bool (self, stmt, 7));
#line 732 "../core/Services/Database.vala"
	_tmp14_ = return_value;
#line 732 "../core/Services/Database.vala"
	_tmp15_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 732 "../core/Services/Database.vala"
	objects_source_set_last_sync (_tmp14_, _tmp15_);
#line 734 "../core/Services/Database.vala"
	_tmp16_ = return_value;
#line 734 "../core/Services/Database.vala"
	_tmp17_ = objects_source_get_source_type (_tmp16_);
#line 734 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 734 "../core/Services/Database.vala"
	if (_tmp18_ == SOURCE_TYPE_TODOIST) {
#line 1628 "Database.c"
		ObjectsSource* _tmp19_;
		const gchar* _tmp20_;
		ObjectsSourceTodoistData* _tmp21_;
		ObjectsSourceTodoistData* _tmp22_;
#line 735 "../core/Services/Database.vala"
		_tmp19_ = return_value;
#line 735 "../core/Services/Database.vala"
		_tmp20_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 735 "../core/Services/Database.vala"
		_tmp21_ = objects_source_todoist_data_new_from_json (_tmp20_);
#line 735 "../core/Services/Database.vala"
		_tmp22_ = _tmp21_;
#line 735 "../core/Services/Database.vala"
		objects_source_set_data (_tmp19_, (ObjectsSourceData*) _tmp22_);
#line 735 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp22_);
#line 1645 "Database.c"
	} else {
		ObjectsSource* _tmp23_;
		SourceType _tmp24_;
		SourceType _tmp25_;
#line 736 "../core/Services/Database.vala"
		_tmp23_ = return_value;
#line 736 "../core/Services/Database.vala"
		_tmp24_ = objects_source_get_source_type (_tmp23_);
#line 736 "../core/Services/Database.vala"
		_tmp25_ = _tmp24_;
#line 736 "../core/Services/Database.vala"
		if (_tmp25_ == SOURCE_TYPE_CALDAV) {
#line 1658 "Database.c"
			ObjectsSource* _tmp26_;
			const gchar* _tmp27_;
			ObjectsSourceCalDAVData* _tmp28_;
			ObjectsSourceCalDAVData* _tmp29_;
#line 737 "../core/Services/Database.vala"
			_tmp26_ = return_value;
#line 737 "../core/Services/Database.vala"
			_tmp27_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 737 "../core/Services/Database.vala"
			_tmp28_ = objects_source_cal_dav_data_new_from_json (_tmp27_);
#line 737 "../core/Services/Database.vala"
			_tmp29_ = _tmp28_;
#line 737 "../core/Services/Database.vala"
			objects_source_set_data (_tmp26_, (ObjectsSourceData*) _tmp29_);
#line 737 "../core/Services/Database.vala"
			_g_object_unref0 (_tmp29_);
#line 1675 "Database.c"
		}
	}
#line 740 "../core/Services/Database.vala"
	result = return_value;
#line 740 "../core/Services/Database.vala"
	return result;
#line 1682 "Database.c"
}

gboolean
services_database_insert_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	SourceType _tmp11_;
	SourceType _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	ObjectsSourceData* _tmp37_;
	ObjectsSourceData* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	sqlite3_stmt* _tmp41_;
	sqlite3_stmt* _tmp45_;
	gboolean result;
#line 743 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 743 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 746 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Sources (id, source_type, display_na" \
"me, added_at,\n" \
"                updated_at, is_visible, child_order, sync_server, last" \
"_sync, data)\n" \
"            VALUES ($id, $source_type, $display_name, $added_at,\n" \
"                $updated_at, $is_visible, $child_order, $sync_server, " \
"$last_sync, $data);\n" \
"        ");
#line 746 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 746 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 753 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 753 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 753 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 753 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 753 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 753 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 753 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 753 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 754 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 754 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 754 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 754 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 755 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 755 "../core/Services/Database.vala"
	_tmp11_ = objects_source_get_source_type (source);
#line 755 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 755 "../core/Services/Database.vala"
	_tmp13_ = source_type_to_string (_tmp12_);
#line 755 "../core/Services/Database.vala"
	_tmp14_ = _tmp13_;
#line 755 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$source_type", _tmp14_);
#line 755 "../core/Services/Database.vala"
	_g_free0 (_tmp14_);
#line 756 "../core/Services/Database.vala"
	_tmp15_ = stmt;
#line 756 "../core/Services/Database.vala"
	_tmp16_ = objects_source_get_display_name (source);
#line 756 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 756 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp15_, "$display_name", _tmp17_);
#line 757 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 757 "../core/Services/Database.vala"
	_tmp19_ = objects_source_get_added_at (source);
#line 757 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 757 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp18_, "$added_at", _tmp20_);
#line 758 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 758 "../core/Services/Database.vala"
	_tmp22_ = objects_source_get_updated_at (source);
#line 758 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 758 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp21_, "$updated_at", _tmp23_);
#line 759 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 759 "../core/Services/Database.vala"
	_tmp25_ = objects_source_get_is_visible (source);
#line 759 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 759 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$is_visible", _tmp26_);
#line 760 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 760 "../core/Services/Database.vala"
	_tmp28_ = objects_source_get_child_order (source);
#line 760 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 760 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp27_, "$child_order", _tmp29_);
#line 761 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 761 "../core/Services/Database.vala"
	_tmp31_ = objects_source_get_sync_server (source);
#line 761 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 761 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$sync_server", _tmp32_);
#line 762 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 762 "../core/Services/Database.vala"
	_tmp34_ = objects_source_get_last_sync (source);
#line 762 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 762 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp33_, "$last_sync", _tmp35_);
#line 763 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 763 "../core/Services/Database.vala"
	_tmp37_ = objects_source_get_data (source);
#line 763 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 763 "../core/Services/Database.vala"
	_tmp39_ = objects_source_data_to_json (_tmp38_);
#line 763 "../core/Services/Database.vala"
	_tmp40_ = _tmp39_;
#line 763 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp36_, "$data", _tmp40_);
#line 763 "../core/Services/Database.vala"
	_g_free0 (_tmp40_);
#line 765 "../core/Services/Database.vala"
	_tmp41_ = stmt;
#line 765 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp41_) != SQLITE_DONE) {
#line 1856 "Database.c"
		sqlite3* _tmp42_;
		sqlite3* _tmp43_;
		const gchar* _tmp44_;
#line 766 "../core/Services/Database.vala"
		_tmp42_ = self->priv->db;
#line 766 "../core/Services/Database.vala"
		_tmp43_ = self->priv->db;
#line 766 "../core/Services/Database.vala"
		_tmp44_ = sqlite3_errmsg (_tmp43_);
#line 766 "../core/Services/Database.vala"
		g_warning ("Database.vala:766: Error: %d: %s", sqlite3_errcode (_tmp42_), _tmp44_);
#line 1868 "Database.c"
	}
#line 769 "../core/Services/Database.vala"
	_tmp45_ = stmt;
#line 769 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp45_) == SQLITE_DONE;
#line 769 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 769 "../core/Services/Database.vala"
	return result;
#line 1878 "Database.c"
}

gboolean
services_database_delete_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 772 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 772 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 775 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Sources WHERE id=$id;\n        ");
#line 775 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 775 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 779 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 779 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 779 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 779 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 779 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 779 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 779 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 779 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 780 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 780 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 780 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 780 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 782 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 782 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 1937 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 783 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 783 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 783 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 783 "../core/Services/Database.vala"
		g_warning ("Database.vala:783: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 1949 "Database.c"
	}
#line 786 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 786 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 786 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 786 "../core/Services/Database.vala"
	return result;
#line 1959 "Database.c"
}

gboolean
services_database_update_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	SourceType _tmp8_;
	SourceType _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	sqlite3_stmt* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	ObjectsSourceData* _tmp31_;
	ObjectsSourceData* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	sqlite3_stmt* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	sqlite3_stmt* _tmp38_;
	sqlite3_stmt* _tmp42_;
	gboolean result;
#line 789 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 789 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 792 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sources SET\n" \
"                source_type=$source_type,\n" \
"                display_name=$display_name,\n" \
"                updated_at=$updated_at,\n" \
"                is_visible=$is_visible,\n" \
"                child_order=$child_order,\n" \
"                sync_server=$sync_server,\n" \
"                last_sync=$last_sync,\n" \
"                data=$data\n" \
"            WHERE id=$id;\n" \
"        ");
#line 792 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 792 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 805 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 805 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 805 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 805 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 805 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 805 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 805 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 805 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 806 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 806 "../core/Services/Database.vala"
	_tmp8_ = objects_source_get_source_type (source);
#line 806 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 806 "../core/Services/Database.vala"
	_tmp10_ = source_type_to_string (_tmp9_);
#line 806 "../core/Services/Database.vala"
	_tmp11_ = _tmp10_;
#line 806 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$source_type", _tmp11_);
#line 806 "../core/Services/Database.vala"
	_g_free0 (_tmp11_);
#line 807 "../core/Services/Database.vala"
	_tmp12_ = stmt;
#line 807 "../core/Services/Database.vala"
	_tmp13_ = objects_source_get_display_name (source);
#line 807 "../core/Services/Database.vala"
	_tmp14_ = _tmp13_;
#line 807 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp12_, "$display_name", _tmp14_);
#line 808 "../core/Services/Database.vala"
	_tmp15_ = stmt;
#line 808 "../core/Services/Database.vala"
	_tmp16_ = objects_source_get_updated_at (source);
#line 808 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 808 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp15_, "$updated_at", _tmp17_);
#line 809 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 809 "../core/Services/Database.vala"
	_tmp19_ = objects_source_get_is_visible (source);
#line 809 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 809 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp18_, "$is_visible", _tmp20_);
#line 810 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 810 "../core/Services/Database.vala"
	_tmp22_ = objects_source_get_child_order (source);
#line 810 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 810 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp21_, "$child_order", _tmp23_);
#line 811 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 811 "../core/Services/Database.vala"
	_tmp25_ = objects_source_get_sync_server (source);
#line 811 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 811 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$sync_server", _tmp26_);
#line 812 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 812 "../core/Services/Database.vala"
	_tmp28_ = objects_source_get_last_sync (source);
#line 812 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 812 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$last_sync", _tmp29_);
#line 813 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 813 "../core/Services/Database.vala"
	_tmp31_ = objects_source_get_data (source);
#line 813 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 813 "../core/Services/Database.vala"
	_tmp33_ = objects_source_data_to_json (_tmp32_);
#line 813 "../core/Services/Database.vala"
	_tmp34_ = _tmp33_;
#line 813 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$data", _tmp34_);
#line 813 "../core/Services/Database.vala"
	_g_free0 (_tmp34_);
#line 814 "../core/Services/Database.vala"
	_tmp35_ = stmt;
#line 814 "../core/Services/Database.vala"
	_tmp36_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 814 "../core/Services/Database.vala"
	_tmp37_ = _tmp36_;
#line 814 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp35_, "$id", _tmp37_);
#line 816 "../core/Services/Database.vala"
	_tmp38_ = stmt;
#line 816 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp38_) != SQLITE_DONE) {
#line 2122 "Database.c"
		sqlite3* _tmp39_;
		sqlite3* _tmp40_;
		const gchar* _tmp41_;
#line 817 "../core/Services/Database.vala"
		_tmp39_ = self->priv->db;
#line 817 "../core/Services/Database.vala"
		_tmp40_ = self->priv->db;
#line 817 "../core/Services/Database.vala"
		_tmp41_ = sqlite3_errmsg (_tmp40_);
#line 817 "../core/Services/Database.vala"
		g_warning ("Database.vala:817: Error: %d: %s", sqlite3_errcode (_tmp39_), _tmp41_);
#line 2134 "Database.c"
	}
#line 820 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 820 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp42_) == SQLITE_DONE;
#line 820 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 820 "../core/Services/Database.vala"
	return result;
#line 2144 "Database.c"
}

GeeArrayList*
services_database_get_projects_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 827 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 828 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 828 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 832 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT * FROM Projects WHERE is_deleted = 0 ORDER BY child" \
"_order;\n" \
"        ");
#line 832 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 832 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 836 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 836 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 836 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 836 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 836 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 836 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 836 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 836 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 838 "../core/Services/Database.vala"
	while (TRUE) {
#line 2191 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
#line 838 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 838 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 838 "../core/Services/Database.vala"
			break;
#line 2203 "Database.c"
		}
#line 839 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 839 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 839 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_project (self, _tmp10_);
#line 839 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 839 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 839 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 2217 "Database.c"
	}
#line 842 "../core/Services/Database.vala"
	result = return_value;
#line 842 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 842 "../core/Services/Database.vala"
	return result;
#line 2225 "Database.c"
}

ObjectsProject*
_services_database_fill_project (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsProject* return_value = NULL;
	ObjectsProject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	ObjectsProject* result;
#line 845 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 845 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 846 "../core/Services/Database.vala"
	_tmp0_ = objects_project_new ();
#line 846 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 847 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 847 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 848 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 848 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 849 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 849 "../core/Services/Database.vala"
	objects_project_set_color (return_value, _tmp3_);
#line 850 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 850 "../core/Services/Database.vala"
	objects_project_set_backend_type (return_value, source_type_parse (_tmp4_));
#line 851 "../core/Services/Database.vala"
	objects_project_set_inbox_project (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 852 "../core/Services/Database.vala"
	objects_project_set_team_inbox (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 853 "../core/Services/Database.vala"
	objects_project_set_child_order (return_value, sqlite3_column_int (stmt, 6));
#line 854 "../core/Services/Database.vala"
	objects_project_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 855 "../core/Services/Database.vala"
	objects_project_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 856 "../core/Services/Database.vala"
	objects_project_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 9));
#line 857 "../core/Services/Database.vala"
	objects_project_set_shared (return_value, services_database_get_parameter_bool (self, stmt, 10));
#line 858 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 11);
#line 858 "../core/Services/Database.vala"
	objects_project_set_view_style (return_value, project_view_style_parse (_tmp5_));
#line 859 "../core/Services/Database.vala"
	objects_project_set_sort_order (return_value, sqlite3_column_int (stmt, 12));
#line 860 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 13);
#line 860 "../core/Services/Database.vala"
	objects_project_set_parent_id (return_value, _tmp6_);
#line 861 "../core/Services/Database.vala"
	objects_project_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 14));
#line 862 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 15);
#line 862 "../core/Services/Database.vala"
	objects_project_set_icon_style (return_value, project_icon_style_parse (_tmp7_));
#line 863 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 16);
#line 863 "../core/Services/Database.vala"
	objects_project_set_emoji (return_value, _tmp8_);
#line 864 "../core/Services/Database.vala"
	objects_project_set_show_completed (return_value, services_database_get_parameter_bool (self, stmt, 17));
#line 865 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 865 "../core/Services/Database.vala"
	objects_project_set_description (return_value, _tmp9_);
#line 866 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 19);
#line 866 "../core/Services/Database.vala"
	objects_project_set_due_date (return_value, _tmp10_);
#line 867 "../core/Services/Database.vala"
	objects_project_set_inbox_section_hidded (return_value, services_database_get_parameter_bool (self, stmt, 20));
#line 868 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 21);
#line 868 "../core/Services/Database.vala"
	objects_project_set_sync_id (return_value, _tmp11_);
#line 869 "../core/Services/Database.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (stmt, 22);
#line 869 "../core/Services/Database.vala"
	objects_project_set_source_id (return_value, _tmp12_);
#line 870 "../core/Services/Database.vala"
	result = return_value;
#line 870 "../core/Services/Database.vala"
	return result;
#line 2329 "Database.c"
}

gboolean
services_database_insert_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	SourceType _tmp17_;
	SourceType _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	sqlite3_stmt* _tmp42_;
	ProjectViewStyle _tmp43_;
	ProjectViewStyle _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	sqlite3_stmt* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	sqlite3_stmt* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	sqlite3_stmt* _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	sqlite3_stmt* _tmp56_;
	ProjectIconStyle _tmp57_;
	ProjectIconStyle _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	sqlite3_stmt* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	sqlite3_stmt* _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	sqlite3_stmt* _tmp82_;
	sqlite3_stmt* _tmp86_;
	gboolean result;
#line 873 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 873 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 876 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Projects (id, name, color, backend_t" \
"ype, inbox_project,\n" \
"                team_inbox, child_order, is_deleted, is_archived, is_f" \
"avorite, shared, view_style,\n" \
"                sort_order, parent_id, collapsed, icon_style, emoji, s" \
"how_completed, description, due_date,\n" \
"                inbox_section_hidded, sync_id, source_id)\n" \
"            VALUES ($id, $name, $color, $backend_type, $inbox_project," \
" $team_inbox,\n" \
"                $child_order, $is_deleted, $is_archived, $is_favorite," \
" $shared, $view_style,\n" \
"                $sort_order, $parent_id, $collapsed, $icon_style, $emo" \
"ji, $show_completed, $description, $due_date,\n" \
"                $inbox_section_hidded, $sync_id, $source_id);\n" \
"        ");
#line 876 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 876 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 887 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 887 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 887 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 887 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 887 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 887 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 887 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 887 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 888 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 888 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 888 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 888 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 889 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 889 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 889 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 889 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 890 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 890 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_color (project);
#line 890 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 890 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 891 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 891 "../core/Services/Database.vala"
	_tmp17_ = objects_project_get_backend_type (project);
#line 891 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 891 "../core/Services/Database.vala"
	_tmp19_ = source_type_to_string (_tmp18_);
#line 891 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 891 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$backend_type", _tmp20_);
#line 891 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 892 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 892 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_inbox_project (project);
#line 892 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 892 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$inbox_project", _tmp23_);
#line 893 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 893 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_team_inbox (project);
#line 893 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 893 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$team_inbox", _tmp26_);
#line 894 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 894 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_child_order (project);
#line 894 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 894 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp27_, "$child_order", _tmp29_);
#line 895 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 895 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_deleted (project);
#line 895 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 895 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_deleted", _tmp32_);
#line 896 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 896 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_archived (project);
#line 896 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 896 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_archived", _tmp35_);
#line 897 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 897 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_is_favorite (project);
#line 897 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 897 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$is_favorite", _tmp38_);
#line 898 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 898 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_shared (project);
#line 898 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 898 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp39_, "$shared", _tmp41_);
#line 899 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 899 "../core/Services/Database.vala"
	_tmp43_ = objects_project_get_view_style (project);
#line 899 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 899 "../core/Services/Database.vala"
	_tmp45_ = project_view_style_to_string (_tmp44_);
#line 899 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 899 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp42_, "$view_style", _tmp46_);
#line 899 "../core/Services/Database.vala"
	_g_free0 (_tmp46_);
#line 900 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 900 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_sort_order (project);
#line 900 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 900 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp47_, "$sort_order", _tmp49_);
#line 901 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 901 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_parent_id (project);
#line 901 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 901 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp50_, "$parent_id", _tmp52_);
#line 902 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 902 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_collapsed (project);
#line 902 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 902 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp53_, "$collapsed", _tmp55_);
#line 903 "../core/Services/Database.vala"
	_tmp56_ = stmt;
#line 903 "../core/Services/Database.vala"
	_tmp57_ = objects_project_get_icon_style (project);
#line 903 "../core/Services/Database.vala"
	_tmp58_ = _tmp57_;
#line 903 "../core/Services/Database.vala"
	_tmp59_ = project_icon_style_to_string (_tmp58_);
#line 903 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 903 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp56_, "$icon_style", _tmp60_);
#line 903 "../core/Services/Database.vala"
	_g_free0 (_tmp60_);
#line 904 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 904 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_emoji (project);
#line 904 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 904 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$emoji", _tmp63_);
#line 905 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 905 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_show_completed (project);
#line 905 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 905 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp64_, "$show_completed", _tmp66_);
#line 906 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 906 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_description (project);
#line 906 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 906 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$description", _tmp69_);
#line 907 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 907 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_due_date (project);
#line 907 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 907 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp70_, "$due_date", _tmp72_);
#line 908 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 908 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_inbox_section_hidded (project);
#line 908 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 908 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp73_, "$inbox_section_hidded", _tmp75_);
#line 909 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 909 "../core/Services/Database.vala"
	_tmp77_ = objects_project_get_sync_id (project);
#line 909 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 909 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$sync_id", _tmp78_);
#line 910 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 910 "../core/Services/Database.vala"
	_tmp80_ = objects_project_get_source_id (project);
#line 910 "../core/Services/Database.vala"
	_tmp81_ = _tmp80_;
#line 910 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp79_, "$source_id", _tmp81_);
#line 912 "../core/Services/Database.vala"
	_tmp82_ = stmt;
#line 912 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp82_) != SQLITE_DONE) {
#line 2654 "Database.c"
		sqlite3* _tmp83_;
		sqlite3* _tmp84_;
		const gchar* _tmp85_;
#line 913 "../core/Services/Database.vala"
		_tmp83_ = self->priv->db;
#line 913 "../core/Services/Database.vala"
		_tmp84_ = self->priv->db;
#line 913 "../core/Services/Database.vala"
		_tmp85_ = sqlite3_errmsg (_tmp84_);
#line 913 "../core/Services/Database.vala"
		g_warning ("Database.vala:913: Error: %d: %s", sqlite3_errcode (_tmp83_), _tmp85_);
#line 2666 "Database.c"
	}
#line 916 "../core/Services/Database.vala"
	_tmp86_ = stmt;
#line 916 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp86_) == SQLITE_DONE;
#line 916 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 916 "../core/Services/Database.vala"
	return result;
#line 2676 "Database.c"
}

gboolean
services_database_delete_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 919 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 919 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 922 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Projects WHERE id=$id;\n        ");
#line 922 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 922 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 926 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 926 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 926 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 926 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 926 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 926 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 926 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 926 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 927 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 927 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 927 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 927 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 929 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 929 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 2735 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 930 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 930 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 930 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 930 "../core/Services/Database.vala"
		g_warning ("Database.vala:930: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 2747 "Database.c"
	}
#line 933 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 933 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 933 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 933 "../core/Services/Database.vala"
	return result;
#line 2757 "Database.c"
}

void
services_database_delete_project_db (ServicesDatabase* self,
                                     ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
#line 936 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 936 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 939 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            DELETE FROM Projects WHERE id=$id;\n" \
"            DELETE FROM Items WHERE project_id=$item_project_id;\n" \
"        ");
#line 939 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 939 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 944 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 944 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 944 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 944 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 944 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 944 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 944 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 944 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 945 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 945 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 945 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 945 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 946 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 946 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 946 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 946 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$section_project_id", _tmp12_);
#line 947 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 947 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 947 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 947 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$item_project_id", _tmp15_);
#line 949 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 949 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) != SQLITE_DONE) {
#line 2836 "Database.c"
		sqlite3* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 950 "../core/Services/Database.vala"
		_tmp17_ = self->priv->db;
#line 950 "../core/Services/Database.vala"
		_tmp18_ = self->priv->db;
#line 950 "../core/Services/Database.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 950 "../core/Services/Database.vala"
		g_warning ("Database.vala:950: Error: %d: %s", sqlite3_errcode (_tmp17_), _tmp19_);
#line 2848 "Database.c"
	}
#line 936 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2852 "Database.c"
}

gboolean
services_database_update_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	SourceType _tmp14_;
	SourceType _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	sqlite3_stmt* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	ProjectViewStyle _tmp40_;
	ProjectViewStyle _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	sqlite3_stmt* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	sqlite3_stmt* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	sqlite3_stmt* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	sqlite3_stmt* _tmp53_;
	ProjectIconStyle _tmp54_;
	ProjectIconStyle _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	sqlite3_stmt* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	sqlite3_stmt* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	sqlite3_stmt* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	sqlite3_stmt* _tmp82_;
	sqlite3_stmt* _tmp86_;
	gboolean result;
#line 954 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 954 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 957 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET\n" \
"                name=$name,\n" \
"                color=$color,\n" \
"                backend_type=$backend_type,\n" \
"                inbox_project=$inbox_project,\n" \
"                team_inbox=$team_inbox,\n" \
"                child_order=$child_order,\n" \
"                is_deleted=$is_deleted,\n" \
"                is_archived=$is_archived,\n" \
"                is_favorite=$is_favorite,\n" \
"                shared=$shared,\n" \
"                view_style=$view_style,\n" \
"                sort_order=$sort_order,\n" \
"                parent_id=$parent_id,\n" \
"                collapsed=$collapsed,\n" \
"                icon_style=$icon_style,\n" \
"                emoji=$emoji,\n" \
"                show_completed=$show_completed,\n" \
"                description=$description,\n" \
"                due_date=$due_date,\n" \
"                inbox_section_hidded=$inbox_section_hidded,\n" \
"                sync_id=$sync_id,\n" \
"                source_id=$source_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 957 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 957 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 984 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 984 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 984 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 984 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 984 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 984 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 984 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 984 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 985 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 985 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 985 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 985 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 986 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 986 "../core/Services/Database.vala"
	_tmp11_ = objects_project_get_color (project);
#line 986 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 986 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 987 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 987 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_backend_type (project);
#line 987 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 987 "../core/Services/Database.vala"
	_tmp16_ = source_type_to_string (_tmp15_);
#line 987 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 987 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$backend_type", _tmp17_);
#line 987 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 988 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 988 "../core/Services/Database.vala"
	_tmp19_ = objects_project_get_inbox_project (project);
#line 988 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 988 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp18_, "$inbox_project", _tmp20_);
#line 989 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 989 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_team_inbox (project);
#line 989 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 989 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$team_inbox", _tmp23_);
#line 990 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 990 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_child_order (project);
#line 990 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 990 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp24_, "$child_order", _tmp26_);
#line 991 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 991 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_is_deleted (project);
#line 991 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 991 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp27_, "$is_deleted", _tmp29_);
#line 992 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 992 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_archived (project);
#line 992 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 992 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_archived", _tmp32_);
#line 993 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 993 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_favorite (project);
#line 993 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 993 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_favorite", _tmp35_);
#line 994 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 994 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_shared (project);
#line 994 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 994 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$shared", _tmp38_);
#line 995 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 995 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_view_style (project);
#line 995 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 995 "../core/Services/Database.vala"
	_tmp42_ = project_view_style_to_string (_tmp41_);
#line 995 "../core/Services/Database.vala"
	_tmp43_ = _tmp42_;
#line 995 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp39_, "$view_style", _tmp43_);
#line 995 "../core/Services/Database.vala"
	_g_free0 (_tmp43_);
#line 996 "../core/Services/Database.vala"
	_tmp44_ = stmt;
#line 996 "../core/Services/Database.vala"
	_tmp45_ = objects_project_get_sort_order (project);
#line 996 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 996 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp44_, "$sort_order", _tmp46_);
#line 997 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 997 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_parent_id (project);
#line 997 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 997 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp47_, "$parent_id", _tmp49_);
#line 998 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 998 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_collapsed (project);
#line 998 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 998 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp50_, "$collapsed", _tmp52_);
#line 999 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 999 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_icon_style (project);
#line 999 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 999 "../core/Services/Database.vala"
	_tmp56_ = project_icon_style_to_string (_tmp55_);
#line 999 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 999 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp53_, "$icon_style", _tmp57_);
#line 999 "../core/Services/Database.vala"
	_g_free0 (_tmp57_);
#line 1000 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 1000 "../core/Services/Database.vala"
	_tmp59_ = objects_project_get_emoji (project);
#line 1000 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 1000 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp58_, "$emoji", _tmp60_);
#line 1001 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 1001 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_show_completed (project);
#line 1001 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 1001 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp61_, "$show_completed", _tmp63_);
#line 1002 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 1002 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_description (project);
#line 1002 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 1002 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp64_, "$description", _tmp66_);
#line 1003 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 1003 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_due_date (project);
#line 1003 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 1003 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$due_date", _tmp69_);
#line 1004 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 1004 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_inbox_section_hidded (project);
#line 1004 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 1004 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp70_, "$inbox_section_hidded", _tmp72_);
#line 1005 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 1005 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_sync_id (project);
#line 1005 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 1005 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp73_, "$sync_id", _tmp75_);
#line 1006 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 1006 "../core/Services/Database.vala"
	_tmp77_ = objects_project_get_source_id (project);
#line 1006 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 1006 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$source_id", _tmp78_);
#line 1007 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 1007 "../core/Services/Database.vala"
	_tmp80_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 1007 "../core/Services/Database.vala"
	_tmp81_ = _tmp80_;
#line 1007 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp79_, "$id", _tmp81_);
#line 1009 "../core/Services/Database.vala"
	_tmp82_ = stmt;
#line 1009 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp82_) != SQLITE_DONE) {
#line 3177 "Database.c"
		sqlite3* _tmp83_;
		sqlite3* _tmp84_;
		const gchar* _tmp85_;
#line 1010 "../core/Services/Database.vala"
		_tmp83_ = self->priv->db;
#line 1010 "../core/Services/Database.vala"
		_tmp84_ = self->priv->db;
#line 1010 "../core/Services/Database.vala"
		_tmp85_ = sqlite3_errmsg (_tmp84_);
#line 1010 "../core/Services/Database.vala"
		g_warning ("Database.vala:1010: Error: %d: %s", sqlite3_errcode (_tmp83_), _tmp85_);
#line 3189 "Database.c"
	}
#line 1013 "../core/Services/Database.vala"
	_tmp86_ = stmt;
#line 1013 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp86_) == SQLITE_DONE;
#line 1013 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1013 "../core/Services/Database.vala"
	return result;
#line 3199 "Database.c"
}

gboolean
services_database_archive_project (ServicesDatabase* self,
                                   ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1016 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 1019 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET is_archived=$is_archived WHERE id=$id;" \
"\n" \
"        ");
#line 1019 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1019 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1023 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1023 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1023 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1023 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1023 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1023 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1023 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1023 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1024 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1024 "../core/Services/Database.vala"
	_tmp8_ = objects_project_get_is_archived (project);
#line 1024 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1024 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$is_archived", _tmp9_);
#line 1025 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1025 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 1025 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1025 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1027 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1027 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 3269 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1028 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1028 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1028 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1028 "../core/Services/Database.vala"
		g_warning ("Database.vala:1028: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 3281 "Database.c"
	}
#line 1031 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1031 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1031 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1031 "../core/Services/Database.vala"
	return result;
#line 3291 "Database.c"
}

GeeArrayList*
services_database_get_labels_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1038 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1039 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1039 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1042 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Labels;\n        ");
#line 1042 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1042 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1046 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1046 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1046 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1046 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1046 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1046 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1046 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1046 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1048 "../core/Services/Database.vala"
	while (TRUE) {
#line 3338 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsLabel* _tmp11_;
		ObjectsLabel* _tmp12_;
#line 1048 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1048 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1048 "../core/Services/Database.vala"
			break;
#line 3350 "Database.c"
		}
#line 1049 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1049 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1049 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_label (self, _tmp10_);
#line 1049 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1049 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1049 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 3364 "Database.c"
	}
#line 1052 "../core/Services/Database.vala"
	result = return_value;
#line 1052 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1052 "../core/Services/Database.vala"
	return result;
#line 3372 "Database.c"
}

ObjectsLabel*
_services_database_fill_label (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsLabel* return_value = NULL;
	ObjectsLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ObjectsLabel* result;
#line 1055 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1055 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1056 "../core/Services/Database.vala"
	_tmp0_ = objects_label_new ();
#line 1056 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1057 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1057 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1058 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1058 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 1059 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1059 "../core/Services/Database.vala"
	objects_label_set_color (return_value, _tmp3_);
#line 1060 "../core/Services/Database.vala"
	objects_label_set_item_order (return_value, sqlite3_column_int (stmt, 3));
#line 1061 "../core/Services/Database.vala"
	objects_label_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 1062 "../core/Services/Database.vala"
	objects_label_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 1063 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 1063 "../core/Services/Database.vala"
	objects_label_set_backend_type (return_value, source_type_parse (_tmp4_));
#line 1064 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 1064 "../core/Services/Database.vala"
	objects_label_set_source_id (return_value, _tmp5_);
#line 1065 "../core/Services/Database.vala"
	result = return_value;
#line 1065 "../core/Services/Database.vala"
	return result;
#line 3425 "Database.c"
}

gboolean
services_database_insert_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	SourceType _tmp26_;
	SourceType _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	sqlite3_stmt* _tmp37_;
	gboolean result;
#line 1068 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1068 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 1071 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Labels (id, name, color, item_order," \
"\n" \
"                is_deleted, is_favorite, backend_type, source_id)\n" \
"            VALUES ($id, $name, $color, $item_order,\n" \
"                $is_deleted, $is_favorite, $backend_type, $source_id);" \
"\n" \
"        ");
#line 1071 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1071 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1078 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1078 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1078 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1078 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1078 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1078 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1078 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1078 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1079 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1079 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 1079 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1079 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1080 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1080 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 1080 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1080 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 1081 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1081 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_color (label);
#line 1081 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1081 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 1082 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1082 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_item_order (label);
#line 1082 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1082 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp16_, "$item_order", _tmp18_);
#line 1083 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1083 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_deleted (label);
#line 1083 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1083 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_deleted", _tmp21_);
#line 1084 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1084 "../core/Services/Database.vala"
	_tmp23_ = objects_label_get_is_favorite (label);
#line 1084 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1084 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$is_favorite", _tmp24_);
#line 1085 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1085 "../core/Services/Database.vala"
	_tmp26_ = objects_label_get_backend_type (label);
#line 1085 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1085 "../core/Services/Database.vala"
	_tmp28_ = source_type_to_string (_tmp27_);
#line 1085 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 1085 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$backend_type", _tmp29_);
#line 1085 "../core/Services/Database.vala"
	_g_free0 (_tmp29_);
#line 1086 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1086 "../core/Services/Database.vala"
	_tmp31_ = objects_label_get_source_id (label);
#line 1086 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 1086 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$source_id", _tmp32_);
#line 1088 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 1088 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp33_) != SQLITE_DONE) {
#line 3569 "Database.c"
		sqlite3* _tmp34_;
		sqlite3* _tmp35_;
		const gchar* _tmp36_;
#line 1089 "../core/Services/Database.vala"
		_tmp34_ = self->priv->db;
#line 1089 "../core/Services/Database.vala"
		_tmp35_ = self->priv->db;
#line 1089 "../core/Services/Database.vala"
		_tmp36_ = sqlite3_errmsg (_tmp35_);
#line 1089 "../core/Services/Database.vala"
		g_warning ("Database.vala:1089: Error: %d: %s", sqlite3_errcode (_tmp34_), _tmp36_);
#line 3581 "Database.c"
	}
#line 1092 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1092 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp37_) == SQLITE_DONE;
#line 1092 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1092 "../core/Services/Database.vala"
	return result;
#line 3591 "Database.c"
}

gboolean
services_database_delete_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1095 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1095 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 1098 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Labels WHERE id=$id;\n        ");
#line 1098 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1098 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1102 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1102 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1102 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1102 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1102 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1102 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1102 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1102 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1103 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1103 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 1103 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1103 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1105 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1105 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 3650 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1106 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1106 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1106 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1106 "../core/Services/Database.vala"
		g_warning ("Database.vala:1106: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 3662 "Database.c"
	}
#line 1109 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1109 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1109 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1109 "../core/Services/Database.vala"
	return result;
#line 3672 "Database.c"
}

gboolean
services_database_update_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp29_;
	gboolean result;
#line 1112 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1112 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 1115 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Labels SET name=$name, color=$color, item_order=$it" \
"em_order,\n" \
"                is_deleted=$is_deleted, is_favorite=$is_favorite\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1115 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1115 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1121 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1121 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1121 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1121 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1121 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1121 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1121 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1121 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1122 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1122 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 1122 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1122 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 1123 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1123 "../core/Services/Database.vala"
	_tmp11_ = objects_label_get_color (label);
#line 1123 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1123 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 1124 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1124 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_item_order (label);
#line 1124 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1124 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp13_, "$item_order", _tmp15_);
#line 1125 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1125 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_is_deleted (label);
#line 1125 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1125 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp16_, "$is_deleted", _tmp18_);
#line 1126 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1126 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_favorite (label);
#line 1126 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1126 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_favorite", _tmp21_);
#line 1127 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1127 "../core/Services/Database.vala"
	_tmp23_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 1127 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1127 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$id", _tmp24_);
#line 1129 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1129 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 3786 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1130 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1130 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1130 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1130 "../core/Services/Database.vala"
		g_warning ("Database.vala:1130: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 3798 "Database.c"
	}
#line 1133 "../core/Services/Database.vala"
	_tmp29_ = stmt;
#line 1133 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp29_) == SQLITE_DONE;
#line 1133 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1133 "../core/Services/Database.vala"
	return result;
#line 3808 "Database.c"
}

gboolean
services_database_insert_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp47_;
	gboolean result;
#line 1140 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1140 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1143 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Sections (id, name, archived_at, add" \
"ed_at, project_id, section_order,\n" \
"            collapsed, is_deleted, is_archived, color, description, hi" \
"dded)\n" \
"            VALUES ($id, $name, $archived_at, $added_at, $project_id, " \
"$section_order,\n" \
"            $collapsed, $is_deleted, $is_archived, $color, $descriptio" \
"n, $hidded);\n" \
"        ");
#line 1143 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1143 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1150 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1150 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1150 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1150 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1150 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1150 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1150 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1150 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1151 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1151 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1151 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1151 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1152 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1152 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 1152 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1152 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 1153 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1153 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_archived_at (section);
#line 1153 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1153 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$archived_at", _tmp15_);
#line 1154 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1154 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_added_at (section);
#line 1154 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1154 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$added_at", _tmp18_);
#line 1155 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1155 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_project_id (section);
#line 1155 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1155 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$project_id", _tmp21_);
#line 1156 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1156 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_section_order (section);
#line 1156 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1156 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp22_, "$section_order", _tmp24_);
#line 1157 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1157 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_collapsed (section);
#line 1157 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1157 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$collapsed", _tmp27_);
#line 1158 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1158 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_deleted (section);
#line 1158 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1158 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_deleted", _tmp30_);
#line 1159 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1159 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_is_archived (section);
#line 1159 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1159 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp31_, "$is_archived", _tmp33_);
#line 1160 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1160 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_color (section);
#line 1160 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1160 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$color", _tmp36_);
#line 1161 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1161 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_description (section);
#line 1161 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1161 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$description", _tmp39_);
#line 1162 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1162 "../core/Services/Database.vala"
	_tmp41_ = objects_section_get_hidded (section);
#line 1162 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1162 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp40_, "$hidded", _tmp42_);
#line 1164 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1164 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) != SQLITE_DONE) {
#line 3988 "Database.c"
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 1165 "../core/Services/Database.vala"
		_tmp44_ = self->priv->db;
#line 1165 "../core/Services/Database.vala"
		_tmp45_ = self->priv->db;
#line 1165 "../core/Services/Database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 1165 "../core/Services/Database.vala"
		g_warning ("Database.vala:1165: Error: %d: %s", sqlite3_errcode (_tmp44_), _tmp46_);
#line 4000 "Database.c"
	}
#line 1168 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 1168 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp47_) == SQLITE_DONE;
#line 1168 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1168 "../core/Services/Database.vala"
	return result;
#line 4010 "Database.c"
}

GeeArrayList*
services_database_get_sections_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1171 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1172 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1172 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1175 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Sections WHERE is_deleted = 0;");
#line 1175 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1175 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1177 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1177 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1177 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1177 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1177 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1177 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1177 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1177 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1179 "../core/Services/Database.vala"
	while (TRUE) {
#line 4057 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsSection* _tmp11_;
		ObjectsSection* _tmp12_;
#line 1179 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1179 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1179 "../core/Services/Database.vala"
			break;
#line 4069 "Database.c"
		}
#line 1180 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1180 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1180 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_section (self, _tmp10_);
#line 1180 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1180 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1180 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 4083 "Database.c"
	}
#line 1183 "../core/Services/Database.vala"
	result = return_value;
#line 1183 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1183 "../core/Services/Database.vala"
	return result;
#line 4091 "Database.c"
}

ObjectsSection*
_services_database_fill_section (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsSection* return_value = NULL;
	ObjectsSection* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	ObjectsSection* result;
#line 1186 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1186 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1187 "../core/Services/Database.vala"
	_tmp0_ = objects_section_new ();
#line 1187 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1188 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1188 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1189 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1189 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 1190 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1190 "../core/Services/Database.vala"
	objects_section_set_archived_at (return_value, _tmp3_);
#line 1191 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1191 "../core/Services/Database.vala"
	objects_section_set_added_at (return_value, _tmp4_);
#line 1192 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1192 "../core/Services/Database.vala"
	objects_section_set_project_id (return_value, _tmp5_);
#line 1193 "../core/Services/Database.vala"
	objects_section_set_section_order (return_value, sqlite3_column_int (stmt, 5));
#line 1194 "../core/Services/Database.vala"
	objects_section_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 6));
#line 1195 "../core/Services/Database.vala"
	objects_section_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 1196 "../core/Services/Database.vala"
	objects_section_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 1197 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1197 "../core/Services/Database.vala"
	objects_section_set_color (return_value, _tmp6_);
#line 1198 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 10);
#line 1198 "../core/Services/Database.vala"
	objects_section_set_description (return_value, _tmp7_);
#line 1199 "../core/Services/Database.vala"
	objects_section_set_hidded (return_value, services_database_get_parameter_bool (self, stmt, 11));
#line 1200 "../core/Services/Database.vala"
	result = return_value;
#line 1200 "../core/Services/Database.vala"
	return result;
#line 4158 "Database.c"
}

gboolean
services_database_delete_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1203 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1203 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1206 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Sections WHERE id=$id;\n        ");
#line 1206 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1206 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1210 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1210 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1210 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1210 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1210 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1210 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1210 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1210 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1211 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1211 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1211 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1211 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1213 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1213 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 4217 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1214 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1214 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1214 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1214 "../core/Services/Database.vala"
		g_warning ("Database.vala:1214: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 4229 "Database.c"
	}
#line 1217 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1217 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1217 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1217 "../core/Services/Database.vala"
	return result;
#line 4239 "Database.c"
}

gboolean
services_database_update_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp47_;
	gboolean result;
#line 1220 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1220 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1223 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET name=$name, archived_at=$archived_at, " \
"added_at=$added_at,\n" \
"                project_id=$project_id, section_order=$section_order, " \
"collapsed=$collapsed,\n" \
"                is_deleted=$is_deleted, is_archived=$is_archived, colo" \
"r=$color, description=$description,\n" \
"                hidded=$hidded\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1223 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1223 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1231 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1231 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1231 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1231 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1231 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1231 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1231 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1231 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1232 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1232 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 1232 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1232 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 1233 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1233 "../core/Services/Database.vala"
	_tmp11_ = objects_section_get_archived_at (section);
#line 1233 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1233 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$archived_at", _tmp12_);
#line 1234 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1234 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_added_at (section);
#line 1234 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1234 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$added_at", _tmp15_);
#line 1235 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1235 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_project_id (section);
#line 1235 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1235 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$project_id", _tmp18_);
#line 1236 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1236 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_section_order (section);
#line 1236 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1236 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp19_, "$section_order", _tmp21_);
#line 1237 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1237 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_collapsed (section);
#line 1237 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1237 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$collapsed", _tmp24_);
#line 1238 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1238 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_is_deleted (section);
#line 1238 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1238 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$is_deleted", _tmp27_);
#line 1239 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1239 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_archived (section);
#line 1239 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1239 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_archived", _tmp30_);
#line 1240 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1240 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_color (section);
#line 1240 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1240 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$color", _tmp33_);
#line 1241 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1241 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_description (section);
#line 1241 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1241 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$description", _tmp36_);
#line 1242 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1242 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_hidded (section);
#line 1242 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1242 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp37_, "$hidded", _tmp39_);
#line 1243 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1243 "../core/Services/Database.vala"
	_tmp41_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1243 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1243 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp40_, "$id", _tmp42_);
#line 1245 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1245 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) != SQLITE_DONE) {
#line 4419 "Database.c"
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 1246 "../core/Services/Database.vala"
		_tmp44_ = self->priv->db;
#line 1246 "../core/Services/Database.vala"
		_tmp45_ = self->priv->db;
#line 1246 "../core/Services/Database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 1246 "../core/Services/Database.vala"
		g_warning ("Database.vala:1246: Error: %d: %s", sqlite3_errcode (_tmp44_), _tmp46_);
#line 4431 "Database.c"
	}
#line 1249 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 1249 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp47_) == SQLITE_DONE;
#line 1249 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1249 "../core/Services/Database.vala"
	return result;
#line 4441 "Database.c"
}

gboolean
services_database_move_section (ServicesDatabase* self,
                                ObjectsSection* section,
                                const gchar* old_project_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1252 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1252 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1252 "../core/Services/Database.vala"
	g_return_val_if_fail (old_project_id != NULL, FALSE);
#line 1255 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET project_id=$project_id WHERE id=$id;\n" \
"        ");
#line 1255 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1255 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1259 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1259 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1259 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1259 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1259 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1259 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1259 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1259 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1260 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1260 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_project_id (section);
#line 1260 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1260 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$project_id", _tmp9_);
#line 1261 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1261 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1261 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1261 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1263 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1263 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4514 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1264 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1264 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1264 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1264 "../core/Services/Database.vala"
		g_warning ("Database.vala:1264: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4526 "Database.c"
	}
#line 1267 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1267 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1267 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1267 "../core/Services/Database.vala"
	return result;
#line 4536 "Database.c"
}

gboolean
services_database_move_section_items (ServicesDatabase* self,
                                      ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1270 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1270 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1273 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET project_id=$project_id WHERE section_id=$" \
"section_id;\n" \
"        ");
#line 1273 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1273 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1277 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1277 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1277 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1277 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1277 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1277 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1277 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1277 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1278 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1278 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_project_id (section);
#line 1278 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1278 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$project_id", _tmp9_);
#line 1279 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1279 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1279 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1279 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$section_id", _tmp12_);
#line 1281 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1281 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4606 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1282 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1282 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1282 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1282 "../core/Services/Database.vala"
		g_warning ("Database.vala:1282: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4618 "Database.c"
	}
#line 1286 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1286 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1286 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1286 "../core/Services/Database.vala"
	return result;
#line 4628 "Database.c"
}

gboolean
services_database_archive_section (ServicesDatabase* self,
                                   ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1289 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1289 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1292 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET is_archived=$is_archived WHERE id=$id;" \
"\n" \
"        ");
#line 1292 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1292 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1296 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1296 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1296 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1296 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1296 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1296 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1296 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1296 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1297 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1297 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_is_archived (section);
#line 1297 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1297 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$is_archived", _tmp9_);
#line 1298 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1298 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1298 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1298 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1300 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1300 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4698 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1301 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1301 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1301 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1301 "../core/Services/Database.vala"
		g_warning ("Database.vala:1301: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4710 "Database.c"
	}
#line 1305 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1305 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1305 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1305 "../core/Services/Database.vala"
	return result;
#line 4720 "Database.c"
}

gboolean
services_database_insert_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               gboolean insert)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	ObjectsDueDate* _tmp17_;
	ObjectsDueDate* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	sqlite3_stmt* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	sqlite3_stmt* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	sqlite3_stmt* _tmp45_;
	gboolean _tmp46_;
	gboolean _tmp47_;
	sqlite3_stmt* _tmp48_;
	gboolean _tmp49_;
	gboolean _tmp50_;
	sqlite3_stmt* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	sqlite3_stmt* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	sqlite3_stmt* _tmp57_;
	gboolean _tmp58_;
	gboolean _tmp59_;
	sqlite3_stmt* _tmp60_;
	GeeArrayList* _tmp61_;
	GeeArrayList* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	sqlite3_stmt* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	sqlite3_stmt* _tmp68_;
	ItemType _tmp69_;
	ItemType _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	sqlite3_stmt* _tmp73_;
	sqlite3_stmt* _tmp77_;
	gboolean result;
#line 1312 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1312 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1315 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Items (id, content, description, due" \
", added_at, completed_at,\n" \
"                updated_at, section_id, project_id, parent_id, priorit" \
"y, child_order,\n" \
"                checked, is_deleted, day_order, collapsed, pinned, lab" \
"els, extra_data, item_type)\n" \
"            VALUES ($id, $content, $description, $due, $added_at, $com" \
"pleted_at,\n" \
"                $updated_at, $section_id, $project_id, $parent_id, $pr" \
"iority, $child_order,\n" \
"                $checked, $is_deleted, $day_order, $collapsed, $pinned" \
", $labels, $extra_data, $item_type);\n" \
"        ");
#line 1315 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1315 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1324 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1324 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1324 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1324 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1324 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1324 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1324 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1324 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1325 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1325 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1325 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1325 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1326 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1326 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_content (item);
#line 1326 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1326 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$content", _tmp12_);
#line 1327 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1327 "../core/Services/Database.vala"
	_tmp14_ = objects_item_get_description (item);
#line 1327 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1327 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$description", _tmp15_);
#line 1328 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1328 "../core/Services/Database.vala"
	_tmp17_ = objects_item_get_due (item);
#line 1328 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1328 "../core/Services/Database.vala"
	_tmp19_ = objects_due_date_to_string (_tmp18_);
#line 1328 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 1328 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$due", _tmp20_);
#line 1328 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 1329 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 1329 "../core/Services/Database.vala"
	_tmp22_ = objects_item_get_added_at (item);
#line 1329 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 1329 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp21_, "$added_at", _tmp23_);
#line 1330 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 1330 "../core/Services/Database.vala"
	_tmp25_ = objects_item_get_completed_at (item);
#line 1330 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 1330 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp24_, "$completed_at", _tmp26_);
#line 1331 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 1331 "../core/Services/Database.vala"
	_tmp28_ = objects_item_get_updated_at (item);
#line 1331 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 1331 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$updated_at", _tmp29_);
#line 1332 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1332 "../core/Services/Database.vala"
	_tmp31_ = objects_item_get_section_id (item);
#line 1332 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 1332 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$section_id", _tmp32_);
#line 1333 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 1333 "../core/Services/Database.vala"
	_tmp34_ = objects_item_get_project_id (item);
#line 1333 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 1333 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp33_, "$project_id", _tmp35_);
#line 1334 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 1334 "../core/Services/Database.vala"
	_tmp37_ = objects_item_get_parent_id (item);
#line 1334 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 1334 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp36_, "$parent_id", _tmp38_);
#line 1335 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 1335 "../core/Services/Database.vala"
	_tmp40_ = objects_item_get_priority (item);
#line 1335 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 1335 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp39_, "$priority", _tmp41_);
#line 1336 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 1336 "../core/Services/Database.vala"
	_tmp43_ = objects_item_get_child_order (item);
#line 1336 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 1336 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp42_, "$child_order", _tmp44_);
#line 1337 "../core/Services/Database.vala"
	_tmp45_ = stmt;
#line 1337 "../core/Services/Database.vala"
	_tmp46_ = objects_item_get_checked (item);
#line 1337 "../core/Services/Database.vala"
	_tmp47_ = _tmp46_;
#line 1337 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp45_, "$checked", _tmp47_);
#line 1338 "../core/Services/Database.vala"
	_tmp48_ = stmt;
#line 1338 "../core/Services/Database.vala"
	_tmp49_ = objects_item_get_is_deleted (item);
#line 1338 "../core/Services/Database.vala"
	_tmp50_ = _tmp49_;
#line 1338 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp48_, "$is_deleted", _tmp50_);
#line 1339 "../core/Services/Database.vala"
	_tmp51_ = stmt;
#line 1339 "../core/Services/Database.vala"
	_tmp52_ = objects_item_get_day_order (item);
#line 1339 "../core/Services/Database.vala"
	_tmp53_ = _tmp52_;
#line 1339 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp51_, "$day_order", _tmp53_);
#line 1340 "../core/Services/Database.vala"
	_tmp54_ = stmt;
#line 1340 "../core/Services/Database.vala"
	_tmp55_ = objects_item_get_collapsed (item);
#line 1340 "../core/Services/Database.vala"
	_tmp56_ = _tmp55_;
#line 1340 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp54_, "$collapsed", _tmp56_);
#line 1341 "../core/Services/Database.vala"
	_tmp57_ = stmt;
#line 1341 "../core/Services/Database.vala"
	_tmp58_ = objects_item_get_pinned (item);
#line 1341 "../core/Services/Database.vala"
	_tmp59_ = _tmp58_;
#line 1341 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp57_, "$pinned", _tmp59_);
#line 1342 "../core/Services/Database.vala"
	_tmp60_ = stmt;
#line 1342 "../core/Services/Database.vala"
	_tmp61_ = objects_item_get_labels (item);
#line 1342 "../core/Services/Database.vala"
	_tmp62_ = _tmp61_;
#line 1342 "../core/Services/Database.vala"
	_tmp63_ = services_database_get_labels_ids (self, _tmp62_);
#line 1342 "../core/Services/Database.vala"
	_tmp64_ = _tmp63_;
#line 1342 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp60_, "$labels", _tmp64_);
#line 1342 "../core/Services/Database.vala"
	_g_free0 (_tmp64_);
#line 1343 "../core/Services/Database.vala"
	_tmp65_ = stmt;
#line 1343 "../core/Services/Database.vala"
	_tmp66_ = objects_item_get_extra_data (item);
#line 1343 "../core/Services/Database.vala"
	_tmp67_ = _tmp66_;
#line 1343 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp65_, "$extra_data", _tmp67_);
#line 1344 "../core/Services/Database.vala"
	_tmp68_ = stmt;
#line 1344 "../core/Services/Database.vala"
	_tmp69_ = objects_item_get_item_type (item);
#line 1344 "../core/Services/Database.vala"
	_tmp70_ = _tmp69_;
#line 1344 "../core/Services/Database.vala"
	_tmp71_ = item_type_to_string (_tmp70_);
#line 1344 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 1344 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp68_, "$item_type", _tmp72_);
#line 1344 "../core/Services/Database.vala"
	_g_free0 (_tmp72_);
#line 1346 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 1346 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp73_) != SQLITE_DONE) {
#line 5013 "Database.c"
		sqlite3* _tmp74_;
		sqlite3* _tmp75_;
		const gchar* _tmp76_;
#line 1347 "../core/Services/Database.vala"
		_tmp74_ = self->priv->db;
#line 1347 "../core/Services/Database.vala"
		_tmp75_ = self->priv->db;
#line 1347 "../core/Services/Database.vala"
		_tmp76_ = sqlite3_errmsg (_tmp75_);
#line 1347 "../core/Services/Database.vala"
		g_warning ("Database.vala:1347: Error: %d: %s", sqlite3_errcode (_tmp74_), _tmp76_);
#line 5025 "Database.c"
	}
#line 1350 "../core/Services/Database.vala"
	_tmp77_ = stmt;
#line 1350 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp77_) == SQLITE_DONE;
#line 1350 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1350 "../core/Services/Database.vala"
	return result;
#line 5035 "Database.c"
}

GeeArrayList*
services_database_get_items_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1353 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1354 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1354 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1357 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE is_deleted = 0;");
#line 1357 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1357 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1359 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1359 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1359 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1359 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1359 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1359 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1359 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1359 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1361 "../core/Services/Database.vala"
	while (TRUE) {
#line 5082 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
		ObjectsItem* _tmp12_;
#line 1361 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1361 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1361 "../core/Services/Database.vala"
			break;
#line 5094 "Database.c"
		}
#line 1362 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1362 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1362 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1362 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1362 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1362 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 5108 "Database.c"
	}
#line 1365 "../core/Services/Database.vala"
	result = return_value;
#line 1365 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1365 "../core/Services/Database.vala"
	return result;
#line 5116 "Database.c"
}

ObjectsItem*
services_database_get_item_by_id (ServicesDatabase* self,
                                  const gchar* id)
{
	ObjectsItem* returned = NULL;
	ObjectsItem* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	ObjectsItem* result;
#line 1368 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1369 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1369 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1372 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE id = $id LIMIT 1;");
#line 1372 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1372 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1374 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1374 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1374 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1374 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1374 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1374 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1374 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1374 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1375 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1375 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1377 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1377 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 5174 "Database.c"
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
#line 1378 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1378 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1378 "../core/Services/Database.vala"
		_g_object_unref0 (returned);
#line 1378 "../core/Services/Database.vala"
		returned = _tmp11_;
#line 5185 "Database.c"
	}
#line 1382 "../core/Services/Database.vala"
	result = returned;
#line 1382 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1382 "../core/Services/Database.vala"
	return result;
#line 5193 "Database.c"
}

ObjectsItem*
_services_database_fill_item (ServicesDatabase* self,
                              sqlite3_stmt* stmt)
{
	ObjectsItem* return_value = NULL;
	ObjectsItem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ObjectsDueDate* _tmp4_;
	ObjectsDueDate* _tmp5_;
	const gchar* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	ServicesStore* _tmp15_;
	const gchar* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	ObjectsItem* result;
#line 1385 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1385 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1386 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1386 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1387 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1387 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1388 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1388 "../core/Services/Database.vala"
	objects_item_set_content (return_value, _tmp2_);
#line 1389 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1389 "../core/Services/Database.vala"
	objects_item_set_description (return_value, _tmp3_);
#line 1390 "../core/Services/Database.vala"
	_tmp4_ = objects_item_get_due (return_value);
#line 1390 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1390 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1390 "../core/Services/Database.vala"
	_tmp7_ = services_database_get_due_parameter (self, _tmp6_);
#line 1390 "../core/Services/Database.vala"
	_tmp8_ = _tmp7_;
#line 1390 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp5_, _tmp8_);
#line 1390 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp8_);
#line 1391 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1391 "../core/Services/Database.vala"
	objects_item_set_added_at (return_value, _tmp9_);
#line 1392 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1392 "../core/Services/Database.vala"
	objects_item_set_completed_at (return_value, _tmp10_);
#line 1393 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 1393 "../core/Services/Database.vala"
	objects_item_set_updated_at (return_value, _tmp11_);
#line 1394 "../core/Services/Database.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 1394 "../core/Services/Database.vala"
	objects_item_set_section_id (return_value, _tmp12_);
#line 1395 "../core/Services/Database.vala"
	_tmp13_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 1395 "../core/Services/Database.vala"
	objects_item_set_project_id (return_value, _tmp13_);
#line 1396 "../core/Services/Database.vala"
	_tmp14_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1396 "../core/Services/Database.vala"
	objects_item_set_parent_id (return_value, _tmp14_);
#line 1397 "../core/Services/Database.vala"
	objects_item_set_priority (return_value, sqlite3_column_int (stmt, 10));
#line 1398 "../core/Services/Database.vala"
	objects_item_set_child_order (return_value, sqlite3_column_int (stmt, 11));
#line 1399 "../core/Services/Database.vala"
	objects_item_set_checked (return_value, services_database_get_parameter_bool (self, stmt, 12));
#line 1400 "../core/Services/Database.vala"
	objects_item_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 13));
#line 1401 "../core/Services/Database.vala"
	objects_item_set_day_order (return_value, sqlite3_column_int (stmt, 14));
#line 1402 "../core/Services/Database.vala"
	objects_item_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 15));
#line 1403 "../core/Services/Database.vala"
	objects_item_set_pinned (return_value, services_database_get_parameter_bool (self, stmt, 16));
#line 1404 "../core/Services/Database.vala"
	_tmp15_ = services_store_instance ();
#line 1404 "../core/Services/Database.vala"
	_tmp16_ = (const gchar*) sqlite3_column_text (stmt, 17);
#line 1404 "../core/Services/Database.vala"
	_tmp17_ = services_store_get_labels_by_item_labels (_tmp15_, _tmp16_);
#line 1404 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1404 "../core/Services/Database.vala"
	objects_item_set_labels (return_value, _tmp18_);
#line 1404 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp18_);
#line 1405 "../core/Services/Database.vala"
	_tmp19_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 1405 "../core/Services/Database.vala"
	objects_item_set_extra_data (return_value, _tmp19_);
#line 1406 "../core/Services/Database.vala"
	_tmp20_ = (const gchar*) sqlite3_column_text (stmt, 19);
#line 1406 "../core/Services/Database.vala"
	objects_item_set_item_type (return_value, item_type_parse (_tmp20_));
#line 1408 "../core/Services/Database.vala"
	result = return_value;
#line 1408 "../core/Services/Database.vala"
	return result;
#line 5319 "Database.c"
}

gboolean
services_database_delete_item (ServicesDatabase* self,
                               ObjectsItem* item)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1411 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1414 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Items WHERE id=$id;\n        ");
#line 1414 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1414 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1418 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1418 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1418 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1418 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1418 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1418 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1418 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1418 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1419 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1419 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1419 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1419 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1421 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1421 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 5378 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1422 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1422 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1422 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1422 "../core/Services/Database.vala"
		g_warning ("Database.vala:1422: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 5390 "Database.c"
	}
#line 1426 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1426 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1426 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1426 "../core/Services/Database.vala"
	return result;
#line 5400 "Database.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 5416 "Database.c"
}

gboolean
services_database_update_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               const gchar* update_id)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	ObjectsDueDate* _tmp18_;
	ObjectsDueDate* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	sqlite3_stmt* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	sqlite3_stmt* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	sqlite3_stmt* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	sqlite3_stmt* _tmp49_;
	gboolean _tmp50_;
	gboolean _tmp51_;
	sqlite3_stmt* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	sqlite3_stmt* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	sqlite3_stmt* _tmp61_;
	GeeArrayList* _tmp62_;
	GeeArrayList* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	sqlite3_stmt* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	sqlite3_stmt* _tmp69_;
	ItemType _tmp70_;
	ItemType _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	sqlite3_stmt* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	sqlite3_stmt* _tmp77_;
	sqlite3_stmt* _tmp81_;
	gboolean result;
#line 1429 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1429 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1429 "../core/Services/Database.vala"
	g_return_val_if_fail (update_id != NULL, FALSE);
#line 1430 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1430 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1430 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1430 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1430 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1430 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1430 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1433 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET content=$content, description=$descriptio" \
"n, due=$due,\n" \
"                added_at=$added_at, completed_at=$completed_at, update" \
"d_at=$updated_at,\n" \
"                section_id=$section_id, project_id=$project_id, parent" \
"_id=$parent_id,\n" \
"                priority=$priority, child_order=$child_order, checked=" \
"$checked,\n" \
"                is_deleted=$is_deleted, day_order=$day_order, collapse" \
"d=$collapsed,\n" \
"                pinned=$pinned, labels=$labels, extra_data=$extra_data" \
", item_type=$item_type\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1433 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1433 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1443 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1443 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1443 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1443 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1443 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1443 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1443 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1443 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1444 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1444 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_content (item);
#line 1444 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1444 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$content", _tmp13_);
#line 1445 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1445 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_description (item);
#line 1445 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1445 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$description", _tmp16_);
#line 1446 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1446 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_due (item);
#line 1446 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1446 "../core/Services/Database.vala"
	_tmp20_ = objects_due_date_to_string (_tmp19_);
#line 1446 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1446 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$due", _tmp21_);
#line 1446 "../core/Services/Database.vala"
	_g_free0 (_tmp21_);
#line 1447 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1447 "../core/Services/Database.vala"
	_tmp23_ = objects_item_get_added_at (item);
#line 1447 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1447 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$added_at", _tmp24_);
#line 1448 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1448 "../core/Services/Database.vala"
	_tmp26_ = objects_item_get_completed_at (item);
#line 1448 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1448 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$completed_at", _tmp27_);
#line 1449 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1449 "../core/Services/Database.vala"
	_tmp29_ = objects_item_get_updated_at (item);
#line 1449 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1449 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp28_, "$updated_at", _tmp30_);
#line 1450 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1450 "../core/Services/Database.vala"
	_tmp32_ = objects_item_get_section_id (item);
#line 1450 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1450 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$section_id", _tmp33_);
#line 1451 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1451 "../core/Services/Database.vala"
	_tmp35_ = objects_item_get_project_id (item);
#line 1451 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1451 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$project_id", _tmp36_);
#line 1452 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1452 "../core/Services/Database.vala"
	_tmp38_ = objects_item_get_parent_id (item);
#line 1452 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1452 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$parent_id", _tmp39_);
#line 1453 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1453 "../core/Services/Database.vala"
	_tmp41_ = objects_item_get_priority (item);
#line 1453 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1453 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp40_, "$priority", _tmp42_);
#line 1454 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1454 "../core/Services/Database.vala"
	_tmp44_ = objects_item_get_child_order (item);
#line 1454 "../core/Services/Database.vala"
	_tmp45_ = _tmp44_;
#line 1454 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp43_, "$child_order", _tmp45_);
#line 1455 "../core/Services/Database.vala"
	_tmp46_ = stmt;
#line 1455 "../core/Services/Database.vala"
	_tmp47_ = objects_item_get_checked (item);
#line 1455 "../core/Services/Database.vala"
	_tmp48_ = _tmp47_;
#line 1455 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp46_, "$checked", _tmp48_);
#line 1456 "../core/Services/Database.vala"
	_tmp49_ = stmt;
#line 1456 "../core/Services/Database.vala"
	_tmp50_ = objects_item_get_is_deleted (item);
#line 1456 "../core/Services/Database.vala"
	_tmp51_ = _tmp50_;
#line 1456 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp49_, "$is_deleted", _tmp51_);
#line 1457 "../core/Services/Database.vala"
	_tmp52_ = stmt;
#line 1457 "../core/Services/Database.vala"
	_tmp53_ = objects_item_get_day_order (item);
#line 1457 "../core/Services/Database.vala"
	_tmp54_ = _tmp53_;
#line 1457 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp52_, "$day_order", _tmp54_);
#line 1458 "../core/Services/Database.vala"
	_tmp55_ = stmt;
#line 1458 "../core/Services/Database.vala"
	_tmp56_ = objects_item_get_collapsed (item);
#line 1458 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 1458 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp55_, "$collapsed", _tmp57_);
#line 1459 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 1459 "../core/Services/Database.vala"
	_tmp59_ = objects_item_get_pinned (item);
#line 1459 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 1459 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp58_, "$pinned", _tmp60_);
#line 1460 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 1460 "../core/Services/Database.vala"
	_tmp62_ = objects_item_get_labels (item);
#line 1460 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 1460 "../core/Services/Database.vala"
	_tmp64_ = services_database_get_labels_ids (self, _tmp63_);
#line 1460 "../core/Services/Database.vala"
	_tmp65_ = _tmp64_;
#line 1460 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$labels", _tmp65_);
#line 1460 "../core/Services/Database.vala"
	_g_free0 (_tmp65_);
#line 1461 "../core/Services/Database.vala"
	_tmp66_ = stmt;
#line 1461 "../core/Services/Database.vala"
	_tmp67_ = objects_item_get_extra_data (item);
#line 1461 "../core/Services/Database.vala"
	_tmp68_ = _tmp67_;
#line 1461 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp66_, "$extra_data", _tmp68_);
#line 1462 "../core/Services/Database.vala"
	_tmp69_ = stmt;
#line 1462 "../core/Services/Database.vala"
	_tmp70_ = objects_item_get_item_type (item);
#line 1462 "../core/Services/Database.vala"
	_tmp71_ = _tmp70_;
#line 1462 "../core/Services/Database.vala"
	_tmp72_ = item_type_to_string (_tmp71_);
#line 1462 "../core/Services/Database.vala"
	_tmp73_ = _tmp72_;
#line 1462 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp69_, "$item_type", _tmp73_);
#line 1462 "../core/Services/Database.vala"
	_g_free0 (_tmp73_);
#line 1463 "../core/Services/Database.vala"
	_tmp74_ = stmt;
#line 1463 "../core/Services/Database.vala"
	_tmp75_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1463 "../core/Services/Database.vala"
	_tmp76_ = _tmp75_;
#line 1463 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp74_, "$id", _tmp76_);
#line 1465 "../core/Services/Database.vala"
	_tmp77_ = stmt;
#line 1465 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp77_) != SQLITE_DONE) {
#line 5729 "Database.c"
		sqlite3* _tmp78_;
		sqlite3* _tmp79_;
		const gchar* _tmp80_;
#line 1466 "../core/Services/Database.vala"
		_tmp78_ = self->priv->db;
#line 1466 "../core/Services/Database.vala"
		_tmp79_ = self->priv->db;
#line 1466 "../core/Services/Database.vala"
		_tmp80_ = sqlite3_errmsg (_tmp79_);
#line 1466 "../core/Services/Database.vala"
		g_warning ("Database.vala:1466: Error: %d: %s", sqlite3_errcode (_tmp78_), _tmp80_);
#line 5741 "Database.c"
	}
#line 1470 "../core/Services/Database.vala"
	_tmp81_ = stmt;
#line 1470 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp81_) == SQLITE_DONE;
#line 1470 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1470 "../core/Services/Database.vala"
	return result;
#line 5751 "Database.c"
}

gboolean
services_database_move_item (ServicesDatabase* self,
                             ObjectsItem* item)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	sqlite3_stmt* _tmp27_;
	gboolean result;
#line 1473 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1474 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1474 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1474 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1474 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1474 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1474 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1474 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1477 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET\n" \
"                section_id=$section_id,\n" \
"                project_id=$project_id,\n" \
"                parent_id=$parent_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1477 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1477 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1485 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1485 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1485 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1485 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1485 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1485 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1485 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1485 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1486 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1486 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_section_id (item);
#line 1486 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1486 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$section_id", _tmp13_);
#line 1487 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1487 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_project_id (item);
#line 1487 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1487 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$project_id", _tmp16_);
#line 1488 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1488 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_parent_id (item);
#line 1488 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1488 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$parent_id", _tmp19_);
#line 1489 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 1489 "../core/Services/Database.vala"
	_tmp21_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1489 "../core/Services/Database.vala"
	_tmp22_ = _tmp21_;
#line 1489 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp20_, "$id", _tmp22_);
#line 1491 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1491 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp23_) != SQLITE_DONE) {
#line 5861 "Database.c"
		sqlite3* _tmp24_;
		sqlite3* _tmp25_;
		const gchar* _tmp26_;
#line 1492 "../core/Services/Database.vala"
		_tmp24_ = self->priv->db;
#line 1492 "../core/Services/Database.vala"
		_tmp25_ = self->priv->db;
#line 1492 "../core/Services/Database.vala"
		_tmp26_ = sqlite3_errmsg (_tmp25_);
#line 1492 "../core/Services/Database.vala"
		g_warning ("Database.vala:1492: Error: %d: %s", sqlite3_errcode (_tmp24_), _tmp26_);
#line 5873 "Database.c"
	}
#line 1496 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 1496 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp27_) == SQLITE_DONE;
#line 1496 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1496 "../core/Services/Database.vala"
	return result;
#line 5883 "Database.c"
}

gboolean
services_database_complete_item (ServicesDatabase* self,
                                 ObjectsItem* item,
                                 gboolean old_checked)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp20_;
	gboolean result;
#line 1499 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1499 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1502 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET checked=$checked, completed_at=$completed" \
"_at\n" \
"            WHERE id=$id OR parent_id=$id;\n" \
"        ");
#line 1502 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1502 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1507 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1507 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1507 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1507 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1507 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1507 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1507 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1507 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1508 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1508 "../core/Services/Database.vala"
	_tmp8_ = objects_item_get_checked (item);
#line 1508 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1508 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$checked", _tmp9_);
#line 1509 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1509 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_completed_at (item);
#line 1509 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1509 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$completed_at", _tmp12_);
#line 1510 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1510 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1510 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1510 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$id", _tmp15_);
#line 1512 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1512 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) != SQLITE_DONE) {
#line 5965 "Database.c"
		sqlite3* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 1513 "../core/Services/Database.vala"
		_tmp17_ = self->priv->db;
#line 1513 "../core/Services/Database.vala"
		_tmp18_ = self->priv->db;
#line 1513 "../core/Services/Database.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 1513 "../core/Services/Database.vala"
		g_warning ("Database.vala:1513: Error: %d: %s", sqlite3_errcode (_tmp17_), _tmp19_);
#line 5977 "Database.c"
	}
#line 1517 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 1517 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp20_) == SQLITE_DONE;
#line 1517 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1517 "../core/Services/Database.vala"
	return result;
#line 5987 "Database.c"
}

void
services_database_update_child_order (ServicesDatabase* self,
                                      ObjectsBaseObject* base_object)
{
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	sqlite3_stmt* _tmp26_;
#line 1520 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1520 "../core/Services/Database.vala"
	g_return_if_fail (base_object != NULL);
#line 1523 "../core/Services/Database.vala"
	_tmp0_ = objects_base_object_get_table_name (base_object);
#line 1523 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1523 "../core/Services/Database.vala"
	_tmp2_ = objects_base_object_get_column_order_name (base_object);
#line 1523 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1523 "../core/Services/Database.vala"
	_tmp4_ = g_strdup_printf ("\n            UPDATE %s SET %s=$order WHERE id=$id;\n        ", _tmp1_, _tmp3_);
#line 1523 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1523 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1527 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1527 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1527 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1527 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1527 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1527 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1527 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1527 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1529 "../core/Services/Database.vala"
	if (OBJECTS_IS_ITEM (base_object)) {
#line 6046 "Database.c"
		sqlite3_stmt* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 1530 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1530 "../core/Services/Database.vala"
		_tmp12_ = objects_item_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_ITEM, ObjectsItem));
#line 1530 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1530 "../core/Services/Database.vala"
		services_database_set_parameter_int (self, _tmp11_, "$order", _tmp13_);
#line 6058 "Database.c"
	} else {
#line 1531 "../core/Services/Database.vala"
		if (OBJECTS_IS_SECTION (base_object)) {
#line 6062 "Database.c"
			sqlite3_stmt* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 1532 "../core/Services/Database.vala"
			_tmp14_ = stmt;
#line 1532 "../core/Services/Database.vala"
			_tmp15_ = objects_section_get_section_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_SECTION, ObjectsSection));
#line 1532 "../core/Services/Database.vala"
			_tmp16_ = _tmp15_;
#line 1532 "../core/Services/Database.vala"
			services_database_set_parameter_int (self, _tmp14_, "$order", _tmp16_);
#line 6074 "Database.c"
		} else {
#line 1533 "../core/Services/Database.vala"
			if (OBJECTS_IS_PROJECT (base_object)) {
#line 6078 "Database.c"
				sqlite3_stmt* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 1534 "../core/Services/Database.vala"
				_tmp17_ = stmt;
#line 1534 "../core/Services/Database.vala"
				_tmp18_ = objects_project_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_PROJECT, ObjectsProject));
#line 1534 "../core/Services/Database.vala"
				_tmp19_ = _tmp18_;
#line 1534 "../core/Services/Database.vala"
				services_database_set_parameter_int (self, _tmp17_, "$order", _tmp19_);
#line 6090 "Database.c"
			} else {
#line 1535 "../core/Services/Database.vala"
				if (OBJECTS_IS_LABEL (base_object)) {
#line 6094 "Database.c"
					sqlite3_stmt* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 1536 "../core/Services/Database.vala"
					_tmp20_ = stmt;
#line 1536 "../core/Services/Database.vala"
					_tmp21_ = objects_label_get_item_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_LABEL, ObjectsLabel));
#line 1536 "../core/Services/Database.vala"
					_tmp22_ = _tmp21_;
#line 1536 "../core/Services/Database.vala"
					services_database_set_parameter_int (self, _tmp20_, "$order", _tmp22_);
#line 6106 "Database.c"
				}
			}
		}
	}
#line 1539 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1539 "../core/Services/Database.vala"
	_tmp24_ = objects_base_object_get_id (base_object);
#line 1539 "../core/Services/Database.vala"
	_tmp25_ = _tmp24_;
#line 1539 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp23_, "$id", _tmp25_);
#line 1541 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1541 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp26_) != SQLITE_DONE) {
#line 6123 "Database.c"
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 1542 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1542 "../core/Services/Database.vala"
		_tmp28_ = self->priv->db;
#line 1542 "../core/Services/Database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 1542 "../core/Services/Database.vala"
		g_warning ("Database.vala:1542: Error: %d: %s", sqlite3_errcode (_tmp27_), _tmp29_);
#line 6135 "Database.c"
	}
#line 1520 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 6139 "Database.c"
}

gboolean
services_database_insert_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	ReminderType _tmp14_;
	ReminderType _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	ObjectsDueDate* _tmp19_;
	ObjectsDueDate* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp30_;
	gboolean result;
#line 1549 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1549 "../core/Services/Database.vala"
	g_return_val_if_fail (reminder != NULL, FALSE);
#line 1553 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Reminders (id, item_id, type, due, m" \
"m_offset)\n" \
"            VALUES ($id, $item_id, $type, $due, $mm_offset);\n" \
"        ");
#line 1553 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1553 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1558 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1558 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1558 "../core/Services/Database.vala"
	_tmp3_ = sql;
#line 1558 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1558 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1558 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1558 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1558 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1559 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1559 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1559 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1559 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1560 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1560 "../core/Services/Database.vala"
	_tmp11_ = objects_reminder_get_item_id (reminder);
#line 1560 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1560 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$item_id", _tmp12_);
#line 1561 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1561 "../core/Services/Database.vala"
	_tmp14_ = objects_reminder_get_reminder_type (reminder);
#line 1561 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1561 "../core/Services/Database.vala"
	_tmp16_ = reminder_type_to_string (_tmp15_);
#line 1561 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1561 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$type", _tmp17_);
#line 1561 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 1562 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 1562 "../core/Services/Database.vala"
	_tmp19_ = objects_reminder_get_due (reminder);
#line 1562 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 1562 "../core/Services/Database.vala"
	_tmp21_ = objects_due_date_to_string (_tmp20_);
#line 1562 "../core/Services/Database.vala"
	_tmp22_ = _tmp21_;
#line 1562 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp18_, "$due", _tmp22_);
#line 1562 "../core/Services/Database.vala"
	_g_free0 (_tmp22_);
#line 1563 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1563 "../core/Services/Database.vala"
	_tmp24_ = objects_reminder_get_mm_offset (reminder);
#line 1563 "../core/Services/Database.vala"
	_tmp25_ = _tmp24_;
#line 1563 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp23_, "$mm_offset", _tmp25_);
#line 1565 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1565 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp26_) != SQLITE_DONE) {
#line 6259 "Database.c"
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 1566 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1566 "../core/Services/Database.vala"
		_tmp28_ = self->priv->db;
#line 1566 "../core/Services/Database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 1566 "../core/Services/Database.vala"
		g_warning ("Database.vala:1566: Error: %d: %s", sqlite3_errcode (_tmp27_), _tmp29_);
#line 6271 "Database.c"
	}
#line 1570 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1570 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp30_) == SQLITE_DONE;
#line 1570 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1570 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1570 "../core/Services/Database.vala"
	return result;
#line 6283 "Database.c"
}

GeeArrayList*
services_database_get_reminders_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1573 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1574 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1574 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1577 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT id, item_id, type, due, mm_offset FROM Reminders;\n" \
"        ");
#line 1577 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1577 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1581 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1581 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1581 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1581 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1581 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1581 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1581 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1581 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1583 "../core/Services/Database.vala"
	while (TRUE) {
#line 6330 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsReminder* _tmp11_;
		ObjectsReminder* _tmp12_;
#line 1583 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1583 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1583 "../core/Services/Database.vala"
			break;
#line 6342 "Database.c"
		}
#line 1584 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1584 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1584 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_reminder (self, _tmp10_);
#line 1584 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1584 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1584 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 6356 "Database.c"
	}
#line 1587 "../core/Services/Database.vala"
	result = return_value;
#line 1587 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1587 "../core/Services/Database.vala"
	return result;
#line 6364 "Database.c"
}

ObjectsReminder*
_services_database_fill_reminder (ServicesDatabase* self,
                                  sqlite3_stmt* stmt)
{
	ObjectsReminder* return_value = NULL;
	ObjectsReminder* _tmp0_;
	ObjectsReminder* _tmp1_;
	const gchar* _tmp2_;
	ObjectsReminder* _tmp3_;
	const gchar* _tmp4_;
	ReminderType _tmp5_ = 0;
	const gchar* _tmp6_;
	ObjectsReminder* _tmp7_;
	ObjectsReminder* _tmp8_;
	ObjectsDueDate* _tmp9_;
	ObjectsDueDate* _tmp10_;
	const gchar* _tmp11_;
	JsonObject* _tmp12_;
	JsonObject* _tmp13_;
	ObjectsReminder* _tmp14_;
	ObjectsReminder* result;
#line 1590 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1590 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1591 "../core/Services/Database.vala"
	_tmp0_ = objects_reminder_new ();
#line 1591 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1592 "../core/Services/Database.vala"
	_tmp1_ = return_value;
#line 1592 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1592 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp1_, _tmp2_);
#line 1593 "../core/Services/Database.vala"
	_tmp3_ = return_value;
#line 1593 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1593 "../core/Services/Database.vala"
	objects_reminder_set_item_id (_tmp3_, _tmp4_);
#line 1594 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1594 "../core/Services/Database.vala"
	if (g_strcmp0 (_tmp6_, "absolute") == 0) {
#line 1594 "../core/Services/Database.vala"
		_tmp5_ = REMINDER_TYPE_ABSOLUTE;
#line 6414 "Database.c"
	} else {
#line 1594 "../core/Services/Database.vala"
		_tmp5_ = REMINDER_TYPE_RELATIVE;
#line 6418 "Database.c"
	}
#line 1594 "../core/Services/Database.vala"
	_tmp7_ = return_value;
#line 1594 "../core/Services/Database.vala"
	objects_reminder_set_reminder_type (_tmp7_, _tmp5_);
#line 1595 "../core/Services/Database.vala"
	_tmp8_ = return_value;
#line 1595 "../core/Services/Database.vala"
	_tmp9_ = objects_reminder_get_due (_tmp8_);
#line 1595 "../core/Services/Database.vala"
	_tmp10_ = _tmp9_;
#line 1595 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1595 "../core/Services/Database.vala"
	_tmp12_ = services_database_get_due_parameter (self, _tmp11_);
#line 1595 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1595 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp10_, _tmp13_);
#line 1595 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp13_);
#line 1596 "../core/Services/Database.vala"
	_tmp14_ = return_value;
#line 1596 "../core/Services/Database.vala"
	objects_reminder_set_mm_offset (_tmp14_, sqlite3_column_int (stmt, 4));
#line 1597 "../core/Services/Database.vala"
	result = return_value;
#line 1597 "../core/Services/Database.vala"
	return result;
#line 6448 "Database.c"
}

GeeArrayList*
services_database_get_reminders_by_item_id (ServicesDatabase* self,
                                            const gchar* id)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* result;
#line 1600 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1600 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1601 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1601 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1604 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT id, item_id, type, due, mm_offset FROM Reminders WH" \
"ERE item_id=$item_id;\n" \
"        ");
#line 1604 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1604 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1608 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1608 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1608 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1608 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1608 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1608 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1608 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1608 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1609 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1609 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$item_id", id);
#line 1611 "../core/Services/Database.vala"
	while (TRUE) {
#line 6503 "Database.c"
		sqlite3_stmt* _tmp9_;
		GeeArrayList* _tmp10_;
		sqlite3_stmt* _tmp11_;
		ObjectsReminder* _tmp12_;
		ObjectsReminder* _tmp13_;
#line 1611 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1611 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp9_) == SQLITE_ROW)) {
#line 1611 "../core/Services/Database.vala"
			break;
#line 6515 "Database.c"
		}
#line 1612 "../core/Services/Database.vala"
		_tmp10_ = return_value;
#line 1612 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1612 "../core/Services/Database.vala"
		_tmp12_ = _services_database_fill_reminder (self, _tmp11_);
#line 1612 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1612 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
#line 1612 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp13_);
#line 6529 "Database.c"
	}
#line 1615 "../core/Services/Database.vala"
	result = return_value;
#line 1615 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1615 "../core/Services/Database.vala"
	return result;
#line 6537 "Database.c"
}

gboolean
services_database_delete_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1618 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1618 "../core/Services/Database.vala"
	g_return_val_if_fail (reminder != NULL, FALSE);
#line 1621 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Reminders WHERE id=$id;\n        ");
#line 1621 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1621 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1625 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1625 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1625 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1625 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1625 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1625 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1625 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1625 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1626 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1626 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1626 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1626 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1628 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1628 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 6596 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1629 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1629 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1629 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1629 "../core/Services/Database.vala"
		g_warning ("Database.vala:1629: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 6608 "Database.c"
	}
#line 1633 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1633 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1633 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1633 "../core/Services/Database.vala"
	return result;
#line 6618 "Database.c"
}

gboolean
services_database_insert_attachment (ServicesDatabase* self,
                                     ObjectsAttachment* attachment)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	gint64 _tmp20_;
	gint64 _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp29_;
	gboolean result;
#line 1637 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1637 "../core/Services/Database.vala"
	g_return_val_if_fail (attachment != NULL, FALSE);
#line 1641 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Attachments (id, item_id, file_type," \
" file_name, file_size, file_path)\n" \
"            VALUES ($id, $item_id, $file_type, $file_name, $file_size," \
" $file_path);\n" \
"        ");
#line 1641 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1641 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1646 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1646 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1646 "../core/Services/Database.vala"
	_tmp3_ = sql;
#line 1646 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1646 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1646 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1646 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1646 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1647 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1647 "../core/Services/Database.vala"
	_tmp8_ = objects_attachment_get_id (attachment);
#line 1647 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1647 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1648 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1648 "../core/Services/Database.vala"
	_tmp11_ = objects_attachment_get_item_id (attachment);
#line 1648 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1648 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$item_id", _tmp12_);
#line 1649 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1649 "../core/Services/Database.vala"
	_tmp14_ = objects_attachment_get_file_type (attachment);
#line 1649 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1649 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$file_type", _tmp15_);
#line 1650 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1650 "../core/Services/Database.vala"
	_tmp17_ = objects_attachment_get_file_name (attachment);
#line 1650 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1650 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$file_name", _tmp18_);
#line 1651 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1651 "../core/Services/Database.vala"
	_tmp20_ = objects_attachment_get_file_size (attachment);
#line 1651 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1651 "../core/Services/Database.vala"
	services_database_set_parameter_int64 (self, _tmp19_, "$file_size", _tmp21_);
#line 1652 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1652 "../core/Services/Database.vala"
	_tmp23_ = objects_attachment_get_file_path (attachment);
#line 1652 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1652 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$file_path", _tmp24_);
#line 1654 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1654 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 6733 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1655 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1655 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1655 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1655 "../core/Services/Database.vala"
		g_warning ("Database.vala:1655: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 6745 "Database.c"
	}
#line 1659 "../core/Services/Database.vala"
	_tmp29_ = stmt;
#line 1659 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp29_) == SQLITE_DONE;
#line 1659 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1659 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1659 "../core/Services/Database.vala"
	return result;
#line 6757 "Database.c"
}

GeeArrayList*
services_database_get_attachments_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1662 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1663 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1663 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1666 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Attachments;\n        ");
#line 1666 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1666 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1670 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1670 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1670 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1670 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1670 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1670 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1670 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1670 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1672 "../core/Services/Database.vala"
	while (TRUE) {
#line 6804 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsAttachment* _tmp11_;
		ObjectsAttachment* _tmp12_;
#line 1672 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1672 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1672 "../core/Services/Database.vala"
			break;
#line 6816 "Database.c"
		}
#line 1673 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1673 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1673 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_attachment (self, _tmp10_);
#line 1673 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1673 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1673 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 6830 "Database.c"
	}
#line 1676 "../core/Services/Database.vala"
	result = return_value;
#line 1676 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1676 "../core/Services/Database.vala"
	return result;
#line 6838 "Database.c"
}

ObjectsAttachment*
_services_database_fill_attachment (ServicesDatabase* self,
                                    sqlite3_stmt* stmt)
{
	ObjectsAttachment* return_value = NULL;
	ObjectsAttachment* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ObjectsAttachment* result;
#line 1679 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1679 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1680 "../core/Services/Database.vala"
	_tmp0_ = objects_attachment_new ();
#line 1680 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1681 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1681 "../core/Services/Database.vala"
	objects_attachment_set_id (return_value, _tmp1_);
#line 1682 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1682 "../core/Services/Database.vala"
	objects_attachment_set_item_id (return_value, _tmp2_);
#line 1683 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1683 "../core/Services/Database.vala"
	objects_attachment_set_file_type (return_value, _tmp3_);
#line 1684 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1684 "../core/Services/Database.vala"
	objects_attachment_set_file_name (return_value, _tmp4_);
#line 1685 "../core/Services/Database.vala"
	objects_attachment_set_file_size (return_value, sqlite3_column_int64 (stmt, 4));
#line 1686 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1686 "../core/Services/Database.vala"
	objects_attachment_set_file_path (return_value, _tmp5_);
#line 1687 "../core/Services/Database.vala"
	result = return_value;
#line 1687 "../core/Services/Database.vala"
	return result;
#line 6887 "Database.c"
}

gboolean
services_database_delete_attachment (ServicesDatabase* self,
                                     ObjectsAttachment* attachment)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1690 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1690 "../core/Services/Database.vala"
	g_return_val_if_fail (attachment != NULL, FALSE);
#line 1693 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Attachments WHERE id=$id;\n        ");
#line 1693 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1693 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1697 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1697 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1697 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1697 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1697 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1697 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1697 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1697 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1698 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1698 "../core/Services/Database.vala"
	_tmp8_ = objects_attachment_get_id (attachment);
#line 1698 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1698 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1700 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1700 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 6946 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1701 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1701 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1701 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1701 "../core/Services/Database.vala"
		g_warning ("Database.vala:1701: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 6958 "Database.c"
	}
#line 1705 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1705 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1705 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1705 "../core/Services/Database.vala"
	return result;
#line 6968 "Database.c"
}

void
services_database_insert_queue (ServicesDatabase* self,
                                ObjectsQueue* queue)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
#line 1712 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1712 "../core/Services/Database.vala"
	g_return_if_fail (queue != NULL);
#line 1715 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Queue (uuid, object_id, query, temp_" \
"id, args, date_added)\n" \
"            VALUES ($uuid, $object_id, $query, $temp_id, $args, $date_" \
"added);\n" \
"        ");
#line 1715 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1715 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1720 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1720 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1720 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1720 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1720 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1720 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1720 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1720 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1721 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1721 "../core/Services/Database.vala"
	_tmp8_ = objects_queue_get_uuid (queue);
#line 1721 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1721 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", _tmp9_);
#line 1722 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1722 "../core/Services/Database.vala"
	_tmp11_ = objects_queue_get_object_id (queue);
#line 1722 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1722 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$object_id", _tmp12_);
#line 1723 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1723 "../core/Services/Database.vala"
	_tmp14_ = objects_queue_get_query (queue);
#line 1723 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1723 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$query", _tmp15_);
#line 1724 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1724 "../core/Services/Database.vala"
	_tmp17_ = objects_queue_get_temp_id (queue);
#line 1724 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1724 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$temp_id", _tmp18_);
#line 1725 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1725 "../core/Services/Database.vala"
	_tmp20_ = objects_queue_get_args (queue);
#line 1725 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1725 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$args", _tmp21_);
#line 1726 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1726 "../core/Services/Database.vala"
	_tmp23_ = objects_queue_get_date_added (queue);
#line 1726 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1726 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$date_added", _tmp24_);
#line 1728 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1728 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 7080 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1729 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1729 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1729 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1729 "../core/Services/Database.vala"
		g_warning ("Database.vala:1729: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 7092 "Database.c"
	}
#line 1712 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7096 "Database.c"
}

GeeArrayList*
services_database_get_all_queue (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1735 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1736 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_QUEUE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1736 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1739 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Queue ORDER BY date_added;\n        ");
#line 1739 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1739 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1743 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1743 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1743 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1743 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1743 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1743 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1743 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1743 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1745 "../core/Services/Database.vala"
	while (TRUE) {
#line 7143 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsQueue* _tmp11_;
		ObjectsQueue* _tmp12_;
#line 1745 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1745 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1745 "../core/Services/Database.vala"
			break;
#line 7155 "Database.c"
		}
#line 1746 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1746 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1746 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_queue (self, _tmp10_);
#line 1746 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1746 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1746 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 7169 "Database.c"
	}
#line 1749 "../core/Services/Database.vala"
	result = return_value;
#line 1749 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1749 "../core/Services/Database.vala"
	return result;
#line 7177 "Database.c"
}

ObjectsQueue*
_services_database_fill_queue (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsQueue* return_value = NULL;
	ObjectsQueue* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	ObjectsQueue* result;
#line 1752 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1752 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1753 "../core/Services/Database.vala"
	_tmp0_ = objects_queue_new ();
#line 1753 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1754 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1754 "../core/Services/Database.vala"
	objects_queue_set_uuid (return_value, _tmp1_);
#line 1755 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1755 "../core/Services/Database.vala"
	objects_queue_set_object_id (return_value, _tmp2_);
#line 1756 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1756 "../core/Services/Database.vala"
	objects_queue_set_query (return_value, _tmp3_);
#line 1757 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1757 "../core/Services/Database.vala"
	objects_queue_set_temp_id (return_value, _tmp4_);
#line 1758 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1758 "../core/Services/Database.vala"
	objects_queue_set_args (return_value, _tmp5_);
#line 1759 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1759 "../core/Services/Database.vala"
	objects_queue_set_date_added (return_value, _tmp6_);
#line 1760 "../core/Services/Database.vala"
	result = return_value;
#line 1760 "../core/Services/Database.vala"
	return result;
#line 7229 "Database.c"
}

void
services_database_insert_CurTempIds (ServicesDatabase* self,
                                     const gchar* id,
                                     const gchar* temp_id,
                                     const gchar* object)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
#line 1763 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1763 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 1763 "../core/Services/Database.vala"
	g_return_if_fail (temp_id != NULL);
#line 1763 "../core/Services/Database.vala"
	g_return_if_fail (object != NULL);
#line 1766 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO CurTempIds (id, temp_id, object)\n" \
"            VALUES ($id, $temp_id, $object);\n" \
"        ");
#line 1766 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1766 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1771 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1771 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1771 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1771 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1771 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1771 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1771 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1771 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1772 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1772 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1773 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1773 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$temp_id", temp_id);
#line 1774 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1774 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp9_, "$object", object);
#line 1776 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1776 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 7296 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1777 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1777 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1777 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1777 "../core/Services/Database.vala"
		g_warning ("Database.vala:1777: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 7308 "Database.c"
	}
#line 1763 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7312 "Database.c"
}

gboolean
services_database_curTempIds_exists (ServicesDatabase* self,
                                     const gchar* id)
{
	gboolean returned = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gboolean result;
#line 1783 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1783 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 1784 "../core/Services/Database.vala"
	returned = FALSE;
#line 1787 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            SELECT COUNT (*) FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1787 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1787 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1791 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1791 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1791 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1791 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1791 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1791 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1791 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1791 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1792 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1792 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1794 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1794 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) == SQLITE_ROW) {
#line 7367 "Database.c"
		sqlite3_stmt* _tmp9_;
#line 1795 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1795 "../core/Services/Database.vala"
		returned = sqlite3_column_int (_tmp9_, 0) > 0;
#line 7373 "Database.c"
	}
#line 1798 "../core/Services/Database.vala"
	result = returned;
#line 1798 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1798 "../core/Services/Database.vala"
	return result;
#line 7381 "Database.c"
}

gchar*
services_database_get_temp_id (ServicesDatabase* self,
                               const gchar* id)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gchar* result;
#line 1801 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1801 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1802 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 1802 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1805 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT temp_id FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1805 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1805 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1809 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1809 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1809 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1809 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1809 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1809 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1809 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1809 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1810 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1810 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1812 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1812 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 7439 "Database.c"
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1813 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1813 "../core/Services/Database.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 1813 "../core/Services/Database.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1813 "../core/Services/Database.vala"
		_g_free0 (returned);
#line 1813 "../core/Services/Database.vala"
		returned = _tmp12_;
#line 7453 "Database.c"
	}
#line 1817 "../core/Services/Database.vala"
	result = returned;
#line 1817 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1817 "../core/Services/Database.vala"
	return result;
#line 7461 "Database.c"
}

gboolean
services_database_update_project_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1820 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1820 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1820 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1823 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1823 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1823 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1827 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1827 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1827 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1827 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1827 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1827 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1827 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1827 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1828 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1828 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1829 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1829 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1831 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1831 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7522 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1832 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1832 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1832 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1832 "../core/Services/Database.vala"
		g_warning ("Database.vala:1832: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7534 "Database.c"
	}
#line 1836 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1836 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1836 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1836 "../core/Services/Database.vala"
	return result;
#line 7544 "Database.c"
}

gboolean
services_database_update_project_section_id (ServicesDatabase* self,
                                             const gchar* current_id,
                                             const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1839 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1839 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1839 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1842 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"                UPDATE Sections SET project_id = $new_id WHERE project" \
"_id = $current_id;\n" \
"            ");
#line 1842 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1842 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1846 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1846 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1846 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1846 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1846 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1846 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1846 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1846 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1847 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1847 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1848 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1848 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1850 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1850 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7605 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1851 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1851 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1851 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1851 "../core/Services/Database.vala"
		g_warning ("Database.vala:1851: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7617 "Database.c"
	}
#line 1855 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1855 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1855 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1855 "../core/Services/Database.vala"
	return result;
#line 7627 "Database.c"
}

gboolean
services_database_update_project_item_id (ServicesDatabase* self,
                                          const gchar* current_id,
                                          const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1858 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1858 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1858 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1861 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET project_id = $new_id WHERE project_id = $" \
"current_id;\n" \
"        ");
#line 1861 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1861 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1865 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1865 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1865 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1865 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1865 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1865 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1865 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1865 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1866 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1866 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1867 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1867 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1869 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1869 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7688 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1870 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1870 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1870 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1870 "../core/Services/Database.vala"
		g_warning ("Database.vala:1870: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7700 "Database.c"
	}
#line 1874 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1874 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1874 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1874 "../core/Services/Database.vala"
	return result;
#line 7710 "Database.c"
}

gboolean
services_database_update_section_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1877 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1877 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1877 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1880 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1880 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1880 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1884 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1884 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1884 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1884 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1884 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1884 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1884 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1884 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1885 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1885 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1886 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1886 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1888 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1888 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7771 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1889 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1889 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1889 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1889 "../core/Services/Database.vala"
		g_warning ("Database.vala:1889: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7783 "Database.c"
	}
#line 1893 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1893 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1893 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1893 "../core/Services/Database.vala"
	return result;
#line 7793 "Database.c"
}

gboolean
services_database_update_section_item_id (ServicesDatabase* self,
                                          const gchar* current_id,
                                          const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1896 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1896 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1896 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1899 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET section_id = $new_id WHERE section_id = $" \
"current_id;\n" \
"        ");
#line 1899 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1899 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1903 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1903 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1903 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1903 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1903 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1903 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1903 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1903 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1904 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1904 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1905 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1905 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1907 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1907 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7854 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1908 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1908 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1908 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1908 "../core/Services/Database.vala"
		g_warning ("Database.vala:1908: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7866 "Database.c"
	}
#line 1912 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1912 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1912 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1912 "../core/Services/Database.vala"
	return result;
#line 7876 "Database.c"
}

gboolean
services_database_update_item_id (ServicesDatabase* self,
                                  const gchar* current_id,
                                  const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1915 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1915 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1915 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1918 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1918 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1918 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1922 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1922 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1922 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1922 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1922 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1922 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1922 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1922 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1923 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1923 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1924 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1924 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1926 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1926 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7937 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1927 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1927 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1927 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1927 "../core/Services/Database.vala"
		g_warning ("Database.vala:1927: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7949 "Database.c"
	}
#line 1931 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1931 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1931 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1931 "../core/Services/Database.vala"
	return result;
#line 7959 "Database.c"
}

gboolean
services_database_update_item_child_id (ServicesDatabase* self,
                                        const gchar* current_id,
                                        const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1934 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1934 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1934 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1937 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET parent_id = $new_id WHERE parent_id = $cu" \
"rrent_id;\n" \
"        ");
#line 1937 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1937 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1941 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1941 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1941 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1941 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1941 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1941 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1941 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1941 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1942 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1942 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1943 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1943 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1945 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1945 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 8020 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1946 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1946 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1946 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1946 "../core/Services/Database.vala"
		g_warning ("Database.vala:1946: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 8032 "Database.c"
	}
#line 1950 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1950 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1950 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1950 "../core/Services/Database.vala"
	return result;
#line 8042 "Database.c"
}

void
services_database_remove_CurTempIds (ServicesDatabase* self,
                                     const gchar* id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
#line 1953 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1953 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 1956 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds WHERE id = $id;\n        ");
#line 1956 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1956 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1960 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1960 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1960 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1960 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1960 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1960 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1960 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1960 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1961 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1961 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1963 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1963 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 8093 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 1964 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1964 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1964 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 1964 "../core/Services/Database.vala"
		g_warning ("Database.vala:1964: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 8105 "Database.c"
	}
#line 1953 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8109 "Database.c"
}

void
services_database_remove_queue (ServicesDatabase* self,
                                const gchar* uuid)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
#line 1970 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1970 "../core/Services/Database.vala"
	g_return_if_fail (uuid != NULL);
#line 1973 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue WHERE uuid = $uuid;\n        ");
#line 1973 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1973 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1977 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1977 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1977 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1977 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1977 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1977 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1977 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1977 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1978 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1978 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", uuid);
#line 1980 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1980 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 8160 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 1981 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1981 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1981 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 1981 "../core/Services/Database.vala"
		g_warning ("Database.vala:1981: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 8172 "Database.c"
	}
#line 1970 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8176 "Database.c"
}

void
services_database_clear_queue (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
#line 1987 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1992 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue;\n        ");
#line 1992 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1992 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1996 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1996 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1996 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 1996 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1996 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 1996 "../core/Services/Database.vala"
	res = _tmp4_;
#line 1997 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1999 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 1999 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 8217 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 2000 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 2000 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 2000 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 2000 "../core/Services/Database.vala"
		g_warning ("Database.vala:2000: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 8229 "Database.c"
	}
#line 1987 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1987 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8235 "Database.c"
}

void
services_database_clear_cur_temp_ids (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
#line 2006 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2011 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds;\n        ");
#line 2011 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2011 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 2015 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2015 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 2015 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 2015 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2015 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 2015 "../core/Services/Database.vala"
	res = _tmp4_;
#line 2016 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2018 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 2018 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 8276 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 2019 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 2019 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 2019 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 2019 "../core/Services/Database.vala"
		g_warning ("Database.vala:2019: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 8288 "Database.c"
	}
#line 2006 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2006 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8294 "Database.c"
}

GeeArrayList*
services_database_get_events_by_item (ServicesDatabase* self,
                                      const gchar* id,
                                      gint start_week,
                                      gint end_week)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* result;
#line 2029 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2029 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 2030 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_OBJECT_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 2030 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 2034 "../core/Services/Database.vala"
	_tmp1_ = g_strdup_printf ("\n" \
"            SELECT * FROM OEvents\n" \
"                WHERE object_id = $object_id\n" \
"                AND (event_date >= DATETIME('now', '-%d days')\n" \
"                AND event_date <= DATETIME('now', '-%d days'))\n" \
"            ORDER BY event_date DESC\n" \
"        ", end_week, start_week);
#line 2034 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2034 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 2042 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 2042 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2042 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 2042 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 2042 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 2042 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 2042 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2042 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 2043 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 2043 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$object_id", id);
#line 2045 "../core/Services/Database.vala"
	while (TRUE) {
#line 8351 "Database.c"
		sqlite3_stmt* _tmp9_;
		GeeArrayList* _tmp10_;
		sqlite3_stmt* _tmp11_;
		ObjectsObjectEvent* _tmp12_;
		ObjectsObjectEvent* _tmp13_;
#line 2045 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 2045 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp9_) == SQLITE_ROW)) {
#line 2045 "../core/Services/Database.vala"
			break;
#line 8363 "Database.c"
		}
#line 2046 "../core/Services/Database.vala"
		_tmp10_ = return_value;
#line 2046 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 2046 "../core/Services/Database.vala"
		_tmp12_ = _services_database_fill_object_event (self, _tmp11_);
#line 2046 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 2046 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
#line 2046 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp13_);
#line 8377 "Database.c"
	}
#line 2049 "../core/Services/Database.vala"
	result = return_value;
#line 2049 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2049 "../core/Services/Database.vala"
	return result;
#line 8385 "Database.c"
}

ObjectsObjectEvent*
_services_database_fill_object_event (ServicesDatabase* self,
                                      sqlite3_stmt* stmt)
{
	ObjectsObjectEvent* return_value = NULL;
	ObjectsObjectEvent* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	ObjectsObjectEvent* result;
#line 2052 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2052 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 2053 "../core/Services/Database.vala"
	_tmp0_ = objects_object_event_new ();
#line 2053 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 2054 "../core/Services/Database.vala"
	objects_object_event_set_id (return_value, sqlite3_column_int64 (stmt, 0));
#line 2055 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 2055 "../core/Services/Database.vala"
	objects_object_event_set_event_type (return_value, object_event_type_parse (_tmp1_));
#line 2056 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 2056 "../core/Services/Database.vala"
	objects_object_event_set_event_date (return_value, _tmp2_);
#line 2057 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 2057 "../core/Services/Database.vala"
	objects_object_event_set_object_id (return_value, _tmp3_);
#line 2058 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 2058 "../core/Services/Database.vala"
	objects_object_event_set_object_type (return_value, _tmp4_);
#line 2059 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 2059 "../core/Services/Database.vala"
	objects_object_event_set_object_key (return_value, object_event_key_type_parse (_tmp5_));
#line 2060 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 2060 "../core/Services/Database.vala"
	objects_object_event_set_object_old_value (return_value, _tmp6_);
#line 2061 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 2061 "../core/Services/Database.vala"
	objects_object_event_set_object_new_value (return_value, _tmp7_);
#line 2062 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 2062 "../core/Services/Database.vala"
	objects_object_event_set_parent_item_id (return_value, _tmp8_);
#line 2063 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 2063 "../core/Services/Database.vala"
	objects_object_event_set_parent_project_id (return_value, _tmp9_);
#line 2064 "../core/Services/Database.vala"
	result = return_value;
#line 2064 "../core/Services/Database.vala"
	return result;
#line 8454 "Database.c"
}

static void
services_database_set_parameter_int (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     gint val)
{
	gint par_position = 0;
#line 2068 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2068 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2069 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2070 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, val);
#line 8472 "Database.c"
}

static void
services_database_set_parameter_int64 (ServicesDatabase* self,
                                       sqlite3_stmt* stmt,
                                       const gchar* par,
                                       gint64 val)
{
	gint par_position = 0;
#line 2073 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2073 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2074 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2075 "../core/Services/Database.vala"
	sqlite3_bind_int64 (stmt, par_position, val);
#line 8490 "Database.c"
}

static void
services_database_set_parameter_str (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     const gchar* val)
{
	gint par_position = 0;
	gchar* _tmp0_;
	GDestroyNotify _tmp1_;
#line 2078 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2078 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2078 "../core/Services/Database.vala"
	g_return_if_fail (val != NULL);
#line 2079 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2080 "../core/Services/Database.vala"
	_tmp0_ = g_strdup (val);
#line 2080 "../core/Services/Database.vala"
	_tmp1_ = g_free;
#line 2080 "../core/Services/Database.vala"
	sqlite3_bind_text (stmt, par_position, _tmp0_, -1, _tmp1_);
#line 8516 "Database.c"
}

static void
services_database_set_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      const gchar* par,
                                      gboolean val)
{
	gint par_position = 0;
	gint _tmp0_ = 0;
#line 2083 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2083 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2084 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2085 "../core/Services/Database.vala"
	if (val) {
#line 2085 "../core/Services/Database.vala"
		_tmp0_ = 1;
#line 8537 "Database.c"
	} else {
#line 2085 "../core/Services/Database.vala"
		_tmp0_ = 0;
#line 8541 "Database.c"
	}
#line 2085 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, _tmp0_);
#line 8545 "Database.c"
}

static gboolean
services_database_get_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      gint col)
{
	gboolean result;
#line 2088 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2088 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 2089 "../core/Services/Database.vala"
	result = sqlite3_column_int (stmt, col) == 1;
#line 2089 "../core/Services/Database.vala"
	return result;
#line 8562 "Database.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 2104 "../core/Services/Database.vala"
	return self ? json_object_ref (self) : NULL;
#line 8570 "Database.c"
}

JsonObject*
services_database_get_due_parameter (ServicesDatabase* self,
                                     const gchar* data)
{
	JsonParser* _tmp0_;
	JsonParser* _tmp5_;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
#line 2093 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2093 "../core/Services/Database.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 2094 "../core/Services/Database.vala"
	_tmp0_ = self->priv->parser;
#line 2094 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 8592 "Database.c"
		JsonParser* _tmp1_;
#line 2095 "../core/Services/Database.vala"
		_tmp1_ = json_parser_new ();
#line 2095 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->parser);
#line 2095 "../core/Services/Database.vala"
		self->priv->parser = _tmp1_;
#line 8600 "Database.c"
	}
	{
		JsonParser* _tmp2_;
#line 2099 "../core/Services/Database.vala"
		_tmp2_ = self->priv->parser;
#line 2099 "../core/Services/Database.vala"
		json_parser_load_from_data (_tmp2_, data, (gssize) -1, &_inner_error0_);
#line 2099 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8610 "Database.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 2098 "../core/Services/Database.vala"
		e = _inner_error0_;
#line 2098 "../core/Services/Database.vala"
		_inner_error0_ = NULL;
#line 2101 "../core/Services/Database.vala"
		_tmp3_ = e;
#line 2101 "../core/Services/Database.vala"
		_tmp4_ = _tmp3_->message;
#line 2101 "../core/Services/Database.vala"
		g_debug ("Database.vala:2101: %s", _tmp4_);
#line 2098 "../core/Services/Database.vala"
		_g_error_free0 (e);
#line 8632 "Database.c"
	}
	__finally0:
#line 2098 "../core/Services/Database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2098 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2098 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 2098 "../core/Services/Database.vala"
		return NULL;
#line 8643 "Database.c"
	}
#line 2104 "../core/Services/Database.vala"
	_tmp5_ = self->priv->parser;
#line 2104 "../core/Services/Database.vala"
	_tmp6_ = json_parser_get_root (_tmp5_);
#line 2104 "../core/Services/Database.vala"
	_tmp7_ = json_node_get_object (_tmp6_);
#line 2104 "../core/Services/Database.vala"
	_tmp8_ = _json_object_ref0 (_tmp7_);
#line 2104 "../core/Services/Database.vala"
	result = _tmp8_;
#line 2104 "../core/Services/Database.vala"
	return result;
#line 8657 "Database.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 8680 "Database.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 8689 "Database.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 8708 "Database.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 8712 "Database.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 8718 "Database.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 8728 "Database.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 8736 "Database.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 8740 "Database.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 8746 "Database.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 8756 "Database.c"
}

gchar*
services_database_get_labels_ids (ServicesDatabase* self,
                                  GeeArrayList* labels)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* result;
#line 2107 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2107 "../core/Services/Database.vala"
	g_return_val_if_fail (labels != NULL, NULL);
#line 2108 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 2108 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8777 "Database.c"
	{
		GeeArrayList* _label_list = NULL;
		gint _label_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _label_index = 0;
#line 2110 "../core/Services/Database.vala"
		_label_list = labels;
#line 2110 "../core/Services/Database.vala"
		_tmp1_ = _label_list;
#line 2110 "../core/Services/Database.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 2110 "../core/Services/Database.vala"
		_tmp3_ = _tmp2_;
#line 2110 "../core/Services/Database.vala"
		_label_size = _tmp3_;
#line 2110 "../core/Services/Database.vala"
		_label_index = -1;
#line 2110 "../core/Services/Database.vala"
		while (TRUE) {
#line 8799 "Database.c"
			gint _tmp4_;
			gint _tmp5_;
			ObjectsLabel* label = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			ObjectsLabel* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 2110 "../core/Services/Database.vala"
			_label_index = _label_index + 1;
#line 2110 "../core/Services/Database.vala"
			_tmp4_ = _label_index;
#line 2110 "../core/Services/Database.vala"
			_tmp5_ = _label_size;
#line 2110 "../core/Services/Database.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2110 "../core/Services/Database.vala"
				break;
#line 8822 "Database.c"
			}
#line 2110 "../core/Services/Database.vala"
			_tmp6_ = _label_list;
#line 2110 "../core/Services/Database.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _label_index);
#line 2110 "../core/Services/Database.vala"
			label = (ObjectsLabel*) _tmp7_;
#line 2111 "../core/Services/Database.vala"
			_tmp8_ = return_value;
#line 2111 "../core/Services/Database.vala"
			_tmp9_ = label;
#line 2111 "../core/Services/Database.vala"
			_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp9_);
#line 2111 "../core/Services/Database.vala"
			_tmp11_ = _tmp10_;
#line 2111 "../core/Services/Database.vala"
			_tmp12_ = g_strconcat (_tmp11_, ";", NULL);
#line 2111 "../core/Services/Database.vala"
			_tmp13_ = _tmp12_;
#line 2111 "../core/Services/Database.vala"
			_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
#line 2111 "../core/Services/Database.vala"
			_g_free0 (return_value);
#line 2111 "../core/Services/Database.vala"
			return_value = _tmp14_;
#line 2111 "../core/Services/Database.vala"
			_g_free0 (_tmp13_);
#line 2110 "../core/Services/Database.vala"
			_g_object_unref0 (label);
#line 8852 "Database.c"
		}
	}
#line 2114 "../core/Services/Database.vala"
	_tmp15_ = return_value;
#line 2114 "../core/Services/Database.vala"
	_tmp16_ = strlen (_tmp15_);
#line 2114 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 2114 "../core/Services/Database.vala"
	if (_tmp17_ > 0) {
#line 8863 "Database.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gchar* _tmp22_;
#line 2115 "../core/Services/Database.vala"
		_tmp18_ = return_value;
#line 2115 "../core/Services/Database.vala"
		_tmp19_ = return_value;
#line 2115 "../core/Services/Database.vala"
		_tmp20_ = strlen (_tmp19_);
#line 2115 "../core/Services/Database.vala"
		_tmp21_ = _tmp20_;
#line 2115 "../core/Services/Database.vala"
		_tmp22_ = string_substring (_tmp18_, (glong) 0, (glong) (_tmp21_ - 1));
#line 2115 "../core/Services/Database.vala"
		_g_free0 (return_value);
#line 2115 "../core/Services/Database.vala"
		return_value = _tmp22_;
#line 8883 "Database.c"
	}
#line 2118 "../core/Services/Database.vala"
	result = return_value;
#line 2118 "../core/Services/Database.vala"
	return result;
#line 8889 "Database.c"
}

gboolean
services_database_column_exists (ServicesDatabase* self,
                                 const gchar* table,
                                 const gchar* column)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean result;
#line 2121 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2121 "../core/Services/Database.vala"
	g_return_val_if_fail (table != NULL, FALSE);
#line 2121 "../core/Services/Database.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 2124 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n            PRAGMA table_info(%s);\n        ", table);
#line 2124 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2124 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2128 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2128 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2128 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2128 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2128 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2128 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2128 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2128 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2130 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2130 "../core/Services/Database.vala"
	sqlite3_step (_tmp7_);
#line 2132 "../core/Services/Database.vala"
	while (TRUE) {
#line 8941 "Database.c"
		sqlite3_stmt* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
#line 2132 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 2132 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 2132 "../core/Services/Database.vala"
			break;
#line 8951 "Database.c"
		}
#line 2133 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 2133 "../core/Services/Database.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 1);
#line 2133 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp10_, column) == 0) {
#line 2134 "../core/Services/Database.vala"
			result = TRUE;
#line 2134 "../core/Services/Database.vala"
			_sqlite3_finalize0 (stmt);
#line 2134 "../core/Services/Database.vala"
			return result;
#line 8965 "Database.c"
		}
	}
#line 2138 "../core/Services/Database.vala"
	result = FALSE;
#line 2138 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2138 "../core/Services/Database.vala"
	return result;
#line 8974 "Database.c"
}

void
services_database_add_text_column (ServicesDatabase* self,
                                   const gchar* table,
                                   const gchar* column,
                                   const gchar* default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 2141 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2141 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 2141 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 2141 "../core/Services/Database.vala"
	g_return_if_fail (default_value != NULL);
#line 2142 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 2143 "../core/Services/Database.vala"
		return;
#line 9004 "Database.c"
	}
#line 2148 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s TEXT DEFAULT '%s';\n" \
"        ", table, column, default_value);
#line 2148 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2148 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2152 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2152 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2152 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2152 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2152 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2152 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2152 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2152 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2154 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2154 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 9032 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2155 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2155 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2155 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2155 "../core/Services/Database.vala"
		g_warning ("Database.vala:2155: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 9044 "Database.c"
	}
#line 2141 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 9048 "Database.c"
}

void
services_database_add_int_column (ServicesDatabase* self,
                                  const gchar* table,
                                  const gchar* column,
                                  gint default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 2161 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2161 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 2161 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 2162 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 2163 "../core/Services/Database.vala"
		return;
#line 9076 "Database.c"
	}
#line 2168 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s INTEGER DEFAULT %i;\n" \
"        ", table, column, default_value);
#line 2168 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2168 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2172 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2172 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2172 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2172 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2172 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2172 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2172 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2172 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2174 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2174 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 9104 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2175 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2175 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2175 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2175 "../core/Services/Database.vala"
		g_warning ("Database.vala:2175: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 9116 "Database.c"
	}
#line 2161 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 9120 "Database.c"
}

void
services_database_add_item_label_column (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 2181 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2182 "../core/Services/Database.vala"
	if (services_database_column_exists (self, "Items", "labels")) {
#line 2183 "../core/Services/Database.vala"
		return;
#line 9141 "Database.c"
	}
#line 2188 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            ALTER TABLE Items ADD COLUMN labels TEXT;\n" \
"\n" \
"            UPDATE Items\n" \
"            SET labels = (\n" \
"                SELECT GROUP_CONCAT(label_id, ';')\n" \
"                FROM Items_Labels\n" \
"                WHERE item_id = Items.id\n" \
"            );\n" \
"        ");
#line 2188 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2188 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2199 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2199 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2199 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2199 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2199 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2199 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2199 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2199 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2201 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2201 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 9169 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2202 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2202 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2202 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2202 "../core/Services/Database.vala"
		g_warning ("Database.vala:2202: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 9181 "Database.c"
	}
#line 2181 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 9185 "Database.c"
}

void
services_database_add_project_labels_source_id (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	Util* _tmp12_;
	Util* _tmp13_;
	ObjectsSource* _tmp14_;
	ObjectsSource* _tmp15_;
	ServicesTodoist* _tmp16_;
	ServicesTodoist* _tmp17_;
	gboolean _tmp18_;
	ServicesCalDAVCore* _tmp45_;
	ServicesCalDAVCore* _tmp46_;
	gboolean _tmp47_;
#line 2208 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2209 "../core/Services/Database.vala"
	if (services_database_column_exists (self, "Projects", "source_id")) {
#line 2210 "../core/Services/Database.vala"
		return;
#line 9217 "Database.c"
	}
#line 2213 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            ALTER TABLE Projects ADD COLUMN source_id TEXT;\n" \
"            UPDATE Projects SET source_id = backend_type;\n" \
"        ");
#line 2213 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2213 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2218 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2218 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2218 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 2218 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 2218 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 2218 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 9237 "Database.c"
		const gchar* _tmp5_;
#line 2219 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 2219 "../core/Services/Database.vala"
		g_warning ("Database.vala:2219: %s", _tmp5_);
#line 9243 "Database.c"
	}
#line 2222 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            ALTER TABLE Labels ADD COLUMN source_id TEXT;\n" \
"            UPDATE Labels SET source_id = backend_type;\n" \
"        ");
#line 2222 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2222 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 2227 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 2227 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 2227 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 2227 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 2227 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 2227 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 9263 "Database.c"
		const gchar* _tmp11_;
#line 2228 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 2228 "../core/Services/Database.vala"
		g_warning ("Database.vala:2228: %s", _tmp11_);
#line 9269 "Database.c"
	}
#line 2231 "../core/Services/Database.vala"
	_tmp12_ = util_get_default ();
#line 2231 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 2231 "../core/Services/Database.vala"
	_tmp14_ = util_create_local_source (_tmp13_);
#line 2231 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 2231 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp15_);
#line 2231 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp13_);
#line 2233 "../core/Services/Database.vala"
	_tmp16_ = services_todoist_get_default ();
#line 2233 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 2233 "../core/Services/Database.vala"
	_tmp18_ = services_todoist_is_logged_in (_tmp17_);
#line 2233 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp17_);
#line 2233 "../core/Services/Database.vala"
	if (_tmp18_) {
#line 9293 "Database.c"
		ObjectsSource* todoist_source = NULL;
		ObjectsSource* _tmp19_;
		ObjectsSource* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		ObjectsSource* _tmp23_;
		ObjectsSource* _tmp24_;
		ServicesSettings* _tmp25_;
		ServicesSettings* _tmp26_;
		GSettings* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		ObjectsSource* _tmp30_;
		ObjectsSourceTodoistData* _tmp31_;
		ObjectsSourceTodoistData* _tmp32_;
		ObjectsSource* _tmp33_;
		ServicesSettings* _tmp34_;
		ServicesSettings* _tmp35_;
		GSettings* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		ObjectsSource* _tmp39_;
		ServicesSettings* _tmp40_;
		ServicesSettings* _tmp41_;
		GSettings* _tmp42_;
		ServicesStore* _tmp43_;
		ObjectsSource* _tmp44_;
#line 2234 "../core/Services/Database.vala"
		_tmp19_ = objects_source_new ();
#line 2234 "../core/Services/Database.vala"
		todoist_source = _tmp19_;
#line 2235 "../core/Services/Database.vala"
		_tmp20_ = todoist_source;
#line 2235 "../core/Services/Database.vala"
		_tmp21_ = source_type_to_string (SOURCE_TYPE_TODOIST);
#line 2235 "../core/Services/Database.vala"
		_tmp22_ = _tmp21_;
#line 2235 "../core/Services/Database.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp20_, _tmp22_);
#line 2235 "../core/Services/Database.vala"
		_g_free0 (_tmp22_);
#line 2236 "../core/Services/Database.vala"
		_tmp23_ = todoist_source;
#line 2236 "../core/Services/Database.vala"
		objects_source_set_source_type (_tmp23_, SOURCE_TYPE_TODOIST);
#line 2237 "../core/Services/Database.vala"
		_tmp24_ = todoist_source;
#line 2237 "../core/Services/Database.vala"
		_tmp25_ = services_settings_get_default ();
#line 2237 "../core/Services/Database.vala"
		_tmp26_ = _tmp25_;
#line 2237 "../core/Services/Database.vala"
		_tmp27_ = _tmp26_->settings;
#line 2237 "../core/Services/Database.vala"
		_tmp28_ = g_settings_get_string (_tmp27_, "todoist-user-email");
#line 2237 "../core/Services/Database.vala"
		_tmp29_ = _tmp28_;
#line 2237 "../core/Services/Database.vala"
		objects_source_set_display_name (_tmp24_, _tmp29_);
#line 2237 "../core/Services/Database.vala"
		_g_free0 (_tmp29_);
#line 2237 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp26_);
#line 2238 "../core/Services/Database.vala"
		_tmp30_ = todoist_source;
#line 2238 "../core/Services/Database.vala"
		_tmp31_ = utils_account_migrate_get_data_from_todoist ();
#line 2238 "../core/Services/Database.vala"
		_tmp32_ = _tmp31_;
#line 2238 "../core/Services/Database.vala"
		objects_source_set_data (_tmp30_, (ObjectsSourceData*) _tmp32_);
#line 2238 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp32_);
#line 2239 "../core/Services/Database.vala"
		_tmp33_ = todoist_source;
#line 2239 "../core/Services/Database.vala"
		_tmp34_ = services_settings_get_default ();
#line 2239 "../core/Services/Database.vala"
		_tmp35_ = _tmp34_;
#line 2239 "../core/Services/Database.vala"
		_tmp36_ = _tmp35_->settings;
#line 2239 "../core/Services/Database.vala"
		_tmp37_ = g_settings_get_string (_tmp36_, "todoist-last-sync");
#line 2239 "../core/Services/Database.vala"
		_tmp38_ = _tmp37_;
#line 2239 "../core/Services/Database.vala"
		objects_source_set_last_sync (_tmp33_, _tmp38_);
#line 2239 "../core/Services/Database.vala"
		_g_free0 (_tmp38_);
#line 2239 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp35_);
#line 2240 "../core/Services/Database.vala"
		_tmp39_ = todoist_source;
#line 2240 "../core/Services/Database.vala"
		_tmp40_ = services_settings_get_default ();
#line 2240 "../core/Services/Database.vala"
		_tmp41_ = _tmp40_;
#line 2240 "../core/Services/Database.vala"
		_tmp42_ = _tmp41_->settings;
#line 2240 "../core/Services/Database.vala"
		objects_source_set_sync_server (_tmp39_, g_settings_get_boolean (_tmp42_, "todoist-sync-server"));
#line 2240 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp41_);
#line 2242 "../core/Services/Database.vala"
		_tmp43_ = services_store_instance ();
#line 2242 "../core/Services/Database.vala"
		_tmp44_ = todoist_source;
#line 2242 "../core/Services/Database.vala"
		services_store_insert_source (_tmp43_, _tmp44_);
#line 2233 "../core/Services/Database.vala"
		_g_object_unref0 (todoist_source);
#line 9405 "Database.c"
	}
#line 2245 "../core/Services/Database.vala"
	_tmp45_ = services_cal_dav_core_get_default ();
#line 2245 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 2245 "../core/Services/Database.vala"
	_tmp47_ = services_cal_dav_core_is_logged_in (_tmp46_);
#line 2245 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp46_);
#line 2245 "../core/Services/Database.vala"
	if (_tmp47_) {
#line 9417 "Database.c"
		ObjectsSource* caldav_source = NULL;
		ObjectsSource* _tmp48_;
		ObjectsSource* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		ObjectsSource* _tmp52_;
		ObjectsSource* _tmp53_;
		ObjectsSourceCalDAVData* _tmp54_;
		ObjectsSourceCalDAVData* _tmp55_;
		ObjectsSource* _tmp56_;
		ServicesSettings* _tmp57_;
		ServicesSettings* _tmp58_;
		GSettings* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		ObjectsSource* _tmp62_;
		ServicesSettings* _tmp63_;
		ServicesSettings* _tmp64_;
		GSettings* _tmp65_;
		ObjectsSource* _tmp66_;
		ObjectsSourceCalDAVData* _tmp67_;
		ObjectsSourceCalDAVData* _tmp68_;
		const gchar* _tmp69_;
		const gchar* _tmp70_;
		ServicesStore* _tmp89_;
		ObjectsSource* _tmp90_;
#line 2246 "../core/Services/Database.vala"
		_tmp48_ = objects_source_new ();
#line 2246 "../core/Services/Database.vala"
		caldav_source = _tmp48_;
#line 2247 "../core/Services/Database.vala"
		_tmp49_ = caldav_source;
#line 2247 "../core/Services/Database.vala"
		_tmp50_ = source_type_to_string (SOURCE_TYPE_CALDAV);
#line 2247 "../core/Services/Database.vala"
		_tmp51_ = _tmp50_;
#line 2247 "../core/Services/Database.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp49_, _tmp51_);
#line 2247 "../core/Services/Database.vala"
		_g_free0 (_tmp51_);
#line 2248 "../core/Services/Database.vala"
		_tmp52_ = caldav_source;
#line 2248 "../core/Services/Database.vala"
		objects_source_set_source_type (_tmp52_, SOURCE_TYPE_CALDAV);
#line 2249 "../core/Services/Database.vala"
		_tmp53_ = caldav_source;
#line 2249 "../core/Services/Database.vala"
		_tmp54_ = utils_account_migrate_get_data_from_caldav ();
#line 2249 "../core/Services/Database.vala"
		_tmp55_ = _tmp54_;
#line 2249 "../core/Services/Database.vala"
		objects_source_set_data (_tmp53_, (ObjectsSourceData*) _tmp55_);
#line 2249 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp55_);
#line 2250 "../core/Services/Database.vala"
		_tmp56_ = caldav_source;
#line 2250 "../core/Services/Database.vala"
		_tmp57_ = services_settings_get_default ();
#line 2250 "../core/Services/Database.vala"
		_tmp58_ = _tmp57_;
#line 2250 "../core/Services/Database.vala"
		_tmp59_ = _tmp58_->settings;
#line 2250 "../core/Services/Database.vala"
		_tmp60_ = g_settings_get_string (_tmp59_, "caldav-last-sync");
#line 2250 "../core/Services/Database.vala"
		_tmp61_ = _tmp60_;
#line 2250 "../core/Services/Database.vala"
		objects_source_set_last_sync (_tmp56_, _tmp61_);
#line 2250 "../core/Services/Database.vala"
		_g_free0 (_tmp61_);
#line 2250 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp58_);
#line 2251 "../core/Services/Database.vala"
		_tmp62_ = caldav_source;
#line 2251 "../core/Services/Database.vala"
		_tmp63_ = services_settings_get_default ();
#line 2251 "../core/Services/Database.vala"
		_tmp64_ = _tmp63_;
#line 2251 "../core/Services/Database.vala"
		_tmp65_ = _tmp64_->settings;
#line 2251 "../core/Services/Database.vala"
		objects_source_set_sync_server (_tmp62_, g_settings_get_boolean (_tmp65_, "caldav-sync-server"));
#line 2251 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp64_);
#line 2253 "../core/Services/Database.vala"
		_tmp66_ = caldav_source;
#line 2253 "../core/Services/Database.vala"
		_tmp67_ = objects_source_get_caldav_data (_tmp66_);
#line 2253 "../core/Services/Database.vala"
		_tmp68_ = _tmp67_;
#line 2253 "../core/Services/Database.vala"
		_tmp69_ = objects_source_cal_dav_data_get_user_email (_tmp68_);
#line 2253 "../core/Services/Database.vala"
		_tmp70_ = _tmp69_;
#line 2253 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp70_, "") != 0) {
#line 9514 "Database.c"
			ObjectsSource* _tmp71_;
			ObjectsSource* _tmp72_;
			ObjectsSourceCalDAVData* _tmp73_;
			ObjectsSourceCalDAVData* _tmp74_;
			const gchar* _tmp75_;
			const gchar* _tmp76_;
#line 2254 "../core/Services/Database.vala"
			_tmp71_ = caldav_source;
#line 2254 "../core/Services/Database.vala"
			_tmp72_ = caldav_source;
#line 2254 "../core/Services/Database.vala"
			_tmp73_ = objects_source_get_caldav_data (_tmp72_);
#line 2254 "../core/Services/Database.vala"
			_tmp74_ = _tmp73_;
#line 2254 "../core/Services/Database.vala"
			_tmp75_ = objects_source_cal_dav_data_get_user_email (_tmp74_);
#line 2254 "../core/Services/Database.vala"
			_tmp76_ = _tmp75_;
#line 2254 "../core/Services/Database.vala"
			objects_source_set_display_name (_tmp71_, _tmp76_);
#line 9535 "Database.c"
		} else {
			ObjectsSource* _tmp77_;
			ObjectsSourceCalDAVData* _tmp78_;
			ObjectsSourceCalDAVData* _tmp79_;
			const gchar* _tmp80_;
			const gchar* _tmp81_;
#line 2255 "../core/Services/Database.vala"
			_tmp77_ = caldav_source;
#line 2255 "../core/Services/Database.vala"
			_tmp78_ = objects_source_get_caldav_data (_tmp77_);
#line 2255 "../core/Services/Database.vala"
			_tmp79_ = _tmp78_;
#line 2255 "../core/Services/Database.vala"
			_tmp80_ = objects_source_cal_dav_data_get_user_displayname (_tmp79_);
#line 2255 "../core/Services/Database.vala"
			_tmp81_ = _tmp80_;
#line 2255 "../core/Services/Database.vala"
			if (g_strcmp0 (_tmp81_, "") != 0) {
#line 9554 "Database.c"
				ObjectsSource* _tmp82_;
				ObjectsSource* _tmp83_;
				ObjectsSourceCalDAVData* _tmp84_;
				ObjectsSourceCalDAVData* _tmp85_;
				const gchar* _tmp86_;
				const gchar* _tmp87_;
#line 2256 "../core/Services/Database.vala"
				_tmp82_ = caldav_source;
#line 2256 "../core/Services/Database.vala"
				_tmp83_ = caldav_source;
#line 2256 "../core/Services/Database.vala"
				_tmp84_ = objects_source_get_caldav_data (_tmp83_);
#line 2256 "../core/Services/Database.vala"
				_tmp85_ = _tmp84_;
#line 2256 "../core/Services/Database.vala"
				_tmp86_ = objects_source_cal_dav_data_get_user_displayname (_tmp85_);
#line 2256 "../core/Services/Database.vala"
				_tmp87_ = _tmp86_;
#line 2256 "../core/Services/Database.vala"
				objects_source_set_display_name (_tmp82_, _tmp87_);
#line 9575 "Database.c"
			} else {
				ObjectsSource* _tmp88_;
#line 2258 "../core/Services/Database.vala"
				_tmp88_ = caldav_source;
#line 2258 "../core/Services/Database.vala"
				objects_source_set_display_name (_tmp88_, _ ("Nextcloud"));
#line 9582 "Database.c"
			}
		}
#line 2261 "../core/Services/Database.vala"
		_tmp89_ = services_store_instance ();
#line 2261 "../core/Services/Database.vala"
		_tmp90_ = caldav_source;
#line 2261 "../core/Services/Database.vala"
		services_store_insert_source (_tmp89_, _tmp90_);
#line 2245 "../core/Services/Database.vala"
		_g_object_unref0 (caldav_source);
#line 9593 "Database.c"
	}
}

ServicesDatabase*
services_database_construct (GType object_type)
{
	ServicesDatabase * self = NULL;
#line 22 "../core/Services/Database.vala"
	self = (ServicesDatabase*) g_object_new (object_type, NULL);
#line 22 "../core/Services/Database.vala"
	return self;
#line 9605 "Database.c"
}

ServicesDatabase*
services_database_new (void)
{
#line 22 "../core/Services/Database.vala"
	return services_database_construct (SERVICES_TYPE_DATABASE);
#line 9613 "Database.c"
}

static GObject *
services_database_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServicesDatabase * self;
	GeeHashMap* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GeeArrayList* _tmp5_;
	GeeHashMap* _tmp6_;
	gpointer _tmp7_;
	GeeArrayList* _tmp8_;
	GeeHashMap* _tmp9_;
	gpointer _tmp10_;
	GeeArrayList* _tmp11_;
	GeeHashMap* _tmp12_;
	gpointer _tmp13_;
	GeeArrayList* _tmp14_;
	GeeHashMap* _tmp15_;
	gpointer _tmp16_;
	GeeArrayList* _tmp17_;
	GeeHashMap* _tmp18_;
	gpointer _tmp19_;
	GeeArrayList* _tmp20_;
	GeeHashMap* _tmp21_;
	GeeArrayList* _tmp22_;
	GeeArrayList* _tmp23_;
	GeeHashMap* _tmp24_;
	gpointer _tmp25_;
	GeeArrayList* _tmp26_;
	GeeHashMap* _tmp27_;
	gpointer _tmp28_;
	GeeArrayList* _tmp29_;
	GeeHashMap* _tmp30_;
	gpointer _tmp31_;
	GeeArrayList* _tmp32_;
	GeeHashMap* _tmp33_;
	GeeArrayList* _tmp34_;
	GeeArrayList* _tmp35_;
	GeeHashMap* _tmp36_;
	gpointer _tmp37_;
	GeeArrayList* _tmp38_;
	GeeHashMap* _tmp39_;
	gpointer _tmp40_;
	GeeArrayList* _tmp41_;
	GeeHashMap* _tmp42_;
	gpointer _tmp43_;
	GeeArrayList* _tmp44_;
	GeeHashMap* _tmp45_;
	gpointer _tmp46_;
	GeeArrayList* _tmp47_;
	GeeHashMap* _tmp48_;
	gpointer _tmp49_;
	GeeArrayList* _tmp50_;
	GeeHashMap* _tmp51_;
	gpointer _tmp52_;
	GeeArrayList* _tmp53_;
	GeeHashMap* _tmp54_;
	gpointer _tmp55_;
	GeeArrayList* _tmp56_;
	GeeHashMap* _tmp57_;
	gpointer _tmp58_;
	GeeArrayList* _tmp59_;
	GeeHashMap* _tmp60_;
	gpointer _tmp61_;
	GeeArrayList* _tmp62_;
	GeeHashMap* _tmp63_;
	gpointer _tmp64_;
	GeeArrayList* _tmp65_;
	GeeHashMap* _tmp66_;
	gpointer _tmp67_;
	GeeArrayList* _tmp68_;
	GeeHashMap* _tmp69_;
	gpointer _tmp70_;
	GeeArrayList* _tmp71_;
	GeeHashMap* _tmp72_;
	gpointer _tmp73_;
	GeeArrayList* _tmp74_;
	GeeHashMap* _tmp75_;
	gpointer _tmp76_;
	GeeArrayList* _tmp77_;
	GeeHashMap* _tmp78_;
	gpointer _tmp79_;
	GeeArrayList* _tmp80_;
	GeeHashMap* _tmp81_;
	gpointer _tmp82_;
	GeeArrayList* _tmp83_;
	GeeHashMap* _tmp84_;
	gpointer _tmp85_;
	GeeArrayList* _tmp86_;
	GeeHashMap* _tmp87_;
	gpointer _tmp88_;
	GeeArrayList* _tmp89_;
	GeeHashMap* _tmp90_;
	gpointer _tmp91_;
	GeeArrayList* _tmp92_;
	GeeHashMap* _tmp93_;
	gpointer _tmp94_;
	GeeArrayList* _tmp95_;
	GeeHashMap* _tmp96_;
	GeeArrayList* _tmp97_;
	GeeArrayList* _tmp98_;
	GeeHashMap* _tmp99_;
	gpointer _tmp100_;
	GeeArrayList* _tmp101_;
	GeeHashMap* _tmp102_;
	gpointer _tmp103_;
	GeeArrayList* _tmp104_;
	GeeHashMap* _tmp105_;
	gpointer _tmp106_;
	GeeArrayList* _tmp107_;
	GeeHashMap* _tmp108_;
	gpointer _tmp109_;
	GeeArrayList* _tmp110_;
	GeeHashMap* _tmp111_;
	gpointer _tmp112_;
	GeeArrayList* _tmp113_;
	GeeHashMap* _tmp114_;
	gpointer _tmp115_;
	GeeArrayList* _tmp116_;
	GeeHashMap* _tmp117_;
	gpointer _tmp118_;
	GeeArrayList* _tmp119_;
	GeeHashMap* _tmp120_;
	gpointer _tmp121_;
	GeeArrayList* _tmp122_;
	GeeHashMap* _tmp123_;
	GeeArrayList* _tmp124_;
	GeeArrayList* _tmp125_;
	GeeHashMap* _tmp126_;
	gpointer _tmp127_;
	GeeArrayList* _tmp128_;
	GeeHashMap* _tmp129_;
	gpointer _tmp130_;
	GeeArrayList* _tmp131_;
	GeeHashMap* _tmp132_;
	gpointer _tmp133_;
	GeeArrayList* _tmp134_;
	GeeHashMap* _tmp135_;
	gpointer _tmp136_;
	GeeArrayList* _tmp137_;
	GeeHashMap* _tmp138_;
	gpointer _tmp139_;
	GeeArrayList* _tmp140_;
	GeeHashMap* _tmp141_;
	gpointer _tmp142_;
	GeeArrayList* _tmp143_;
	GeeHashMap* _tmp144_;
	gpointer _tmp145_;
	GeeArrayList* _tmp146_;
	GeeHashMap* _tmp147_;
	gpointer _tmp148_;
	GeeArrayList* _tmp149_;
	GeeHashMap* _tmp150_;
	gpointer _tmp151_;
	GeeArrayList* _tmp152_;
	GeeHashMap* _tmp153_;
	gpointer _tmp154_;
	GeeArrayList* _tmp155_;
	GeeHashMap* _tmp156_;
	GeeArrayList* _tmp157_;
	GeeArrayList* _tmp158_;
	GeeHashMap* _tmp159_;
	gpointer _tmp160_;
	GeeArrayList* _tmp161_;
	GeeHashMap* _tmp162_;
	gpointer _tmp163_;
	GeeArrayList* _tmp164_;
	GeeHashMap* _tmp165_;
	gpointer _tmp166_;
	GeeArrayList* _tmp167_;
	GeeHashMap* _tmp168_;
	gpointer _tmp169_;
	GeeArrayList* _tmp170_;
	GeeHashMap* _tmp171_;
	gpointer _tmp172_;
	GeeArrayList* _tmp173_;
	GeeHashMap* _tmp174_;
	gpointer _tmp175_;
	GeeArrayList* _tmp176_;
	GeeHashMap* _tmp177_;
	gpointer _tmp178_;
	GeeArrayList* _tmp179_;
	GeeHashMap* _tmp180_;
	gpointer _tmp181_;
	GeeArrayList* _tmp182_;
	GeeHashMap* _tmp183_;
	gpointer _tmp184_;
	GeeArrayList* _tmp185_;
	GeeHashMap* _tmp186_;
	gpointer _tmp187_;
	GeeArrayList* _tmp188_;
	GeeHashMap* _tmp189_;
	gpointer _tmp190_;
	GeeArrayList* _tmp191_;
	GeeHashMap* _tmp192_;
	gpointer _tmp193_;
	GeeArrayList* _tmp194_;
	GeeHashMap* _tmp195_;
	gpointer _tmp196_;
	GeeArrayList* _tmp197_;
	GeeHashMap* _tmp198_;
	gpointer _tmp199_;
	GeeArrayList* _tmp200_;
	GeeHashMap* _tmp201_;
	gpointer _tmp202_;
	GeeArrayList* _tmp203_;
	GeeHashMap* _tmp204_;
	gpointer _tmp205_;
	GeeArrayList* _tmp206_;
	GeeHashMap* _tmp207_;
	gpointer _tmp208_;
	GeeArrayList* _tmp209_;
	GeeHashMap* _tmp210_;
	gpointer _tmp211_;
	GeeArrayList* _tmp212_;
	GeeHashMap* _tmp213_;
	gpointer _tmp214_;
	GeeArrayList* _tmp215_;
	GeeHashMap* _tmp216_;
	gpointer _tmp217_;
	GeeArrayList* _tmp218_;
	GeeHashMap* _tmp219_;
	gpointer _tmp220_;
	GeeArrayList* _tmp221_;
	GeeHashMap* _tmp222_;
	gpointer _tmp223_;
	GeeArrayList* _tmp224_;
	GeeHashMap* _tmp225_;
	gpointer _tmp226_;
	GeeArrayList* _tmp227_;
	GeeHashMap* _tmp228_;
	GeeArrayList* _tmp229_;
	GeeArrayList* _tmp230_;
	GeeHashMap* _tmp231_;
	gpointer _tmp232_;
	GeeArrayList* _tmp233_;
	GeeHashMap* _tmp234_;
	gpointer _tmp235_;
	GeeArrayList* _tmp236_;
	GeeHashMap* _tmp237_;
	gpointer _tmp238_;
	GeeArrayList* _tmp239_;
	GeeHashMap* _tmp240_;
	gpointer _tmp241_;
	GeeArrayList* _tmp242_;
	GeeHashMap* _tmp243_;
	gpointer _tmp244_;
	GeeArrayList* _tmp245_;
	GeeHashMap* _tmp246_;
	gpointer _tmp247_;
	GeeArrayList* _tmp248_;
	GeeHashMap* _tmp249_;
	GeeArrayList* _tmp250_;
	GeeArrayList* _tmp251_;
	GeeHashMap* _tmp252_;
	gpointer _tmp253_;
	GeeArrayList* _tmp254_;
	GeeHashMap* _tmp255_;
	gpointer _tmp256_;
	GeeArrayList* _tmp257_;
	GeeHashMap* _tmp258_;
	gpointer _tmp259_;
	GeeArrayList* _tmp260_;
	GeeHashMap* _tmp261_;
	gpointer _tmp262_;
	GeeArrayList* _tmp263_;
	GeeHashMap* _tmp264_;
	gpointer _tmp265_;
	GeeArrayList* _tmp266_;
	GeeHashMap* _tmp267_;
	gpointer _tmp268_;
	GeeArrayList* _tmp269_;
	GeeHashMap* _tmp270_;
	gpointer _tmp271_;
	GeeArrayList* _tmp272_;
	GeeHashMap* _tmp273_;
	gpointer _tmp274_;
	GeeArrayList* _tmp275_;
	GeeHashMap* _tmp276_;
	GeeArrayList* _tmp277_;
	GeeArrayList* _tmp278_;
	GeeHashMap* _tmp279_;
	gpointer _tmp280_;
	GeeArrayList* _tmp281_;
	GeeHashMap* _tmp282_;
	gpointer _tmp283_;
	GeeArrayList* _tmp284_;
	GeeHashMap* _tmp285_;
	gpointer _tmp286_;
	GeeArrayList* _tmp287_;
	GeeHashMap* _tmp288_;
	gpointer _tmp289_;
	GeeArrayList* _tmp290_;
	GeeHashMap* _tmp291_;
	gpointer _tmp292_;
	GeeArrayList* _tmp293_;
	GeeHashMap* _tmp294_;
	gpointer _tmp295_;
	GeeArrayList* _tmp296_;
	GeeHashMap* _tmp297_;
	gpointer _tmp298_;
	GeeArrayList* _tmp299_;
	GeeHashMap* _tmp300_;
	gpointer _tmp301_;
	GeeArrayList* _tmp302_;
	GeeHashMap* _tmp303_;
	gpointer _tmp304_;
	GeeArrayList* _tmp305_;
	GeeHashMap* _tmp306_;
	gpointer _tmp307_;
	GeeArrayList* _tmp308_;
	GeeHashMap* _tmp309_;
	gpointer _tmp310_;
	GeeArrayList* _tmp311_;
	GeeHashMap* _tmp312_;
	gpointer _tmp313_;
	GeeArrayList* _tmp314_;
	GeeHashMap* _tmp315_;
	GeeArrayList* _tmp316_;
	GeeArrayList* _tmp317_;
	GeeHashMap* _tmp318_;
	gpointer _tmp319_;
	GeeArrayList* _tmp320_;
	GeeHashMap* _tmp321_;
	gpointer _tmp322_;
	GeeArrayList* _tmp323_;
	GeeHashMap* _tmp324_;
	gpointer _tmp325_;
	GeeArrayList* _tmp326_;
	GeeHashMap* _tmp327_;
	gpointer _tmp328_;
	GeeArrayList* _tmp329_;
	GeeHashMap* _tmp330_;
	gpointer _tmp331_;
	GeeArrayList* _tmp332_;
	GeeHashMap* _tmp333_;
	gpointer _tmp334_;
	GeeArrayList* _tmp335_;
	GeeHashMap* _tmp336_;
	gpointer _tmp337_;
	GeeArrayList* _tmp338_;
	GeeHashMap* _tmp339_;
	gpointer _tmp340_;
	GeeArrayList* _tmp341_;
	GeeHashMap* _tmp342_;
	gpointer _tmp343_;
	GeeArrayList* _tmp344_;
	GeeHashMap* _tmp345_;
	gpointer _tmp346_;
	GeeArrayList* _tmp347_;
#line 42 "../core/Services/Database.vala"
	parent_class = G_OBJECT_CLASS (services_database_parent_class);
#line 42 "../core/Services/Database.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../core/Services/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 43 "../core/Services/Database.vala"
	_tmp0_ = self->priv->table_columns;
#line 43 "../core/Services/Database.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 43 "../core/Services/Database.vala"
	_tmp2_ = _tmp1_;
#line 43 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, "Attachments", _tmp2_);
#line 43 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp2_);
#line 44 "../core/Services/Database.vala"
	_tmp3_ = self->priv->table_columns;
#line 44 "../core/Services/Database.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, "Attachments");
#line 44 "../core/Services/Database.vala"
	_tmp5_ = (GeeArrayList*) _tmp4_;
#line 44 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, "id");
#line 44 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp5_);
#line 45 "../core/Services/Database.vala"
	_tmp6_ = self->priv->table_columns;
#line 45 "../core/Services/Database.vala"
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, "Attachments");
#line 45 "../core/Services/Database.vala"
	_tmp8_ = (GeeArrayList*) _tmp7_;
#line 45 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, "item_id");
#line 45 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp8_);
#line 46 "../core/Services/Database.vala"
	_tmp9_ = self->priv->table_columns;
#line 46 "../core/Services/Database.vala"
	_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, "Attachments");
#line 46 "../core/Services/Database.vala"
	_tmp11_ = (GeeArrayList*) _tmp10_;
#line 46 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, "file_type");
#line 46 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp11_);
#line 47 "../core/Services/Database.vala"
	_tmp12_ = self->priv->table_columns;
#line 47 "../core/Services/Database.vala"
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, "Attachments");
#line 47 "../core/Services/Database.vala"
	_tmp14_ = (GeeArrayList*) _tmp13_;
#line 47 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, "file_name");
#line 47 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp14_);
#line 48 "../core/Services/Database.vala"
	_tmp15_ = self->priv->table_columns;
#line 48 "../core/Services/Database.vala"
	_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, "Attachments");
#line 48 "../core/Services/Database.vala"
	_tmp17_ = (GeeArrayList*) _tmp16_;
#line 48 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, "file_size");
#line 48 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp17_);
#line 49 "../core/Services/Database.vala"
	_tmp18_ = self->priv->table_columns;
#line 49 "../core/Services/Database.vala"
	_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, "Attachments");
#line 49 "../core/Services/Database.vala"
	_tmp20_ = (GeeArrayList*) _tmp19_;
#line 49 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "file_path");
#line 49 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp20_);
#line 51 "../core/Services/Database.vala"
	_tmp21_ = self->priv->table_columns;
#line 51 "../core/Services/Database.vala"
	_tmp22_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 51 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 51 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, "CurTempIds", _tmp23_);
#line 51 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp23_);
#line 52 "../core/Services/Database.vala"
	_tmp24_ = self->priv->table_columns;
#line 52 "../core/Services/Database.vala"
	_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, "CurTempIds");
#line 52 "../core/Services/Database.vala"
	_tmp26_ = (GeeArrayList*) _tmp25_;
#line 52 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "id");
#line 52 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp26_);
#line 53 "../core/Services/Database.vala"
	_tmp27_ = self->priv->table_columns;
#line 53 "../core/Services/Database.vala"
	_tmp28_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, "CurTempIds");
#line 53 "../core/Services/Database.vala"
	_tmp29_ = (GeeArrayList*) _tmp28_;
#line 53 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, "temp_id");
#line 53 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp29_);
#line 54 "../core/Services/Database.vala"
	_tmp30_ = self->priv->table_columns;
#line 54 "../core/Services/Database.vala"
	_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp30_, "CurTempIds");
#line 54 "../core/Services/Database.vala"
	_tmp32_ = (GeeArrayList*) _tmp31_;
#line 54 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, "object");
#line 54 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp32_);
#line 56 "../core/Services/Database.vala"
	_tmp33_ = self->priv->table_columns;
#line 56 "../core/Services/Database.vala"
	_tmp34_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 56 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 56 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp33_, "Items", _tmp35_);
#line 56 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp35_);
#line 57 "../core/Services/Database.vala"
	_tmp36_ = self->priv->table_columns;
#line 57 "../core/Services/Database.vala"
	_tmp37_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp36_, "Items");
#line 57 "../core/Services/Database.vala"
	_tmp38_ = (GeeArrayList*) _tmp37_;
#line 57 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, "id");
#line 57 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp38_);
#line 58 "../core/Services/Database.vala"
	_tmp39_ = self->priv->table_columns;
#line 58 "../core/Services/Database.vala"
	_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp39_, "Items");
#line 58 "../core/Services/Database.vala"
	_tmp41_ = (GeeArrayList*) _tmp40_;
#line 58 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, "content");
#line 58 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp41_);
#line 59 "../core/Services/Database.vala"
	_tmp42_ = self->priv->table_columns;
#line 59 "../core/Services/Database.vala"
	_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, "Items");
#line 59 "../core/Services/Database.vala"
	_tmp44_ = (GeeArrayList*) _tmp43_;
#line 59 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, "description");
#line 59 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp44_);
#line 60 "../core/Services/Database.vala"
	_tmp45_ = self->priv->table_columns;
#line 60 "../core/Services/Database.vala"
	_tmp46_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp45_, "Items");
#line 60 "../core/Services/Database.vala"
	_tmp47_ = (GeeArrayList*) _tmp46_;
#line 60 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp47_, "due");
#line 60 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp47_);
#line 61 "../core/Services/Database.vala"
	_tmp48_ = self->priv->table_columns;
#line 61 "../core/Services/Database.vala"
	_tmp49_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, "Items");
#line 61 "../core/Services/Database.vala"
	_tmp50_ = (GeeArrayList*) _tmp49_;
#line 61 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, "added_at");
#line 61 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp50_);
#line 62 "../core/Services/Database.vala"
	_tmp51_ = self->priv->table_columns;
#line 62 "../core/Services/Database.vala"
	_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, "Items");
#line 62 "../core/Services/Database.vala"
	_tmp53_ = (GeeArrayList*) _tmp52_;
#line 62 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp53_, "completed_at");
#line 62 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp53_);
#line 63 "../core/Services/Database.vala"
	_tmp54_ = self->priv->table_columns;
#line 63 "../core/Services/Database.vala"
	_tmp55_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp54_, "Items");
#line 63 "../core/Services/Database.vala"
	_tmp56_ = (GeeArrayList*) _tmp55_;
#line 63 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, "updated_at");
#line 63 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp56_);
#line 64 "../core/Services/Database.vala"
	_tmp57_ = self->priv->table_columns;
#line 64 "../core/Services/Database.vala"
	_tmp58_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp57_, "Items");
#line 64 "../core/Services/Database.vala"
	_tmp59_ = (GeeArrayList*) _tmp58_;
#line 64 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, "section_id");
#line 64 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp59_);
#line 65 "../core/Services/Database.vala"
	_tmp60_ = self->priv->table_columns;
#line 65 "../core/Services/Database.vala"
	_tmp61_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp60_, "Items");
#line 65 "../core/Services/Database.vala"
	_tmp62_ = (GeeArrayList*) _tmp61_;
#line 65 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, "project_id");
#line 65 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp62_);
#line 66 "../core/Services/Database.vala"
	_tmp63_ = self->priv->table_columns;
#line 66 "../core/Services/Database.vala"
	_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp63_, "Items");
#line 66 "../core/Services/Database.vala"
	_tmp65_ = (GeeArrayList*) _tmp64_;
#line 66 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp65_, "parent_id");
#line 66 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp65_);
#line 67 "../core/Services/Database.vala"
	_tmp66_ = self->priv->table_columns;
#line 67 "../core/Services/Database.vala"
	_tmp67_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp66_, "Items");
#line 67 "../core/Services/Database.vala"
	_tmp68_ = (GeeArrayList*) _tmp67_;
#line 67 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp68_, "priority");
#line 67 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp68_);
#line 68 "../core/Services/Database.vala"
	_tmp69_ = self->priv->table_columns;
#line 68 "../core/Services/Database.vala"
	_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, "Items");
#line 68 "../core/Services/Database.vala"
	_tmp71_ = (GeeArrayList*) _tmp70_;
#line 68 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp71_, "child_order");
#line 68 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp71_);
#line 69 "../core/Services/Database.vala"
	_tmp72_ = self->priv->table_columns;
#line 69 "../core/Services/Database.vala"
	_tmp73_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp72_, "Items");
#line 69 "../core/Services/Database.vala"
	_tmp74_ = (GeeArrayList*) _tmp73_;
#line 69 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, "checked");
#line 69 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp74_);
#line 70 "../core/Services/Database.vala"
	_tmp75_ = self->priv->table_columns;
#line 70 "../core/Services/Database.vala"
	_tmp76_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp75_, "Items");
#line 70 "../core/Services/Database.vala"
	_tmp77_ = (GeeArrayList*) _tmp76_;
#line 70 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp77_, "is_deleted");
#line 70 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp77_);
#line 71 "../core/Services/Database.vala"
	_tmp78_ = self->priv->table_columns;
#line 71 "../core/Services/Database.vala"
	_tmp79_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp78_, "Items");
#line 71 "../core/Services/Database.vala"
	_tmp80_ = (GeeArrayList*) _tmp79_;
#line 71 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp80_, "day_order");
#line 71 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp80_);
#line 72 "../core/Services/Database.vala"
	_tmp81_ = self->priv->table_columns;
#line 72 "../core/Services/Database.vala"
	_tmp82_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp81_, "Items");
#line 72 "../core/Services/Database.vala"
	_tmp83_ = (GeeArrayList*) _tmp82_;
#line 72 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp83_, "collapsed");
#line 72 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp83_);
#line 73 "../core/Services/Database.vala"
	_tmp84_ = self->priv->table_columns;
#line 73 "../core/Services/Database.vala"
	_tmp85_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, "Items");
#line 73 "../core/Services/Database.vala"
	_tmp86_ = (GeeArrayList*) _tmp85_;
#line 73 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp86_, "pinned");
#line 73 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp86_);
#line 74 "../core/Services/Database.vala"
	_tmp87_ = self->priv->table_columns;
#line 74 "../core/Services/Database.vala"
	_tmp88_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp87_, "Items");
#line 74 "../core/Services/Database.vala"
	_tmp89_ = (GeeArrayList*) _tmp88_;
#line 74 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp89_, "labels");
#line 74 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp89_);
#line 75 "../core/Services/Database.vala"
	_tmp90_ = self->priv->table_columns;
#line 75 "../core/Services/Database.vala"
	_tmp91_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp90_, "Items");
#line 75 "../core/Services/Database.vala"
	_tmp92_ = (GeeArrayList*) _tmp91_;
#line 75 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp92_, "extra_data");
#line 75 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp92_);
#line 76 "../core/Services/Database.vala"
	_tmp93_ = self->priv->table_columns;
#line 76 "../core/Services/Database.vala"
	_tmp94_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp93_, "Items");
#line 76 "../core/Services/Database.vala"
	_tmp95_ = (GeeArrayList*) _tmp94_;
#line 76 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp95_, "item_type");
#line 76 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp95_);
#line 78 "../core/Services/Database.vala"
	_tmp96_ = self->priv->table_columns;
#line 78 "../core/Services/Database.vala"
	_tmp97_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 78 "../core/Services/Database.vala"
	_tmp98_ = _tmp97_;
#line 78 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp96_, "Labels", _tmp98_);
#line 78 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp98_);
#line 79 "../core/Services/Database.vala"
	_tmp99_ = self->priv->table_columns;
#line 79 "../core/Services/Database.vala"
	_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, "Labels");
#line 79 "../core/Services/Database.vala"
	_tmp101_ = (GeeArrayList*) _tmp100_;
#line 79 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp101_, "id");
#line 79 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp101_);
#line 80 "../core/Services/Database.vala"
	_tmp102_ = self->priv->table_columns;
#line 80 "../core/Services/Database.vala"
	_tmp103_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp102_, "Labels");
#line 80 "../core/Services/Database.vala"
	_tmp104_ = (GeeArrayList*) _tmp103_;
#line 80 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp104_, "name");
#line 80 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp104_);
#line 81 "../core/Services/Database.vala"
	_tmp105_ = self->priv->table_columns;
#line 81 "../core/Services/Database.vala"
	_tmp106_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp105_, "Labels");
#line 81 "../core/Services/Database.vala"
	_tmp107_ = (GeeArrayList*) _tmp106_;
#line 81 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp107_, "color");
#line 81 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp107_);
#line 82 "../core/Services/Database.vala"
	_tmp108_ = self->priv->table_columns;
#line 82 "../core/Services/Database.vala"
	_tmp109_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp108_, "Labels");
#line 82 "../core/Services/Database.vala"
	_tmp110_ = (GeeArrayList*) _tmp109_;
#line 82 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp110_, "item_order");
#line 82 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp110_);
#line 83 "../core/Services/Database.vala"
	_tmp111_ = self->priv->table_columns;
#line 83 "../core/Services/Database.vala"
	_tmp112_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp111_, "Labels");
#line 83 "../core/Services/Database.vala"
	_tmp113_ = (GeeArrayList*) _tmp112_;
#line 83 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp113_, "is_deleted");
#line 83 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp113_);
#line 84 "../core/Services/Database.vala"
	_tmp114_ = self->priv->table_columns;
#line 84 "../core/Services/Database.vala"
	_tmp115_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp114_, "Labels");
#line 84 "../core/Services/Database.vala"
	_tmp116_ = (GeeArrayList*) _tmp115_;
#line 84 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp116_, "is_favorite");
#line 84 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp116_);
#line 85 "../core/Services/Database.vala"
	_tmp117_ = self->priv->table_columns;
#line 85 "../core/Services/Database.vala"
	_tmp118_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, "Labels");
#line 85 "../core/Services/Database.vala"
	_tmp119_ = (GeeArrayList*) _tmp118_;
#line 85 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp119_, "backend_type");
#line 85 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp119_);
#line 86 "../core/Services/Database.vala"
	_tmp120_ = self->priv->table_columns;
#line 86 "../core/Services/Database.vala"
	_tmp121_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp120_, "Labels");
#line 86 "../core/Services/Database.vala"
	_tmp122_ = (GeeArrayList*) _tmp121_;
#line 86 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp122_, "source_id");
#line 86 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp122_);
#line 88 "../core/Services/Database.vala"
	_tmp123_ = self->priv->table_columns;
#line 88 "../core/Services/Database.vala"
	_tmp124_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 88 "../core/Services/Database.vala"
	_tmp125_ = _tmp124_;
#line 88 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp123_, "OEvents", _tmp125_);
#line 88 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp125_);
#line 89 "../core/Services/Database.vala"
	_tmp126_ = self->priv->table_columns;
#line 89 "../core/Services/Database.vala"
	_tmp127_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp126_, "OEvents");
#line 89 "../core/Services/Database.vala"
	_tmp128_ = (GeeArrayList*) _tmp127_;
#line 89 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp128_, "id");
#line 89 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp128_);
#line 90 "../core/Services/Database.vala"
	_tmp129_ = self->priv->table_columns;
#line 90 "../core/Services/Database.vala"
	_tmp130_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp129_, "OEvents");
#line 90 "../core/Services/Database.vala"
	_tmp131_ = (GeeArrayList*) _tmp130_;
#line 90 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp131_, "event_type");
#line 90 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp131_);
#line 91 "../core/Services/Database.vala"
	_tmp132_ = self->priv->table_columns;
#line 91 "../core/Services/Database.vala"
	_tmp133_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp132_, "OEvents");
#line 91 "../core/Services/Database.vala"
	_tmp134_ = (GeeArrayList*) _tmp133_;
#line 91 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp134_, "event_date");
#line 91 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp134_);
#line 92 "../core/Services/Database.vala"
	_tmp135_ = self->priv->table_columns;
#line 92 "../core/Services/Database.vala"
	_tmp136_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp135_, "OEvents");
#line 92 "../core/Services/Database.vala"
	_tmp137_ = (GeeArrayList*) _tmp136_;
#line 92 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp137_, "object_id");
#line 92 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp137_);
#line 93 "../core/Services/Database.vala"
	_tmp138_ = self->priv->table_columns;
#line 93 "../core/Services/Database.vala"
	_tmp139_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp138_, "OEvents");
#line 93 "../core/Services/Database.vala"
	_tmp140_ = (GeeArrayList*) _tmp139_;
#line 93 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp140_, "object_type");
#line 93 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp140_);
#line 94 "../core/Services/Database.vala"
	_tmp141_ = self->priv->table_columns;
#line 94 "../core/Services/Database.vala"
	_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp141_, "OEvents");
#line 94 "../core/Services/Database.vala"
	_tmp143_ = (GeeArrayList*) _tmp142_;
#line 94 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp143_, "object_key");
#line 94 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp143_);
#line 95 "../core/Services/Database.vala"
	_tmp144_ = self->priv->table_columns;
#line 95 "../core/Services/Database.vala"
	_tmp145_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp144_, "OEvents");
#line 95 "../core/Services/Database.vala"
	_tmp146_ = (GeeArrayList*) _tmp145_;
#line 95 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp146_, "object_old_value");
#line 95 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp146_);
#line 96 "../core/Services/Database.vala"
	_tmp147_ = self->priv->table_columns;
#line 96 "../core/Services/Database.vala"
	_tmp148_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp147_, "OEvents");
#line 96 "../core/Services/Database.vala"
	_tmp149_ = (GeeArrayList*) _tmp148_;
#line 96 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp149_, "object_new_value");
#line 96 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp149_);
#line 97 "../core/Services/Database.vala"
	_tmp150_ = self->priv->table_columns;
#line 97 "../core/Services/Database.vala"
	_tmp151_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp150_, "OEvents");
#line 97 "../core/Services/Database.vala"
	_tmp152_ = (GeeArrayList*) _tmp151_;
#line 97 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp152_, "parent_item_id");
#line 97 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp152_);
#line 98 "../core/Services/Database.vala"
	_tmp153_ = self->priv->table_columns;
#line 98 "../core/Services/Database.vala"
	_tmp154_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp153_, "OEvents");
#line 98 "../core/Services/Database.vala"
	_tmp155_ = (GeeArrayList*) _tmp154_;
#line 98 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp155_, "parent_project_id");
#line 98 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp155_);
#line 100 "../core/Services/Database.vala"
	_tmp156_ = self->priv->table_columns;
#line 100 "../core/Services/Database.vala"
	_tmp157_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 100 "../core/Services/Database.vala"
	_tmp158_ = _tmp157_;
#line 100 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp156_, "Projects", _tmp158_);
#line 100 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp158_);
#line 101 "../core/Services/Database.vala"
	_tmp159_ = self->priv->table_columns;
#line 101 "../core/Services/Database.vala"
	_tmp160_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp159_, "Projects");
#line 101 "../core/Services/Database.vala"
	_tmp161_ = (GeeArrayList*) _tmp160_;
#line 101 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, "id");
#line 101 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp161_);
#line 102 "../core/Services/Database.vala"
	_tmp162_ = self->priv->table_columns;
#line 102 "../core/Services/Database.vala"
	_tmp163_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp162_, "Projects");
#line 102 "../core/Services/Database.vala"
	_tmp164_ = (GeeArrayList*) _tmp163_;
#line 102 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp164_, "name");
#line 102 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp164_);
#line 103 "../core/Services/Database.vala"
	_tmp165_ = self->priv->table_columns;
#line 103 "../core/Services/Database.vala"
	_tmp166_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp165_, "Projects");
#line 103 "../core/Services/Database.vala"
	_tmp167_ = (GeeArrayList*) _tmp166_;
#line 103 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp167_, "color");
#line 103 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp167_);
#line 104 "../core/Services/Database.vala"
	_tmp168_ = self->priv->table_columns;
#line 104 "../core/Services/Database.vala"
	_tmp169_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp168_, "Projects");
#line 104 "../core/Services/Database.vala"
	_tmp170_ = (GeeArrayList*) _tmp169_;
#line 104 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp170_, "backend_type");
#line 104 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp170_);
#line 105 "../core/Services/Database.vala"
	_tmp171_ = self->priv->table_columns;
#line 105 "../core/Services/Database.vala"
	_tmp172_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp171_, "Projects");
#line 105 "../core/Services/Database.vala"
	_tmp173_ = (GeeArrayList*) _tmp172_;
#line 105 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp173_, "inbox_project");
#line 105 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp173_);
#line 106 "../core/Services/Database.vala"
	_tmp174_ = self->priv->table_columns;
#line 106 "../core/Services/Database.vala"
	_tmp175_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp174_, "Projects");
#line 106 "../core/Services/Database.vala"
	_tmp176_ = (GeeArrayList*) _tmp175_;
#line 106 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp176_, "team_inbox");
#line 106 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp176_);
#line 107 "../core/Services/Database.vala"
	_tmp177_ = self->priv->table_columns;
#line 107 "../core/Services/Database.vala"
	_tmp178_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp177_, "Projects");
#line 107 "../core/Services/Database.vala"
	_tmp179_ = (GeeArrayList*) _tmp178_;
#line 107 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp179_, "child_order");
#line 107 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp179_);
#line 108 "../core/Services/Database.vala"
	_tmp180_ = self->priv->table_columns;
#line 108 "../core/Services/Database.vala"
	_tmp181_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp180_, "Projects");
#line 108 "../core/Services/Database.vala"
	_tmp182_ = (GeeArrayList*) _tmp181_;
#line 108 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp182_, "is_deleted");
#line 108 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp182_);
#line 109 "../core/Services/Database.vala"
	_tmp183_ = self->priv->table_columns;
#line 109 "../core/Services/Database.vala"
	_tmp184_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp183_, "Projects");
#line 109 "../core/Services/Database.vala"
	_tmp185_ = (GeeArrayList*) _tmp184_;
#line 109 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp185_, "is_archived");
#line 109 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp185_);
#line 110 "../core/Services/Database.vala"
	_tmp186_ = self->priv->table_columns;
#line 110 "../core/Services/Database.vala"
	_tmp187_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp186_, "Projects");
#line 110 "../core/Services/Database.vala"
	_tmp188_ = (GeeArrayList*) _tmp187_;
#line 110 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp188_, "is_favorite");
#line 110 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp188_);
#line 111 "../core/Services/Database.vala"
	_tmp189_ = self->priv->table_columns;
#line 111 "../core/Services/Database.vala"
	_tmp190_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp189_, "Projects");
#line 111 "../core/Services/Database.vala"
	_tmp191_ = (GeeArrayList*) _tmp190_;
#line 111 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp191_, "shared");
#line 111 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp191_);
#line 112 "../core/Services/Database.vala"
	_tmp192_ = self->priv->table_columns;
#line 112 "../core/Services/Database.vala"
	_tmp193_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp192_, "Projects");
#line 112 "../core/Services/Database.vala"
	_tmp194_ = (GeeArrayList*) _tmp193_;
#line 112 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp194_, "view_style");
#line 112 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp194_);
#line 113 "../core/Services/Database.vala"
	_tmp195_ = self->priv->table_columns;
#line 113 "../core/Services/Database.vala"
	_tmp196_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp195_, "Projects");
#line 113 "../core/Services/Database.vala"
	_tmp197_ = (GeeArrayList*) _tmp196_;
#line 113 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp197_, "sort_order");
#line 113 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp197_);
#line 114 "../core/Services/Database.vala"
	_tmp198_ = self->priv->table_columns;
#line 114 "../core/Services/Database.vala"
	_tmp199_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp198_, "Projects");
#line 114 "../core/Services/Database.vala"
	_tmp200_ = (GeeArrayList*) _tmp199_;
#line 114 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp200_, "parent_id");
#line 114 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp200_);
#line 115 "../core/Services/Database.vala"
	_tmp201_ = self->priv->table_columns;
#line 115 "../core/Services/Database.vala"
	_tmp202_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp201_, "Projects");
#line 115 "../core/Services/Database.vala"
	_tmp203_ = (GeeArrayList*) _tmp202_;
#line 115 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp203_, "collapsed");
#line 115 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp203_);
#line 116 "../core/Services/Database.vala"
	_tmp204_ = self->priv->table_columns;
#line 116 "../core/Services/Database.vala"
	_tmp205_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp204_, "Projects");
#line 116 "../core/Services/Database.vala"
	_tmp206_ = (GeeArrayList*) _tmp205_;
#line 116 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp206_, "icon_style");
#line 116 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp206_);
#line 117 "../core/Services/Database.vala"
	_tmp207_ = self->priv->table_columns;
#line 117 "../core/Services/Database.vala"
	_tmp208_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp207_, "Projects");
#line 117 "../core/Services/Database.vala"
	_tmp209_ = (GeeArrayList*) _tmp208_;
#line 117 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp209_, "emoji");
#line 117 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp209_);
#line 118 "../core/Services/Database.vala"
	_tmp210_ = self->priv->table_columns;
#line 118 "../core/Services/Database.vala"
	_tmp211_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp210_, "Projects");
#line 118 "../core/Services/Database.vala"
	_tmp212_ = (GeeArrayList*) _tmp211_;
#line 118 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp212_, "show_completed");
#line 118 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp212_);
#line 119 "../core/Services/Database.vala"
	_tmp213_ = self->priv->table_columns;
#line 119 "../core/Services/Database.vala"
	_tmp214_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp213_, "Projects");
#line 119 "../core/Services/Database.vala"
	_tmp215_ = (GeeArrayList*) _tmp214_;
#line 119 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp215_, "description");
#line 119 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp215_);
#line 120 "../core/Services/Database.vala"
	_tmp216_ = self->priv->table_columns;
#line 120 "../core/Services/Database.vala"
	_tmp217_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp216_, "Projects");
#line 120 "../core/Services/Database.vala"
	_tmp218_ = (GeeArrayList*) _tmp217_;
#line 120 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp218_, "due_date");
#line 120 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp218_);
#line 121 "../core/Services/Database.vala"
	_tmp219_ = self->priv->table_columns;
#line 121 "../core/Services/Database.vala"
	_tmp220_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp219_, "Projects");
#line 121 "../core/Services/Database.vala"
	_tmp221_ = (GeeArrayList*) _tmp220_;
#line 121 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp221_, "inbox_section_hidded");
#line 121 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp221_);
#line 122 "../core/Services/Database.vala"
	_tmp222_ = self->priv->table_columns;
#line 122 "../core/Services/Database.vala"
	_tmp223_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp222_, "Projects");
#line 122 "../core/Services/Database.vala"
	_tmp224_ = (GeeArrayList*) _tmp223_;
#line 122 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp224_, "sync_id");
#line 122 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp224_);
#line 123 "../core/Services/Database.vala"
	_tmp225_ = self->priv->table_columns;
#line 123 "../core/Services/Database.vala"
	_tmp226_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp225_, "Projects");
#line 123 "../core/Services/Database.vala"
	_tmp227_ = (GeeArrayList*) _tmp226_;
#line 123 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp227_, "source_id");
#line 123 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp227_);
#line 125 "../core/Services/Database.vala"
	_tmp228_ = self->priv->table_columns;
#line 125 "../core/Services/Database.vala"
	_tmp229_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 125 "../core/Services/Database.vala"
	_tmp230_ = _tmp229_;
#line 125 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp228_, "Queue", _tmp230_);
#line 125 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp230_);
#line 126 "../core/Services/Database.vala"
	_tmp231_ = self->priv->table_columns;
#line 126 "../core/Services/Database.vala"
	_tmp232_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp231_, "Queue");
#line 126 "../core/Services/Database.vala"
	_tmp233_ = (GeeArrayList*) _tmp232_;
#line 126 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp233_, "uuid");
#line 126 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp233_);
#line 127 "../core/Services/Database.vala"
	_tmp234_ = self->priv->table_columns;
#line 127 "../core/Services/Database.vala"
	_tmp235_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp234_, "Queue");
#line 127 "../core/Services/Database.vala"
	_tmp236_ = (GeeArrayList*) _tmp235_;
#line 127 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp236_, "object_id");
#line 127 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp236_);
#line 128 "../core/Services/Database.vala"
	_tmp237_ = self->priv->table_columns;
#line 128 "../core/Services/Database.vala"
	_tmp238_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp237_, "Queue");
#line 128 "../core/Services/Database.vala"
	_tmp239_ = (GeeArrayList*) _tmp238_;
#line 128 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp239_, "query");
#line 128 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp239_);
#line 129 "../core/Services/Database.vala"
	_tmp240_ = self->priv->table_columns;
#line 129 "../core/Services/Database.vala"
	_tmp241_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp240_, "Queue");
#line 129 "../core/Services/Database.vala"
	_tmp242_ = (GeeArrayList*) _tmp241_;
#line 129 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp242_, "temp_id");
#line 129 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp242_);
#line 130 "../core/Services/Database.vala"
	_tmp243_ = self->priv->table_columns;
#line 130 "../core/Services/Database.vala"
	_tmp244_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp243_, "Queue");
#line 130 "../core/Services/Database.vala"
	_tmp245_ = (GeeArrayList*) _tmp244_;
#line 130 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp245_, "args");
#line 130 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp245_);
#line 131 "../core/Services/Database.vala"
	_tmp246_ = self->priv->table_columns;
#line 131 "../core/Services/Database.vala"
	_tmp247_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp246_, "Queue");
#line 131 "../core/Services/Database.vala"
	_tmp248_ = (GeeArrayList*) _tmp247_;
#line 131 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp248_, "date_added");
#line 131 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp248_);
#line 133 "../core/Services/Database.vala"
	_tmp249_ = self->priv->table_columns;
#line 133 "../core/Services/Database.vala"
	_tmp250_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 133 "../core/Services/Database.vala"
	_tmp251_ = _tmp250_;
#line 133 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp249_, "Reminders", _tmp251_);
#line 133 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp251_);
#line 134 "../core/Services/Database.vala"
	_tmp252_ = self->priv->table_columns;
#line 134 "../core/Services/Database.vala"
	_tmp253_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp252_, "Reminders");
#line 134 "../core/Services/Database.vala"
	_tmp254_ = (GeeArrayList*) _tmp253_;
#line 134 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp254_, "id");
#line 134 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp254_);
#line 135 "../core/Services/Database.vala"
	_tmp255_ = self->priv->table_columns;
#line 135 "../core/Services/Database.vala"
	_tmp256_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp255_, "Reminders");
#line 135 "../core/Services/Database.vala"
	_tmp257_ = (GeeArrayList*) _tmp256_;
#line 135 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp257_, "notify_uid");
#line 135 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp257_);
#line 136 "../core/Services/Database.vala"
	_tmp258_ = self->priv->table_columns;
#line 136 "../core/Services/Database.vala"
	_tmp259_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp258_, "Reminders");
#line 136 "../core/Services/Database.vala"
	_tmp260_ = (GeeArrayList*) _tmp259_;
#line 136 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp260_, "item_id");
#line 136 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp260_);
#line 137 "../core/Services/Database.vala"
	_tmp261_ = self->priv->table_columns;
#line 137 "../core/Services/Database.vala"
	_tmp262_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp261_, "Reminders");
#line 137 "../core/Services/Database.vala"
	_tmp263_ = (GeeArrayList*) _tmp262_;
#line 137 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp263_, "service");
#line 137 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp263_);
#line 138 "../core/Services/Database.vala"
	_tmp264_ = self->priv->table_columns;
#line 138 "../core/Services/Database.vala"
	_tmp265_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp264_, "Reminders");
#line 138 "../core/Services/Database.vala"
	_tmp266_ = (GeeArrayList*) _tmp265_;
#line 138 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp266_, "type");
#line 138 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp266_);
#line 139 "../core/Services/Database.vala"
	_tmp267_ = self->priv->table_columns;
#line 139 "../core/Services/Database.vala"
	_tmp268_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp267_, "Reminders");
#line 139 "../core/Services/Database.vala"
	_tmp269_ = (GeeArrayList*) _tmp268_;
#line 139 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp269_, "due");
#line 139 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp269_);
#line 140 "../core/Services/Database.vala"
	_tmp270_ = self->priv->table_columns;
#line 140 "../core/Services/Database.vala"
	_tmp271_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp270_, "Reminders");
#line 140 "../core/Services/Database.vala"
	_tmp272_ = (GeeArrayList*) _tmp271_;
#line 140 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp272_, "mm_offset");
#line 140 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp272_);
#line 141 "../core/Services/Database.vala"
	_tmp273_ = self->priv->table_columns;
#line 141 "../core/Services/Database.vala"
	_tmp274_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp273_, "Reminders");
#line 141 "../core/Services/Database.vala"
	_tmp275_ = (GeeArrayList*) _tmp274_;
#line 141 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp275_, "is_deleted");
#line 141 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp275_);
#line 143 "../core/Services/Database.vala"
	_tmp276_ = self->priv->table_columns;
#line 143 "../core/Services/Database.vala"
	_tmp277_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 143 "../core/Services/Database.vala"
	_tmp278_ = _tmp277_;
#line 143 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp276_, "Sections", _tmp278_);
#line 143 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp278_);
#line 144 "../core/Services/Database.vala"
	_tmp279_ = self->priv->table_columns;
#line 144 "../core/Services/Database.vala"
	_tmp280_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp279_, "Sections");
#line 144 "../core/Services/Database.vala"
	_tmp281_ = (GeeArrayList*) _tmp280_;
#line 144 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp281_, "id");
#line 144 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp281_);
#line 145 "../core/Services/Database.vala"
	_tmp282_ = self->priv->table_columns;
#line 145 "../core/Services/Database.vala"
	_tmp283_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp282_, "Sections");
#line 145 "../core/Services/Database.vala"
	_tmp284_ = (GeeArrayList*) _tmp283_;
#line 145 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp284_, "name");
#line 145 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp284_);
#line 146 "../core/Services/Database.vala"
	_tmp285_ = self->priv->table_columns;
#line 146 "../core/Services/Database.vala"
	_tmp286_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp285_, "Sections");
#line 146 "../core/Services/Database.vala"
	_tmp287_ = (GeeArrayList*) _tmp286_;
#line 146 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp287_, "archived_at");
#line 146 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp287_);
#line 147 "../core/Services/Database.vala"
	_tmp288_ = self->priv->table_columns;
#line 147 "../core/Services/Database.vala"
	_tmp289_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp288_, "Sections");
#line 147 "../core/Services/Database.vala"
	_tmp290_ = (GeeArrayList*) _tmp289_;
#line 147 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp290_, "added_at");
#line 147 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp290_);
#line 148 "../core/Services/Database.vala"
	_tmp291_ = self->priv->table_columns;
#line 148 "../core/Services/Database.vala"
	_tmp292_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp291_, "Sections");
#line 148 "../core/Services/Database.vala"
	_tmp293_ = (GeeArrayList*) _tmp292_;
#line 148 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp293_, "project_id");
#line 148 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp293_);
#line 149 "../core/Services/Database.vala"
	_tmp294_ = self->priv->table_columns;
#line 149 "../core/Services/Database.vala"
	_tmp295_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp294_, "Sections");
#line 149 "../core/Services/Database.vala"
	_tmp296_ = (GeeArrayList*) _tmp295_;
#line 149 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp296_, "section_order");
#line 149 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp296_);
#line 150 "../core/Services/Database.vala"
	_tmp297_ = self->priv->table_columns;
#line 150 "../core/Services/Database.vala"
	_tmp298_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp297_, "Sections");
#line 150 "../core/Services/Database.vala"
	_tmp299_ = (GeeArrayList*) _tmp298_;
#line 150 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp299_, "collapsed");
#line 150 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp299_);
#line 151 "../core/Services/Database.vala"
	_tmp300_ = self->priv->table_columns;
#line 151 "../core/Services/Database.vala"
	_tmp301_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp300_, "Sections");
#line 151 "../core/Services/Database.vala"
	_tmp302_ = (GeeArrayList*) _tmp301_;
#line 151 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp302_, "is_deleted");
#line 151 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp302_);
#line 152 "../core/Services/Database.vala"
	_tmp303_ = self->priv->table_columns;
#line 152 "../core/Services/Database.vala"
	_tmp304_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp303_, "Sections");
#line 152 "../core/Services/Database.vala"
	_tmp305_ = (GeeArrayList*) _tmp304_;
#line 152 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp305_, "is_archived");
#line 152 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp305_);
#line 153 "../core/Services/Database.vala"
	_tmp306_ = self->priv->table_columns;
#line 153 "../core/Services/Database.vala"
	_tmp307_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp306_, "Sections");
#line 153 "../core/Services/Database.vala"
	_tmp308_ = (GeeArrayList*) _tmp307_;
#line 153 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp308_, "color");
#line 153 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp308_);
#line 154 "../core/Services/Database.vala"
	_tmp309_ = self->priv->table_columns;
#line 154 "../core/Services/Database.vala"
	_tmp310_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp309_, "Sections");
#line 154 "../core/Services/Database.vala"
	_tmp311_ = (GeeArrayList*) _tmp310_;
#line 154 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp311_, "description");
#line 154 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp311_);
#line 155 "../core/Services/Database.vala"
	_tmp312_ = self->priv->table_columns;
#line 155 "../core/Services/Database.vala"
	_tmp313_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp312_, "Sections");
#line 155 "../core/Services/Database.vala"
	_tmp314_ = (GeeArrayList*) _tmp313_;
#line 155 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp314_, "hidded");
#line 155 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp314_);
#line 157 "../core/Services/Database.vala"
	_tmp315_ = self->priv->table_columns;
#line 157 "../core/Services/Database.vala"
	_tmp316_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 157 "../core/Services/Database.vala"
	_tmp317_ = _tmp316_;
#line 157 "../core/Services/Database.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp315_, "Sources", _tmp317_);
#line 157 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp317_);
#line 158 "../core/Services/Database.vala"
	_tmp318_ = self->priv->table_columns;
#line 158 "../core/Services/Database.vala"
	_tmp319_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp318_, "Sources");
#line 158 "../core/Services/Database.vala"
	_tmp320_ = (GeeArrayList*) _tmp319_;
#line 158 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp320_, "id");
#line 158 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp320_);
#line 159 "../core/Services/Database.vala"
	_tmp321_ = self->priv->table_columns;
#line 159 "../core/Services/Database.vala"
	_tmp322_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp321_, "Sources");
#line 159 "../core/Services/Database.vala"
	_tmp323_ = (GeeArrayList*) _tmp322_;
#line 159 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp323_, "source_type");
#line 159 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp323_);
#line 160 "../core/Services/Database.vala"
	_tmp324_ = self->priv->table_columns;
#line 160 "../core/Services/Database.vala"
	_tmp325_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp324_, "Sources");
#line 160 "../core/Services/Database.vala"
	_tmp326_ = (GeeArrayList*) _tmp325_;
#line 160 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp326_, "display_name");
#line 160 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp326_);
#line 161 "../core/Services/Database.vala"
	_tmp327_ = self->priv->table_columns;
#line 161 "../core/Services/Database.vala"
	_tmp328_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp327_, "Sources");
#line 161 "../core/Services/Database.vala"
	_tmp329_ = (GeeArrayList*) _tmp328_;
#line 161 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp329_, "added_at");
#line 161 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp329_);
#line 162 "../core/Services/Database.vala"
	_tmp330_ = self->priv->table_columns;
#line 162 "../core/Services/Database.vala"
	_tmp331_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp330_, "Sources");
#line 162 "../core/Services/Database.vala"
	_tmp332_ = (GeeArrayList*) _tmp331_;
#line 162 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp332_, "updated_at");
#line 162 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp332_);
#line 163 "../core/Services/Database.vala"
	_tmp333_ = self->priv->table_columns;
#line 163 "../core/Services/Database.vala"
	_tmp334_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp333_, "Sources");
#line 163 "../core/Services/Database.vala"
	_tmp335_ = (GeeArrayList*) _tmp334_;
#line 163 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp335_, "is_visible");
#line 163 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp335_);
#line 164 "../core/Services/Database.vala"
	_tmp336_ = self->priv->table_columns;
#line 164 "../core/Services/Database.vala"
	_tmp337_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp336_, "Sources");
#line 164 "../core/Services/Database.vala"
	_tmp338_ = (GeeArrayList*) _tmp337_;
#line 164 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp338_, "child_order");
#line 164 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp338_);
#line 165 "../core/Services/Database.vala"
	_tmp339_ = self->priv->table_columns;
#line 165 "../core/Services/Database.vala"
	_tmp340_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp339_, "Sources");
#line 165 "../core/Services/Database.vala"
	_tmp341_ = (GeeArrayList*) _tmp340_;
#line 165 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp341_, "sync_server");
#line 165 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp341_);
#line 166 "../core/Services/Database.vala"
	_tmp342_ = self->priv->table_columns;
#line 166 "../core/Services/Database.vala"
	_tmp343_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp342_, "Sources");
#line 166 "../core/Services/Database.vala"
	_tmp344_ = (GeeArrayList*) _tmp343_;
#line 166 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp344_, "last_sync");
#line 166 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp344_);
#line 167 "../core/Services/Database.vala"
	_tmp345_ = self->priv->table_columns;
#line 167 "../core/Services/Database.vala"
	_tmp346_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp345_, "Sources");
#line 167 "../core/Services/Database.vala"
	_tmp347_ = (GeeArrayList*) _tmp346_;
#line 167 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp347_, "data");
#line 167 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp347_);
#line 42 "../core/Services/Database.vala"
	return obj;
#line 11140 "Database.c"
}

static void
services_database_class_init (ServicesDatabaseClass * klass,
                              gpointer klass_data)
{
#line 22 "../core/Services/Database.vala"
	services_database_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/Database.vala"
	g_type_class_adjust_private_offset (klass, &ServicesDatabase_private_offset);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->constructor = services_database_constructor;
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->finalize = services_database_finalize;
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL] = g_signal_new ("opened", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_RESET_SIGNAL] = g_signal_new ("reset", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11159 "Database.c"
}

static void
services_database_instance_init (ServicesDatabase * self,
                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 22 "../core/Services/Database.vala"
	self->priv = services_database_get_instance_private (self);
#line 28 "../core/Services/Database.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 28 "../core/Services/Database.vala"
	self->priv->table_columns = _tmp0_;
#line 11173 "Database.c"
}

static void
services_database_finalize (GObject * obj)
{
	ServicesDatabase * self;
#line 22 "../core/Services/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 23 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 24 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 25 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 26 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 28 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->table_columns);
#line 2092 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->parser);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (services_database_parent_class)->finalize (obj);
#line 11196 "Database.c"
}

static GType
services_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesDatabase), 0, (GInstanceInitFunc) services_database_instance_init, NULL };
	GType services_database_type_id;
	services_database_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesDatabase", &g_define_type_info, 0);
	ServicesDatabase_private_offset = g_type_add_instance_private (services_database_type_id, sizeof (ServicesDatabasePrivate));
	return services_database_type_id;
}

GType
services_database_get_type (void)
{
	static volatile gsize services_database_type_id__once = 0;
	if (g_once_init_enter (&services_database_type_id__once)) {
		GType services_database_type_id;
		services_database_type_id = services_database_get_type_once ();
		g_once_init_leave (&services_database_type_id__once, services_database_type_id);
	}
	return services_database_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

