/* Todoist.c generated by valac 0.56.17, the Vala compiler
 * generated from Todoist.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gxml/gxml.h>
#include <gobject/gvaluecollector.h>

#define SERVICES_TODOIST_TODOIST_SYNC_URL "https://api.todoist.com/sync/v9/sync"
#define SERVICES_TODOIST_RESOURCE_TYPES "[\"user\", \"projects\", \"sections\", \"items\", \"labels\", \"remind" \
"ers\"]"
#define SERVICES_TODOIST_PROJECTS_COLLECTION "projects"
#define SERVICES_TODOIST_SECTIONS_COLLECTION "sections"
#define SERVICES_TODOIST_ITEMS_COLLECTION "items"
#define SERVICES_TODOIST_LABELS_COLLECTION "labels"
#define SERVICES_TODOIST_REMINDERS_COLLECTION "reminders"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_TODOIST_0_PROPERTY,
	SERVICES_TODOIST_NUM_PROPERTIES
};
static GParamSpec* services_todoist_properties[SERVICES_TODOIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _http_response_unref0(var) ((var == NULL) ? NULL : (var = (http_response_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ServicesTodoistLoginData ServicesTodoistLoginData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _ServicesTodoistAddTodoistAccountData ServicesTodoistAddTodoistAccountData;
typedef struct _ServicesTodoistSyncData ServicesTodoistSyncData;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
typedef struct _ServicesTodoistQueueData ServicesTodoistQueueData;
typedef struct _ServicesTodoistAddData ServicesTodoistAddData;
typedef struct _ServicesTodoistUpdateData ServicesTodoistUpdateData;
typedef struct _ServicesTodoistUpdateItemsData ServicesTodoistUpdateItemsData;
typedef struct _ServicesTodoistDeleteData ServicesTodoistDeleteData;
typedef struct _ServicesTodoistCompleteItemData ServicesTodoistCompleteItemData;
typedef struct _ServicesTodoistMoveItemData ServicesTodoistMoveItemData;
typedef struct _ServicesTodoistMoveProjectSectionData ServicesTodoistMoveProjectSectionData;
typedef struct _ServicesTodoistDuplicateProjectData ServicesTodoistDuplicateProjectData;
enum  {
	SERVICES_TODOIST_SYNC_STARTED_SIGNAL,
	SERVICES_TODOIST_SYNC_FINISHED_SIGNAL,
	SERVICES_TODOIST_FIRST_SYNC_STARTED_SIGNAL,
	SERVICES_TODOIST_FIRST_SYNC_FINISHED_SIGNAL,
	SERVICES_TODOIST_NUM_SIGNALS
};
static guint services_todoist_signals[SERVICES_TODOIST_NUM_SIGNALS] = {0};
typedef struct _ParamSpecHttpResponse ParamSpecHttpResponse;

struct _ServicesTodoistPrivate {
	SoupSession* session;
	JsonParser* parser;
};

struct _ServicesTodoistLoginData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	gchar* _url;
	HttpResponse* result;
	gchar* code;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* url;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	SoupMessage* message;
	const gchar* _tmp14_;
	SoupMessage* _tmp15_;
	HttpResponse* response;
	HttpResponse* _tmp16_;
	GBytes* stream;
	SoupSession* _tmp17_;
	SoupMessage* _tmp18_;
	GBytes* _tmp19_;
	JsonParser* _tmp20_;
	GBytes* _tmp21_;
	gsize _tmp22_;
	guint8* _tmp23_;
	JsonParser* _tmp24_;
	JsonNode* _tmp25_;
	JsonObject* root;
	JsonParser* _tmp26_;
	JsonNode* _tmp27_;
	JsonObject* _tmp28_;
	JsonObject* _tmp29_;
	gchar* token;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	HttpResponse* _tmp32_;
	GError* e;
	HttpResponse* _tmp33_;
	HttpResponse* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	GError* _inner_error0_;
};

struct _ServicesTodoistAddTodoistAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	gchar* token;
	HttpResponse* response;
	gchar* url;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	SoupMessage* message;
	const gchar* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GBytes* stream;
	SoupSession* _tmp16_;
	SoupMessage* _tmp17_;
	GBytes* _tmp18_;
	JsonParser* _tmp19_;
	GBytes* _tmp20_;
	gsize _tmp21_;
	guint8* _tmp22_;
	JsonParser* _tmp23_;
	JsonNode* _tmp24_;
	ObjectsSource* source;
	ObjectsSource* _tmp25_;
	ObjectsSource* _tmp26_;
	Util* _tmp27_;
	Util* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	ObjectsSource* _tmp31_;
	ObjectsSourceTodoistData* todoist_data;
	ObjectsSourceTodoistData* _tmp32_;
	ObjectsSourceTodoistData* _tmp33_;
	JsonParser* _tmp34_;
	JsonNode* _tmp35_;
	JsonObject* _tmp36_;
	const gchar* _tmp37_;
	ObjectsSourceTodoistData* _tmp38_;
	ObjectsSource* _tmp39_;
	JsonObject* user_object;
	JsonParser* _tmp40_;
	JsonNode* _tmp41_;
	JsonObject* _tmp42_;
	JsonObject* _tmp43_;
	JsonObject* _tmp44_;
	JsonObject* _tmp45_;
	ObjectsSourceTodoistData* _tmp46_;
	JsonObject* _tmp47_;
	const gchar* _tmp48_;
	ObjectsSourceTodoistData* _tmp49_;
	JsonObject* _tmp50_;
	const gchar* _tmp51_;
	ObjectsSourceTodoistData* _tmp52_;
	JsonObject* _tmp53_;
	const gchar* _tmp54_;
	ObjectsSourceTodoistData* _tmp55_;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	ObjectsSourceTodoistData* _tmp58_;
	JsonObject* _tmp59_;
	ObjectsSource* _tmp60_;
	JsonObject* _tmp61_;
	const gchar* _tmp62_;
	ObjectsSource* _tmp63_;
	ObjectsSourceTodoistData* _tmp64_;
	ServicesStore* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	ServicesStore* _tmp69_;
	ObjectsSource* _tmp70_;
	JsonArray* labels;
	JsonParser* _tmp71_;
	JsonNode* _tmp72_;
	JsonObject* _tmp73_;
	JsonArray* _tmp74_;
	JsonArray* _tmp75_;
	GList* _tmp76_;
	GList* _node_collection;
	GList* _node_it;
	JsonNode* _node;
	ObjectsLabel* _label;
	JsonNode* _tmp77_;
	ObjectsLabel* _tmp78_;
	ObjectsLabel* _tmp79_;
	ObjectsSource* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	ServicesStore* _tmp83_;
	ObjectsLabel* _tmp84_;
	JsonArray* projects;
	JsonParser* _tmp85_;
	JsonNode* _tmp86_;
	JsonObject* _tmp87_;
	JsonArray* _tmp88_;
	JsonArray* _tmp89_;
	GList* _tmp90_;
	GList* _vala1__node_collection;
	GList* _vala1__node_it;
	JsonNode* _vala1__node;
	ObjectsProject* _project;
	JsonNode* _tmp91_;
	ObjectsProject* _tmp92_;
	ObjectsProject* _tmp93_;
	ObjectsSource* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	JsonNode* _tmp97_;
	JsonObject* _tmp98_;
	ObjectsProject* project;
	ServicesStore* _tmp99_;
	JsonNode* _tmp100_;
	JsonObject* _tmp101_;
	const gchar* _tmp102_;
	ObjectsProject* _tmp103_;
	ObjectsProject* _tmp104_;
	ObjectsProject* _tmp105_;
	ObjectsProject* _tmp106_;
	ObjectsProject* _tmp107_;
	ObjectsProject* _tmp108_;
	ServicesStore* _tmp109_;
	ObjectsProject* _tmp110_;
	JsonArray* sections;
	JsonParser* _tmp111_;
	JsonNode* _tmp112_;
	JsonObject* _tmp113_;
	JsonArray* _tmp114_;
	JsonArray* _tmp115_;
	GList* _tmp116_;
	GList* _vala2__node_collection;
	GList* _vala2__node_it;
	JsonNode* _vala2__node;
	JsonNode* _tmp117_;
	JsonArray* items;
	JsonParser* _tmp118_;
	JsonNode* _tmp119_;
	JsonObject* _tmp120_;
	JsonArray* _tmp121_;
	JsonArray* _tmp122_;
	GList* _tmp123_;
	GList* _vala3__node_collection;
	GList* _vala3__node_it;
	JsonNode* _vala3__node;
	JsonNode* _tmp124_;
	JsonArray* reminders;
	JsonParser* _tmp125_;
	JsonNode* _tmp126_;
	JsonObject* _tmp127_;
	JsonArray* _tmp128_;
	JsonArray* _tmp129_;
	GList* _tmp130_;
	GList* _vala4__node_collection;
	GList* _vala4__node_it;
	JsonNode* _vala4__node;
	ObjectsReminder* reminder;
	JsonNode* _tmp131_;
	ObjectsReminder* _tmp132_;
	ObjectsItem* item;
	ServicesStore* _tmp133_;
	ObjectsReminder* _tmp134_;
	const gchar* _tmp135_;
	const gchar* _tmp136_;
	ObjectsItem* _tmp137_;
	ObjectsItem* _tmp138_;
	ObjectsItem* _tmp139_;
	ObjectsReminder* _tmp140_;
	ObjectsReminder* _tmp141_;
	ObjectsReminder* _tmp142_;
	JsonObject* _tmp143_;
	Util* _tmp144_;
	Util* _tmp145_;
	ObjectsSource* _tmp146_;
	ObjectsSourceTodoistData* _tmp147_;
	ObjectsSourceTodoistData* _tmp148_;
	const gchar* _tmp149_;
	const gchar* _tmp150_;
	JsonObject* _tmp151_;
	const gchar* _tmp152_;
	ObjectsSource* _tmp153_;
	GDateTime* _tmp154_;
	GDateTime* _tmp155_;
	gchar* _tmp156_;
	gchar* _tmp157_;
	ObjectsSource* _tmp158_;
	GError* e;
	GError* _tmp159_;
	GError* _tmp160_;
	const gchar* _tmp161_;
	GError* _tmp162_;
	const gchar* _tmp163_;
	GError* _inner_error0_;
};

struct _ServicesTodoistSyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsSource* source;
	ObjectsSourceTodoistData* _tmp0_;
	ObjectsSourceTodoistData* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* url;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ObjectsSourceTodoistData* _tmp8_;
	ObjectsSourceTodoistData* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* message;
	const gchar* _tmp20_;
	SoupMessage* _tmp21_;
	SoupMessage* _tmp22_;
	SoupMessageHeaders* _tmp23_;
	SoupMessageHeaders* _tmp24_;
	ObjectsSourceTodoistData* _tmp25_;
	ObjectsSourceTodoistData* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	JsonParser* _tmp40_;
	JsonNode* _tmp41_;
	JsonObject* _tmp42_;
	ObjectsSourceTodoistData* _tmp43_;
	ObjectsSourceTodoistData* _tmp44_;
	JsonParser* _tmp45_;
	JsonNode* _tmp46_;
	JsonObject* _tmp47_;
	const gchar* _tmp48_;
	JsonParser* _tmp49_;
	JsonNode* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* user_object;
	JsonParser* _tmp52_;
	JsonNode* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonObject* _tmp56_;
	ObjectsSourceTodoistData* _tmp57_;
	ObjectsSourceTodoistData* _tmp58_;
	JsonObject* _tmp59_;
	ObjectsSourceTodoistData* _tmp60_;
	ObjectsSourceTodoistData* _tmp61_;
	JsonObject* _tmp62_;
	const gchar* _tmp63_;
	ObjectsSourceTodoistData* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	JsonArray* _labels;
	JsonParser* _tmp68_;
	JsonNode* _tmp69_;
	JsonObject* _tmp70_;
	JsonArray* _tmp71_;
	JsonArray* _tmp72_;
	GList* _tmp73_;
	GList* _node_collection;
	GList* _node_it;
	JsonNode* _node;
	gchar* _id;
	JsonNode* _tmp74_;
	JsonObject* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	ObjectsLabel* label;
	ServicesStore* _tmp78_;
	const gchar* _tmp79_;
	ObjectsLabel* _tmp80_;
	ObjectsLabel* _tmp81_;
	JsonNode* _tmp82_;
	JsonObject* _tmp83_;
	ServicesStore* _tmp84_;
	ObjectsLabel* _tmp85_;
	ObjectsLabel* _tmp86_;
	JsonNode* _tmp87_;
	ServicesStore* _tmp88_;
	ObjectsLabel* _tmp89_;
	ObjectsLabel* _label;
	JsonNode* _tmp90_;
	ObjectsLabel* _tmp91_;
	ObjectsLabel* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	ServicesStore* _tmp95_;
	ObjectsLabel* _tmp96_;
	JsonArray* projects;
	JsonParser* _tmp97_;
	JsonNode* _tmp98_;
	JsonObject* _tmp99_;
	JsonArray* _tmp100_;
	JsonArray* _tmp101_;
	GList* _tmp102_;
	GList* _vala1__node_collection;
	GList* _vala1__node_it;
	JsonNode* _vala1__node;
	ObjectsProject* project;
	ServicesStore* _tmp103_;
	JsonNode* _tmp104_;
	JsonObject* _tmp105_;
	const gchar* _tmp106_;
	ObjectsProject* _tmp107_;
	ObjectsProject* _tmp108_;
	JsonNode* _tmp109_;
	JsonObject* _tmp110_;
	ServicesStore* _tmp111_;
	ObjectsProject* _tmp112_;
	gchar* old_parent_id;
	ObjectsProject* _tmp113_;
	const gchar* _tmp114_;
	const gchar* _tmp115_;
	gchar* _tmp116_;
	gboolean old_is_favorite;
	ObjectsProject* _tmp117_;
	gboolean _tmp118_;
	gboolean _tmp119_;
	ObjectsProject* _tmp120_;
	JsonNode* _tmp121_;
	ServicesStore* _tmp122_;
	ObjectsProject* _tmp123_;
	ObjectsProject* _tmp124_;
	const gchar* _tmp125_;
	const gchar* _tmp126_;
	const gchar* _tmp127_;
	ServicesEventBus* _tmp128_;
	ServicesEventBus* _tmp129_;
	ObjectsProject* _tmp130_;
	const gchar* _tmp131_;
	ObjectsProject* _tmp132_;
	gboolean _tmp133_;
	gboolean _tmp134_;
	ServicesEventBus* _tmp135_;
	ServicesEventBus* _tmp136_;
	ObjectsProject* _tmp137_;
	ObjectsProject* _project;
	JsonNode* _tmp138_;
	ObjectsProject* _tmp139_;
	ObjectsProject* _tmp140_;
	const gchar* _tmp141_;
	const gchar* _tmp142_;
	ServicesStore* _tmp143_;
	ObjectsProject* _tmp144_;
	JsonArray* sections;
	JsonParser* _tmp145_;
	JsonNode* _tmp146_;
	JsonObject* _tmp147_;
	JsonArray* _tmp148_;
	JsonArray* _tmp149_;
	GList* _tmp150_;
	GList* _vala2__node_collection;
	GList* _vala2__node_it;
	JsonNode* _vala2__node;
	ObjectsSection* section;
	ServicesStore* _tmp151_;
	JsonNode* _tmp152_;
	JsonObject* _tmp153_;
	const gchar* _tmp154_;
	ObjectsSection* _tmp155_;
	ObjectsSection* _tmp156_;
	JsonNode* _tmp157_;
	JsonObject* _tmp158_;
	ServicesStore* _tmp159_;
	ObjectsSection* _tmp160_;
	ObjectsSection* _tmp161_;
	JsonNode* _tmp162_;
	ServicesStore* _tmp163_;
	ObjectsSection* _tmp164_;
	JsonNode* _tmp165_;
	JsonArray* items;
	JsonParser* _tmp166_;
	JsonNode* _tmp167_;
	JsonObject* _tmp168_;
	JsonArray* _tmp169_;
	JsonArray* _tmp170_;
	GList* _tmp171_;
	GList* _vala3__node_collection;
	GList* _vala3__node_it;
	JsonNode* _vala3__node;
	ObjectsItem* item;
	ServicesStore* _tmp172_;
	JsonNode* _tmp173_;
	JsonObject* _tmp174_;
	const gchar* _tmp175_;
	ObjectsItem* _tmp176_;
	ObjectsItem* _tmp177_;
	JsonNode* _tmp178_;
	JsonObject* _tmp179_;
	ServicesStore* _tmp180_;
	ObjectsItem* _tmp181_;
	gchar* old_project_id;
	ObjectsItem* _tmp182_;
	const gchar* _tmp183_;
	const gchar* _tmp184_;
	gchar* _tmp185_;
	gchar* old_section_id;
	ObjectsItem* _tmp186_;
	const gchar* _tmp187_;
	const gchar* _tmp188_;
	gchar* _tmp189_;
	gchar* _vala1_old_parent_id;
	ObjectsItem* _tmp190_;
	const gchar* _tmp191_;
	const gchar* _tmp192_;
	gchar* _tmp193_;
	gboolean old_checked;
	ObjectsItem* _tmp194_;
	gboolean _tmp195_;
	gboolean _tmp196_;
	ObjectsItem* _tmp197_;
	JsonNode* _tmp198_;
	ServicesStore* _tmp199_;
	ObjectsItem* _tmp200_;
	gboolean _tmp201_;
	gboolean _tmp202_;
	const gchar* _tmp203_;
	ObjectsItem* _tmp204_;
	const gchar* _tmp205_;
	const gchar* _tmp206_;
	const gchar* _tmp207_;
	ObjectsItem* _tmp208_;
	const gchar* _tmp209_;
	const gchar* _tmp210_;
	const gchar* _tmp211_;
	ObjectsItem* _tmp212_;
	const gchar* _tmp213_;
	const gchar* _tmp214_;
	ServicesEventBus* _tmp215_;
	ServicesEventBus* _tmp216_;
	ObjectsItem* _tmp217_;
	const gchar* _tmp218_;
	const gchar* _tmp219_;
	const gchar* _tmp220_;
	ObjectsItem* _tmp221_;
	gboolean _tmp222_;
	gboolean _tmp223_;
	ServicesStore* _tmp224_;
	ObjectsItem* _tmp225_;
	JsonNode* _tmp226_;
	JsonArray* reminders;
	JsonParser* _tmp227_;
	JsonNode* _tmp228_;
	JsonObject* _tmp229_;
	JsonArray* _tmp230_;
	JsonArray* _tmp231_;
	GList* _tmp232_;
	GList* _vala4__node_collection;
	GList* _vala4__node_it;
	JsonNode* _vala4__node;
	ObjectsReminder* reminder;
	ServicesStore* _tmp233_;
	JsonNode* _tmp234_;
	JsonObject* _tmp235_;
	const gchar* _tmp236_;
	ObjectsReminder* _tmp237_;
	ObjectsReminder* _tmp238_;
	JsonNode* _tmp239_;
	JsonObject* _tmp240_;
	ServicesStore* _tmp241_;
	ObjectsReminder* _tmp242_;
	JsonNode* _tmp243_;
	ObjectsReminder* _tmp244_;
	ObjectsItem* _vala1_item;
	ServicesStore* _tmp245_;
	ObjectsReminder* _tmp246_;
	const gchar* _tmp247_;
	const gchar* _tmp248_;
	ObjectsItem* _tmp249_;
	ObjectsItem* _tmp250_;
	ObjectsItem* _tmp251_;
	ObjectsReminder* _tmp252_;
	ObjectsReminder* _tmp253_;
	ObjectsReminder* _tmp254_;
	GError* e;
	GError* _tmp255_;
	const gchar* _tmp256_;
	GDateTime* _tmp257_;
	GDateTime* _tmp258_;
	gchar* _tmp259_;
	gchar* _tmp260_;
	GError* _inner_error0_;
};

struct _ServicesTodoistQueueData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsSource* source;
	GeeArrayList* queue_collection;
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* json;
	GeeArrayList* _tmp7_;
	gchar* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSourceTodoistData* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	SoupMessage* _tmp19_;
	const gchar* _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8* _tmp23_;
	gint _tmp23__length1;
	GBytes* _tmp24_;
	GBytes* _tmp25_;
	GBytes* stream;
	SoupSession* _tmp26_;
	SoupMessage* _tmp27_;
	GBytes* _tmp28_;
	JsonParser* _tmp29_;
	GBytes* _tmp30_;
	gsize _tmp31_;
	guint8* _tmp32_;
	JsonParser* _tmp33_;
	JsonNode* _tmp34_;
	JsonObject* node;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	JsonObject* _tmp37_;
	JsonObject* _tmp38_;
	gchar* sync_token;
	JsonObject* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	ObjectsSourceTodoistData* _tmp42_;
	ObjectsSourceTodoistData* _tmp43_;
	const gchar* _tmp44_;
	GeeArrayList* _q_list;
	GeeArrayList* _tmp45_;
	gint _q_size;
	GeeArrayList* _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gint _q_index;
	gint _tmp49_;
	gint _tmp50_;
	ObjectsQueue* q;
	GeeArrayList* _tmp51_;
	gpointer _tmp52_;
	JsonNode* uuid_member;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	ObjectsQueue* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsQueue* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	gchar* id;
	JsonObject* _tmp64_;
	JsonObject* _tmp65_;
	ObjectsQueue* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	ServicesStore* _tmp71_;
	ObjectsQueue* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	ServicesDatabase* _tmp76_;
	ServicesDatabase* _tmp77_;
	ObjectsQueue* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	ObjectsQueue* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gchar* _vala1_id;
	JsonObject* _tmp84_;
	JsonObject* _tmp85_;
	ObjectsQueue* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	ServicesStore* _tmp91_;
	ObjectsQueue* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	const gchar* _tmp95_;
	ServicesDatabase* _tmp96_;
	ServicesDatabase* _tmp97_;
	ObjectsQueue* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	gchar* _vala2_id;
	JsonObject* _tmp104_;
	JsonObject* _tmp105_;
	ObjectsQueue* _tmp106_;
	const gchar* _tmp107_;
	const gchar* _tmp108_;
	const gchar* _tmp109_;
	gchar* _tmp110_;
	ServicesStore* _tmp111_;
	ObjectsQueue* _tmp112_;
	const gchar* _tmp113_;
	const gchar* _tmp114_;
	const gchar* _tmp115_;
	ServicesDatabase* _tmp116_;
	ServicesDatabase* _tmp117_;
	ObjectsQueue* _tmp118_;
	const gchar* _tmp119_;
	const gchar* _tmp120_;
	ServicesDatabase* _tmp121_;
	ServicesDatabase* _tmp122_;
	ObjectsQueue* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	GError* e;
	GError* _tmp126_;
	const gchar* _tmp127_;
	GError* _inner_error0_;
};

struct _ServicesTodoistAddData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* temp_id;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* uuid;
	Util* _tmp4_;
	Util* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* id;
	gchar* json;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	SoupMessage* message;
	SoupMessage* _tmp11_;
	SoupMessage* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	SoupMessageHeaders* _tmp14_;
	ObjectsSource* _tmp15_;
	ObjectsSource* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	ObjectsSourceTodoistData* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	SoupMessage* _tmp23_;
	const gchar* _tmp24_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gint _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	GBytes* _tmp28_;
	GBytes* _tmp29_;
	HttpResponse* response;
	HttpResponse* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	SoupMessage* _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	HttpResponse* _tmp43_;
	JsonParser* _tmp44_;
	JsonNode* _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	SoupMessage* _tmp49_;
	guint _tmp50_;
	guint _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	JsonObject* sync_status;
	JsonParser* _tmp54_;
	JsonNode* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonObject* _tmp58_;
	JsonNode* uuid_member;
	JsonObject* _tmp59_;
	const gchar* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	JsonNode* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSource* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	ObjectsSourceTodoistData* _tmp67_;
	JsonParser* _tmp68_;
	JsonNode* _tmp69_;
	JsonObject* _tmp70_;
	const gchar* _tmp71_;
	ObjectsSource* _tmp72_;
	ObjectsSource* _tmp73_;
	GDateTime* _tmp74_;
	GDateTime* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	ObjectsSource* _tmp78_;
	ObjectsSource* _tmp79_;
	JsonParser* _tmp80_;
	JsonNode* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_;
	HttpResponse* _tmp87_;
	HttpResponse* _tmp88_;
	const gchar* _tmp89_;
	HttpResponse* _tmp90_;
	JsonObject* _tmp91_;
	const gchar* _tmp92_;
	JsonObject* _tmp93_;
	const gchar* _tmp94_;
	JsonObject* _tmp95_;
	const gchar* _tmp96_;
	JsonObject* _tmp97_;
	JsonObject* _tmp98_;
	const gchar* _tmp99_;
	JsonObject* _tmp100_;
	const gchar* _tmp101_;
	GError* e;
	SoupMessage* _tmp102_;
	guint _tmp103_;
	guint _tmp104_;
	HttpResponse* _tmp105_;
	GError* _tmp106_;
	const gchar* _tmp107_;
	SoupMessage* _tmp108_;
	guint _tmp109_;
	guint _tmp110_;
	GError* _tmp111_;
	const gchar* _tmp112_;
	Util* _tmp113_;
	Util* _tmp114_;
	gchar* _tmp115_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp116_;
	ObjectsQueue* _tmp117_;
	const gchar* _tmp118_;
	ObjectsQueue* _tmp119_;
	const gchar* _tmp120_;
	ObjectsQueue* _tmp121_;
	const gchar* _tmp122_;
	ObjectsQueue* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	ObjectsQueue* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	ServicesDatabase* _tmp129_;
	ServicesDatabase* _tmp130_;
	ObjectsQueue* _tmp131_;
	ServicesDatabase* _tmp132_;
	ServicesDatabase* _tmp133_;
	const gchar* _tmp134_;
	const gchar* _tmp135_;
	const gchar* _tmp136_;
	const gchar* _tmp137_;
	const gchar* _tmp138_;
	HttpResponse* _tmp139_;
	HttpResponse* _tmp140_;
	ObjectsQueue* _tmp141_;
	const gchar* _tmp142_;
	const gchar* _tmp143_;
	GError* _inner_error0_;
};

struct _ServicesTodoistUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	ObjectsSource* source;
	ObjectsSource* _tmp6_;
	ObjectsSource* _tmp7_;
	ObjectsSource* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	ObjectsSourceTodoistData* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* _tmp20_;
	const gchar* _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gint _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	GBytes* _tmp25_;
	GBytes* _tmp26_;
	HttpResponse* response;
	HttpResponse* _tmp27_;
	GBytes* stream;
	SoupSession* _tmp28_;
	SoupMessage* _tmp29_;
	GBytes* _tmp30_;
	JsonParser* _tmp31_;
	GBytes* _tmp32_;
	gsize _tmp33_;
	guint8* _tmp34_;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	HttpResponse* _tmp40_;
	JsonParser* _tmp41_;
	JsonNode* _tmp42_;
	SoupMessage* _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	JsonObject* sync_status;
	JsonParser* _tmp51_;
	JsonNode* _tmp52_;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonNode* uuid_member;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsSource* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	ObjectsSourceTodoistData* _tmp63_;
	JsonParser* _tmp64_;
	JsonNode* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	HttpResponse* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	HttpResponse* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	JsonObject* _tmp78_;
	const gchar* _tmp79_;
	JsonObject* _tmp80_;
	const gchar* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	GError* e;
	SoupMessage* _tmp87_;
	guint _tmp88_;
	guint _tmp89_;
	HttpResponse* _tmp90_;
	GError* _tmp91_;
	const gchar* _tmp92_;
	SoupMessage* _tmp93_;
	guint _tmp94_;
	guint _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp98_;
	ObjectsQueue* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	ObjectsQueue* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	ServicesDatabase* _tmp110_;
	ServicesDatabase* _tmp111_;
	ObjectsQueue* _tmp112_;
	HttpResponse* _tmp113_;
	GError* _inner_error0_;
};

struct _ServicesTodoistUpdateItemsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	GeeArrayList* objects;
	gchar* json;
	gchar* _tmp0_;
	SoupMessage* message;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessageHeaders* _tmp3_;
	SoupMessageHeaders* _tmp4_;
	ServicesSettings* _tmp5_;
	ServicesSettings* _tmp6_;
	GSettings* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	SoupMessage* _tmp12_;
	const gchar* _tmp13_;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_;
	guint8* _tmp16_;
	gint _tmp16__length1;
	GBytes* _tmp17_;
	GBytes* _tmp18_;
	GBytes* stream;
	SoupSession* _tmp19_;
	SoupMessage* _tmp20_;
	GBytes* _tmp21_;
	JsonParser* _tmp22_;
	GBytes* _tmp23_;
	gsize _tmp24_;
	guint8* _tmp25_;
	JsonParser* _tmp26_;
	JsonNode* _tmp27_;
	SoupMessage* _tmp28_;
	guint _tmp29_;
	guint _tmp30_;
	SoupMessage* _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	SoupMessage* _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	ServicesSettings* _tmp39_;
	ServicesSettings* _tmp40_;
	GSettings* _tmp41_;
	JsonParser* _tmp42_;
	JsonNode* _tmp43_;
	JsonObject* _tmp44_;
	const gchar* _tmp45_;
	GError* e;
	const gchar* _tmp46_;
	GError* _inner_error0_;
};

struct _ServicesTodoistDeleteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	SoupMessage* message;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	ObjectsSource* _tmp14_;
	ObjectsSource* _tmp15_;
	ObjectsSourceTodoistData* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	SoupMessage* _tmp22_;
	const gchar* _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gint _tmp25_;
	guint8* _tmp26_;
	gint _tmp26__length1;
	GBytes* _tmp27_;
	GBytes* _tmp28_;
	HttpResponse* response;
	HttpResponse* _tmp29_;
	GBytes* stream;
	SoupSession* _tmp30_;
	SoupMessage* _tmp31_;
	GBytes* _tmp32_;
	JsonParser* _tmp33_;
	GBytes* _tmp34_;
	gsize _tmp35_;
	guint8* _tmp36_;
	JsonParser* _tmp37_;
	JsonNode* _tmp38_;
	SoupMessage* _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	HttpResponse* _tmp42_;
	JsonParser* _tmp43_;
	JsonNode* _tmp44_;
	SoupMessage* _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	SoupMessage* _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	JsonObject* sync_status;
	JsonParser* _tmp53_;
	JsonNode* _tmp54_;
	JsonObject* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonNode* uuid_member;
	JsonObject* _tmp58_;
	const gchar* _tmp59_;
	JsonNode* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	ObjectsSource* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	JsonParser* _tmp67_;
	JsonNode* _tmp68_;
	JsonObject* _tmp69_;
	const gchar* _tmp70_;
	ObjectsSource* _tmp71_;
	ObjectsSource* _tmp72_;
	GDateTime* _tmp73_;
	GDateTime* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	ObjectsSource* _tmp77_;
	ObjectsSource* _tmp78_;
	HttpResponse* _tmp79_;
	HttpResponse* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	JsonObject* _tmp87_;
	JsonObject* _tmp88_;
	const gchar* _tmp89_;
	JsonObject* _tmp90_;
	const gchar* _tmp91_;
	GError* e;
	SoupMessage* _tmp92_;
	guint _tmp93_;
	guint _tmp94_;
	HttpResponse* _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	SoupMessage* _tmp98_;
	guint _tmp99_;
	guint _tmp100_;
	GError* _tmp101_;
	const gchar* _tmp102_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	ObjectsQueue* _tmp106_;
	const gchar* _tmp107_;
	const gchar* _tmp108_;
	ObjectsQueue* _tmp109_;
	const gchar* _tmp110_;
	const gchar* _tmp111_;
	ObjectsQueue* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	ServicesDatabase* _tmp115_;
	ServicesDatabase* _tmp116_;
	ObjectsQueue* _tmp117_;
	HttpResponse* _tmp118_;
	GError* _inner_error0_;
};

struct _ServicesTodoistCompleteItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsItem* item;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar* json;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	ObjectsSource* source;
	ObjectsSource* _tmp9_;
	ObjectsSource* _tmp10_;
	ObjectsSource* _tmp11_;
	SoupMessage* message;
	SoupMessage* _tmp12_;
	SoupMessage* _tmp13_;
	SoupMessageHeaders* _tmp14_;
	SoupMessageHeaders* _tmp15_;
	ObjectsSource* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	ObjectsSourceTodoistData* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	SoupMessage* _tmp23_;
	const gchar* _tmp24_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gint _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	GBytes* _tmp28_;
	GBytes* _tmp29_;
	HttpResponse* response;
	HttpResponse* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	SoupMessage* _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	HttpResponse* _tmp43_;
	JsonParser* _tmp44_;
	JsonNode* _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	SoupMessage* _tmp49_;
	guint _tmp50_;
	guint _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	JsonObject* sync_status;
	JsonParser* _tmp54_;
	JsonNode* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonObject* _tmp58_;
	JsonNode* uuid_member;
	JsonObject* _tmp59_;
	const gchar* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	JsonNode* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	JsonParser* _tmp67_;
	JsonNode* _tmp68_;
	JsonObject* _tmp69_;
	const gchar* _tmp70_;
	HttpResponse* _tmp71_;
	ObjectsSource* _tmp72_;
	GDateTime* _tmp73_;
	GDateTime* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	ObjectsSource* _tmp77_;
	HttpResponse* _tmp78_;
	JsonObject* _tmp79_;
	const gchar* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	JsonObject* _tmp86_;
	const gchar* _tmp87_;
	JsonObject* _tmp88_;
	const gchar* _tmp89_;
	GError* e;
	SoupMessage* _tmp90_;
	guint _tmp91_;
	guint _tmp92_;
	HttpResponse* _tmp93_;
	GError* _tmp94_;
	const gchar* _tmp95_;
	SoupMessage* _tmp96_;
	guint _tmp97_;
	guint _tmp98_;
	GError* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp101_;
	ObjectsQueue* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	const gchar* _tmp107_;
	gboolean _tmp108_;
	gboolean _tmp109_;
	ObjectsQueue* _tmp110_;
	ObjectsQueue* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	ServicesDatabase* _tmp114_;
	ServicesDatabase* _tmp115_;
	ObjectsQueue* _tmp116_;
	HttpResponse* _tmp117_;
	GError* _inner_error0_;
};

struct _ServicesTodoistMoveItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsItem* item;
	gchar* type;
	gchar* id;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	ObjectsSource* source;
	ObjectsSource* _tmp6_;
	ObjectsSource* _tmp7_;
	ObjectsSource* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	ObjectsSourceTodoistData* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* _tmp20_;
	const gchar* _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gint _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	GBytes* _tmp25_;
	GBytes* _tmp26_;
	HttpResponse* response;
	HttpResponse* _tmp27_;
	GBytes* stream;
	SoupSession* _tmp28_;
	SoupMessage* _tmp29_;
	GBytes* _tmp30_;
	JsonParser* _tmp31_;
	GBytes* _tmp32_;
	gsize _tmp33_;
	guint8* _tmp34_;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	HttpResponse* _tmp40_;
	JsonParser* _tmp41_;
	JsonNode* _tmp42_;
	SoupMessage* _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	JsonObject* sync_status;
	JsonParser* _tmp51_;
	JsonNode* _tmp52_;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonNode* uuid_member;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsSource* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	ObjectsSourceTodoistData* _tmp63_;
	JsonParser* _tmp64_;
	JsonNode* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	HttpResponse* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	HttpResponse* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	JsonObject* _tmp78_;
	const gchar* _tmp79_;
	JsonObject* _tmp80_;
	const gchar* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	GError* e;
	SoupMessage* _tmp87_;
	guint _tmp88_;
	guint _tmp89_;
	HttpResponse* _tmp90_;
	GError* _tmp91_;
	const gchar* _tmp92_;
	SoupMessage* _tmp93_;
	guint _tmp94_;
	guint _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp98_;
	ObjectsQueue* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	ObjectsQueue* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	ServicesDatabase* _tmp108_;
	ServicesDatabase* _tmp109_;
	ObjectsQueue* _tmp110_;
	HttpResponse* _tmp111_;
	GError* _inner_error0_;
};

struct _ServicesTodoistMoveProjectSectionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* base_object;
	gchar* project_id;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	SoupMessage* message;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	SoupMessageHeaders* _tmp8_;
	SoupMessageHeaders* _tmp9_;
	ObjectsSource* _tmp10_;
	ObjectsSource* _tmp11_;
	ObjectsSourceTodoistData* _tmp12_;
	ObjectsSourceTodoistData* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	SoupMessage* _tmp18_;
	const gchar* _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	GBytes* _tmp23_;
	GBytes* _tmp24_;
	HttpResponse* response;
	HttpResponse* _tmp25_;
	GBytes* stream;
	SoupSession* _tmp26_;
	SoupMessage* _tmp27_;
	GBytes* _tmp28_;
	JsonParser* _tmp29_;
	GBytes* _tmp30_;
	gsize _tmp31_;
	guint8* _tmp32_;
	JsonParser* _tmp33_;
	JsonNode* _tmp34_;
	SoupMessage* _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	HttpResponse* _tmp38_;
	JsonParser* _tmp39_;
	JsonNode* _tmp40_;
	SoupMessage* _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	SoupMessage* _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	JsonObject* sync_status;
	JsonParser* _tmp49_;
	JsonNode* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* _tmp52_;
	JsonObject* _tmp53_;
	JsonNode* uuid_member;
	JsonObject* _tmp54_;
	const gchar* _tmp55_;
	JsonNode* _tmp56_;
	JsonNode* _tmp57_;
	JsonNode* _tmp58_;
	ObjectsSource* _tmp59_;
	ObjectsSource* _tmp60_;
	ObjectsSourceTodoistData* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	JsonParser* _tmp63_;
	JsonNode* _tmp64_;
	JsonObject* _tmp65_;
	const gchar* _tmp66_;
	HttpResponse* _tmp67_;
	ObjectsSource* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	ObjectsSource* _tmp75_;
	HttpResponse* _tmp76_;
	JsonObject* _tmp77_;
	const gchar* _tmp78_;
	JsonObject* _tmp79_;
	const gchar* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	JsonObject* _tmp84_;
	const gchar* _tmp85_;
	JsonObject* _tmp86_;
	const gchar* _tmp87_;
	GError* e;
	SoupMessage* _tmp88_;
	guint _tmp89_;
	guint _tmp90_;
	HttpResponse* _tmp91_;
	GError* _tmp92_;
	const gchar* _tmp93_;
	SoupMessage* _tmp94_;
	guint _tmp95_;
	guint _tmp96_;
	GError* _tmp97_;
	const gchar* _tmp98_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp99_;
	ObjectsQueue* _tmp100_;
	const gchar* _tmp101_;
	ObjectsQueue* _tmp102_;
	const gchar* _tmp103_;
	const gchar* _tmp104_;
	ObjectsQueue* _tmp105_;
	ObjectsQueue* _tmp106_;
	ObjectsQueue* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	HttpResponse* _tmp110_;
	ServicesDatabase* _tmp111_;
	ServicesDatabase* _tmp112_;
	ObjectsQueue* _tmp113_;
	GError* _inner_error0_;
};

struct _ServicesTodoistDuplicateProjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsProject* project;
	HttpResponse* result;
	gchar* json;
	gchar* _tmp0_;
	SoupMessage* message;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessageHeaders* _tmp3_;
	SoupMessageHeaders* _tmp4_;
	ObjectsSource* _tmp5_;
	ObjectsSource* _tmp6_;
	ObjectsSourceTodoistData* _tmp7_;
	ObjectsSourceTodoistData* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupMessage* _tmp13_;
	const gchar* _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	gint _tmp16_;
	guint8* _tmp17_;
	gint _tmp17__length1;
	GBytes* _tmp18_;
	GBytes* _tmp19_;
	HttpResponse* response;
	HttpResponse* _tmp20_;
	GBytes* stream;
	SoupSession* _tmp21_;
	SoupMessage* _tmp22_;
	GBytes* _tmp23_;
	JsonParser* _tmp24_;
	GBytes* _tmp25_;
	gsize _tmp26_;
	guint8* _tmp27_;
	JsonParser* _tmp28_;
	JsonNode* _tmp29_;
	SoupMessage* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	HttpResponse* _tmp33_;
	JsonParser* _tmp34_;
	JsonNode* _tmp35_;
	SoupMessage* _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	SoupMessage* _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	HttpResponse* _tmp44_;
	GError* _inner_error0_;
};

struct _HttpResponsePrivate {
	gboolean _status;
	gchar* _error;
	gint _error_code;
	gint _http_code;
	gchar* _data;
	GValue _data_object;
};

struct _ParamSpecHttpResponse {
	GParamSpec parent_instance;
};

static gint ServicesTodoist_private_offset;
static gpointer services_todoist_parent_class = NULL;
static ServicesTodoist* services_todoist__instance;
static ServicesTodoist* services_todoist__instance = NULL;
static gint HttpResponse_private_offset;
static gpointer http_response_parent_class = NULL;

static void services_todoist_login_data_free (gpointer _data);
static gboolean services_todoist_login_co (ServicesTodoistLoginData* _data_);
static void services_todoist_login_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static void services_todoist_print_root (ServicesTodoist* self,
                                  JsonNode* root);
static void services_todoist_add_todoist_account_data_free (gpointer _data);
static gboolean services_todoist_add_todoist_account_co (ServicesTodoistAddTodoistAccountData* _data_);
static void services_todoist_add_todoist_account_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void services_todoist_add_section_if_not_exists (ServicesTodoist* self,
                                                 JsonNode* node);
static void services_todoist_add_item_if_not_exists (ServicesTodoist* self,
                                              JsonNode* node);
static void services_todoist_sync_data_free (gpointer _data);
static gboolean services_todoist_sync_co (ServicesTodoistSyncData* _data_);
static void services_todoist_sync_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_);
static void services_todoist_queue_data_free (gpointer _data);
static gboolean services_todoist_queue_co (ServicesTodoistQueueData* _data_);
static void services_todoist_queue_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void services_todoist_add_data_free (gpointer _data);
static gboolean services_todoist_add_co (ServicesTodoistAddData* _data_);
static void services_todoist_add_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_);
static void services_todoist_debug_error (ServicesTodoist* self,
                                   guint status_code,
                                   const gchar* message);
static void services_todoist_update_data_free (gpointer _data);
static gboolean services_todoist_update_co (ServicesTodoistUpdateData* _data_);
static void services_todoist_update_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void services_todoist_update_items_data_free (gpointer _data);
static gboolean services_todoist_update_items_co (ServicesTodoistUpdateItemsData* _data_);
static void services_todoist_update_items_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void services_todoist_delete_data_free (gpointer _data);
static gboolean services_todoist_delete_co (ServicesTodoistDeleteData* _data_);
static void services_todoist_delete_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void services_todoist_complete_item_data_free (gpointer _data);
static gboolean services_todoist_complete_item_co (ServicesTodoistCompleteItemData* _data_);
static void services_todoist_complete_item_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void services_todoist_move_item_data_free (gpointer _data);
static gboolean services_todoist_move_item_co (ServicesTodoistMoveItemData* _data_);
static void services_todoist_move_item_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void services_todoist_move_project_section_data_free (gpointer _data);
static gboolean services_todoist_move_project_section_co (ServicesTodoistMoveProjectSectionData* _data_);
static void services_todoist_move_project_section_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void services_todoist_duplicate_project_data_free (gpointer _data);
static gboolean services_todoist_duplicate_project_co (ServicesTodoistDuplicateProjectData* _data_);
static gchar* services_todoist_get_duplicate_project_json (ServicesTodoist* self,
                                                    ObjectsProject* project);
static void services_todoist_duplicate_project_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void services_todoist_finalize (GObject * obj);
static GType services_todoist_get_type_once (void);
static void http_response_finalize (HttpResponse * obj);
static GType http_response_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
services_todoist_get_instance_private (ServicesTodoist* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesTodoist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../core/Services/Todoist.vala"
	return self ? g_object_ref (self) : NULL;
#line 1928 "Todoist.c"
}

ServicesTodoist*
services_todoist_get_default (void)
{
	ServicesTodoist* _tmp0_;
	ServicesTodoist* _tmp2_;
	ServicesTodoist* _tmp3_;
	ServicesTodoist* result;
#line 36 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist__instance;
#line 36 "../core/Services/Todoist.vala"
	if (_tmp0_ == NULL) {
#line 1942 "Todoist.c"
		ServicesTodoist* _tmp1_;
#line 37 "../core/Services/Todoist.vala"
		_tmp1_ = services_todoist_new ();
#line 37 "../core/Services/Todoist.vala"
		_g_object_unref0 (services_todoist__instance);
#line 37 "../core/Services/Todoist.vala"
		services_todoist__instance = _tmp1_;
#line 1950 "Todoist.c"
	}
#line 40 "../core/Services/Todoist.vala"
	_tmp2_ = services_todoist__instance;
#line 40 "../core/Services/Todoist.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 40 "../core/Services/Todoist.vala"
	result = _tmp3_;
#line 40 "../core/Services/Todoist.vala"
	return result;
#line 1960 "Todoist.c"
}

ServicesTodoist*
services_todoist_construct (GType object_type)
{
	ServicesTodoist * self = NULL;
	SoupSession* _tmp0_;
	JsonParser* _tmp1_;
#line 49 "../core/Services/Todoist.vala"
	self = (ServicesTodoist*) g_object_new (object_type, NULL);
#line 50 "../core/Services/Todoist.vala"
	_tmp0_ = soup_session_new ();
#line 50 "../core/Services/Todoist.vala"
	_g_object_unref0 (self->priv->session);
#line 50 "../core/Services/Todoist.vala"
	self->priv->session = _tmp0_;
#line 51 "../core/Services/Todoist.vala"
	_tmp1_ = json_parser_new ();
#line 51 "../core/Services/Todoist.vala"
	_g_object_unref0 (self->priv->parser);
#line 51 "../core/Services/Todoist.vala"
	self->priv->parser = _tmp1_;
#line 49 "../core/Services/Todoist.vala"
	return self;
#line 1985 "Todoist.c"
}

ServicesTodoist*
services_todoist_new (void)
{
#line 49 "../core/Services/Todoist.vala"
	return services_todoist_construct (SERVICES_TYPE_TODOIST);
#line 1993 "Todoist.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2014 "Todoist.c"
}

gboolean
services_todoist_invalid_token (ServicesTodoist* self)
{
	ServicesSettings* _tmp0_;
	ServicesSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 54 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../core/Services/Todoist.vala"
	_tmp0_ = services_settings_get_default ();
#line 55 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 55 "../core/Services/Todoist.vala"
	_tmp2_ = _tmp1_->settings;
#line 55 "../core/Services/Todoist.vala"
	_tmp3_ = g_settings_get_string (_tmp2_, "todoist-access-token");
#line 55 "../core/Services/Todoist.vala"
	_tmp4_ = _tmp3_;
#line 55 "../core/Services/Todoist.vala"
	_tmp5_ = string_strip (_tmp4_);
#line 55 "../core/Services/Todoist.vala"
	_tmp6_ = _tmp5_;
#line 55 "../core/Services/Todoist.vala"
	_tmp7_ = g_strcmp0 (_tmp6_, "") == 0;
#line 55 "../core/Services/Todoist.vala"
	_g_free0 (_tmp6_);
#line 55 "../core/Services/Todoist.vala"
	_g_free0 (_tmp4_);
#line 55 "../core/Services/Todoist.vala"
	_g_object_unref0 (_tmp1_);
#line 55 "../core/Services/Todoist.vala"
	result = _tmp7_;
#line 55 "../core/Services/Todoist.vala"
	return result;
#line 2057 "Todoist.c"
}

gboolean
services_todoist_is_logged_in (ServicesTodoist* self)
{
	gboolean result;
#line 58 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../core/Services/Todoist.vala"
	result = !services_todoist_invalid_token (self);
#line 59 "../core/Services/Todoist.vala"
	return result;
#line 2070 "Todoist.c"
}

static void
services_todoist_login_data_free (gpointer _data)
{
	ServicesTodoistLoginData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_url);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistLoginData, _data_);
#line 2086 "Todoist.c"
}

void
services_todoist_login (ServicesTodoist* self,
                        const gchar* _url,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ServicesTodoistLoginData* _data_;
	ServicesTodoist* _tmp0_;
	gchar* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (_url != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistLoginData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_login_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = g_strdup (_url);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_url);
#line 22 "../core/Services/Todoist.vala"
	_data_->_url = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_login_co (_data_);
#line 2120 "Todoist.c"
}

HttpResponse*
services_todoist_login_finish (ServicesTodoist* self,
                               GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistLoginData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 2137 "Todoist.c"
}

static void
services_todoist_login_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ServicesTodoistLoginData* _data_;
#line 74 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 74 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 74 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 74 "../core/Services/Todoist.vala"
	services_todoist_login_co (_data_);
#line 2154 "Todoist.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 80 "../core/Services/Todoist.vala"
	return self ? json_object_ref (self) : NULL;
#line 2162 "Todoist.c"
}

static gboolean
services_todoist_login_co (ServicesTodoistLoginData* _data_)
{
#line 62 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 62 "../core/Services/Todoist.vala"
		case 0:
#line 2172 "Todoist.c"
		goto _state_0;
#line 62 "../core/Services/Todoist.vala"
		case 1:
#line 2176 "Todoist.c"
		goto _state_1;
#line 62 "../core/Services/Todoist.vala"
		case 2:
#line 2180 "Todoist.c"
		goto _state_2;
		default:
#line 62 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 2185 "Todoist.c"
	}
	_state_0:
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_ = g_strsplit (_data_->_url, "=", 0);
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp2__length1 = _vala_array_length (_data_->_tmp0_);
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_[1];
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = g_strdup (_data_->_tmp3_);
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 63 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = (_vala_array_free (_data_->_tmp2_, _data_->_tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 63 "../core/Services/Todoist.vala"
	_data_->code = _data_->_tmp5_;
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = _data_->code;
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _data_->_tmp7_ = g_strsplit (_data_->_tmp6_, "&", 0);
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp9__length1 = _vala_array_length (_data_->_tmp7_);
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->_tmp9_[0];
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = g_strdup (_data_->_tmp10_);
#line 64 "../core/Services/Todoist.vala"
	_g_free0 (_data_->code);
#line 64 "../core/Services/Todoist.vala"
	_data_->code = _data_->_tmp11_;
#line 64 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = (_vala_array_free (_data_->_tmp9_, _data_->_tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 66 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->code;
#line 66 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = g_strdup_printf ("https://todoist.com/oauth/access_token?client_id=%s&client_secret=%s&c" \
"ode=%s", CONSTANTS_TODOIST_CLIENT_ID, CONSTANTS_TODOIST_CLIENT_SECRET, _data_->_tmp12_);
#line 66 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp13_;
#line 69 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = _data_->url;
#line 69 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = soup_message_new ("POST", _data_->_tmp14_);
#line 69 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp15_;
#line 71 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = http_response_new ();
#line 71 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp16_;
#line 2238 "Todoist.c"
	{
#line 74 "../core/Services/Todoist.vala"
		_data_->_tmp17_ = _data_->self->priv->session;
#line 74 "../core/Services/Todoist.vala"
		_data_->_tmp18_ = _data_->message;
#line 74 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 74 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp17_, _data_->_tmp18_, G_PRIORITY_HIGH, NULL, services_todoist_login_ready, _data_);
#line 74 "../core/Services/Todoist.vala"
		return FALSE;
#line 2250 "Todoist.c"
		_state_1:
#line 74 "../core/Services/Todoist.vala"
		_data_->_tmp19_ = soup_session_send_and_read_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 74 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp19_;
#line 74 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2258 "Todoist.c"
			goto __catch0_g_error;
		}
#line 75 "../core/Services/Todoist.vala"
		_data_->_tmp20_ = _data_->self->priv->parser;
#line 75 "../core/Services/Todoist.vala"
		_data_->_tmp21_ = _data_->stream;
#line 75 "../core/Services/Todoist.vala"
		_data_->_tmp22_ = 0;
#line 75 "../core/Services/Todoist.vala"
		_data_->_tmp23_ = g_bytes_get_data (_data_->_tmp21_, &_data_->_tmp22_);
#line 75 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp20_, (const gchar*) _data_->_tmp23_, (gssize) -1, &_data_->_inner_error0_);
#line 75 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 75 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 2275 "Todoist.c"
			goto __catch0_g_error;
		}
#line 78 "../core/Services/Todoist.vala"
		_data_->_tmp24_ = _data_->self->priv->parser;
#line 78 "../core/Services/Todoist.vala"
		_data_->_tmp25_ = json_parser_get_root (_data_->_tmp24_);
#line 78 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp25_);
#line 80 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = _data_->self->priv->parser;
#line 80 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = json_parser_get_root (_data_->_tmp26_);
#line 80 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = json_node_get_object (_data_->_tmp27_);
#line 80 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = _json_object_ref0 (_data_->_tmp28_);
#line 80 "../core/Services/Todoist.vala"
		_data_->root = _data_->_tmp29_;
#line 81 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = json_object_get_string_member (_data_->root, "access_token");
#line 81 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = g_strdup (_data_->_tmp30_);
#line 81 "../core/Services/Todoist.vala"
		_data_->token = _data_->_tmp31_;
#line 83 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->response;
#line 83 "../core/Services/Todoist.vala"
		_data_->_state_ = 2;
#line 83 "../core/Services/Todoist.vala"
		services_todoist_add_todoist_account (_data_->self, _data_->token, _data_->_tmp32_, services_todoist_login_ready, _data_);
#line 83 "../core/Services/Todoist.vala"
		return FALSE;
#line 2308 "Todoist.c"
		_state_2:
#line 83 "../core/Services/Todoist.vala"
		services_todoist_add_todoist_account_finish (_data_->self, _data_->_res_);
#line 73 "../core/Services/Todoist.vala"
		_g_free0 (_data_->token);
#line 73 "../core/Services/Todoist.vala"
		_json_object_unref0 (_data_->root);
#line 73 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 2318 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 73 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 73 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 85 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = _data_->response;
#line 85 "../core/Services/Todoist.vala"
		http_response_set_error_code (_data_->_tmp33_, _data_->e->code);
#line 86 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->response;
#line 86 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->e->message;
#line 86 "../core/Services/Todoist.vala"
		http_response_set_error (_data_->_tmp34_, _data_->_tmp35_);
#line 87 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = _data_->e->message;
#line 87 "../core/Services/Todoist.vala"
		g_error ("Todoist.vala:87: %s", _data_->_tmp36_);
#line 73 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 2343 "Todoist.c"
	}
	__finally0:
#line 73 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 73 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 73 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 73 "../core/Services/Todoist.vala"
		_g_free0 (_data_->url);
#line 73 "../core/Services/Todoist.vala"
		_g_free0 (_data_->code);
#line 73 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 73 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 73 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 73 "../core/Services/Todoist.vala"
		return FALSE;
#line 2364 "Todoist.c"
	}
#line 90 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 90 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 90 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 90 "../core/Services/Todoist.vala"
	_g_free0 (_data_->code);
#line 90 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 90 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 90 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 90 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2382 "Todoist.c"
		}
	}
#line 90 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 90 "../core/Services/Todoist.vala"
	return FALSE;
#line 2389 "Todoist.c"
}

static void
services_todoist_add_todoist_account_data_free (gpointer _data)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->token);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->response);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistAddTodoistAccountData, _data_);
#line 2405 "Todoist.c"
}

static gpointer
_http_response_ref0 (gpointer self)
{
#line 22 "../core/Services/Todoist.vala"
	return self ? http_response_ref (self) : NULL;
#line 2413 "Todoist.c"
}

void
services_todoist_add_todoist_account (ServicesTodoist* self,
                                      const gchar* token,
                                      HttpResponse* response,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	ServicesTodoist* _tmp0_;
	gchar* _tmp1_;
	HttpResponse* _tmp2_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (token != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (response != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistAddTodoistAccountData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_add_todoist_account_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = g_strdup (token);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->token);
#line 22 "../core/Services/Todoist.vala"
	_data_->token = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	_tmp2_ = _http_response_ref0 (response);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->response);
#line 22 "../core/Services/Todoist.vala"
	_data_->response = _tmp2_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_add_todoist_account_co (_data_);
#line 2457 "Todoist.c"
}

void
services_todoist_add_todoist_account_finish (ServicesTodoist* self,
                                             GAsyncResult* _res_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2467 "Todoist.c"
}

static void
services_todoist_add_todoist_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
#line 102 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 102 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 102 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 102 "../core/Services/Todoist.vala"
	services_todoist_add_todoist_account_co (_data_);
#line 2484 "Todoist.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 2500 "Todoist.c"
}

static gboolean
services_todoist_add_todoist_account_co (ServicesTodoistAddTodoistAccountData* _data_)
{
#line 93 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 93 "../core/Services/Todoist.vala"
		case 0:
#line 2510 "Todoist.c"
		goto _state_0;
#line 93 "../core/Services/Todoist.vala"
		case 1:
#line 2514 "Todoist.c"
		goto _state_1;
		default:
#line 93 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 2519 "Todoist.c"
	}
	_state_0:
#line 94 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = g_strdup (SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 94 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp0_;
#line 95 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->url;
#line 95 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = g_strconcat (_data_->_tmp1_, "?sync_token=", NULL);
#line 95 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 95 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = g_strconcat (_data_->_tmp3_, "*", NULL);
#line 95 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 95 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp4_;
#line 95 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp3_);
#line 96 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = _data_->url;
#line 96 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "&resource_types=", NULL);
#line 96 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 96 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = g_strconcat (_data_->_tmp7_, SERVICES_TODOIST_RESOURCE_TYPES, NULL);
#line 96 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 96 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp8_;
#line 96 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp7_);
#line 98 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->url;
#line 98 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = soup_message_new ("POST", _data_->_tmp9_);
#line 98 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp10_;
#line 99 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _data_->message;
#line 99 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = soup_message_get_request_headers (_data_->_tmp11_);
#line 99 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 99 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = g_strdup_printf ("Bearer %s", _data_->token);
#line 99 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 99 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp13_, "Authorization", _data_->_tmp15_);
#line 99 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp15_);
#line 2574 "Todoist.c"
	{
#line 102 "../core/Services/Todoist.vala"
		_data_->_tmp16_ = _data_->self->priv->session;
#line 102 "../core/Services/Todoist.vala"
		_data_->_tmp17_ = _data_->message;
#line 102 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 102 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp16_, _data_->_tmp17_, G_PRIORITY_HIGH, NULL, services_todoist_add_todoist_account_ready, _data_);
#line 102 "../core/Services/Todoist.vala"
		return FALSE;
#line 2586 "Todoist.c"
		_state_1:
#line 102 "../core/Services/Todoist.vala"
		_data_->_tmp18_ = soup_session_send_and_read_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 102 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp18_;
#line 102 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2594 "Todoist.c"
			goto __catch0_g_error;
		}
#line 103 "../core/Services/Todoist.vala"
		_data_->_tmp19_ = _data_->self->priv->parser;
#line 103 "../core/Services/Todoist.vala"
		_data_->_tmp20_ = _data_->stream;
#line 103 "../core/Services/Todoist.vala"
		_data_->_tmp21_ = 0;
#line 103 "../core/Services/Todoist.vala"
		_data_->_tmp22_ = g_bytes_get_data (_data_->_tmp20_, &_data_->_tmp21_);
#line 103 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp19_, (const gchar*) _data_->_tmp22_, (gssize) -1, &_data_->_inner_error0_);
#line 103 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 103 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 2611 "Todoist.c"
			goto __catch0_g_error;
		}
#line 106 "../core/Services/Todoist.vala"
		_data_->_tmp23_ = _data_->self->priv->parser;
#line 106 "../core/Services/Todoist.vala"
		_data_->_tmp24_ = json_parser_get_root (_data_->_tmp23_);
#line 106 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp24_);
#line 108 "../core/Services/Todoist.vala"
		_data_->_tmp25_ = objects_source_new ();
#line 108 "../core/Services/Todoist.vala"
		_data_->source = _data_->_tmp25_;
#line 109 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = _data_->source;
#line 109 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = util_get_default ();
#line 109 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 109 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = util_generate_id (_data_->_tmp28_, NULL);
#line 109 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 109 "../core/Services/Todoist.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _data_->_tmp26_, _data_->_tmp30_);
#line 109 "../core/Services/Todoist.vala"
		_g_free0 (_data_->_tmp30_);
#line 109 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->_tmp28_);
#line 110 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->source;
#line 110 "../core/Services/Todoist.vala"
		objects_source_set_source_type (_data_->_tmp31_, SOURCE_TYPE_TODOIST);
#line 111 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = objects_source_todoist_data_new ();
#line 111 "../core/Services/Todoist.vala"
		_data_->todoist_data = _data_->_tmp32_;
#line 113 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = _data_->todoist_data;
#line 113 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->self->priv->parser;
#line 113 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = json_parser_get_root (_data_->_tmp34_);
#line 113 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = json_node_get_object (_data_->_tmp35_);
#line 113 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = json_object_get_string_member (_data_->_tmp36_, "sync_token");
#line 113 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_sync_token (_data_->_tmp33_, _data_->_tmp37_);
#line 114 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = _data_->todoist_data;
#line 114 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_access_token (_data_->_tmp38_, _data_->token);
#line 115 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = _data_->source;
#line 115 "../core/Services/Todoist.vala"
		objects_source_set_sync_server (_data_->_tmp39_, TRUE);
#line 118 "../core/Services/Todoist.vala"
		_data_->_tmp40_ = _data_->self->priv->parser;
#line 118 "../core/Services/Todoist.vala"
		_data_->_tmp41_ = json_parser_get_root (_data_->_tmp40_);
#line 118 "../core/Services/Todoist.vala"
		_data_->_tmp42_ = json_node_get_object (_data_->_tmp41_);
#line 118 "../core/Services/Todoist.vala"
		_data_->_tmp43_ = json_object_get_object_member (_data_->_tmp42_, "user");
#line 118 "../core/Services/Todoist.vala"
		_data_->_tmp44_ = _json_object_ref0 (_data_->_tmp43_);
#line 118 "../core/Services/Todoist.vala"
		_data_->user_object = _data_->_tmp44_;
#line 119 "../core/Services/Todoist.vala"
		_data_->_tmp45_ = _data_->user_object;
#line 119 "../core/Services/Todoist.vala"
		if (json_object_get_null_member (_data_->_tmp45_, "image_id") == FALSE) {
#line 120 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->todoist_data;
#line 120 "../core/Services/Todoist.vala"
			_data_->_tmp47_ = _data_->user_object;
#line 120 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = json_object_get_string_member (_data_->_tmp47_, "image_id");
#line 120 "../core/Services/Todoist.vala"
			objects_source_todoist_data_set_user_image_id (_data_->_tmp46_, _data_->_tmp48_);
#line 121 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = _data_->todoist_data;
#line 121 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = _data_->user_object;
#line 121 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = json_object_get_string_member (_data_->_tmp50_, "avatar_s640");
#line 121 "../core/Services/Todoist.vala"
			objects_source_todoist_data_set_user_avatar (_data_->_tmp49_, _data_->_tmp51_);
#line 2700 "Todoist.c"
		}
#line 125 "../core/Services/Todoist.vala"
		_data_->_tmp52_ = _data_->todoist_data;
#line 125 "../core/Services/Todoist.vala"
		_data_->_tmp53_ = _data_->user_object;
#line 125 "../core/Services/Todoist.vala"
		_data_->_tmp54_ = json_object_get_string_member (_data_->_tmp53_, "full_name");
#line 125 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_user_name (_data_->_tmp52_, _data_->_tmp54_);
#line 126 "../core/Services/Todoist.vala"
		_data_->_tmp55_ = _data_->todoist_data;
#line 126 "../core/Services/Todoist.vala"
		_data_->_tmp56_ = _data_->user_object;
#line 126 "../core/Services/Todoist.vala"
		_data_->_tmp57_ = json_object_get_string_member (_data_->_tmp56_, "email");
#line 126 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_user_email (_data_->_tmp55_, _data_->_tmp57_);
#line 127 "../core/Services/Todoist.vala"
		_data_->_tmp58_ = _data_->todoist_data;
#line 127 "../core/Services/Todoist.vala"
		_data_->_tmp59_ = _data_->user_object;
#line 127 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_user_is_premium (_data_->_tmp58_, json_object_get_boolean_member (_data_->_tmp59_, "is_premium"));
#line 129 "../core/Services/Todoist.vala"
		_data_->_tmp60_ = _data_->source;
#line 129 "../core/Services/Todoist.vala"
		_data_->_tmp61_ = _data_->user_object;
#line 129 "../core/Services/Todoist.vala"
		_data_->_tmp62_ = json_object_get_string_member (_data_->_tmp61_, "email");
#line 129 "../core/Services/Todoist.vala"
		objects_source_set_display_name (_data_->_tmp60_, _data_->_tmp62_);
#line 130 "../core/Services/Todoist.vala"
		_data_->_tmp63_ = _data_->source;
#line 130 "../core/Services/Todoist.vala"
		_data_->_tmp64_ = _data_->todoist_data;
#line 130 "../core/Services/Todoist.vala"
		objects_source_set_data (_data_->_tmp63_, (ObjectsSourceData*) _data_->_tmp64_);
#line 132 "../core/Services/Todoist.vala"
		_data_->_tmp65_ = services_store_instance ();
#line 132 "../core/Services/Todoist.vala"
		_data_->_tmp66_ = _data_->todoist_data;
#line 132 "../core/Services/Todoist.vala"
		_data_->_tmp67_ = objects_source_todoist_data_get_user_email (_data_->_tmp66_);
#line 132 "../core/Services/Todoist.vala"
		_data_->_tmp68_ = _data_->_tmp67_;
#line 132 "../core/Services/Todoist.vala"
		if (services_store_source_todoist_exists (_data_->_tmp65_, _data_->_tmp68_)) {
#line 133 "../core/Services/Todoist.vala"
			http_response_set_error_code (_data_->response, 409);
#line 134 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->response, "Source already exists");
#line 135 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->response, FALSE);
#line 136 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->user_object);
#line 136 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->todoist_data);
#line 136 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->source);
#line 136 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 136 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->message);
#line 136 "../core/Services/Todoist.vala"
			_g_free0 (_data_->url);
#line 136 "../core/Services/Todoist.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 136 "../core/Services/Todoist.vala"
			if (_data_->_state_ != 0) {
#line 136 "../core/Services/Todoist.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 136 "../core/Services/Todoist.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2774 "Todoist.c"
				}
			}
#line 136 "../core/Services/Todoist.vala"
			g_object_unref (_data_->_async_result);
#line 136 "../core/Services/Todoist.vala"
			return FALSE;
#line 2781 "Todoist.c"
		}
#line 139 "../core/Services/Todoist.vala"
		_data_->_tmp69_ = services_store_instance ();
#line 139 "../core/Services/Todoist.vala"
		_data_->_tmp70_ = _data_->source;
#line 139 "../core/Services/Todoist.vala"
		services_store_insert_source (_data_->_tmp69_, _data_->_tmp70_);
#line 142 "../core/Services/Todoist.vala"
		_data_->_tmp71_ = _data_->self->priv->parser;
#line 142 "../core/Services/Todoist.vala"
		_data_->_tmp72_ = json_parser_get_root (_data_->_tmp71_);
#line 142 "../core/Services/Todoist.vala"
		_data_->_tmp73_ = json_node_get_object (_data_->_tmp72_);
#line 142 "../core/Services/Todoist.vala"
		_data_->_tmp74_ = json_object_get_array_member (_data_->_tmp73_, SERVICES_TODOIST_LABELS_COLLECTION);
#line 142 "../core/Services/Todoist.vala"
		_data_->labels = _data_->_tmp74_;
#line 143 "../core/Services/Todoist.vala"
		_data_->_tmp75_ = _data_->labels;
#line 143 "../core/Services/Todoist.vala"
		_data_->_tmp76_ = json_array_get_elements (_data_->_tmp75_);
#line 2803 "Todoist.c"
		{
#line 143 "../core/Services/Todoist.vala"
			_data_->_node_collection = _data_->_tmp76_;
#line 143 "../core/Services/Todoist.vala"
			for (_data_->_node_it = _data_->_node_collection; _data_->_node_it != NULL; _data_->_node_it = _data_->_node_it->next) {
#line 143 "../core/Services/Todoist.vala"
				_data_->_node = (JsonNode*) _data_->_node_it->data;
#line 2811 "Todoist.c"
				{
#line 144 "../core/Services/Todoist.vala"
					_data_->_tmp77_ = _data_->_node;
#line 144 "../core/Services/Todoist.vala"
					_data_->_tmp78_ = objects_label_new_from_json (_data_->_tmp77_);
#line 144 "../core/Services/Todoist.vala"
					_data_->_label = _data_->_tmp78_;
#line 145 "../core/Services/Todoist.vala"
					_data_->_tmp79_ = _data_->_label;
#line 145 "../core/Services/Todoist.vala"
					_data_->_tmp80_ = _data_->source;
#line 145 "../core/Services/Todoist.vala"
					_data_->_tmp81_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->_tmp80_);
#line 145 "../core/Services/Todoist.vala"
					_data_->_tmp82_ = _data_->_tmp81_;
#line 145 "../core/Services/Todoist.vala"
					objects_label_set_source_id (_data_->_tmp79_, _data_->_tmp82_);
#line 147 "../core/Services/Todoist.vala"
					_data_->_tmp83_ = services_store_instance ();
#line 147 "../core/Services/Todoist.vala"
					_data_->_tmp84_ = _data_->_label;
#line 147 "../core/Services/Todoist.vala"
					services_store_insert_label (_data_->_tmp83_, _data_->_tmp84_);
#line 143 "../core/Services/Todoist.vala"
					_g_object_unref0 (_data_->_label);
#line 2837 "Todoist.c"
				}
			}
#line 143 "../core/Services/Todoist.vala"
			(_data_->_node_collection == NULL) ? NULL : (_data_->_node_collection = (g_list_free (_data_->_node_collection), NULL));
#line 2842 "Todoist.c"
		}
#line 151 "../core/Services/Todoist.vala"
		_data_->_tmp85_ = _data_->self->priv->parser;
#line 151 "../core/Services/Todoist.vala"
		_data_->_tmp86_ = json_parser_get_root (_data_->_tmp85_);
#line 151 "../core/Services/Todoist.vala"
		_data_->_tmp87_ = json_node_get_object (_data_->_tmp86_);
#line 151 "../core/Services/Todoist.vala"
		_data_->_tmp88_ = json_object_get_array_member (_data_->_tmp87_, SERVICES_TODOIST_PROJECTS_COLLECTION);
#line 151 "../core/Services/Todoist.vala"
		_data_->projects = _data_->_tmp88_;
#line 152 "../core/Services/Todoist.vala"
		_data_->_tmp89_ = _data_->projects;
#line 152 "../core/Services/Todoist.vala"
		_data_->_tmp90_ = json_array_get_elements (_data_->_tmp89_);
#line 2858 "Todoist.c"
		{
#line 152 "../core/Services/Todoist.vala"
			_data_->_vala1__node_collection = _data_->_tmp90_;
#line 152 "../core/Services/Todoist.vala"
			for (_data_->_vala1__node_it = _data_->_vala1__node_collection; _data_->_vala1__node_it != NULL; _data_->_vala1__node_it = _data_->_vala1__node_it->next) {
#line 152 "../core/Services/Todoist.vala"
				_data_->_vala1__node = (JsonNode*) _data_->_vala1__node_it->data;
#line 2866 "Todoist.c"
				{
#line 153 "../core/Services/Todoist.vala"
					_data_->_tmp91_ = _data_->_vala1__node;
#line 153 "../core/Services/Todoist.vala"
					_data_->_tmp92_ = objects_project_new_from_json (_data_->_tmp91_);
#line 153 "../core/Services/Todoist.vala"
					_data_->_project = _data_->_tmp92_;
#line 154 "../core/Services/Todoist.vala"
					_data_->_tmp93_ = _data_->_project;
#line 154 "../core/Services/Todoist.vala"
					_data_->_tmp94_ = _data_->source;
#line 154 "../core/Services/Todoist.vala"
					_data_->_tmp95_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->_tmp94_);
#line 154 "../core/Services/Todoist.vala"
					_data_->_tmp96_ = _data_->_tmp95_;
#line 154 "../core/Services/Todoist.vala"
					objects_project_set_source_id (_data_->_tmp93_, _data_->_tmp96_);
#line 156 "../core/Services/Todoist.vala"
					_data_->_tmp97_ = _data_->_vala1__node;
#line 156 "../core/Services/Todoist.vala"
					_data_->_tmp98_ = json_node_get_object (_data_->_tmp97_);
#line 156 "../core/Services/Todoist.vala"
					if (!json_object_get_null_member (_data_->_tmp98_, "parent_id")) {
#line 157 "../core/Services/Todoist.vala"
						_data_->_tmp99_ = services_store_instance ();
#line 157 "../core/Services/Todoist.vala"
						_data_->_tmp100_ = _data_->_vala1__node;
#line 157 "../core/Services/Todoist.vala"
						_data_->_tmp101_ = json_node_get_object (_data_->_tmp100_);
#line 157 "../core/Services/Todoist.vala"
						_data_->_tmp102_ = json_object_get_string_member (_data_->_tmp101_, "parent_id");
#line 157 "../core/Services/Todoist.vala"
						_data_->_tmp103_ = services_store_get_project (_data_->_tmp99_, _data_->_tmp102_);
#line 157 "../core/Services/Todoist.vala"
						_data_->project = _data_->_tmp103_;
#line 158 "../core/Services/Todoist.vala"
						_data_->_tmp104_ = _data_->project;
#line 158 "../core/Services/Todoist.vala"
						if (_data_->_tmp104_ != NULL) {
#line 159 "../core/Services/Todoist.vala"
							_data_->_tmp105_ = _data_->project;
#line 159 "../core/Services/Todoist.vala"
							_data_->_tmp106_ = _data_->_project;
#line 159 "../core/Services/Todoist.vala"
							_data_->_tmp107_ = objects_project_add_subproject_if_not_exists (_data_->_tmp105_, _data_->_tmp106_);
#line 159 "../core/Services/Todoist.vala"
							_data_->_tmp108_ = _data_->_tmp107_;
#line 159 "../core/Services/Todoist.vala"
							_g_object_unref0 (_data_->_tmp108_);
#line 2916 "Todoist.c"
						}
#line 156 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->project);
#line 2920 "Todoist.c"
					} else {
#line 162 "../core/Services/Todoist.vala"
						_data_->_tmp109_ = services_store_instance ();
#line 162 "../core/Services/Todoist.vala"
						_data_->_tmp110_ = _data_->_project;
#line 162 "../core/Services/Todoist.vala"
						services_store_insert_project (_data_->_tmp109_, _data_->_tmp110_);
#line 2928 "Todoist.c"
					}
#line 152 "../core/Services/Todoist.vala"
					_g_object_unref0 (_data_->_project);
#line 2932 "Todoist.c"
				}
			}
#line 152 "../core/Services/Todoist.vala"
			(_data_->_vala1__node_collection == NULL) ? NULL : (_data_->_vala1__node_collection = (g_list_free (_data_->_vala1__node_collection), NULL));
#line 2937 "Todoist.c"
		}
#line 167 "../core/Services/Todoist.vala"
		_data_->_tmp111_ = _data_->self->priv->parser;
#line 167 "../core/Services/Todoist.vala"
		_data_->_tmp112_ = json_parser_get_root (_data_->_tmp111_);
#line 167 "../core/Services/Todoist.vala"
		_data_->_tmp113_ = json_node_get_object (_data_->_tmp112_);
#line 167 "../core/Services/Todoist.vala"
		_data_->_tmp114_ = json_object_get_array_member (_data_->_tmp113_, SERVICES_TODOIST_SECTIONS_COLLECTION);
#line 167 "../core/Services/Todoist.vala"
		_data_->sections = _data_->_tmp114_;
#line 168 "../core/Services/Todoist.vala"
		_data_->_tmp115_ = _data_->sections;
#line 168 "../core/Services/Todoist.vala"
		_data_->_tmp116_ = json_array_get_elements (_data_->_tmp115_);
#line 2953 "Todoist.c"
		{
#line 168 "../core/Services/Todoist.vala"
			_data_->_vala2__node_collection = _data_->_tmp116_;
#line 168 "../core/Services/Todoist.vala"
			for (_data_->_vala2__node_it = _data_->_vala2__node_collection; _data_->_vala2__node_it != NULL; _data_->_vala2__node_it = _data_->_vala2__node_it->next) {
#line 168 "../core/Services/Todoist.vala"
				_data_->_vala2__node = (JsonNode*) _data_->_vala2__node_it->data;
#line 2961 "Todoist.c"
				{
#line 169 "../core/Services/Todoist.vala"
					_data_->_tmp117_ = _data_->_vala2__node;
#line 169 "../core/Services/Todoist.vala"
					services_todoist_add_section_if_not_exists (_data_->self, _data_->_tmp117_);
#line 2967 "Todoist.c"
				}
			}
#line 168 "../core/Services/Todoist.vala"
			(_data_->_vala2__node_collection == NULL) ? NULL : (_data_->_vala2__node_collection = (g_list_free (_data_->_vala2__node_collection), NULL));
#line 2972 "Todoist.c"
		}
#line 173 "../core/Services/Todoist.vala"
		_data_->_tmp118_ = _data_->self->priv->parser;
#line 173 "../core/Services/Todoist.vala"
		_data_->_tmp119_ = json_parser_get_root (_data_->_tmp118_);
#line 173 "../core/Services/Todoist.vala"
		_data_->_tmp120_ = json_node_get_object (_data_->_tmp119_);
#line 173 "../core/Services/Todoist.vala"
		_data_->_tmp121_ = json_object_get_array_member (_data_->_tmp120_, SERVICES_TODOIST_ITEMS_COLLECTION);
#line 173 "../core/Services/Todoist.vala"
		_data_->items = _data_->_tmp121_;
#line 174 "../core/Services/Todoist.vala"
		_data_->_tmp122_ = _data_->items;
#line 174 "../core/Services/Todoist.vala"
		_data_->_tmp123_ = json_array_get_elements (_data_->_tmp122_);
#line 2988 "Todoist.c"
		{
#line 174 "../core/Services/Todoist.vala"
			_data_->_vala3__node_collection = _data_->_tmp123_;
#line 174 "../core/Services/Todoist.vala"
			for (_data_->_vala3__node_it = _data_->_vala3__node_collection; _data_->_vala3__node_it != NULL; _data_->_vala3__node_it = _data_->_vala3__node_it->next) {
#line 174 "../core/Services/Todoist.vala"
				_data_->_vala3__node = (JsonNode*) _data_->_vala3__node_it->data;
#line 2996 "Todoist.c"
				{
#line 175 "../core/Services/Todoist.vala"
					_data_->_tmp124_ = _data_->_vala3__node;
#line 175 "../core/Services/Todoist.vala"
					services_todoist_add_item_if_not_exists (_data_->self, _data_->_tmp124_);
#line 3002 "Todoist.c"
				}
			}
#line 174 "../core/Services/Todoist.vala"
			(_data_->_vala3__node_collection == NULL) ? NULL : (_data_->_vala3__node_collection = (g_list_free (_data_->_vala3__node_collection), NULL));
#line 3007 "Todoist.c"
		}
#line 179 "../core/Services/Todoist.vala"
		_data_->_tmp125_ = _data_->self->priv->parser;
#line 179 "../core/Services/Todoist.vala"
		_data_->_tmp126_ = json_parser_get_root (_data_->_tmp125_);
#line 179 "../core/Services/Todoist.vala"
		_data_->_tmp127_ = json_node_get_object (_data_->_tmp126_);
#line 179 "../core/Services/Todoist.vala"
		_data_->_tmp128_ = json_object_get_array_member (_data_->_tmp127_, SERVICES_TODOIST_REMINDERS_COLLECTION);
#line 179 "../core/Services/Todoist.vala"
		_data_->reminders = _data_->_tmp128_;
#line 180 "../core/Services/Todoist.vala"
		_data_->_tmp129_ = _data_->reminders;
#line 180 "../core/Services/Todoist.vala"
		_data_->_tmp130_ = json_array_get_elements (_data_->_tmp129_);
#line 3023 "Todoist.c"
		{
#line 180 "../core/Services/Todoist.vala"
			_data_->_vala4__node_collection = _data_->_tmp130_;
#line 180 "../core/Services/Todoist.vala"
			for (_data_->_vala4__node_it = _data_->_vala4__node_collection; _data_->_vala4__node_it != NULL; _data_->_vala4__node_it = _data_->_vala4__node_it->next) {
#line 180 "../core/Services/Todoist.vala"
				_data_->_vala4__node = (JsonNode*) _data_->_vala4__node_it->data;
#line 3031 "Todoist.c"
				{
#line 181 "../core/Services/Todoist.vala"
					_data_->_tmp131_ = _data_->_vala4__node;
#line 181 "../core/Services/Todoist.vala"
					_data_->_tmp132_ = objects_reminder_new_from_json (_data_->_tmp131_);
#line 181 "../core/Services/Todoist.vala"
					_data_->reminder = _data_->_tmp132_;
#line 182 "../core/Services/Todoist.vala"
					_data_->_tmp133_ = services_store_instance ();
#line 182 "../core/Services/Todoist.vala"
					_data_->_tmp134_ = _data_->reminder;
#line 182 "../core/Services/Todoist.vala"
					_data_->_tmp135_ = objects_reminder_get_item_id (_data_->_tmp134_);
#line 182 "../core/Services/Todoist.vala"
					_data_->_tmp136_ = _data_->_tmp135_;
#line 182 "../core/Services/Todoist.vala"
					_data_->_tmp137_ = services_store_get_item (_data_->_tmp133_, _data_->_tmp136_);
#line 182 "../core/Services/Todoist.vala"
					_data_->item = _data_->_tmp137_;
#line 183 "../core/Services/Todoist.vala"
					_data_->_tmp138_ = _data_->item;
#line 183 "../core/Services/Todoist.vala"
					if (_data_->_tmp138_ != NULL) {
#line 184 "../core/Services/Todoist.vala"
						_data_->_tmp139_ = _data_->item;
#line 184 "../core/Services/Todoist.vala"
						_data_->_tmp140_ = _data_->reminder;
#line 184 "../core/Services/Todoist.vala"
						_data_->_tmp141_ = objects_item_add_reminder_if_not_exists (_data_->_tmp139_, _data_->_tmp140_, TRUE);
#line 184 "../core/Services/Todoist.vala"
						_data_->_tmp142_ = _data_->_tmp141_;
#line 184 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->_tmp142_);
#line 3065 "Todoist.c"
					}
#line 180 "../core/Services/Todoist.vala"
					_g_object_unref0 (_data_->item);
#line 180 "../core/Services/Todoist.vala"
					_g_object_unref0 (_data_->reminder);
#line 3071 "Todoist.c"
				}
			}
#line 180 "../core/Services/Todoist.vala"
			(_data_->_vala4__node_collection == NULL) ? NULL : (_data_->_vala4__node_collection = (g_list_free (_data_->_vala4__node_collection), NULL));
#line 3076 "Todoist.c"
		}
#line 189 "../core/Services/Todoist.vala"
		_data_->_tmp143_ = _data_->user_object;
#line 189 "../core/Services/Todoist.vala"
		if (json_object_get_null_member (_data_->_tmp143_, "image_id") == FALSE) {
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp144_ = util_get_default ();
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp145_ = _data_->_tmp144_;
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp146_ = _data_->source;
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp147_ = objects_source_get_todoist_data (_data_->_tmp146_);
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp148_ = _data_->_tmp147_;
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp149_ = objects_source_todoist_data_get_user_image_id (_data_->_tmp148_);
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp150_ = _data_->_tmp149_;
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp151_ = _data_->user_object;
#line 190 "../core/Services/Todoist.vala"
			_data_->_tmp152_ = json_object_get_string_member (_data_->_tmp151_, "avatar_s640");
#line 190 "../core/Services/Todoist.vala"
			util_download_profile_image (_data_->_tmp145_, _data_->_tmp150_, _data_->_tmp152_);
#line 190 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp145_);
#line 3104 "Todoist.c"
		}
#line 195 "../core/Services/Todoist.vala"
		_data_->_tmp153_ = _data_->source;
#line 195 "../core/Services/Todoist.vala"
		_data_->_tmp154_ = g_date_time_new_now_local ();
#line 195 "../core/Services/Todoist.vala"
		_data_->_tmp155_ = _data_->_tmp154_;
#line 195 "../core/Services/Todoist.vala"
		_data_->_tmp156_ = g_date_time_to_string (_data_->_tmp155_);
#line 195 "../core/Services/Todoist.vala"
		_data_->_tmp157_ = _data_->_tmp156_;
#line 195 "../core/Services/Todoist.vala"
		objects_source_set_last_sync (_data_->_tmp153_, _data_->_tmp157_);
#line 195 "../core/Services/Todoist.vala"
		_g_free0 (_data_->_tmp157_);
#line 195 "../core/Services/Todoist.vala"
		_g_date_time_unref0 (_data_->_tmp155_);
#line 196 "../core/Services/Todoist.vala"
		_data_->_tmp158_ = _data_->source;
#line 196 "../core/Services/Todoist.vala"
		objects_source_save (_data_->_tmp158_);
#line 198 "../core/Services/Todoist.vala"
		http_response_set_status (_data_->response, TRUE);
#line 101 "../core/Services/Todoist.vala"
		_json_object_unref0 (_data_->user_object);
#line 101 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->todoist_data);
#line 101 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->source);
#line 101 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 3136 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 101 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 101 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 200 "../core/Services/Todoist.vala"
		_data_->_tmp159_ = _data_->e;
#line 200 "../core/Services/Todoist.vala"
		http_response_set_error_code (_data_->response, _data_->_tmp159_->code);
#line 201 "../core/Services/Todoist.vala"
		_data_->_tmp160_ = _data_->e;
#line 201 "../core/Services/Todoist.vala"
		_data_->_tmp161_ = _data_->_tmp160_->message;
#line 201 "../core/Services/Todoist.vala"
		http_response_set_error (_data_->response, _data_->_tmp161_);
#line 202 "../core/Services/Todoist.vala"
		_data_->_tmp162_ = _data_->e;
#line 202 "../core/Services/Todoist.vala"
		_data_->_tmp163_ = _data_->_tmp162_->message;
#line 202 "../core/Services/Todoist.vala"
		g_debug ("Todoist.vala:202: %s", _data_->_tmp163_);
#line 101 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 3163 "Todoist.c"
	}
	__finally0:
#line 101 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 101 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 101 "../core/Services/Todoist.vala"
		_g_free0 (_data_->url);
#line 101 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 101 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 101 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 101 "../core/Services/Todoist.vala"
		return FALSE;
#line 3180 "Todoist.c"
	}
#line 93 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 93 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 93 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 93 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 93 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 93 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3194 "Todoist.c"
		}
	}
#line 93 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 93 "../core/Services/Todoist.vala"
	return FALSE;
#line 3201 "Todoist.c"
}

static void
services_todoist_sync_data_free (gpointer _data)
{
	ServicesTodoistSyncData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistSyncData, _data_);
#line 3215 "Todoist.c"
}

void
services_todoist_sync (ServicesTodoist* self,
                       ObjectsSource* source,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_)
{
	ServicesTodoistSyncData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsSource* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (source != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistSyncData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_sync_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 22 "../core/Services/Todoist.vala"
	_data_->source = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_sync_co (_data_);
#line 3249 "Todoist.c"
}

void
services_todoist_sync_finish (ServicesTodoist* self,
                              GAsyncResult* _res_)
{
	ServicesTodoistSyncData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3259 "Todoist.c"
}

static void
services_todoist_sync_ready (GObject* source_object,
                             GAsyncResult* _res_,
                             gpointer _user_data_)
{
	ServicesTodoistSyncData* _data_;
#line 227 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 227 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 227 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 227 "../core/Services/Todoist.vala"
	services_todoist_sync_co (_data_);
#line 3276 "Todoist.c"
}

static gboolean
services_todoist_sync_co (ServicesTodoistSyncData* _data_)
{
#line 210 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 210 "../core/Services/Todoist.vala"
		case 0:
#line 3286 "Todoist.c"
		goto _state_0;
#line 210 "../core/Services/Todoist.vala"
		case 1:
#line 3290 "Todoist.c"
		goto _state_1;
#line 210 "../core/Services/Todoist.vala"
		case 2:
#line 3294 "Todoist.c"
		goto _state_2;
		default:
#line 210 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 3299 "Todoist.c"
	}
	_state_0:
#line 211 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = objects_source_get_todoist_data (_data_->source);
#line 211 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 211 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = objects_source_todoist_data_get_access_token (_data_->_tmp1_);
#line 211 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 211 "../core/Services/Todoist.vala"
	if (_data_->_tmp3_ == NULL) {
#line 212 "../core/Services/Todoist.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 212 "../core/Services/Todoist.vala"
		if (_data_->_state_ != 0) {
#line 212 "../core/Services/Todoist.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 212 "../core/Services/Todoist.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3320 "Todoist.c"
			}
		}
#line 212 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 212 "../core/Services/Todoist.vala"
		return FALSE;
#line 3327 "Todoist.c"
	}
#line 215 "../core/Services/Todoist.vala"
	g_signal_emit_by_name (_data_->source, "sync-started");
#line 217 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = g_strdup (SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 217 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp4_;
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = _data_->url;
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "?sync_token=", NULL);
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = objects_source_get_todoist_data (_data_->source);
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = objects_source_todoist_data_get_sync_token (_data_->_tmp9_);
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 218 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = g_strconcat (_data_->_tmp7_, _data_->_tmp11_, NULL);
#line 218 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 218 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp12_;
#line 218 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp7_);
#line 219 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->url;
#line 219 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = g_strconcat (_data_->_tmp13_, "&resource_types=", NULL);
#line 219 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 219 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = g_strconcat (_data_->_tmp15_, SERVICES_TODOIST_RESOURCE_TYPES, NULL);
#line 219 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 219 "../core/Services/Todoist.vala"
	_data_->url = _data_->_tmp16_;
#line 219 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp15_);
#line 221 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->url;
#line 221 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = g_strdup_printf ("SYNC URL: %s\n", _data_->_tmp17_);
#line 221 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 221 "../core/Services/Todoist.vala"
	g_print ("%s", _data_->_tmp19_);
#line 221 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp19_);
#line 223 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->url;
#line 223 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = soup_message_new ("POST", _data_->_tmp20_);
#line 223 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp21_;
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = _data_->message;
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = soup_message_get_request_headers (_data_->_tmp22_);
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = objects_source_get_todoist_data (_data_->source);
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = objects_source_todoist_data_get_access_token (_data_->_tmp26_);
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp29_ = g_strdup_printf ("Bearer %s", _data_->_tmp28_);
#line 224 "../core/Services/Todoist.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 224 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp24_, "Authorization", _data_->_tmp30_);
#line 224 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp30_);
#line 3409 "Todoist.c"
	{
#line 227 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->self->priv->session;
#line 227 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->message;
#line 227 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 227 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_LOW, NULL, services_todoist_sync_ready, _data_);
#line 227 "../core/Services/Todoist.vala"
		return FALSE;
#line 3421 "Todoist.c"
		_state_1:
#line 227 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
#line 227 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp33_;
#line 227 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3429 "Todoist.c"
			goto __catch0_g_error;
		}
#line 228 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->self->priv->parser;
#line 228 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->stream;
#line 228 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = 0;
#line 228 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
#line 228 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
#line 228 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 228 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 3446 "Todoist.c"
			goto __catch0_g_error;
		}
#line 231 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = _data_->self->priv->parser;
#line 231 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
#line 231 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
#line 233 "../core/Services/Todoist.vala"
		_data_->_tmp40_ = _data_->self->priv->parser;
#line 233 "../core/Services/Todoist.vala"
		_data_->_tmp41_ = json_parser_get_root (_data_->_tmp40_);
#line 233 "../core/Services/Todoist.vala"
		_data_->_tmp42_ = json_node_get_object (_data_->_tmp41_);
#line 233 "../core/Services/Todoist.vala"
		if (!json_object_has_member (_data_->_tmp42_, "error")) {
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = objects_source_get_todoist_data (_data_->source);
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = _data_->_tmp43_;
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = _data_->self->priv->parser;
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = json_parser_get_root (_data_->_tmp45_);
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp47_ = json_node_get_object (_data_->_tmp46_);
#line 235 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = json_object_get_string_member (_data_->_tmp47_, "sync_token");
#line 235 "../core/Services/Todoist.vala"
			objects_source_todoist_data_set_sync_token (_data_->_tmp44_, _data_->_tmp48_);
#line 238 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = _data_->self->priv->parser;
#line 238 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = json_parser_get_root (_data_->_tmp49_);
#line 238 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = json_node_get_object (_data_->_tmp50_);
#line 238 "../core/Services/Todoist.vala"
			if (json_object_has_member (_data_->_tmp51_, "user")) {
#line 239 "../core/Services/Todoist.vala"
				_data_->_tmp52_ = _data_->self->priv->parser;
#line 239 "../core/Services/Todoist.vala"
				_data_->_tmp53_ = json_parser_get_root (_data_->_tmp52_);
#line 239 "../core/Services/Todoist.vala"
				_data_->_tmp54_ = json_node_get_object (_data_->_tmp53_);
#line 239 "../core/Services/Todoist.vala"
				_data_->_tmp55_ = json_object_get_object_member (_data_->_tmp54_, "user");
#line 239 "../core/Services/Todoist.vala"
				_data_->_tmp56_ = _json_object_ref0 (_data_->_tmp55_);
#line 239 "../core/Services/Todoist.vala"
				_data_->user_object = _data_->_tmp56_;
#line 240 "../core/Services/Todoist.vala"
				_data_->_tmp57_ = objects_source_get_todoist_data (_data_->source);
#line 240 "../core/Services/Todoist.vala"
				_data_->_tmp58_ = _data_->_tmp57_;
#line 240 "../core/Services/Todoist.vala"
				_data_->_tmp59_ = _data_->user_object;
#line 240 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_user_is_premium (_data_->_tmp58_, json_object_get_boolean_member (_data_->_tmp59_, "is_premium"));
#line 241 "../core/Services/Todoist.vala"
				_data_->_tmp60_ = objects_source_get_todoist_data (_data_->source);
#line 241 "../core/Services/Todoist.vala"
				_data_->_tmp61_ = _data_->_tmp60_;
#line 241 "../core/Services/Todoist.vala"
				_data_->_tmp62_ = _data_->user_object;
#line 241 "../core/Services/Todoist.vala"
				_data_->_tmp63_ = json_object_get_string_member (_data_->_tmp62_, "email");
#line 241 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_user_email (_data_->_tmp61_, _data_->_tmp63_);
#line 242 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = objects_source_get_todoist_data (_data_->source);
#line 242 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = _data_->_tmp64_;
#line 242 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = _data_->user_object;
#line 242 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "full_name");
#line 242 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_user_name (_data_->_tmp65_, _data_->_tmp67_);
#line 238 "../core/Services/Todoist.vala"
				_json_object_unref0 (_data_->user_object);
#line 3527 "Todoist.c"
			}
#line 246 "../core/Services/Todoist.vala"
			_data_->_tmp68_ = _data_->self->priv->parser;
#line 246 "../core/Services/Todoist.vala"
			_data_->_tmp69_ = json_parser_get_root (_data_->_tmp68_);
#line 246 "../core/Services/Todoist.vala"
			_data_->_tmp70_ = json_node_get_object (_data_->_tmp69_);
#line 246 "../core/Services/Todoist.vala"
			_data_->_tmp71_ = json_object_get_array_member (_data_->_tmp70_, SERVICES_TODOIST_LABELS_COLLECTION);
#line 246 "../core/Services/Todoist.vala"
			_data_->_labels = _data_->_tmp71_;
#line 247 "../core/Services/Todoist.vala"
			_data_->_tmp72_ = _data_->_labels;
#line 247 "../core/Services/Todoist.vala"
			_data_->_tmp73_ = json_array_get_elements (_data_->_tmp72_);
#line 3543 "Todoist.c"
			{
#line 247 "../core/Services/Todoist.vala"
				_data_->_node_collection = _data_->_tmp73_;
#line 247 "../core/Services/Todoist.vala"
				for (_data_->_node_it = _data_->_node_collection; _data_->_node_it != NULL; _data_->_node_it = _data_->_node_it->next) {
#line 247 "../core/Services/Todoist.vala"
					_data_->_node = (JsonNode*) _data_->_node_it->data;
#line 3551 "Todoist.c"
					{
#line 248 "../core/Services/Todoist.vala"
						_data_->_tmp74_ = _data_->_node;
#line 248 "../core/Services/Todoist.vala"
						_data_->_tmp75_ = json_node_get_object (_data_->_tmp74_);
#line 248 "../core/Services/Todoist.vala"
						_data_->_tmp76_ = json_object_get_string_member (_data_->_tmp75_, "id");
#line 248 "../core/Services/Todoist.vala"
						_data_->_tmp77_ = g_strdup (_data_->_tmp76_);
#line 248 "../core/Services/Todoist.vala"
						_data_->_id = _data_->_tmp77_;
#line 249 "../core/Services/Todoist.vala"
						_data_->_tmp78_ = services_store_instance ();
#line 249 "../core/Services/Todoist.vala"
						_data_->_tmp79_ = _data_->_id;
#line 249 "../core/Services/Todoist.vala"
						_data_->_tmp80_ = services_store_get_label (_data_->_tmp78_, _data_->_tmp79_);
#line 249 "../core/Services/Todoist.vala"
						_data_->label = _data_->_tmp80_;
#line 250 "../core/Services/Todoist.vala"
						_data_->_tmp81_ = _data_->label;
#line 250 "../core/Services/Todoist.vala"
						if (_data_->_tmp81_ != NULL) {
#line 251 "../core/Services/Todoist.vala"
							_data_->_tmp82_ = _data_->_node;
#line 251 "../core/Services/Todoist.vala"
							_data_->_tmp83_ = json_node_get_object (_data_->_tmp82_);
#line 251 "../core/Services/Todoist.vala"
							if (json_object_get_boolean_member (_data_->_tmp83_, "is_deleted")) {
#line 252 "../core/Services/Todoist.vala"
								_data_->_tmp84_ = services_store_instance ();
#line 252 "../core/Services/Todoist.vala"
								_data_->_tmp85_ = _data_->label;
#line 252 "../core/Services/Todoist.vala"
								services_store_delete_label (_data_->_tmp84_, _data_->_tmp85_);
#line 3587 "Todoist.c"
							} else {
#line 254 "../core/Services/Todoist.vala"
								_data_->_tmp86_ = _data_->label;
#line 254 "../core/Services/Todoist.vala"
								_data_->_tmp87_ = _data_->_node;
#line 254 "../core/Services/Todoist.vala"
								objects_label_update_from_json (_data_->_tmp86_, _data_->_tmp87_);
#line 255 "../core/Services/Todoist.vala"
								_data_->_tmp88_ = services_store_instance ();
#line 255 "../core/Services/Todoist.vala"
								_data_->_tmp89_ = _data_->label;
#line 255 "../core/Services/Todoist.vala"
								services_store_update_label (_data_->_tmp88_, _data_->_tmp89_);
#line 3601 "Todoist.c"
							}
						} else {
#line 258 "../core/Services/Todoist.vala"
							_data_->_tmp90_ = _data_->_node;
#line 258 "../core/Services/Todoist.vala"
							_data_->_tmp91_ = objects_label_new_from_json (_data_->_tmp90_);
#line 258 "../core/Services/Todoist.vala"
							_data_->_label = _data_->_tmp91_;
#line 259 "../core/Services/Todoist.vala"
							_data_->_tmp92_ = _data_->_label;
#line 259 "../core/Services/Todoist.vala"
							_data_->_tmp93_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->source);
#line 259 "../core/Services/Todoist.vala"
							_data_->_tmp94_ = _data_->_tmp93_;
#line 259 "../core/Services/Todoist.vala"
							objects_label_set_source_id (_data_->_tmp92_, _data_->_tmp94_);
#line 261 "../core/Services/Todoist.vala"
							_data_->_tmp95_ = services_store_instance ();
#line 261 "../core/Services/Todoist.vala"
							_data_->_tmp96_ = _data_->_label;
#line 261 "../core/Services/Todoist.vala"
							services_store_insert_label (_data_->_tmp95_, _data_->_tmp96_);
#line 250 "../core/Services/Todoist.vala"
							_g_object_unref0 (_data_->_label);
#line 3626 "Todoist.c"
						}
#line 247 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->label);
#line 247 "../core/Services/Todoist.vala"
						_g_free0 (_data_->_id);
#line 3632 "Todoist.c"
					}
				}
#line 247 "../core/Services/Todoist.vala"
				(_data_->_node_collection == NULL) ? NULL : (_data_->_node_collection = (g_list_free (_data_->_node_collection), NULL));
#line 3637 "Todoist.c"
			}
#line 266 "../core/Services/Todoist.vala"
			_data_->_tmp97_ = _data_->self->priv->parser;
#line 266 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = json_parser_get_root (_data_->_tmp97_);
#line 266 "../core/Services/Todoist.vala"
			_data_->_tmp99_ = json_node_get_object (_data_->_tmp98_);
#line 266 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = json_object_get_array_member (_data_->_tmp99_, SERVICES_TODOIST_PROJECTS_COLLECTION);
#line 266 "../core/Services/Todoist.vala"
			_data_->projects = _data_->_tmp100_;
#line 267 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = _data_->projects;
#line 267 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = json_array_get_elements (_data_->_tmp101_);
#line 3653 "Todoist.c"
			{
#line 267 "../core/Services/Todoist.vala"
				_data_->_vala1__node_collection = _data_->_tmp102_;
#line 267 "../core/Services/Todoist.vala"
				for (_data_->_vala1__node_it = _data_->_vala1__node_collection; _data_->_vala1__node_it != NULL; _data_->_vala1__node_it = _data_->_vala1__node_it->next) {
#line 267 "../core/Services/Todoist.vala"
					_data_->_vala1__node = (JsonNode*) _data_->_vala1__node_it->data;
#line 3661 "Todoist.c"
					{
#line 268 "../core/Services/Todoist.vala"
						_data_->_tmp103_ = services_store_instance ();
#line 268 "../core/Services/Todoist.vala"
						_data_->_tmp104_ = _data_->_vala1__node;
#line 268 "../core/Services/Todoist.vala"
						_data_->_tmp105_ = json_node_get_object (_data_->_tmp104_);
#line 268 "../core/Services/Todoist.vala"
						_data_->_tmp106_ = json_object_get_string_member (_data_->_tmp105_, "id");
#line 268 "../core/Services/Todoist.vala"
						_data_->_tmp107_ = services_store_get_project (_data_->_tmp103_, _data_->_tmp106_);
#line 268 "../core/Services/Todoist.vala"
						_data_->project = _data_->_tmp107_;
#line 269 "../core/Services/Todoist.vala"
						_data_->_tmp108_ = _data_->project;
#line 269 "../core/Services/Todoist.vala"
						if (_data_->_tmp108_ != NULL) {
#line 270 "../core/Services/Todoist.vala"
							_data_->_tmp109_ = _data_->_vala1__node;
#line 270 "../core/Services/Todoist.vala"
							_data_->_tmp110_ = json_node_get_object (_data_->_tmp109_);
#line 270 "../core/Services/Todoist.vala"
							if (json_object_get_boolean_member (_data_->_tmp110_, "is_deleted")) {
#line 271 "../core/Services/Todoist.vala"
								_data_->_tmp111_ = services_store_instance ();
#line 271 "../core/Services/Todoist.vala"
								_data_->_tmp112_ = _data_->project;
#line 271 "../core/Services/Todoist.vala"
								services_store_delete_project (_data_->_tmp111_, _data_->_tmp112_);
#line 3691 "Todoist.c"
							} else {
#line 273 "../core/Services/Todoist.vala"
								_data_->_tmp113_ = _data_->project;
#line 273 "../core/Services/Todoist.vala"
								_data_->_tmp114_ = objects_project_get_parent_id (_data_->_tmp113_);
#line 273 "../core/Services/Todoist.vala"
								_data_->_tmp115_ = _data_->_tmp114_;
#line 273 "../core/Services/Todoist.vala"
								_data_->_tmp116_ = g_strdup (_data_->_tmp115_);
#line 273 "../core/Services/Todoist.vala"
								_data_->old_parent_id = _data_->_tmp116_;
#line 274 "../core/Services/Todoist.vala"
								_data_->_tmp117_ = _data_->project;
#line 274 "../core/Services/Todoist.vala"
								_data_->_tmp118_ = objects_project_get_is_favorite (_data_->_tmp117_);
#line 274 "../core/Services/Todoist.vala"
								_data_->_tmp119_ = _data_->_tmp118_;
#line 274 "../core/Services/Todoist.vala"
								_data_->old_is_favorite = _data_->_tmp119_;
#line 276 "../core/Services/Todoist.vala"
								_data_->_tmp120_ = _data_->project;
#line 276 "../core/Services/Todoist.vala"
								_data_->_tmp121_ = _data_->_vala1__node;
#line 276 "../core/Services/Todoist.vala"
								objects_project_update_from_json (_data_->_tmp120_, _data_->_tmp121_);
#line 277 "../core/Services/Todoist.vala"
								_data_->_tmp122_ = services_store_instance ();
#line 277 "../core/Services/Todoist.vala"
								_data_->_tmp123_ = _data_->project;
#line 277 "../core/Services/Todoist.vala"
								services_store_update_project (_data_->_tmp122_, _data_->_tmp123_);
#line 279 "../core/Services/Todoist.vala"
								_data_->_tmp124_ = _data_->project;
#line 279 "../core/Services/Todoist.vala"
								_data_->_tmp125_ = objects_project_get_parent_id (_data_->_tmp124_);
#line 279 "../core/Services/Todoist.vala"
								_data_->_tmp126_ = _data_->_tmp125_;
#line 279 "../core/Services/Todoist.vala"
								_data_->_tmp127_ = _data_->old_parent_id;
#line 279 "../core/Services/Todoist.vala"
								if (g_strcmp0 (_data_->_tmp126_, _data_->_tmp127_) != 0) {
#line 280 "../core/Services/Todoist.vala"
									_data_->_tmp128_ = services_event_bus_get_default ();
#line 280 "../core/Services/Todoist.vala"
									_data_->_tmp129_ = _data_->_tmp128_;
#line 280 "../core/Services/Todoist.vala"
									_data_->_tmp130_ = _data_->project;
#line 280 "../core/Services/Todoist.vala"
									_data_->_tmp131_ = _data_->old_parent_id;
#line 280 "../core/Services/Todoist.vala"
									g_signal_emit_by_name (_data_->_tmp129_, "project-parent-changed", _data_->_tmp130_, _data_->_tmp131_, FALSE);
#line 280 "../core/Services/Todoist.vala"
									_g_object_unref0 (_data_->_tmp129_);
#line 3745 "Todoist.c"
								}
#line 283 "../core/Services/Todoist.vala"
								_data_->_tmp132_ = _data_->project;
#line 283 "../core/Services/Todoist.vala"
								_data_->_tmp133_ = objects_project_get_is_favorite (_data_->_tmp132_);
#line 283 "../core/Services/Todoist.vala"
								_data_->_tmp134_ = _data_->_tmp133_;
#line 283 "../core/Services/Todoist.vala"
								if (_data_->_tmp134_ != _data_->old_is_favorite) {
#line 284 "../core/Services/Todoist.vala"
									_data_->_tmp135_ = services_event_bus_get_default ();
#line 284 "../core/Services/Todoist.vala"
									_data_->_tmp136_ = _data_->_tmp135_;
#line 284 "../core/Services/Todoist.vala"
									_data_->_tmp137_ = _data_->project;
#line 284 "../core/Services/Todoist.vala"
									g_signal_emit_by_name (_data_->_tmp136_, "favorite-toggled", _data_->_tmp137_);
#line 284 "../core/Services/Todoist.vala"
									_g_object_unref0 (_data_->_tmp136_);
#line 3765 "Todoist.c"
								}
#line 270 "../core/Services/Todoist.vala"
								_g_free0 (_data_->old_parent_id);
#line 3769 "Todoist.c"
							}
						} else {
#line 288 "../core/Services/Todoist.vala"
							_data_->_tmp138_ = _data_->_vala1__node;
#line 288 "../core/Services/Todoist.vala"
							_data_->_tmp139_ = objects_project_new_from_json (_data_->_tmp138_);
#line 288 "../core/Services/Todoist.vala"
							_data_->_project = _data_->_tmp139_;
#line 289 "../core/Services/Todoist.vala"
							_data_->_tmp140_ = _data_->_project;
#line 289 "../core/Services/Todoist.vala"
							_data_->_tmp141_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->source);
#line 289 "../core/Services/Todoist.vala"
							_data_->_tmp142_ = _data_->_tmp141_;
#line 289 "../core/Services/Todoist.vala"
							objects_project_set_source_id (_data_->_tmp140_, _data_->_tmp142_);
#line 291 "../core/Services/Todoist.vala"
							_data_->_tmp143_ = services_store_instance ();
#line 291 "../core/Services/Todoist.vala"
							_data_->_tmp144_ = _data_->_project;
#line 291 "../core/Services/Todoist.vala"
							services_store_insert_project (_data_->_tmp143_, _data_->_tmp144_);
#line 269 "../core/Services/Todoist.vala"
							_g_object_unref0 (_data_->_project);
#line 3794 "Todoist.c"
						}
#line 267 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->project);
#line 3798 "Todoist.c"
					}
				}
#line 267 "../core/Services/Todoist.vala"
				(_data_->_vala1__node_collection == NULL) ? NULL : (_data_->_vala1__node_collection = (g_list_free (_data_->_vala1__node_collection), NULL));
#line 3803 "Todoist.c"
			}
#line 296 "../core/Services/Todoist.vala"
			_data_->_tmp145_ = _data_->self->priv->parser;
#line 296 "../core/Services/Todoist.vala"
			_data_->_tmp146_ = json_parser_get_root (_data_->_tmp145_);
#line 296 "../core/Services/Todoist.vala"
			_data_->_tmp147_ = json_node_get_object (_data_->_tmp146_);
#line 296 "../core/Services/Todoist.vala"
			_data_->_tmp148_ = json_object_get_array_member (_data_->_tmp147_, SERVICES_TODOIST_SECTIONS_COLLECTION);
#line 296 "../core/Services/Todoist.vala"
			_data_->sections = _data_->_tmp148_;
#line 297 "../core/Services/Todoist.vala"
			_data_->_tmp149_ = _data_->sections;
#line 297 "../core/Services/Todoist.vala"
			_data_->_tmp150_ = json_array_get_elements (_data_->_tmp149_);
#line 3819 "Todoist.c"
			{
#line 297 "../core/Services/Todoist.vala"
				_data_->_vala2__node_collection = _data_->_tmp150_;
#line 297 "../core/Services/Todoist.vala"
				for (_data_->_vala2__node_it = _data_->_vala2__node_collection; _data_->_vala2__node_it != NULL; _data_->_vala2__node_it = _data_->_vala2__node_it->next) {
#line 297 "../core/Services/Todoist.vala"
					_data_->_vala2__node = (JsonNode*) _data_->_vala2__node_it->data;
#line 3827 "Todoist.c"
					{
#line 298 "../core/Services/Todoist.vala"
						_data_->_tmp151_ = services_store_instance ();
#line 298 "../core/Services/Todoist.vala"
						_data_->_tmp152_ = _data_->_vala2__node;
#line 298 "../core/Services/Todoist.vala"
						_data_->_tmp153_ = json_node_get_object (_data_->_tmp152_);
#line 298 "../core/Services/Todoist.vala"
						_data_->_tmp154_ = json_object_get_string_member (_data_->_tmp153_, "id");
#line 298 "../core/Services/Todoist.vala"
						_data_->_tmp155_ = services_store_get_section (_data_->_tmp151_, _data_->_tmp154_);
#line 298 "../core/Services/Todoist.vala"
						_data_->section = _data_->_tmp155_;
#line 299 "../core/Services/Todoist.vala"
						_data_->_tmp156_ = _data_->section;
#line 299 "../core/Services/Todoist.vala"
						if (_data_->_tmp156_ != NULL) {
#line 300 "../core/Services/Todoist.vala"
							_data_->_tmp157_ = _data_->_vala2__node;
#line 300 "../core/Services/Todoist.vala"
							_data_->_tmp158_ = json_node_get_object (_data_->_tmp157_);
#line 300 "../core/Services/Todoist.vala"
							if (json_object_get_boolean_member (_data_->_tmp158_, "is_deleted")) {
#line 301 "../core/Services/Todoist.vala"
								_data_->_tmp159_ = services_store_instance ();
#line 301 "../core/Services/Todoist.vala"
								_data_->_tmp160_ = _data_->section;
#line 301 "../core/Services/Todoist.vala"
								services_store_delete_section (_data_->_tmp159_, _data_->_tmp160_);
#line 3857 "Todoist.c"
							} else {
#line 303 "../core/Services/Todoist.vala"
								_data_->_tmp161_ = _data_->section;
#line 303 "../core/Services/Todoist.vala"
								_data_->_tmp162_ = _data_->_vala2__node;
#line 303 "../core/Services/Todoist.vala"
								objects_section_update_from_json (_data_->_tmp161_, _data_->_tmp162_);
#line 304 "../core/Services/Todoist.vala"
								_data_->_tmp163_ = services_store_instance ();
#line 304 "../core/Services/Todoist.vala"
								_data_->_tmp164_ = _data_->section;
#line 304 "../core/Services/Todoist.vala"
								services_store_update_section (_data_->_tmp163_, _data_->_tmp164_);
#line 3871 "Todoist.c"
							}
						} else {
#line 307 "../core/Services/Todoist.vala"
							_data_->_tmp165_ = _data_->_vala2__node;
#line 307 "../core/Services/Todoist.vala"
							services_todoist_add_section_if_not_exists (_data_->self, _data_->_tmp165_);
#line 3878 "Todoist.c"
						}
#line 297 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->section);
#line 3882 "Todoist.c"
					}
				}
#line 297 "../core/Services/Todoist.vala"
				(_data_->_vala2__node_collection == NULL) ? NULL : (_data_->_vala2__node_collection = (g_list_free (_data_->_vala2__node_collection), NULL));
#line 3887 "Todoist.c"
			}
#line 312 "../core/Services/Todoist.vala"
			_data_->_tmp166_ = _data_->self->priv->parser;
#line 312 "../core/Services/Todoist.vala"
			_data_->_tmp167_ = json_parser_get_root (_data_->_tmp166_);
#line 312 "../core/Services/Todoist.vala"
			_data_->_tmp168_ = json_node_get_object (_data_->_tmp167_);
#line 312 "../core/Services/Todoist.vala"
			_data_->_tmp169_ = json_object_get_array_member (_data_->_tmp168_, SERVICES_TODOIST_ITEMS_COLLECTION);
#line 312 "../core/Services/Todoist.vala"
			_data_->items = _data_->_tmp169_;
#line 313 "../core/Services/Todoist.vala"
			_data_->_tmp170_ = _data_->items;
#line 313 "../core/Services/Todoist.vala"
			_data_->_tmp171_ = json_array_get_elements (_data_->_tmp170_);
#line 3903 "Todoist.c"
			{
#line 313 "../core/Services/Todoist.vala"
				_data_->_vala3__node_collection = _data_->_tmp171_;
#line 313 "../core/Services/Todoist.vala"
				for (_data_->_vala3__node_it = _data_->_vala3__node_collection; _data_->_vala3__node_it != NULL; _data_->_vala3__node_it = _data_->_vala3__node_it->next) {
#line 313 "../core/Services/Todoist.vala"
					_data_->_vala3__node = (JsonNode*) _data_->_vala3__node_it->data;
#line 3911 "Todoist.c"
					{
#line 314 "../core/Services/Todoist.vala"
						_data_->_tmp172_ = services_store_instance ();
#line 314 "../core/Services/Todoist.vala"
						_data_->_tmp173_ = _data_->_vala3__node;
#line 314 "../core/Services/Todoist.vala"
						_data_->_tmp174_ = json_node_get_object (_data_->_tmp173_);
#line 314 "../core/Services/Todoist.vala"
						_data_->_tmp175_ = json_object_get_string_member (_data_->_tmp174_, "id");
#line 314 "../core/Services/Todoist.vala"
						_data_->_tmp176_ = services_store_get_item (_data_->_tmp172_, _data_->_tmp175_);
#line 314 "../core/Services/Todoist.vala"
						_data_->item = _data_->_tmp176_;
#line 315 "../core/Services/Todoist.vala"
						_data_->_tmp177_ = _data_->item;
#line 315 "../core/Services/Todoist.vala"
						if (_data_->_tmp177_ != NULL) {
#line 316 "../core/Services/Todoist.vala"
							_data_->_tmp178_ = _data_->_vala3__node;
#line 316 "../core/Services/Todoist.vala"
							_data_->_tmp179_ = json_node_get_object (_data_->_tmp178_);
#line 316 "../core/Services/Todoist.vala"
							if (json_object_get_boolean_member (_data_->_tmp179_, "is_deleted")) {
#line 317 "../core/Services/Todoist.vala"
								_data_->_tmp180_ = services_store_instance ();
#line 317 "../core/Services/Todoist.vala"
								_data_->_tmp181_ = _data_->item;
#line 317 "../core/Services/Todoist.vala"
								services_store_delete_item (_data_->_tmp180_, _data_->_tmp181_);
#line 3941 "Todoist.c"
							} else {
#line 319 "../core/Services/Todoist.vala"
								_data_->_tmp182_ = _data_->item;
#line 319 "../core/Services/Todoist.vala"
								_data_->_tmp183_ = objects_item_get_project_id (_data_->_tmp182_);
#line 319 "../core/Services/Todoist.vala"
								_data_->_tmp184_ = _data_->_tmp183_;
#line 319 "../core/Services/Todoist.vala"
								_data_->_tmp185_ = g_strdup (_data_->_tmp184_);
#line 319 "../core/Services/Todoist.vala"
								_data_->old_project_id = _data_->_tmp185_;
#line 320 "../core/Services/Todoist.vala"
								_data_->_tmp186_ = _data_->item;
#line 320 "../core/Services/Todoist.vala"
								_data_->_tmp187_ = objects_item_get_section_id (_data_->_tmp186_);
#line 320 "../core/Services/Todoist.vala"
								_data_->_tmp188_ = _data_->_tmp187_;
#line 320 "../core/Services/Todoist.vala"
								_data_->_tmp189_ = g_strdup (_data_->_tmp188_);
#line 320 "../core/Services/Todoist.vala"
								_data_->old_section_id = _data_->_tmp189_;
#line 321 "../core/Services/Todoist.vala"
								_data_->_tmp190_ = _data_->item;
#line 321 "../core/Services/Todoist.vala"
								_data_->_tmp191_ = objects_item_get_parent_id (_data_->_tmp190_);
#line 321 "../core/Services/Todoist.vala"
								_data_->_tmp192_ = _data_->_tmp191_;
#line 321 "../core/Services/Todoist.vala"
								_data_->_tmp193_ = g_strdup (_data_->_tmp192_);
#line 321 "../core/Services/Todoist.vala"
								_data_->_vala1_old_parent_id = _data_->_tmp193_;
#line 322 "../core/Services/Todoist.vala"
								_data_->_tmp194_ = _data_->item;
#line 322 "../core/Services/Todoist.vala"
								_data_->_tmp195_ = objects_item_get_checked (_data_->_tmp194_);
#line 322 "../core/Services/Todoist.vala"
								_data_->_tmp196_ = _data_->_tmp195_;
#line 322 "../core/Services/Todoist.vala"
								_data_->old_checked = _data_->_tmp196_;
#line 324 "../core/Services/Todoist.vala"
								_data_->_tmp197_ = _data_->item;
#line 324 "../core/Services/Todoist.vala"
								_data_->_tmp198_ = _data_->_vala3__node;
#line 324 "../core/Services/Todoist.vala"
								objects_item_update_from_json (_data_->_tmp197_, _data_->_tmp198_);
#line 325 "../core/Services/Todoist.vala"
								_data_->_tmp199_ = services_store_instance ();
#line 325 "../core/Services/Todoist.vala"
								_data_->_tmp200_ = _data_->item;
#line 325 "../core/Services/Todoist.vala"
								services_store_update_item (_data_->_tmp199_, _data_->_tmp200_, "");
#line 327 "../core/Services/Todoist.vala"
								_data_->_tmp203_ = _data_->old_project_id;
#line 327 "../core/Services/Todoist.vala"
								_data_->_tmp204_ = _data_->item;
#line 327 "../core/Services/Todoist.vala"
								_data_->_tmp205_ = objects_item_get_project_id (_data_->_tmp204_);
#line 327 "../core/Services/Todoist.vala"
								_data_->_tmp206_ = _data_->_tmp205_;
#line 327 "../core/Services/Todoist.vala"
								if (g_strcmp0 (_data_->_tmp203_, _data_->_tmp206_) != 0) {
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp202_ = TRUE;
#line 4005 "Todoist.c"
								} else {
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp207_ = _data_->old_section_id;
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp208_ = _data_->item;
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp209_ = objects_item_get_section_id (_data_->_tmp208_);
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp210_ = _data_->_tmp209_;
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp202_ = g_strcmp0 (_data_->_tmp207_, _data_->_tmp210_) != 0;
#line 4017 "Todoist.c"
								}
#line 327 "../core/Services/Todoist.vala"
								if (_data_->_tmp202_) {
#line 327 "../core/Services/Todoist.vala"
									_data_->_tmp201_ = TRUE;
#line 4023 "Todoist.c"
								} else {
#line 328 "../core/Services/Todoist.vala"
									_data_->_tmp211_ = _data_->_vala1_old_parent_id;
#line 328 "../core/Services/Todoist.vala"
									_data_->_tmp212_ = _data_->item;
#line 328 "../core/Services/Todoist.vala"
									_data_->_tmp213_ = objects_item_get_parent_id (_data_->_tmp212_);
#line 328 "../core/Services/Todoist.vala"
									_data_->_tmp214_ = _data_->_tmp213_;
#line 328 "../core/Services/Todoist.vala"
									_data_->_tmp201_ = g_strcmp0 (_data_->_tmp211_, _data_->_tmp214_) != 0;
#line 4035 "Todoist.c"
								}
#line 327 "../core/Services/Todoist.vala"
								if (_data_->_tmp201_) {
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp215_ = services_event_bus_get_default ();
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp216_ = _data_->_tmp215_;
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp217_ = _data_->item;
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp218_ = _data_->old_project_id;
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp219_ = _data_->old_section_id;
#line 329 "../core/Services/Todoist.vala"
									_data_->_tmp220_ = _data_->_vala1_old_parent_id;
#line 329 "../core/Services/Todoist.vala"
									g_signal_emit_by_name (_data_->_tmp216_, "item-moved", _data_->_tmp217_, _data_->_tmp218_, _data_->_tmp219_, _data_->_tmp220_);
#line 329 "../core/Services/Todoist.vala"
									_g_object_unref0 (_data_->_tmp216_);
#line 4055 "Todoist.c"
								}
#line 332 "../core/Services/Todoist.vala"
								_data_->_tmp221_ = _data_->item;
#line 332 "../core/Services/Todoist.vala"
								_data_->_tmp222_ = objects_item_get_checked (_data_->_tmp221_);
#line 332 "../core/Services/Todoist.vala"
								_data_->_tmp223_ = _data_->_tmp222_;
#line 332 "../core/Services/Todoist.vala"
								if (_data_->old_checked != _data_->_tmp223_) {
#line 333 "../core/Services/Todoist.vala"
									_data_->_tmp224_ = services_store_instance ();
#line 333 "../core/Services/Todoist.vala"
									_data_->_tmp225_ = _data_->item;
#line 333 "../core/Services/Todoist.vala"
									services_store_complete_item (_data_->_tmp224_, _data_->_tmp225_, _data_->old_checked, TRUE);
#line 4071 "Todoist.c"
								}
#line 316 "../core/Services/Todoist.vala"
								_g_free0 (_data_->_vala1_old_parent_id);
#line 316 "../core/Services/Todoist.vala"
								_g_free0 (_data_->old_section_id);
#line 316 "../core/Services/Todoist.vala"
								_g_free0 (_data_->old_project_id);
#line 4079 "Todoist.c"
							}
						} else {
#line 337 "../core/Services/Todoist.vala"
							_data_->_tmp226_ = _data_->_vala3__node;
#line 337 "../core/Services/Todoist.vala"
							services_todoist_add_item_if_not_exists (_data_->self, _data_->_tmp226_);
#line 4086 "Todoist.c"
						}
#line 313 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->item);
#line 4090 "Todoist.c"
					}
				}
#line 313 "../core/Services/Todoist.vala"
				(_data_->_vala3__node_collection == NULL) ? NULL : (_data_->_vala3__node_collection = (g_list_free (_data_->_vala3__node_collection), NULL));
#line 4095 "Todoist.c"
			}
#line 342 "../core/Services/Todoist.vala"
			_data_->_tmp227_ = _data_->self->priv->parser;
#line 342 "../core/Services/Todoist.vala"
			_data_->_tmp228_ = json_parser_get_root (_data_->_tmp227_);
#line 342 "../core/Services/Todoist.vala"
			_data_->_tmp229_ = json_node_get_object (_data_->_tmp228_);
#line 342 "../core/Services/Todoist.vala"
			_data_->_tmp230_ = json_object_get_array_member (_data_->_tmp229_, SERVICES_TODOIST_REMINDERS_COLLECTION);
#line 342 "../core/Services/Todoist.vala"
			_data_->reminders = _data_->_tmp230_;
#line 343 "../core/Services/Todoist.vala"
			_data_->_tmp231_ = _data_->reminders;
#line 343 "../core/Services/Todoist.vala"
			_data_->_tmp232_ = json_array_get_elements (_data_->_tmp231_);
#line 4111 "Todoist.c"
			{
#line 343 "../core/Services/Todoist.vala"
				_data_->_vala4__node_collection = _data_->_tmp232_;
#line 343 "../core/Services/Todoist.vala"
				for (_data_->_vala4__node_it = _data_->_vala4__node_collection; _data_->_vala4__node_it != NULL; _data_->_vala4__node_it = _data_->_vala4__node_it->next) {
#line 343 "../core/Services/Todoist.vala"
					_data_->_vala4__node = (JsonNode*) _data_->_vala4__node_it->data;
#line 4119 "Todoist.c"
					{
#line 344 "../core/Services/Todoist.vala"
						_data_->_tmp233_ = services_store_instance ();
#line 344 "../core/Services/Todoist.vala"
						_data_->_tmp234_ = _data_->_vala4__node;
#line 344 "../core/Services/Todoist.vala"
						_data_->_tmp235_ = json_node_get_object (_data_->_tmp234_);
#line 344 "../core/Services/Todoist.vala"
						_data_->_tmp236_ = json_object_get_string_member (_data_->_tmp235_, "id");
#line 344 "../core/Services/Todoist.vala"
						_data_->_tmp237_ = services_store_get_reminder (_data_->_tmp233_, _data_->_tmp236_);
#line 344 "../core/Services/Todoist.vala"
						_data_->reminder = _data_->_tmp237_;
#line 346 "../core/Services/Todoist.vala"
						_data_->_tmp238_ = _data_->reminder;
#line 346 "../core/Services/Todoist.vala"
						if (_data_->_tmp238_ != NULL) {
#line 347 "../core/Services/Todoist.vala"
							_data_->_tmp239_ = _data_->_vala4__node;
#line 347 "../core/Services/Todoist.vala"
							_data_->_tmp240_ = json_node_get_object (_data_->_tmp239_);
#line 347 "../core/Services/Todoist.vala"
							if (json_object_get_boolean_member (_data_->_tmp240_, "is_deleted")) {
#line 348 "../core/Services/Todoist.vala"
								_data_->_tmp241_ = services_store_instance ();
#line 348 "../core/Services/Todoist.vala"
								_data_->_tmp242_ = _data_->reminder;
#line 348 "../core/Services/Todoist.vala"
								services_store_delete_reminder (_data_->_tmp241_, _data_->_tmp242_);
#line 4149 "Todoist.c"
							}
						} else {
#line 351 "../core/Services/Todoist.vala"
							_data_->_tmp243_ = _data_->_vala4__node;
#line 351 "../core/Services/Todoist.vala"
							_data_->_tmp244_ = objects_reminder_new_from_json (_data_->_tmp243_);
#line 351 "../core/Services/Todoist.vala"
							_g_object_unref0 (_data_->reminder);
#line 351 "../core/Services/Todoist.vala"
							_data_->reminder = _data_->_tmp244_;
#line 353 "../core/Services/Todoist.vala"
							_data_->_tmp245_ = services_store_instance ();
#line 353 "../core/Services/Todoist.vala"
							_data_->_tmp246_ = _data_->reminder;
#line 353 "../core/Services/Todoist.vala"
							_data_->_tmp247_ = objects_reminder_get_item_id (_data_->_tmp246_);
#line 353 "../core/Services/Todoist.vala"
							_data_->_tmp248_ = _data_->_tmp247_;
#line 353 "../core/Services/Todoist.vala"
							_data_->_tmp249_ = services_store_get_item (_data_->_tmp245_, _data_->_tmp248_);
#line 353 "../core/Services/Todoist.vala"
							_data_->_vala1_item = _data_->_tmp249_;
#line 354 "../core/Services/Todoist.vala"
							_data_->_tmp250_ = _data_->_vala1_item;
#line 354 "../core/Services/Todoist.vala"
							if (_data_->_tmp250_ != NULL) {
#line 355 "../core/Services/Todoist.vala"
								_data_->_tmp251_ = _data_->_vala1_item;
#line 355 "../core/Services/Todoist.vala"
								_data_->_tmp252_ = _data_->reminder;
#line 355 "../core/Services/Todoist.vala"
								_data_->_tmp253_ = objects_item_add_reminder_if_not_exists (_data_->_tmp251_, _data_->_tmp252_, TRUE);
#line 355 "../core/Services/Todoist.vala"
								_data_->_tmp254_ = _data_->_tmp253_;
#line 355 "../core/Services/Todoist.vala"
								_g_object_unref0 (_data_->_tmp254_);
#line 4186 "Todoist.c"
							}
#line 346 "../core/Services/Todoist.vala"
							_g_object_unref0 (_data_->_vala1_item);
#line 4190 "Todoist.c"
						}
#line 343 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->reminder);
#line 4194 "Todoist.c"
					}
				}
#line 343 "../core/Services/Todoist.vala"
				(_data_->_vala4__node_collection == NULL) ? NULL : (_data_->_vala4__node_collection = (g_list_free (_data_->_vala4__node_collection), NULL));
#line 4199 "Todoist.c"
			}
#line 360 "../core/Services/Todoist.vala"
			_data_->_state_ = 2;
#line 360 "../core/Services/Todoist.vala"
			services_todoist_queue (_data_->self, _data_->source, services_todoist_sync_ready, _data_);
#line 360 "../core/Services/Todoist.vala"
			return FALSE;
#line 4207 "Todoist.c"
			_state_2:
#line 360 "../core/Services/Todoist.vala"
			services_todoist_queue_finish (_data_->self, _data_->_res_);
#line 4211 "Todoist.c"
		}
#line 226 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 4215 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 226 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 226 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 363 "../core/Services/Todoist.vala"
		_data_->_tmp255_ = _data_->e;
#line 363 "../core/Services/Todoist.vala"
		_data_->_tmp256_ = _data_->_tmp255_->message;
#line 363 "../core/Services/Todoist.vala"
		g_debug ("Todoist.vala:363: %s", _data_->_tmp256_);
#line 226 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 4232 "Todoist.c"
	}
	__finally0:
#line 226 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 226 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 226 "../core/Services/Todoist.vala"
		_g_free0 (_data_->url);
#line 226 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 226 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 226 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 226 "../core/Services/Todoist.vala"
		return FALSE;
#line 4249 "Todoist.c"
	}
#line 366 "../core/Services/Todoist.vala"
	_data_->_tmp257_ = g_date_time_new_now_local ();
#line 366 "../core/Services/Todoist.vala"
	_data_->_tmp258_ = _data_->_tmp257_;
#line 366 "../core/Services/Todoist.vala"
	_data_->_tmp259_ = g_date_time_to_string (_data_->_tmp258_);
#line 366 "../core/Services/Todoist.vala"
	_data_->_tmp260_ = _data_->_tmp259_;
#line 366 "../core/Services/Todoist.vala"
	objects_source_set_last_sync (_data_->source, _data_->_tmp260_);
#line 366 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp260_);
#line 366 "../core/Services/Todoist.vala"
	_g_date_time_unref0 (_data_->_tmp258_);
#line 367 "../core/Services/Todoist.vala"
	g_signal_emit_by_name (_data_->source, "sync-finished");
#line 210 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 210 "../core/Services/Todoist.vala"
	_g_free0 (_data_->url);
#line 210 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 210 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 210 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 210 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4279 "Todoist.c"
		}
	}
#line 210 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 210 "../core/Services/Todoist.vala"
	return FALSE;
#line 4286 "Todoist.c"
}

static void
services_todoist_queue_data_free (gpointer _data)
{
	ServicesTodoistQueueData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistQueueData, _data_);
#line 4300 "Todoist.c"
}

void
services_todoist_queue (ServicesTodoist* self,
                        ObjectsSource* source,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ServicesTodoistQueueData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsSource* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (source != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistQueueData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_queue_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 22 "../core/Services/Todoist.vala"
	_data_->source = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_queue_co (_data_);
#line 4334 "Todoist.c"
}

void
services_todoist_queue_finish (ServicesTodoist* self,
                               GAsyncResult* _res_)
{
	ServicesTodoistQueueData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4344 "Todoist.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 4381 "Todoist.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 4387 "Todoist.c"
}

static void
services_todoist_queue_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ServicesTodoistQueueData* _data_;
#line 390 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 390 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 390 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 390 "../core/Services/Todoist.vala"
	services_todoist_queue_co (_data_);
#line 4404 "Todoist.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 401 "../core/Services/Todoist.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 4412 "Todoist.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 401 "../core/Services/Todoist.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 4420 "Todoist.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 400 "../core/Services/Todoist.vala"
	g_boxed_free (json_node_get_type (), self);
#line 4428 "Todoist.c"
}

static gboolean
services_todoist_queue_co (ServicesTodoistQueueData* _data_)
{
#line 374 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 374 "../core/Services/Todoist.vala"
		case 0:
#line 4438 "Todoist.c"
		goto _state_0;
#line 374 "../core/Services/Todoist.vala"
		case 1:
#line 4442 "Todoist.c"
		goto _state_1;
		default:
#line 374 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 4447 "Todoist.c"
	}
	_state_0:
#line 375 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = services_database_get_default ();
#line 375 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 375 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = services_database_get_all_queue (_data_->_tmp1_);
#line 375 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 375 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 375 "../core/Services/Todoist.vala"
	_data_->queue_collection = _data_->_tmp3_;
#line 376 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->queue_collection;
#line 376 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp4_);
#line 376 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 376 "../core/Services/Todoist.vala"
	if (_data_->_tmp6_ <= 0) {
#line 377 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->queue_collection);
#line 377 "../core/Services/Todoist.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 377 "../core/Services/Todoist.vala"
		if (_data_->_state_ != 0) {
#line 377 "../core/Services/Todoist.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 377 "../core/Services/Todoist.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4480 "Todoist.c"
			}
		}
#line 377 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 377 "../core/Services/Todoist.vala"
		return FALSE;
#line 4487 "Todoist.c"
	}
#line 380 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->queue_collection;
#line 380 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = services_todoist_get_queue_json (_data_->self, _data_->_tmp7_);
#line 380 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp8_;
#line 382 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 382 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp9_;
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->message;
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = objects_source_get_todoist_data (_data_->source);
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = objects_source_todoist_data_get_access_token (_data_->_tmp14_);
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = g_strdup_printf ("Bearer %s", _data_->_tmp16_);
#line 383 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 383 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp18_);
#line 383 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp18_);
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->message;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->json;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = 0;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = string_get_data (_data_->_tmp20_, &_data_->_tmp22_);
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp21__length1 = _data_->_tmp22_;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = _data_->_tmp21_;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp23__length1 = _data_->_tmp21__length1;
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = g_bytes_new (_data_->_tmp23_, _data_->_tmp23__length1);
#line 387 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 387 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp19_, "application/json", _data_->_tmp25_);
#line 387 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp25_);
#line 4543 "Todoist.c"
	{
#line 390 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = _data_->self->priv->session;
#line 390 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = _data_->message;
#line 390 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 390 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp26_, _data_->_tmp27_, G_PRIORITY_LOW, NULL, services_todoist_queue_ready, _data_);
#line 390 "../core/Services/Todoist.vala"
		return FALSE;
#line 4555 "Todoist.c"
		_state_1:
#line 390 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = soup_session_send_and_read_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
#line 390 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp28_;
#line 390 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4563 "Todoist.c"
			goto __catch0_g_error;
		}
#line 391 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = _data_->self->priv->parser;
#line 391 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->stream;
#line 391 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = 0;
#line 391 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = g_bytes_get_data (_data_->_tmp30_, &_data_->_tmp31_);
#line 391 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp29_, (const gchar*) _data_->_tmp32_, (gssize) -1, &_data_->_inner_error0_);
#line 391 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 391 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 4580 "Todoist.c"
			goto __catch0_g_error;
		}
#line 394 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = _data_->self->priv->parser;
#line 394 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = json_parser_get_root (_data_->_tmp33_);
#line 394 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp34_);
#line 396 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->self->priv->parser;
#line 396 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
#line 396 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = json_node_get_object (_data_->_tmp36_);
#line 396 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = _json_object_ref0 (_data_->_tmp37_);
#line 396 "../core/Services/Todoist.vala"
		_data_->node = _data_->_tmp38_;
#line 397 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = _data_->node;
#line 397 "../core/Services/Todoist.vala"
		_data_->_tmp40_ = json_object_get_string_member (_data_->_tmp39_, "sync_token");
#line 397 "../core/Services/Todoist.vala"
		_data_->_tmp41_ = g_strdup (_data_->_tmp40_);
#line 397 "../core/Services/Todoist.vala"
		_data_->sync_token = _data_->_tmp41_;
#line 398 "../core/Services/Todoist.vala"
		_data_->_tmp42_ = objects_source_get_todoist_data (_data_->source);
#line 398 "../core/Services/Todoist.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 398 "../core/Services/Todoist.vala"
		_data_->_tmp44_ = _data_->sync_token;
#line 398 "../core/Services/Todoist.vala"
		objects_source_todoist_data_set_sync_token (_data_->_tmp43_, _data_->_tmp44_);
#line 4615 "Todoist.c"
		{
#line 400 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = _data_->queue_collection;
#line 400 "../core/Services/Todoist.vala"
			_data_->_q_list = _data_->_tmp45_;
#line 400 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->_q_list;
#line 400 "../core/Services/Todoist.vala"
			_data_->_tmp47_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp46_);
#line 400 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 400 "../core/Services/Todoist.vala"
			_data_->_q_size = _data_->_tmp48_;
#line 400 "../core/Services/Todoist.vala"
			_data_->_q_index = -1;
#line 400 "../core/Services/Todoist.vala"
			while (TRUE) {
#line 400 "../core/Services/Todoist.vala"
				_data_->_q_index = _data_->_q_index + 1;
#line 400 "../core/Services/Todoist.vala"
				_data_->_tmp49_ = _data_->_q_index;
#line 400 "../core/Services/Todoist.vala"
				_data_->_tmp50_ = _data_->_q_size;
#line 400 "../core/Services/Todoist.vala"
				if (!(_data_->_tmp49_ < _data_->_tmp50_)) {
#line 400 "../core/Services/Todoist.vala"
					break;
#line 4643 "Todoist.c"
				}
#line 400 "../core/Services/Todoist.vala"
				_data_->_tmp51_ = _data_->_q_list;
#line 400 "../core/Services/Todoist.vala"
				_data_->_tmp52_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp51_, _data_->_q_index);
#line 400 "../core/Services/Todoist.vala"
				_data_->q = (ObjectsQueue*) _data_->_tmp52_;
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp53_ = _data_->node;
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp55_ = _data_->q;
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp56_ = objects_queue_get_uuid (_data_->_tmp55_);
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp57_ = _data_->_tmp56_;
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp58_ = json_object_get_member (_data_->_tmp54_, _data_->_tmp57_);
#line 401 "../core/Services/Todoist.vala"
				_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
#line 401 "../core/Services/Todoist.vala"
				_data_->uuid_member = _data_->_tmp59_;
#line 402 "../core/Services/Todoist.vala"
				_data_->_tmp60_ = _data_->uuid_member;
#line 402 "../core/Services/Todoist.vala"
				if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
#line 403 "../core/Services/Todoist.vala"
					_data_->_tmp61_ = _data_->q;
#line 403 "../core/Services/Todoist.vala"
					_data_->_tmp62_ = objects_queue_get_query (_data_->_tmp61_);
#line 403 "../core/Services/Todoist.vala"
					_data_->_tmp63_ = _data_->_tmp62_;
#line 403 "../core/Services/Todoist.vala"
					if (g_strcmp0 (_data_->_tmp63_, "project_add") == 0) {
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp64_ = _data_->node;
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp65_ = json_object_get_object_member (_data_->_tmp64_, "temp_id_mapping");
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp66_ = _data_->q;
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp67_ = objects_queue_get_temp_id (_data_->_tmp66_);
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp68_ = _data_->_tmp67_;
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp69_ = json_object_get_string_member (_data_->_tmp65_, _data_->_tmp68_);
#line 404 "../core/Services/Todoist.vala"
						_data_->_tmp70_ = g_strdup (_data_->_tmp69_);
#line 404 "../core/Services/Todoist.vala"
						_data_->id = _data_->_tmp70_;
#line 405 "../core/Services/Todoist.vala"
						_data_->_tmp71_ = services_store_instance ();
#line 405 "../core/Services/Todoist.vala"
						_data_->_tmp72_ = _data_->q;
#line 405 "../core/Services/Todoist.vala"
						_data_->_tmp73_ = objects_queue_get_object_id (_data_->_tmp72_);
#line 405 "../core/Services/Todoist.vala"
						_data_->_tmp74_ = _data_->_tmp73_;
#line 405 "../core/Services/Todoist.vala"
						_data_->_tmp75_ = _data_->id;
#line 405 "../core/Services/Todoist.vala"
						services_store_update_project_id (_data_->_tmp71_, _data_->_tmp74_, _data_->_tmp75_);
#line 406 "../core/Services/Todoist.vala"
						_data_->_tmp76_ = services_database_get_default ();
#line 406 "../core/Services/Todoist.vala"
						_data_->_tmp77_ = _data_->_tmp76_;
#line 406 "../core/Services/Todoist.vala"
						_data_->_tmp78_ = _data_->q;
#line 406 "../core/Services/Todoist.vala"
						_data_->_tmp79_ = objects_queue_get_object_id (_data_->_tmp78_);
#line 406 "../core/Services/Todoist.vala"
						_data_->_tmp80_ = _data_->_tmp79_;
#line 406 "../core/Services/Todoist.vala"
						services_database_remove_CurTempIds (_data_->_tmp77_, _data_->_tmp80_);
#line 406 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->_tmp77_);
#line 403 "../core/Services/Todoist.vala"
						_g_free0 (_data_->id);
#line 4723 "Todoist.c"
					}
#line 409 "../core/Services/Todoist.vala"
					_data_->_tmp81_ = _data_->q;
#line 409 "../core/Services/Todoist.vala"
					_data_->_tmp82_ = objects_queue_get_query (_data_->_tmp81_);
#line 409 "../core/Services/Todoist.vala"
					_data_->_tmp83_ = _data_->_tmp82_;
#line 409 "../core/Services/Todoist.vala"
					if (g_strcmp0 (_data_->_tmp83_, "section_add") == 0) {
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp84_ = _data_->node;
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp84_, "temp_id_mapping");
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp86_ = _data_->q;
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp87_ = objects_queue_get_temp_id (_data_->_tmp86_);
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp88_ = _data_->_tmp87_;
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp89_ = json_object_get_string_member (_data_->_tmp85_, _data_->_tmp88_);
#line 410 "../core/Services/Todoist.vala"
						_data_->_tmp90_ = g_strdup (_data_->_tmp89_);
#line 410 "../core/Services/Todoist.vala"
						_data_->_vala1_id = _data_->_tmp90_;
#line 411 "../core/Services/Todoist.vala"
						_data_->_tmp91_ = services_store_instance ();
#line 411 "../core/Services/Todoist.vala"
						_data_->_tmp92_ = _data_->q;
#line 411 "../core/Services/Todoist.vala"
						_data_->_tmp93_ = objects_queue_get_object_id (_data_->_tmp92_);
#line 411 "../core/Services/Todoist.vala"
						_data_->_tmp94_ = _data_->_tmp93_;
#line 411 "../core/Services/Todoist.vala"
						_data_->_tmp95_ = _data_->_vala1_id;
#line 411 "../core/Services/Todoist.vala"
						services_store_update_section_id (_data_->_tmp91_, _data_->_tmp94_, _data_->_tmp95_);
#line 412 "../core/Services/Todoist.vala"
						_data_->_tmp96_ = services_database_get_default ();
#line 412 "../core/Services/Todoist.vala"
						_data_->_tmp97_ = _data_->_tmp96_;
#line 412 "../core/Services/Todoist.vala"
						_data_->_tmp98_ = _data_->q;
#line 412 "../core/Services/Todoist.vala"
						_data_->_tmp99_ = objects_queue_get_object_id (_data_->_tmp98_);
#line 412 "../core/Services/Todoist.vala"
						_data_->_tmp100_ = _data_->_tmp99_;
#line 412 "../core/Services/Todoist.vala"
						services_database_remove_CurTempIds (_data_->_tmp97_, _data_->_tmp100_);
#line 412 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->_tmp97_);
#line 409 "../core/Services/Todoist.vala"
						_g_free0 (_data_->_vala1_id);
#line 4777 "Todoist.c"
					}
#line 415 "../core/Services/Todoist.vala"
					_data_->_tmp101_ = _data_->q;
#line 415 "../core/Services/Todoist.vala"
					_data_->_tmp102_ = objects_queue_get_query (_data_->_tmp101_);
#line 415 "../core/Services/Todoist.vala"
					_data_->_tmp103_ = _data_->_tmp102_;
#line 415 "../core/Services/Todoist.vala"
					if (g_strcmp0 (_data_->_tmp103_, "item_add") == 0) {
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp104_ = _data_->node;
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp105_ = json_object_get_object_member (_data_->_tmp104_, "temp_id_mapping");
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp106_ = _data_->q;
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp107_ = objects_queue_get_temp_id (_data_->_tmp106_);
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp108_ = _data_->_tmp107_;
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp109_ = json_object_get_string_member (_data_->_tmp105_, _data_->_tmp108_);
#line 416 "../core/Services/Todoist.vala"
						_data_->_tmp110_ = g_strdup (_data_->_tmp109_);
#line 416 "../core/Services/Todoist.vala"
						_data_->_vala2_id = _data_->_tmp110_;
#line 417 "../core/Services/Todoist.vala"
						_data_->_tmp111_ = services_store_instance ();
#line 417 "../core/Services/Todoist.vala"
						_data_->_tmp112_ = _data_->q;
#line 417 "../core/Services/Todoist.vala"
						_data_->_tmp113_ = objects_queue_get_object_id (_data_->_tmp112_);
#line 417 "../core/Services/Todoist.vala"
						_data_->_tmp114_ = _data_->_tmp113_;
#line 417 "../core/Services/Todoist.vala"
						_data_->_tmp115_ = _data_->_vala2_id;
#line 417 "../core/Services/Todoist.vala"
						services_store_update_item_id (_data_->_tmp111_, _data_->_tmp114_, _data_->_tmp115_);
#line 418 "../core/Services/Todoist.vala"
						_data_->_tmp116_ = services_database_get_default ();
#line 418 "../core/Services/Todoist.vala"
						_data_->_tmp117_ = _data_->_tmp116_;
#line 418 "../core/Services/Todoist.vala"
						_data_->_tmp118_ = _data_->q;
#line 418 "../core/Services/Todoist.vala"
						_data_->_tmp119_ = objects_queue_get_object_id (_data_->_tmp118_);
#line 418 "../core/Services/Todoist.vala"
						_data_->_tmp120_ = _data_->_tmp119_;
#line 418 "../core/Services/Todoist.vala"
						services_database_remove_CurTempIds (_data_->_tmp117_, _data_->_tmp120_);
#line 418 "../core/Services/Todoist.vala"
						_g_object_unref0 (_data_->_tmp117_);
#line 415 "../core/Services/Todoist.vala"
						_g_free0 (_data_->_vala2_id);
#line 4831 "Todoist.c"
					}
#line 421 "../core/Services/Todoist.vala"
					_data_->_tmp121_ = services_database_get_default ();
#line 421 "../core/Services/Todoist.vala"
					_data_->_tmp122_ = _data_->_tmp121_;
#line 421 "../core/Services/Todoist.vala"
					_data_->_tmp123_ = _data_->q;
#line 421 "../core/Services/Todoist.vala"
					_data_->_tmp124_ = objects_queue_get_uuid (_data_->_tmp123_);
#line 421 "../core/Services/Todoist.vala"
					_data_->_tmp125_ = _data_->_tmp124_;
#line 421 "../core/Services/Todoist.vala"
					services_database_remove_queue (_data_->_tmp122_, _data_->_tmp125_);
#line 421 "../core/Services/Todoist.vala"
					_g_object_unref0 (_data_->_tmp122_);
#line 4847 "Todoist.c"
				}
#line 400 "../core/Services/Todoist.vala"
				__vala_JsonNode_free0 (_data_->uuid_member);
#line 400 "../core/Services/Todoist.vala"
				_g_object_unref0 (_data_->q);
#line 4853 "Todoist.c"
			}
		}
#line 389 "../core/Services/Todoist.vala"
		_g_free0 (_data_->sync_token);
#line 389 "../core/Services/Todoist.vala"
		_json_object_unref0 (_data_->node);
#line 389 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 4862 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 389 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 389 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 425 "../core/Services/Todoist.vala"
		_data_->_tmp126_ = _data_->e;
#line 425 "../core/Services/Todoist.vala"
		_data_->_tmp127_ = _data_->_tmp126_->message;
#line 425 "../core/Services/Todoist.vala"
		g_debug ("Todoist.vala:425: %s", _data_->_tmp127_);
#line 389 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 4879 "Todoist.c"
	}
	__finally0:
#line 389 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 389 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 389 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 389 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->queue_collection);
#line 389 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 389 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 389 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 389 "../core/Services/Todoist.vala"
		return FALSE;
#line 4898 "Todoist.c"
	}
#line 374 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 374 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 374 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->queue_collection);
#line 374 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 374 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 374 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 374 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4914 "Todoist.c"
		}
	}
#line 374 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 374 "../core/Services/Todoist.vala"
	return FALSE;
#line 4921 "Todoist.c"
}

gchar*
services_todoist_get_queue_json (ServicesTodoist* self,
                                 GeeArrayList* queue)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp420_;
	JsonBuilder* _tmp421_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp422_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp423_;
	JsonNode* _tmp424_;
	gchar* _tmp425_;
	gchar* result;
#line 429 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 429 "../core/Services/Todoist.vala"
	g_return_val_if_fail (queue != NULL, NULL);
#line 430 "../core/Services/Todoist.vala"
	_tmp0_ = json_builder_new ();
#line 430 "../core/Services/Todoist.vala"
	builder = _tmp0_;
#line 431 "../core/Services/Todoist.vala"
	_tmp1_ = builder;
#line 431 "../core/Services/Todoist.vala"
	json_builder_begin_object (_tmp1_);
#line 432 "../core/Services/Todoist.vala"
	_tmp2_ = builder;
#line 432 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp2_, "commands");
#line 434 "../core/Services/Todoist.vala"
	_tmp3_ = builder;
#line 434 "../core/Services/Todoist.vala"
	json_builder_begin_array (_tmp3_);
#line 4962 "Todoist.c"
	{
		GeeArrayList* _q_list = NULL;
		gint _q_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _q_index = 0;
#line 435 "../core/Services/Todoist.vala"
		_q_list = queue;
#line 435 "../core/Services/Todoist.vala"
		_tmp4_ = _q_list;
#line 435 "../core/Services/Todoist.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 435 "../core/Services/Todoist.vala"
		_tmp6_ = _tmp5_;
#line 435 "../core/Services/Todoist.vala"
		_q_size = _tmp6_;
#line 435 "../core/Services/Todoist.vala"
		_q_index = -1;
#line 435 "../core/Services/Todoist.vala"
		while (TRUE) {
#line 4984 "Todoist.c"
			gint _tmp7_;
			gint _tmp8_;
			ObjectsQueue* q = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonBuilder* _tmp11_;
			ObjectsQueue* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			JsonBuilder* _tmp419_;
#line 435 "../core/Services/Todoist.vala"
			_q_index = _q_index + 1;
#line 435 "../core/Services/Todoist.vala"
			_tmp7_ = _q_index;
#line 435 "../core/Services/Todoist.vala"
			_tmp8_ = _q_size;
#line 435 "../core/Services/Todoist.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 435 "../core/Services/Todoist.vala"
				break;
#line 5005 "Todoist.c"
			}
#line 435 "../core/Services/Todoist.vala"
			_tmp9_ = _q_list;
#line 435 "../core/Services/Todoist.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _q_index);
#line 435 "../core/Services/Todoist.vala"
			q = (ObjectsQueue*) _tmp10_;
#line 436 "../core/Services/Todoist.vala"
			_tmp11_ = builder;
#line 436 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp11_);
#line 438 "../core/Services/Todoist.vala"
			_tmp12_ = q;
#line 438 "../core/Services/Todoist.vala"
			_tmp13_ = objects_queue_get_query (_tmp12_);
#line 438 "../core/Services/Todoist.vala"
			_tmp14_ = _tmp13_;
#line 438 "../core/Services/Todoist.vala"
			if (g_strcmp0 (_tmp14_, "project_add") == 0) {
#line 5025 "Todoist.c"
				JsonBuilder* _tmp15_;
				JsonBuilder* _tmp16_;
				JsonBuilder* _tmp17_;
				JsonBuilder* _tmp18_;
				ObjectsQueue* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				JsonBuilder* _tmp22_;
				JsonBuilder* _tmp23_;
				ObjectsQueue* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				JsonBuilder* _tmp27_;
				JsonBuilder* _tmp28_;
				JsonBuilder* _tmp29_;
				JsonBuilder* _tmp30_;
				ObjectsQueue* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				JsonBuilder* _tmp36_;
				JsonBuilder* _tmp37_;
				ObjectsQueue* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				JsonBuilder* _tmp43_;
				JsonBuilder* _tmp44_;
#line 439 "../core/Services/Todoist.vala"
				_tmp15_ = builder;
#line 439 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp15_, "type");
#line 440 "../core/Services/Todoist.vala"
				_tmp16_ = builder;
#line 440 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp16_, "project_add");
#line 442 "../core/Services/Todoist.vala"
				_tmp17_ = builder;
#line 442 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp17_, "temp_id");
#line 443 "../core/Services/Todoist.vala"
				_tmp18_ = builder;
#line 443 "../core/Services/Todoist.vala"
				_tmp19_ = q;
#line 443 "../core/Services/Todoist.vala"
				_tmp20_ = objects_queue_get_temp_id (_tmp19_);
#line 443 "../core/Services/Todoist.vala"
				_tmp21_ = _tmp20_;
#line 443 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp18_, _tmp21_);
#line 445 "../core/Services/Todoist.vala"
				_tmp22_ = builder;
#line 445 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp22_, "uuid");
#line 446 "../core/Services/Todoist.vala"
				_tmp23_ = builder;
#line 446 "../core/Services/Todoist.vala"
				_tmp24_ = q;
#line 446 "../core/Services/Todoist.vala"
				_tmp25_ = objects_queue_get_uuid (_tmp24_);
#line 446 "../core/Services/Todoist.vala"
				_tmp26_ = _tmp25_;
#line 446 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp23_, _tmp26_);
#line 448 "../core/Services/Todoist.vala"
				_tmp27_ = builder;
#line 448 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp27_, "args");
#line 449 "../core/Services/Todoist.vala"
				_tmp28_ = builder;
#line 449 "../core/Services/Todoist.vala"
				json_builder_begin_object (_tmp28_);
#line 451 "../core/Services/Todoist.vala"
				_tmp29_ = builder;
#line 451 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp29_, "name");
#line 452 "../core/Services/Todoist.vala"
				_tmp30_ = builder;
#line 452 "../core/Services/Todoist.vala"
				_tmp31_ = q;
#line 452 "../core/Services/Todoist.vala"
				_tmp32_ = objects_queue_get_args (_tmp31_);
#line 452 "../core/Services/Todoist.vala"
				_tmp33_ = _tmp32_;
#line 452 "../core/Services/Todoist.vala"
				_tmp34_ = services_todoist_get_string_member_by_object (self, _tmp33_, "name");
#line 452 "../core/Services/Todoist.vala"
				_tmp35_ = _tmp34_;
#line 452 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp30_, _tmp35_);
#line 452 "../core/Services/Todoist.vala"
				_g_free0 (_tmp35_);
#line 454 "../core/Services/Todoist.vala"
				_tmp36_ = builder;
#line 454 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp36_, "color");
#line 455 "../core/Services/Todoist.vala"
				_tmp37_ = builder;
#line 455 "../core/Services/Todoist.vala"
				_tmp38_ = q;
#line 455 "../core/Services/Todoist.vala"
				_tmp39_ = objects_queue_get_args (_tmp38_);
#line 455 "../core/Services/Todoist.vala"
				_tmp40_ = _tmp39_;
#line 455 "../core/Services/Todoist.vala"
				_tmp41_ = services_todoist_get_string_member_by_object (self, _tmp40_, "color");
#line 455 "../core/Services/Todoist.vala"
				_tmp42_ = _tmp41_;
#line 455 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp37_, _tmp42_);
#line 455 "../core/Services/Todoist.vala"
				_g_free0 (_tmp42_);
#line 457 "../core/Services/Todoist.vala"
				_tmp43_ = builder;
#line 457 "../core/Services/Todoist.vala"
				json_builder_end_object (_tmp43_);
#line 458 "../core/Services/Todoist.vala"
				_tmp44_ = builder;
#line 458 "../core/Services/Todoist.vala"
				json_builder_end_object (_tmp44_);
#line 5148 "Todoist.c"
			} else {
				ObjectsQueue* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
#line 459 "../core/Services/Todoist.vala"
				_tmp45_ = q;
#line 459 "../core/Services/Todoist.vala"
				_tmp46_ = objects_queue_get_query (_tmp45_);
#line 459 "../core/Services/Todoist.vala"
				_tmp47_ = _tmp46_;
#line 459 "../core/Services/Todoist.vala"
				if (g_strcmp0 (_tmp47_, "project_update") == 0) {
#line 5161 "Todoist.c"
					JsonBuilder* _tmp48_;
					JsonBuilder* _tmp49_;
					JsonBuilder* _tmp50_;
					JsonBuilder* _tmp51_;
					ObjectsQueue* _tmp52_;
					const gchar* _tmp53_;
					const gchar* _tmp54_;
					JsonBuilder* _tmp55_;
					JsonBuilder* _tmp56_;
					JsonBuilder* _tmp57_;
					JsonBuilder* _tmp58_;
					ObjectsQueue* _tmp59_;
					const gchar* _tmp60_;
					const gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
					JsonBuilder* _tmp64_;
					JsonBuilder* _tmp65_;
					ObjectsQueue* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
					JsonBuilder* _tmp71_;
					JsonBuilder* _tmp72_;
					ObjectsQueue* _tmp73_;
					const gchar* _tmp74_;
					const gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					JsonBuilder* _tmp78_;
					JsonBuilder* _tmp79_;
#line 460 "../core/Services/Todoist.vala"
					_tmp48_ = builder;
#line 460 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp48_, "type");
#line 461 "../core/Services/Todoist.vala"
					_tmp49_ = builder;
#line 461 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp49_, "project_update");
#line 463 "../core/Services/Todoist.vala"
					_tmp50_ = builder;
#line 463 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp50_, "uuid");
#line 464 "../core/Services/Todoist.vala"
					_tmp51_ = builder;
#line 464 "../core/Services/Todoist.vala"
					_tmp52_ = q;
#line 464 "../core/Services/Todoist.vala"
					_tmp53_ = objects_queue_get_uuid (_tmp52_);
#line 464 "../core/Services/Todoist.vala"
					_tmp54_ = _tmp53_;
#line 464 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp51_, _tmp54_);
#line 466 "../core/Services/Todoist.vala"
					_tmp55_ = builder;
#line 466 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp55_, "args");
#line 467 "../core/Services/Todoist.vala"
					_tmp56_ = builder;
#line 467 "../core/Services/Todoist.vala"
					json_builder_begin_object (_tmp56_);
#line 468 "../core/Services/Todoist.vala"
					_tmp57_ = builder;
#line 468 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp57_, "id");
#line 469 "../core/Services/Todoist.vala"
					_tmp58_ = builder;
#line 469 "../core/Services/Todoist.vala"
					_tmp59_ = q;
#line 469 "../core/Services/Todoist.vala"
					_tmp60_ = objects_queue_get_args (_tmp59_);
#line 469 "../core/Services/Todoist.vala"
					_tmp61_ = _tmp60_;
#line 469 "../core/Services/Todoist.vala"
					_tmp62_ = services_todoist_get_string_member_by_object (self, _tmp61_, "id");
#line 469 "../core/Services/Todoist.vala"
					_tmp63_ = _tmp62_;
#line 469 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp58_, _tmp63_);
#line 469 "../core/Services/Todoist.vala"
					_g_free0 (_tmp63_);
#line 471 "../core/Services/Todoist.vala"
					_tmp64_ = builder;
#line 471 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp64_, "name");
#line 472 "../core/Services/Todoist.vala"
					_tmp65_ = builder;
#line 472 "../core/Services/Todoist.vala"
					_tmp66_ = q;
#line 472 "../core/Services/Todoist.vala"
					_tmp67_ = objects_queue_get_args (_tmp66_);
#line 472 "../core/Services/Todoist.vala"
					_tmp68_ = _tmp67_;
#line 472 "../core/Services/Todoist.vala"
					_tmp69_ = services_todoist_get_string_member_by_object (self, _tmp68_, "name");
#line 472 "../core/Services/Todoist.vala"
					_tmp70_ = _tmp69_;
#line 472 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp65_, _tmp70_);
#line 472 "../core/Services/Todoist.vala"
					_g_free0 (_tmp70_);
#line 474 "../core/Services/Todoist.vala"
					_tmp71_ = builder;
#line 474 "../core/Services/Todoist.vala"
					json_builder_set_member_name (_tmp71_, "color");
#line 475 "../core/Services/Todoist.vala"
					_tmp72_ = builder;
#line 475 "../core/Services/Todoist.vala"
					_tmp73_ = q;
#line 475 "../core/Services/Todoist.vala"
					_tmp74_ = objects_queue_get_args (_tmp73_);
#line 475 "../core/Services/Todoist.vala"
					_tmp75_ = _tmp74_;
#line 475 "../core/Services/Todoist.vala"
					_tmp76_ = services_todoist_get_string_member_by_object (self, _tmp75_, "color");
#line 475 "../core/Services/Todoist.vala"
					_tmp77_ = _tmp76_;
#line 475 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp72_, _tmp77_);
#line 475 "../core/Services/Todoist.vala"
					_g_free0 (_tmp77_);
#line 477 "../core/Services/Todoist.vala"
					_tmp78_ = builder;
#line 477 "../core/Services/Todoist.vala"
					json_builder_end_object (_tmp78_);
#line 478 "../core/Services/Todoist.vala"
					_tmp79_ = builder;
#line 478 "../core/Services/Todoist.vala"
					json_builder_end_object (_tmp79_);
#line 5292 "Todoist.c"
				} else {
					ObjectsQueue* _tmp80_;
					const gchar* _tmp81_;
					const gchar* _tmp82_;
#line 479 "../core/Services/Todoist.vala"
					_tmp80_ = q;
#line 479 "../core/Services/Todoist.vala"
					_tmp81_ = objects_queue_get_query (_tmp80_);
#line 479 "../core/Services/Todoist.vala"
					_tmp82_ = _tmp81_;
#line 479 "../core/Services/Todoist.vala"
					if (g_strcmp0 (_tmp82_, "project_delete") == 0) {
#line 5305 "Todoist.c"
						JsonBuilder* _tmp83_;
						JsonBuilder* _tmp84_;
						JsonBuilder* _tmp85_;
						JsonBuilder* _tmp86_;
						ObjectsQueue* _tmp87_;
						const gchar* _tmp88_;
						const gchar* _tmp89_;
						JsonBuilder* _tmp90_;
						JsonBuilder* _tmp91_;
						JsonBuilder* _tmp92_;
						JsonBuilder* _tmp93_;
						ObjectsQueue* _tmp94_;
						const gchar* _tmp95_;
						const gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						JsonBuilder* _tmp99_;
						JsonBuilder* _tmp100_;
#line 480 "../core/Services/Todoist.vala"
						_tmp83_ = builder;
#line 480 "../core/Services/Todoist.vala"
						json_builder_set_member_name (_tmp83_, "type");
#line 481 "../core/Services/Todoist.vala"
						_tmp84_ = builder;
#line 481 "../core/Services/Todoist.vala"
						json_builder_add_string_value (_tmp84_, "project_delete");
#line 483 "../core/Services/Todoist.vala"
						_tmp85_ = builder;
#line 483 "../core/Services/Todoist.vala"
						json_builder_set_member_name (_tmp85_, "uuid");
#line 484 "../core/Services/Todoist.vala"
						_tmp86_ = builder;
#line 484 "../core/Services/Todoist.vala"
						_tmp87_ = q;
#line 484 "../core/Services/Todoist.vala"
						_tmp88_ = objects_queue_get_uuid (_tmp87_);
#line 484 "../core/Services/Todoist.vala"
						_tmp89_ = _tmp88_;
#line 484 "../core/Services/Todoist.vala"
						json_builder_add_string_value (_tmp86_, _tmp89_);
#line 486 "../core/Services/Todoist.vala"
						_tmp90_ = builder;
#line 486 "../core/Services/Todoist.vala"
						json_builder_set_member_name (_tmp90_, "args");
#line 487 "../core/Services/Todoist.vala"
						_tmp91_ = builder;
#line 487 "../core/Services/Todoist.vala"
						json_builder_begin_object (_tmp91_);
#line 489 "../core/Services/Todoist.vala"
						_tmp92_ = builder;
#line 489 "../core/Services/Todoist.vala"
						json_builder_set_member_name (_tmp92_, "id");
#line 490 "../core/Services/Todoist.vala"
						_tmp93_ = builder;
#line 490 "../core/Services/Todoist.vala"
						_tmp94_ = q;
#line 490 "../core/Services/Todoist.vala"
						_tmp95_ = objects_queue_get_args (_tmp94_);
#line 490 "../core/Services/Todoist.vala"
						_tmp96_ = _tmp95_;
#line 490 "../core/Services/Todoist.vala"
						_tmp97_ = services_todoist_get_string_member_by_object (self, _tmp96_, "id");
#line 490 "../core/Services/Todoist.vala"
						_tmp98_ = _tmp97_;
#line 490 "../core/Services/Todoist.vala"
						json_builder_add_string_value (_tmp93_, _tmp98_);
#line 490 "../core/Services/Todoist.vala"
						_g_free0 (_tmp98_);
#line 492 "../core/Services/Todoist.vala"
						_tmp99_ = builder;
#line 492 "../core/Services/Todoist.vala"
						json_builder_end_object (_tmp99_);
#line 493 "../core/Services/Todoist.vala"
						_tmp100_ = builder;
#line 493 "../core/Services/Todoist.vala"
						json_builder_end_object (_tmp100_);
#line 5382 "Todoist.c"
					} else {
						ObjectsQueue* _tmp101_;
						const gchar* _tmp102_;
						const gchar* _tmp103_;
#line 494 "../core/Services/Todoist.vala"
						_tmp101_ = q;
#line 494 "../core/Services/Todoist.vala"
						_tmp102_ = objects_queue_get_query (_tmp101_);
#line 494 "../core/Services/Todoist.vala"
						_tmp103_ = _tmp102_;
#line 494 "../core/Services/Todoist.vala"
						if (g_strcmp0 (_tmp103_, "section_add") == 0) {
#line 5395 "Todoist.c"
							JsonBuilder* _tmp104_;
							JsonBuilder* _tmp105_;
							JsonBuilder* _tmp106_;
							JsonBuilder* _tmp107_;
							ObjectsQueue* _tmp108_;
							const gchar* _tmp109_;
							const gchar* _tmp110_;
							JsonBuilder* _tmp111_;
							JsonBuilder* _tmp112_;
							ObjectsQueue* _tmp113_;
							const gchar* _tmp114_;
							const gchar* _tmp115_;
							JsonBuilder* _tmp116_;
							JsonBuilder* _tmp117_;
							JsonBuilder* _tmp118_;
							JsonBuilder* _tmp119_;
							ObjectsQueue* _tmp120_;
							const gchar* _tmp121_;
							const gchar* _tmp122_;
							gchar* _tmp123_;
							gchar* _tmp124_;
							JsonBuilder* _tmp125_;
							ObjectsQueue* _tmp126_;
							const gchar* _tmp127_;
							const gchar* _tmp128_;
							JsonBuilder* _tmp141_;
							JsonBuilder* _tmp142_;
#line 495 "../core/Services/Todoist.vala"
							_tmp104_ = builder;
#line 495 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp104_, "type");
#line 496 "../core/Services/Todoist.vala"
							_tmp105_ = builder;
#line 496 "../core/Services/Todoist.vala"
							json_builder_add_string_value (_tmp105_, "section_add");
#line 498 "../core/Services/Todoist.vala"
							_tmp106_ = builder;
#line 498 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp106_, "temp_id");
#line 499 "../core/Services/Todoist.vala"
							_tmp107_ = builder;
#line 499 "../core/Services/Todoist.vala"
							_tmp108_ = q;
#line 499 "../core/Services/Todoist.vala"
							_tmp109_ = objects_queue_get_temp_id (_tmp108_);
#line 499 "../core/Services/Todoist.vala"
							_tmp110_ = _tmp109_;
#line 499 "../core/Services/Todoist.vala"
							json_builder_add_string_value (_tmp107_, _tmp110_);
#line 501 "../core/Services/Todoist.vala"
							_tmp111_ = builder;
#line 501 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp111_, "uuid");
#line 502 "../core/Services/Todoist.vala"
							_tmp112_ = builder;
#line 502 "../core/Services/Todoist.vala"
							_tmp113_ = q;
#line 502 "../core/Services/Todoist.vala"
							_tmp114_ = objects_queue_get_uuid (_tmp113_);
#line 502 "../core/Services/Todoist.vala"
							_tmp115_ = _tmp114_;
#line 502 "../core/Services/Todoist.vala"
							json_builder_add_string_value (_tmp112_, _tmp115_);
#line 504 "../core/Services/Todoist.vala"
							_tmp116_ = builder;
#line 504 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp116_, "args");
#line 505 "../core/Services/Todoist.vala"
							_tmp117_ = builder;
#line 505 "../core/Services/Todoist.vala"
							json_builder_begin_object (_tmp117_);
#line 507 "../core/Services/Todoist.vala"
							_tmp118_ = builder;
#line 507 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp118_, "name");
#line 508 "../core/Services/Todoist.vala"
							_tmp119_ = builder;
#line 508 "../core/Services/Todoist.vala"
							_tmp120_ = q;
#line 508 "../core/Services/Todoist.vala"
							_tmp121_ = objects_queue_get_args (_tmp120_);
#line 508 "../core/Services/Todoist.vala"
							_tmp122_ = _tmp121_;
#line 508 "../core/Services/Todoist.vala"
							_tmp123_ = services_todoist_get_string_member_by_object (self, _tmp122_, "name");
#line 508 "../core/Services/Todoist.vala"
							_tmp124_ = _tmp123_;
#line 508 "../core/Services/Todoist.vala"
							json_builder_add_string_value (_tmp119_, _tmp124_);
#line 508 "../core/Services/Todoist.vala"
							_g_free0 (_tmp124_);
#line 510 "../core/Services/Todoist.vala"
							_tmp125_ = builder;
#line 510 "../core/Services/Todoist.vala"
							json_builder_set_member_name (_tmp125_, "project_id");
#line 511 "../core/Services/Todoist.vala"
							_tmp126_ = q;
#line 511 "../core/Services/Todoist.vala"
							_tmp127_ = objects_queue_get_args (_tmp126_);
#line 511 "../core/Services/Todoist.vala"
							_tmp128_ = _tmp127_;
#line 511 "../core/Services/Todoist.vala"
							if (services_todoist_get_type_by_member (self, _tmp128_, "project_id") == G_TYPE_STRING) {
#line 5499 "Todoist.c"
								JsonBuilder* _tmp129_;
								ObjectsQueue* _tmp130_;
								const gchar* _tmp131_;
								const gchar* _tmp132_;
								gchar* _tmp133_;
								gchar* _tmp134_;
#line 512 "../core/Services/Todoist.vala"
								_tmp129_ = builder;
#line 512 "../core/Services/Todoist.vala"
								_tmp130_ = q;
#line 512 "../core/Services/Todoist.vala"
								_tmp131_ = objects_queue_get_args (_tmp130_);
#line 512 "../core/Services/Todoist.vala"
								_tmp132_ = _tmp131_;
#line 512 "../core/Services/Todoist.vala"
								_tmp133_ = services_todoist_get_string_member_by_object (self, _tmp132_, "project_id");
#line 512 "../core/Services/Todoist.vala"
								_tmp134_ = _tmp133_;
#line 512 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp129_, _tmp134_);
#line 512 "../core/Services/Todoist.vala"
								_g_free0 (_tmp134_);
#line 5522 "Todoist.c"
							} else {
								JsonBuilder* _tmp135_;
								ObjectsQueue* _tmp136_;
								const gchar* _tmp137_;
								const gchar* _tmp138_;
								gchar* _tmp139_;
								gchar* _tmp140_;
#line 514 "../core/Services/Todoist.vala"
								_tmp135_ = builder;
#line 514 "../core/Services/Todoist.vala"
								_tmp136_ = q;
#line 514 "../core/Services/Todoist.vala"
								_tmp137_ = objects_queue_get_args (_tmp136_);
#line 514 "../core/Services/Todoist.vala"
								_tmp138_ = _tmp137_;
#line 514 "../core/Services/Todoist.vala"
								_tmp139_ = services_todoist_get_string_member_by_object (self, _tmp138_, "project_id");
#line 514 "../core/Services/Todoist.vala"
								_tmp140_ = _tmp139_;
#line 514 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp135_, _tmp140_);
#line 514 "../core/Services/Todoist.vala"
								_g_free0 (_tmp140_);
#line 5546 "Todoist.c"
							}
#line 517 "../core/Services/Todoist.vala"
							_tmp141_ = builder;
#line 517 "../core/Services/Todoist.vala"
							json_builder_end_object (_tmp141_);
#line 518 "../core/Services/Todoist.vala"
							_tmp142_ = builder;
#line 518 "../core/Services/Todoist.vala"
							json_builder_end_object (_tmp142_);
#line 5556 "Todoist.c"
						} else {
							ObjectsQueue* _tmp143_;
							const gchar* _tmp144_;
							const gchar* _tmp145_;
#line 519 "../core/Services/Todoist.vala"
							_tmp143_ = q;
#line 519 "../core/Services/Todoist.vala"
							_tmp144_ = objects_queue_get_query (_tmp143_);
#line 519 "../core/Services/Todoist.vala"
							_tmp145_ = _tmp144_;
#line 519 "../core/Services/Todoist.vala"
							if (g_strcmp0 (_tmp145_, "section_update") == 0) {
#line 5569 "Todoist.c"
								JsonBuilder* _tmp146_;
								JsonBuilder* _tmp147_;
								JsonBuilder* _tmp148_;
								JsonBuilder* _tmp149_;
								ObjectsQueue* _tmp150_;
								const gchar* _tmp151_;
								const gchar* _tmp152_;
								JsonBuilder* _tmp153_;
								JsonBuilder* _tmp154_;
								JsonBuilder* _tmp155_;
								JsonBuilder* _tmp156_;
								ObjectsQueue* _tmp157_;
								const gchar* _tmp158_;
								const gchar* _tmp159_;
								gchar* _tmp160_;
								gchar* _tmp161_;
								JsonBuilder* _tmp162_;
								JsonBuilder* _tmp163_;
								ObjectsQueue* _tmp164_;
								const gchar* _tmp165_;
								const gchar* _tmp166_;
								gchar* _tmp167_;
								gchar* _tmp168_;
								JsonBuilder* _tmp169_;
								JsonBuilder* _tmp170_;
#line 520 "../core/Services/Todoist.vala"
								_tmp146_ = builder;
#line 520 "../core/Services/Todoist.vala"
								json_builder_set_member_name (_tmp146_, "type");
#line 521 "../core/Services/Todoist.vala"
								_tmp147_ = builder;
#line 521 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp147_, "section_update");
#line 523 "../core/Services/Todoist.vala"
								_tmp148_ = builder;
#line 523 "../core/Services/Todoist.vala"
								json_builder_set_member_name (_tmp148_, "uuid");
#line 524 "../core/Services/Todoist.vala"
								_tmp149_ = builder;
#line 524 "../core/Services/Todoist.vala"
								_tmp150_ = q;
#line 524 "../core/Services/Todoist.vala"
								_tmp151_ = objects_queue_get_uuid (_tmp150_);
#line 524 "../core/Services/Todoist.vala"
								_tmp152_ = _tmp151_;
#line 524 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp149_, _tmp152_);
#line 526 "../core/Services/Todoist.vala"
								_tmp153_ = builder;
#line 526 "../core/Services/Todoist.vala"
								json_builder_set_member_name (_tmp153_, "args");
#line 527 "../core/Services/Todoist.vala"
								_tmp154_ = builder;
#line 527 "../core/Services/Todoist.vala"
								json_builder_begin_object (_tmp154_);
#line 528 "../core/Services/Todoist.vala"
								_tmp155_ = builder;
#line 528 "../core/Services/Todoist.vala"
								json_builder_set_member_name (_tmp155_, "id");
#line 529 "../core/Services/Todoist.vala"
								_tmp156_ = builder;
#line 529 "../core/Services/Todoist.vala"
								_tmp157_ = q;
#line 529 "../core/Services/Todoist.vala"
								_tmp158_ = objects_queue_get_args (_tmp157_);
#line 529 "../core/Services/Todoist.vala"
								_tmp159_ = _tmp158_;
#line 529 "../core/Services/Todoist.vala"
								_tmp160_ = services_todoist_get_string_member_by_object (self, _tmp159_, "id");
#line 529 "../core/Services/Todoist.vala"
								_tmp161_ = _tmp160_;
#line 529 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp156_, _tmp161_);
#line 529 "../core/Services/Todoist.vala"
								_g_free0 (_tmp161_);
#line 531 "../core/Services/Todoist.vala"
								_tmp162_ = builder;
#line 531 "../core/Services/Todoist.vala"
								json_builder_set_member_name (_tmp162_, "name");
#line 532 "../core/Services/Todoist.vala"
								_tmp163_ = builder;
#line 532 "../core/Services/Todoist.vala"
								_tmp164_ = q;
#line 532 "../core/Services/Todoist.vala"
								_tmp165_ = objects_queue_get_args (_tmp164_);
#line 532 "../core/Services/Todoist.vala"
								_tmp166_ = _tmp165_;
#line 532 "../core/Services/Todoist.vala"
								_tmp167_ = services_todoist_get_string_member_by_object (self, _tmp166_, "name");
#line 532 "../core/Services/Todoist.vala"
								_tmp168_ = _tmp167_;
#line 532 "../core/Services/Todoist.vala"
								json_builder_add_string_value (_tmp163_, _tmp168_);
#line 532 "../core/Services/Todoist.vala"
								_g_free0 (_tmp168_);
#line 534 "../core/Services/Todoist.vala"
								_tmp169_ = builder;
#line 534 "../core/Services/Todoist.vala"
								json_builder_end_object (_tmp169_);
#line 535 "../core/Services/Todoist.vala"
								_tmp170_ = builder;
#line 535 "../core/Services/Todoist.vala"
								json_builder_end_object (_tmp170_);
#line 5673 "Todoist.c"
							} else {
								ObjectsQueue* _tmp171_;
								const gchar* _tmp172_;
								const gchar* _tmp173_;
#line 536 "../core/Services/Todoist.vala"
								_tmp171_ = q;
#line 536 "../core/Services/Todoist.vala"
								_tmp172_ = objects_queue_get_query (_tmp171_);
#line 536 "../core/Services/Todoist.vala"
								_tmp173_ = _tmp172_;
#line 536 "../core/Services/Todoist.vala"
								if (g_strcmp0 (_tmp173_, "section_delete") == 0) {
#line 5686 "Todoist.c"
									JsonBuilder* _tmp174_;
									JsonBuilder* _tmp175_;
									JsonBuilder* _tmp176_;
									JsonBuilder* _tmp177_;
									ObjectsQueue* _tmp178_;
									const gchar* _tmp179_;
									const gchar* _tmp180_;
									JsonBuilder* _tmp181_;
									JsonBuilder* _tmp182_;
									JsonBuilder* _tmp183_;
									JsonBuilder* _tmp184_;
									ObjectsQueue* _tmp185_;
									const gchar* _tmp186_;
									const gchar* _tmp187_;
									gchar* _tmp188_;
									gchar* _tmp189_;
									JsonBuilder* _tmp190_;
									JsonBuilder* _tmp191_;
#line 537 "../core/Services/Todoist.vala"
									_tmp174_ = builder;
#line 537 "../core/Services/Todoist.vala"
									json_builder_set_member_name (_tmp174_, "type");
#line 538 "../core/Services/Todoist.vala"
									_tmp175_ = builder;
#line 538 "../core/Services/Todoist.vala"
									json_builder_add_string_value (_tmp175_, "section_delete");
#line 540 "../core/Services/Todoist.vala"
									_tmp176_ = builder;
#line 540 "../core/Services/Todoist.vala"
									json_builder_set_member_name (_tmp176_, "uuid");
#line 541 "../core/Services/Todoist.vala"
									_tmp177_ = builder;
#line 541 "../core/Services/Todoist.vala"
									_tmp178_ = q;
#line 541 "../core/Services/Todoist.vala"
									_tmp179_ = objects_queue_get_uuid (_tmp178_);
#line 541 "../core/Services/Todoist.vala"
									_tmp180_ = _tmp179_;
#line 541 "../core/Services/Todoist.vala"
									json_builder_add_string_value (_tmp177_, _tmp180_);
#line 543 "../core/Services/Todoist.vala"
									_tmp181_ = builder;
#line 543 "../core/Services/Todoist.vala"
									json_builder_set_member_name (_tmp181_, "args");
#line 544 "../core/Services/Todoist.vala"
									_tmp182_ = builder;
#line 544 "../core/Services/Todoist.vala"
									json_builder_begin_object (_tmp182_);
#line 546 "../core/Services/Todoist.vala"
									_tmp183_ = builder;
#line 546 "../core/Services/Todoist.vala"
									json_builder_set_member_name (_tmp183_, "id");
#line 547 "../core/Services/Todoist.vala"
									_tmp184_ = builder;
#line 547 "../core/Services/Todoist.vala"
									_tmp185_ = q;
#line 547 "../core/Services/Todoist.vala"
									_tmp186_ = objects_queue_get_args (_tmp185_);
#line 547 "../core/Services/Todoist.vala"
									_tmp187_ = _tmp186_;
#line 547 "../core/Services/Todoist.vala"
									_tmp188_ = services_todoist_get_string_member_by_object (self, _tmp187_, "id");
#line 547 "../core/Services/Todoist.vala"
									_tmp189_ = _tmp188_;
#line 547 "../core/Services/Todoist.vala"
									json_builder_add_string_value (_tmp184_, _tmp189_);
#line 547 "../core/Services/Todoist.vala"
									_g_free0 (_tmp189_);
#line 549 "../core/Services/Todoist.vala"
									_tmp190_ = builder;
#line 549 "../core/Services/Todoist.vala"
									json_builder_end_object (_tmp190_);
#line 550 "../core/Services/Todoist.vala"
									_tmp191_ = builder;
#line 550 "../core/Services/Todoist.vala"
									json_builder_end_object (_tmp191_);
#line 5763 "Todoist.c"
								} else {
									ObjectsQueue* _tmp192_;
									const gchar* _tmp193_;
									const gchar* _tmp194_;
#line 551 "../core/Services/Todoist.vala"
									_tmp192_ = q;
#line 551 "../core/Services/Todoist.vala"
									_tmp193_ = objects_queue_get_query (_tmp192_);
#line 551 "../core/Services/Todoist.vala"
									_tmp194_ = _tmp193_;
#line 551 "../core/Services/Todoist.vala"
									if (g_strcmp0 (_tmp194_, "section_move") == 0) {
#line 5776 "Todoist.c"
										JsonBuilder* _tmp195_;
										JsonBuilder* _tmp196_;
										JsonBuilder* _tmp197_;
										JsonBuilder* _tmp198_;
										ObjectsQueue* _tmp199_;
										const gchar* _tmp200_;
										const gchar* _tmp201_;
										JsonBuilder* _tmp202_;
										JsonBuilder* _tmp203_;
										JsonBuilder* _tmp204_;
										JsonBuilder* _tmp205_;
										ObjectsQueue* _tmp206_;
										const gchar* _tmp207_;
										const gchar* _tmp208_;
										gchar* _tmp209_;
										gchar* _tmp210_;
										JsonBuilder* _tmp211_;
										JsonBuilder* _tmp212_;
										ObjectsQueue* _tmp213_;
										const gchar* _tmp214_;
										const gchar* _tmp215_;
										gchar* _tmp216_;
										gchar* _tmp217_;
										JsonBuilder* _tmp218_;
										JsonBuilder* _tmp219_;
#line 552 "../core/Services/Todoist.vala"
										_tmp195_ = builder;
#line 552 "../core/Services/Todoist.vala"
										json_builder_set_member_name (_tmp195_, "type");
#line 553 "../core/Services/Todoist.vala"
										_tmp196_ = builder;
#line 553 "../core/Services/Todoist.vala"
										json_builder_add_string_value (_tmp196_, "section_move");
#line 555 "../core/Services/Todoist.vala"
										_tmp197_ = builder;
#line 555 "../core/Services/Todoist.vala"
										json_builder_set_member_name (_tmp197_, "uuid");
#line 556 "../core/Services/Todoist.vala"
										_tmp198_ = builder;
#line 556 "../core/Services/Todoist.vala"
										_tmp199_ = q;
#line 556 "../core/Services/Todoist.vala"
										_tmp200_ = objects_queue_get_uuid (_tmp199_);
#line 556 "../core/Services/Todoist.vala"
										_tmp201_ = _tmp200_;
#line 556 "../core/Services/Todoist.vala"
										json_builder_add_string_value (_tmp198_, _tmp201_);
#line 558 "../core/Services/Todoist.vala"
										_tmp202_ = builder;
#line 558 "../core/Services/Todoist.vala"
										json_builder_set_member_name (_tmp202_, "args");
#line 559 "../core/Services/Todoist.vala"
										_tmp203_ = builder;
#line 559 "../core/Services/Todoist.vala"
										json_builder_begin_object (_tmp203_);
#line 561 "../core/Services/Todoist.vala"
										_tmp204_ = builder;
#line 561 "../core/Services/Todoist.vala"
										json_builder_set_member_name (_tmp204_, "id");
#line 562 "../core/Services/Todoist.vala"
										_tmp205_ = builder;
#line 562 "../core/Services/Todoist.vala"
										_tmp206_ = q;
#line 562 "../core/Services/Todoist.vala"
										_tmp207_ = objects_queue_get_args (_tmp206_);
#line 562 "../core/Services/Todoist.vala"
										_tmp208_ = _tmp207_;
#line 562 "../core/Services/Todoist.vala"
										_tmp209_ = services_todoist_get_string_member_by_object (self, _tmp208_, "id");
#line 562 "../core/Services/Todoist.vala"
										_tmp210_ = _tmp209_;
#line 562 "../core/Services/Todoist.vala"
										json_builder_add_string_value (_tmp205_, _tmp210_);
#line 562 "../core/Services/Todoist.vala"
										_g_free0 (_tmp210_);
#line 564 "../core/Services/Todoist.vala"
										_tmp211_ = builder;
#line 564 "../core/Services/Todoist.vala"
										json_builder_set_member_name (_tmp211_, "project_id");
#line 565 "../core/Services/Todoist.vala"
										_tmp212_ = builder;
#line 565 "../core/Services/Todoist.vala"
										_tmp213_ = q;
#line 565 "../core/Services/Todoist.vala"
										_tmp214_ = objects_queue_get_args (_tmp213_);
#line 565 "../core/Services/Todoist.vala"
										_tmp215_ = _tmp214_;
#line 565 "../core/Services/Todoist.vala"
										_tmp216_ = services_todoist_get_string_member_by_object (self, _tmp215_, "project_id");
#line 565 "../core/Services/Todoist.vala"
										_tmp217_ = _tmp216_;
#line 565 "../core/Services/Todoist.vala"
										json_builder_add_string_value (_tmp212_, _tmp217_);
#line 565 "../core/Services/Todoist.vala"
										_g_free0 (_tmp217_);
#line 567 "../core/Services/Todoist.vala"
										_tmp218_ = builder;
#line 567 "../core/Services/Todoist.vala"
										json_builder_end_object (_tmp218_);
#line 568 "../core/Services/Todoist.vala"
										_tmp219_ = builder;
#line 568 "../core/Services/Todoist.vala"
										json_builder_end_object (_tmp219_);
#line 5880 "Todoist.c"
									} else {
										ObjectsQueue* _tmp220_;
										const gchar* _tmp221_;
										const gchar* _tmp222_;
#line 569 "../core/Services/Todoist.vala"
										_tmp220_ = q;
#line 569 "../core/Services/Todoist.vala"
										_tmp221_ = objects_queue_get_query (_tmp220_);
#line 569 "../core/Services/Todoist.vala"
										_tmp222_ = _tmp221_;
#line 569 "../core/Services/Todoist.vala"
										if (g_strcmp0 (_tmp222_, "item_add") == 0) {
#line 5893 "Todoist.c"
											JsonBuilder* _tmp223_;
											JsonBuilder* _tmp224_;
											JsonBuilder* _tmp225_;
											JsonBuilder* _tmp226_;
											ObjectsQueue* _tmp227_;
											const gchar* _tmp228_;
											const gchar* _tmp229_;
											JsonBuilder* _tmp230_;
											JsonBuilder* _tmp231_;
											ObjectsQueue* _tmp232_;
											const gchar* _tmp233_;
											const gchar* _tmp234_;
											JsonBuilder* _tmp235_;
											JsonBuilder* _tmp236_;
											JsonBuilder* _tmp237_;
											JsonBuilder* _tmp238_;
											ObjectsQueue* _tmp239_;
											const gchar* _tmp240_;
											const gchar* _tmp241_;
											gchar* _tmp242_;
											gchar* _tmp243_;
											JsonBuilder* _tmp244_;
											JsonBuilder* _tmp245_;
											ObjectsQueue* _tmp246_;
											const gchar* _tmp247_;
											const gchar* _tmp248_;
											gchar* _tmp249_;
											gchar* _tmp250_;
											JsonBuilder* _tmp251_;
											JsonBuilder* _tmp252_;
											ObjectsQueue* _tmp253_;
											const gchar* _tmp254_;
											const gchar* _tmp255_;
											JsonBuilder* _tmp256_;
											JsonBuilder* _tmp257_;
											ObjectsQueue* _tmp258_;
											const gchar* _tmp259_;
											const gchar* _tmp260_;
											gchar* _tmp261_;
											gchar* _tmp262_;
											JsonBuilder* _tmp263_;
											JsonBuilder* _tmp264_;
											ObjectsQueue* _tmp265_;
											const gchar* _tmp266_;
											const gchar* _tmp267_;
											gchar* _tmp268_;
											gchar* _tmp269_;
											JsonBuilder* _tmp270_;
											JsonBuilder* _tmp271_;
											ObjectsQueue* _tmp272_;
											const gchar* _tmp273_;
											const gchar* _tmp274_;
											gchar* _tmp275_;
											gchar* _tmp276_;
											JsonBuilder* _tmp277_;
											JsonBuilder* _tmp278_;
#line 570 "../core/Services/Todoist.vala"
											_tmp223_ = builder;
#line 570 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp223_, "type");
#line 571 "../core/Services/Todoist.vala"
											_tmp224_ = builder;
#line 571 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp224_, "item_add");
#line 573 "../core/Services/Todoist.vala"
											_tmp225_ = builder;
#line 573 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp225_, "temp_id");
#line 574 "../core/Services/Todoist.vala"
											_tmp226_ = builder;
#line 574 "../core/Services/Todoist.vala"
											_tmp227_ = q;
#line 574 "../core/Services/Todoist.vala"
											_tmp228_ = objects_queue_get_temp_id (_tmp227_);
#line 574 "../core/Services/Todoist.vala"
											_tmp229_ = _tmp228_;
#line 574 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp226_, _tmp229_);
#line 576 "../core/Services/Todoist.vala"
											_tmp230_ = builder;
#line 576 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp230_, "uuid");
#line 577 "../core/Services/Todoist.vala"
											_tmp231_ = builder;
#line 577 "../core/Services/Todoist.vala"
											_tmp232_ = q;
#line 577 "../core/Services/Todoist.vala"
											_tmp233_ = objects_queue_get_uuid (_tmp232_);
#line 577 "../core/Services/Todoist.vala"
											_tmp234_ = _tmp233_;
#line 577 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp231_, _tmp234_);
#line 579 "../core/Services/Todoist.vala"
											_tmp235_ = builder;
#line 579 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp235_, "args");
#line 580 "../core/Services/Todoist.vala"
											_tmp236_ = builder;
#line 580 "../core/Services/Todoist.vala"
											json_builder_begin_object (_tmp236_);
#line 582 "../core/Services/Todoist.vala"
											_tmp237_ = builder;
#line 582 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp237_, "content");
#line 583 "../core/Services/Todoist.vala"
											_tmp238_ = builder;
#line 583 "../core/Services/Todoist.vala"
											_tmp239_ = q;
#line 583 "../core/Services/Todoist.vala"
											_tmp240_ = objects_queue_get_args (_tmp239_);
#line 583 "../core/Services/Todoist.vala"
											_tmp241_ = _tmp240_;
#line 583 "../core/Services/Todoist.vala"
											_tmp242_ = services_todoist_get_string_member_by_object (self, _tmp241_, "content");
#line 583 "../core/Services/Todoist.vala"
											_tmp243_ = _tmp242_;
#line 583 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp238_, _tmp243_);
#line 583 "../core/Services/Todoist.vala"
											_g_free0 (_tmp243_);
#line 585 "../core/Services/Todoist.vala"
											_tmp244_ = builder;
#line 585 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp244_, "description");
#line 586 "../core/Services/Todoist.vala"
											_tmp245_ = builder;
#line 586 "../core/Services/Todoist.vala"
											_tmp246_ = q;
#line 586 "../core/Services/Todoist.vala"
											_tmp247_ = objects_queue_get_args (_tmp246_);
#line 586 "../core/Services/Todoist.vala"
											_tmp248_ = _tmp247_;
#line 586 "../core/Services/Todoist.vala"
											_tmp249_ = services_todoist_get_string_member_by_object (self, _tmp248_, "description");
#line 586 "../core/Services/Todoist.vala"
											_tmp250_ = _tmp249_;
#line 586 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp245_, _tmp250_);
#line 586 "../core/Services/Todoist.vala"
											_g_free0 (_tmp250_);
#line 588 "../core/Services/Todoist.vala"
											_tmp251_ = builder;
#line 588 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp251_, "priority");
#line 589 "../core/Services/Todoist.vala"
											_tmp252_ = builder;
#line 589 "../core/Services/Todoist.vala"
											_tmp253_ = q;
#line 589 "../core/Services/Todoist.vala"
											_tmp254_ = objects_queue_get_args (_tmp253_);
#line 589 "../core/Services/Todoist.vala"
											_tmp255_ = _tmp254_;
#line 589 "../core/Services/Todoist.vala"
											json_builder_add_int_value (_tmp252_, services_todoist_get_int_member_by_object (self, _tmp255_, "priority"));
#line 591 "../core/Services/Todoist.vala"
											_tmp256_ = builder;
#line 591 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp256_, "project_id");
#line 592 "../core/Services/Todoist.vala"
											_tmp257_ = builder;
#line 592 "../core/Services/Todoist.vala"
											_tmp258_ = q;
#line 592 "../core/Services/Todoist.vala"
											_tmp259_ = objects_queue_get_args (_tmp258_);
#line 592 "../core/Services/Todoist.vala"
											_tmp260_ = _tmp259_;
#line 592 "../core/Services/Todoist.vala"
											_tmp261_ = services_todoist_get_string_member_by_object (self, _tmp260_, "project_id");
#line 592 "../core/Services/Todoist.vala"
											_tmp262_ = _tmp261_;
#line 592 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp257_, _tmp262_);
#line 592 "../core/Services/Todoist.vala"
											_g_free0 (_tmp262_);
#line 594 "../core/Services/Todoist.vala"
											_tmp263_ = builder;
#line 594 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp263_, "section_id");
#line 595 "../core/Services/Todoist.vala"
											_tmp264_ = builder;
#line 595 "../core/Services/Todoist.vala"
											_tmp265_ = q;
#line 595 "../core/Services/Todoist.vala"
											_tmp266_ = objects_queue_get_args (_tmp265_);
#line 595 "../core/Services/Todoist.vala"
											_tmp267_ = _tmp266_;
#line 595 "../core/Services/Todoist.vala"
											_tmp268_ = services_todoist_get_string_member_by_object (self, _tmp267_, "section_id");
#line 595 "../core/Services/Todoist.vala"
											_tmp269_ = _tmp268_;
#line 595 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp264_, _tmp269_);
#line 595 "../core/Services/Todoist.vala"
											_g_free0 (_tmp269_);
#line 597 "../core/Services/Todoist.vala"
											_tmp270_ = builder;
#line 597 "../core/Services/Todoist.vala"
											json_builder_set_member_name (_tmp270_, "parent_id");
#line 598 "../core/Services/Todoist.vala"
											_tmp271_ = builder;
#line 598 "../core/Services/Todoist.vala"
											_tmp272_ = q;
#line 598 "../core/Services/Todoist.vala"
											_tmp273_ = objects_queue_get_args (_tmp272_);
#line 598 "../core/Services/Todoist.vala"
											_tmp274_ = _tmp273_;
#line 598 "../core/Services/Todoist.vala"
											_tmp275_ = services_todoist_get_string_member_by_object (self, _tmp274_, "parent_id");
#line 598 "../core/Services/Todoist.vala"
											_tmp276_ = _tmp275_;
#line 598 "../core/Services/Todoist.vala"
											json_builder_add_string_value (_tmp271_, _tmp276_);
#line 598 "../core/Services/Todoist.vala"
											_g_free0 (_tmp276_);
#line 600 "../core/Services/Todoist.vala"
											_tmp277_ = builder;
#line 600 "../core/Services/Todoist.vala"
											json_builder_end_object (_tmp277_);
#line 601 "../core/Services/Todoist.vala"
											_tmp278_ = builder;
#line 601 "../core/Services/Todoist.vala"
											json_builder_end_object (_tmp278_);
#line 6116 "Todoist.c"
										} else {
											ObjectsQueue* _tmp279_;
											const gchar* _tmp280_;
											const gchar* _tmp281_;
#line 602 "../core/Services/Todoist.vala"
											_tmp279_ = q;
#line 602 "../core/Services/Todoist.vala"
											_tmp280_ = objects_queue_get_query (_tmp279_);
#line 602 "../core/Services/Todoist.vala"
											_tmp281_ = _tmp280_;
#line 602 "../core/Services/Todoist.vala"
											if (g_strcmp0 (_tmp281_, "item_update") == 0) {
#line 6129 "Todoist.c"
												JsonBuilder* _tmp282_;
												JsonBuilder* _tmp283_;
												JsonBuilder* _tmp284_;
												JsonBuilder* _tmp285_;
												ObjectsQueue* _tmp286_;
												const gchar* _tmp287_;
												const gchar* _tmp288_;
												JsonBuilder* _tmp289_;
												JsonBuilder* _tmp290_;
												JsonBuilder* _tmp291_;
												JsonBuilder* _tmp292_;
												ObjectsQueue* _tmp293_;
												const gchar* _tmp294_;
												const gchar* _tmp295_;
												gchar* _tmp296_;
												gchar* _tmp297_;
												JsonBuilder* _tmp298_;
												JsonBuilder* _tmp299_;
												ObjectsQueue* _tmp300_;
												const gchar* _tmp301_;
												const gchar* _tmp302_;
												gchar* _tmp303_;
												gchar* _tmp304_;
												JsonBuilder* _tmp305_;
												JsonBuilder* _tmp306_;
												ObjectsQueue* _tmp307_;
												const gchar* _tmp308_;
												const gchar* _tmp309_;
												gchar* _tmp310_;
												gchar* _tmp311_;
												JsonBuilder* _tmp312_;
												JsonBuilder* _tmp313_;
												ObjectsQueue* _tmp314_;
												const gchar* _tmp315_;
												const gchar* _tmp316_;
												ObjectsQueue* _tmp317_;
												const gchar* _tmp318_;
												const gchar* _tmp319_;
												JsonBuilder* _tmp333_;
												JsonBuilder* _tmp334_;
												JsonBuilder* _tmp335_;
#line 603 "../core/Services/Todoist.vala"
												_tmp282_ = builder;
#line 603 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp282_, "type");
#line 604 "../core/Services/Todoist.vala"
												_tmp283_ = builder;
#line 604 "../core/Services/Todoist.vala"
												json_builder_add_string_value (_tmp283_, "item_update");
#line 606 "../core/Services/Todoist.vala"
												_tmp284_ = builder;
#line 606 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp284_, "uuid");
#line 607 "../core/Services/Todoist.vala"
												_tmp285_ = builder;
#line 607 "../core/Services/Todoist.vala"
												_tmp286_ = q;
#line 607 "../core/Services/Todoist.vala"
												_tmp287_ = objects_queue_get_uuid (_tmp286_);
#line 607 "../core/Services/Todoist.vala"
												_tmp288_ = _tmp287_;
#line 607 "../core/Services/Todoist.vala"
												json_builder_add_string_value (_tmp285_, _tmp288_);
#line 609 "../core/Services/Todoist.vala"
												_tmp289_ = builder;
#line 609 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp289_, "args");
#line 610 "../core/Services/Todoist.vala"
												_tmp290_ = builder;
#line 610 "../core/Services/Todoist.vala"
												json_builder_begin_object (_tmp290_);
#line 612 "../core/Services/Todoist.vala"
												_tmp291_ = builder;
#line 612 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp291_, "id");
#line 613 "../core/Services/Todoist.vala"
												_tmp292_ = builder;
#line 613 "../core/Services/Todoist.vala"
												_tmp293_ = q;
#line 613 "../core/Services/Todoist.vala"
												_tmp294_ = objects_queue_get_args (_tmp293_);
#line 613 "../core/Services/Todoist.vala"
												_tmp295_ = _tmp294_;
#line 613 "../core/Services/Todoist.vala"
												_tmp296_ = services_todoist_get_string_member_by_object (self, _tmp295_, "id");
#line 613 "../core/Services/Todoist.vala"
												_tmp297_ = _tmp296_;
#line 613 "../core/Services/Todoist.vala"
												json_builder_add_string_value (_tmp292_, _tmp297_);
#line 613 "../core/Services/Todoist.vala"
												_g_free0 (_tmp297_);
#line 615 "../core/Services/Todoist.vala"
												_tmp298_ = builder;
#line 615 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp298_, "content");
#line 616 "../core/Services/Todoist.vala"
												_tmp299_ = builder;
#line 616 "../core/Services/Todoist.vala"
												_tmp300_ = q;
#line 616 "../core/Services/Todoist.vala"
												_tmp301_ = objects_queue_get_args (_tmp300_);
#line 616 "../core/Services/Todoist.vala"
												_tmp302_ = _tmp301_;
#line 616 "../core/Services/Todoist.vala"
												_tmp303_ = services_todoist_get_string_member_by_object (self, _tmp302_, "content");
#line 616 "../core/Services/Todoist.vala"
												_tmp304_ = _tmp303_;
#line 616 "../core/Services/Todoist.vala"
												json_builder_add_string_value (_tmp299_, _tmp304_);
#line 616 "../core/Services/Todoist.vala"
												_g_free0 (_tmp304_);
#line 618 "../core/Services/Todoist.vala"
												_tmp305_ = builder;
#line 618 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp305_, "description");
#line 619 "../core/Services/Todoist.vala"
												_tmp306_ = builder;
#line 619 "../core/Services/Todoist.vala"
												_tmp307_ = q;
#line 619 "../core/Services/Todoist.vala"
												_tmp308_ = objects_queue_get_args (_tmp307_);
#line 619 "../core/Services/Todoist.vala"
												_tmp309_ = _tmp308_;
#line 619 "../core/Services/Todoist.vala"
												_tmp310_ = services_todoist_get_string_member_by_object (self, _tmp309_, "description");
#line 619 "../core/Services/Todoist.vala"
												_tmp311_ = _tmp310_;
#line 619 "../core/Services/Todoist.vala"
												json_builder_add_string_value (_tmp306_, _tmp311_);
#line 619 "../core/Services/Todoist.vala"
												_g_free0 (_tmp311_);
#line 621 "../core/Services/Todoist.vala"
												_tmp312_ = builder;
#line 621 "../core/Services/Todoist.vala"
												json_builder_set_member_name (_tmp312_, "priority");
#line 622 "../core/Services/Todoist.vala"
												_tmp313_ = builder;
#line 622 "../core/Services/Todoist.vala"
												_tmp314_ = q;
#line 622 "../core/Services/Todoist.vala"
												_tmp315_ = objects_queue_get_args (_tmp314_);
#line 622 "../core/Services/Todoist.vala"
												_tmp316_ = _tmp315_;
#line 622 "../core/Services/Todoist.vala"
												json_builder_add_int_value (_tmp313_, services_todoist_get_int_member_by_object (self, _tmp316_, "priority"));
#line 624 "../core/Services/Todoist.vala"
												_tmp317_ = q;
#line 624 "../core/Services/Todoist.vala"
												_tmp318_ = objects_queue_get_args (_tmp317_);
#line 624 "../core/Services/Todoist.vala"
												_tmp319_ = _tmp318_;
#line 624 "../core/Services/Todoist.vala"
												if (services_todoist_is_null_member (self, _tmp319_, "due")) {
#line 6283 "Todoist.c"
													JsonBuilder* _tmp320_;
													JsonBuilder* _tmp321_;
#line 625 "../core/Services/Todoist.vala"
													_tmp320_ = builder;
#line 625 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp320_, "due");
#line 626 "../core/Services/Todoist.vala"
													_tmp321_ = builder;
#line 626 "../core/Services/Todoist.vala"
													json_builder_add_null_value (_tmp321_);
#line 6294 "Todoist.c"
												} else {
													JsonBuilder* _tmp322_;
													JsonBuilder* _tmp323_;
													JsonObject* due = NULL;
													ObjectsQueue* _tmp324_;
													const gchar* _tmp325_;
													const gchar* _tmp326_;
													JsonObject* _tmp327_;
													JsonBuilder* _tmp328_;
													JsonBuilder* _tmp329_;
													JsonObject* _tmp330_;
													const gchar* _tmp331_;
													JsonBuilder* _tmp332_;
#line 628 "../core/Services/Todoist.vala"
													_tmp322_ = builder;
#line 628 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp322_, "due");
#line 629 "../core/Services/Todoist.vala"
													_tmp323_ = builder;
#line 629 "../core/Services/Todoist.vala"
													json_builder_begin_object (_tmp323_);
#line 631 "../core/Services/Todoist.vala"
													_tmp324_ = q;
#line 631 "../core/Services/Todoist.vala"
													_tmp325_ = objects_queue_get_args (_tmp324_);
#line 631 "../core/Services/Todoist.vala"
													_tmp326_ = _tmp325_;
#line 631 "../core/Services/Todoist.vala"
													_tmp327_ = services_todoist_get_object_member_by_object (self, _tmp326_, "due");
#line 631 "../core/Services/Todoist.vala"
													due = _tmp327_;
#line 633 "../core/Services/Todoist.vala"
													_tmp328_ = builder;
#line 633 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp328_, "date");
#line 634 "../core/Services/Todoist.vala"
													_tmp329_ = builder;
#line 634 "../core/Services/Todoist.vala"
													_tmp330_ = due;
#line 634 "../core/Services/Todoist.vala"
													_tmp331_ = json_object_get_string_member (_tmp330_, "date");
#line 634 "../core/Services/Todoist.vala"
													json_builder_add_string_value (_tmp329_, _tmp331_);
#line 636 "../core/Services/Todoist.vala"
													_tmp332_ = builder;
#line 636 "../core/Services/Todoist.vala"
													json_builder_end_object (_tmp332_);
#line 624 "../core/Services/Todoist.vala"
													_json_object_unref0 (due);
#line 6344 "Todoist.c"
												}
#line 639 "../core/Services/Todoist.vala"
												_tmp333_ = builder;
#line 639 "../core/Services/Todoist.vala"
												json_builder_end_object (_tmp333_);
#line 640 "../core/Services/Todoist.vala"
												_tmp334_ = builder;
#line 640 "../core/Services/Todoist.vala"
												json_builder_end_object (_tmp334_);
#line 641 "../core/Services/Todoist.vala"
												_tmp335_ = builder;
#line 641 "../core/Services/Todoist.vala"
												json_builder_begin_object (_tmp335_);
#line 6358 "Todoist.c"
											} else {
												ObjectsQueue* _tmp336_;
												const gchar* _tmp337_;
												const gchar* _tmp338_;
#line 642 "../core/Services/Todoist.vala"
												_tmp336_ = q;
#line 642 "../core/Services/Todoist.vala"
												_tmp337_ = objects_queue_get_query (_tmp336_);
#line 642 "../core/Services/Todoist.vala"
												_tmp338_ = _tmp337_;
#line 642 "../core/Services/Todoist.vala"
												if (g_strcmp0 (_tmp338_, "item_delete") == 0) {
#line 6371 "Todoist.c"
													JsonBuilder* _tmp339_;
													JsonBuilder* _tmp340_;
													JsonBuilder* _tmp341_;
													JsonBuilder* _tmp342_;
													ObjectsQueue* _tmp343_;
													const gchar* _tmp344_;
													const gchar* _tmp345_;
													JsonBuilder* _tmp346_;
													JsonBuilder* _tmp347_;
													JsonBuilder* _tmp348_;
													JsonBuilder* _tmp349_;
													ObjectsQueue* _tmp350_;
													const gchar* _tmp351_;
													const gchar* _tmp352_;
													gchar* _tmp353_;
													gchar* _tmp354_;
													JsonBuilder* _tmp355_;
													JsonBuilder* _tmp356_;
#line 643 "../core/Services/Todoist.vala"
													_tmp339_ = builder;
#line 643 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp339_, "type");
#line 644 "../core/Services/Todoist.vala"
													_tmp340_ = builder;
#line 644 "../core/Services/Todoist.vala"
													json_builder_add_string_value (_tmp340_, "item_delete");
#line 646 "../core/Services/Todoist.vala"
													_tmp341_ = builder;
#line 646 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp341_, "uuid");
#line 647 "../core/Services/Todoist.vala"
													_tmp342_ = builder;
#line 647 "../core/Services/Todoist.vala"
													_tmp343_ = q;
#line 647 "../core/Services/Todoist.vala"
													_tmp344_ = objects_queue_get_uuid (_tmp343_);
#line 647 "../core/Services/Todoist.vala"
													_tmp345_ = _tmp344_;
#line 647 "../core/Services/Todoist.vala"
													json_builder_add_string_value (_tmp342_, _tmp345_);
#line 649 "../core/Services/Todoist.vala"
													_tmp346_ = builder;
#line 649 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp346_, "args");
#line 650 "../core/Services/Todoist.vala"
													_tmp347_ = builder;
#line 650 "../core/Services/Todoist.vala"
													json_builder_begin_object (_tmp347_);
#line 652 "../core/Services/Todoist.vala"
													_tmp348_ = builder;
#line 652 "../core/Services/Todoist.vala"
													json_builder_set_member_name (_tmp348_, "id");
#line 653 "../core/Services/Todoist.vala"
													_tmp349_ = builder;
#line 653 "../core/Services/Todoist.vala"
													_tmp350_ = q;
#line 653 "../core/Services/Todoist.vala"
													_tmp351_ = objects_queue_get_args (_tmp350_);
#line 653 "../core/Services/Todoist.vala"
													_tmp352_ = _tmp351_;
#line 653 "../core/Services/Todoist.vala"
													_tmp353_ = services_todoist_get_string_member_by_object (self, _tmp352_, "id");
#line 653 "../core/Services/Todoist.vala"
													_tmp354_ = _tmp353_;
#line 653 "../core/Services/Todoist.vala"
													json_builder_add_string_value (_tmp349_, _tmp354_);
#line 653 "../core/Services/Todoist.vala"
													_g_free0 (_tmp354_);
#line 655 "../core/Services/Todoist.vala"
													_tmp355_ = builder;
#line 655 "../core/Services/Todoist.vala"
													json_builder_end_object (_tmp355_);
#line 656 "../core/Services/Todoist.vala"
													_tmp356_ = builder;
#line 656 "../core/Services/Todoist.vala"
													json_builder_end_object (_tmp356_);
#line 6448 "Todoist.c"
												} else {
													ObjectsQueue* _tmp357_;
													const gchar* _tmp358_;
													const gchar* _tmp359_;
#line 657 "../core/Services/Todoist.vala"
													_tmp357_ = q;
#line 657 "../core/Services/Todoist.vala"
													_tmp358_ = objects_queue_get_query (_tmp357_);
#line 657 "../core/Services/Todoist.vala"
													_tmp359_ = _tmp358_;
#line 657 "../core/Services/Todoist.vala"
													if (g_strcmp0 (_tmp359_, "item_move") == 0) {
#line 6461 "Todoist.c"
														JsonBuilder* _tmp360_;
														JsonBuilder* _tmp361_;
														JsonBuilder* _tmp362_;
														JsonBuilder* _tmp363_;
														ObjectsQueue* _tmp364_;
														const gchar* _tmp365_;
														const gchar* _tmp366_;
														JsonBuilder* _tmp367_;
														JsonBuilder* _tmp368_;
														JsonBuilder* _tmp369_;
														JsonBuilder* _tmp370_;
														ObjectsQueue* _tmp371_;
														const gchar* _tmp372_;
														const gchar* _tmp373_;
														gchar* _tmp374_;
														gchar* _tmp375_;
														gchar* type = NULL;
														ObjectsQueue* _tmp376_;
														const gchar* _tmp377_;
														const gchar* _tmp378_;
														gchar* _tmp379_;
														JsonBuilder* _tmp380_;
														const gchar* _tmp381_;
														JsonBuilder* _tmp382_;
														ObjectsQueue* _tmp383_;
														const gchar* _tmp384_;
														const gchar* _tmp385_;
														const gchar* _tmp386_;
														gchar* _tmp387_;
														gchar* _tmp388_;
														JsonBuilder* _tmp389_;
														JsonBuilder* _tmp390_;
#line 658 "../core/Services/Todoist.vala"
														_tmp360_ = builder;
#line 658 "../core/Services/Todoist.vala"
														json_builder_set_member_name (_tmp360_, "type");
#line 659 "../core/Services/Todoist.vala"
														_tmp361_ = builder;
#line 659 "../core/Services/Todoist.vala"
														json_builder_add_string_value (_tmp361_, "item_move");
#line 661 "../core/Services/Todoist.vala"
														_tmp362_ = builder;
#line 661 "../core/Services/Todoist.vala"
														json_builder_set_member_name (_tmp362_, "uuid");
#line 662 "../core/Services/Todoist.vala"
														_tmp363_ = builder;
#line 662 "../core/Services/Todoist.vala"
														_tmp364_ = q;
#line 662 "../core/Services/Todoist.vala"
														_tmp365_ = objects_queue_get_uuid (_tmp364_);
#line 662 "../core/Services/Todoist.vala"
														_tmp366_ = _tmp365_;
#line 662 "../core/Services/Todoist.vala"
														json_builder_add_string_value (_tmp363_, _tmp366_);
#line 664 "../core/Services/Todoist.vala"
														_tmp367_ = builder;
#line 664 "../core/Services/Todoist.vala"
														json_builder_set_member_name (_tmp367_, "args");
#line 665 "../core/Services/Todoist.vala"
														_tmp368_ = builder;
#line 665 "../core/Services/Todoist.vala"
														json_builder_begin_object (_tmp368_);
#line 667 "../core/Services/Todoist.vala"
														_tmp369_ = builder;
#line 667 "../core/Services/Todoist.vala"
														json_builder_set_member_name (_tmp369_, "id");
#line 668 "../core/Services/Todoist.vala"
														_tmp370_ = builder;
#line 668 "../core/Services/Todoist.vala"
														_tmp371_ = q;
#line 668 "../core/Services/Todoist.vala"
														_tmp372_ = objects_queue_get_args (_tmp371_);
#line 668 "../core/Services/Todoist.vala"
														_tmp373_ = _tmp372_;
#line 668 "../core/Services/Todoist.vala"
														_tmp374_ = services_todoist_get_string_member_by_object (self, _tmp373_, "id");
#line 668 "../core/Services/Todoist.vala"
														_tmp375_ = _tmp374_;
#line 668 "../core/Services/Todoist.vala"
														json_builder_add_string_value (_tmp370_, _tmp375_);
#line 668 "../core/Services/Todoist.vala"
														_g_free0 (_tmp375_);
#line 670 "../core/Services/Todoist.vala"
														_tmp376_ = q;
#line 670 "../core/Services/Todoist.vala"
														_tmp377_ = objects_queue_get_args (_tmp376_);
#line 670 "../core/Services/Todoist.vala"
														_tmp378_ = _tmp377_;
#line 670 "../core/Services/Todoist.vala"
														_tmp379_ = services_todoist_get_string_member_by_object (self, _tmp378_, "type");
#line 670 "../core/Services/Todoist.vala"
														type = _tmp379_;
#line 672 "../core/Services/Todoist.vala"
														_tmp380_ = builder;
#line 672 "../core/Services/Todoist.vala"
														_tmp381_ = type;
#line 672 "../core/Services/Todoist.vala"
														json_builder_set_member_name (_tmp380_, _tmp381_);
#line 673 "../core/Services/Todoist.vala"
														_tmp382_ = builder;
#line 673 "../core/Services/Todoist.vala"
														_tmp383_ = q;
#line 673 "../core/Services/Todoist.vala"
														_tmp384_ = objects_queue_get_args (_tmp383_);
#line 673 "../core/Services/Todoist.vala"
														_tmp385_ = _tmp384_;
#line 673 "../core/Services/Todoist.vala"
														_tmp386_ = type;
#line 673 "../core/Services/Todoist.vala"
														_tmp387_ = services_todoist_get_string_member_by_object (self, _tmp385_, _tmp386_);
#line 673 "../core/Services/Todoist.vala"
														_tmp388_ = _tmp387_;
#line 673 "../core/Services/Todoist.vala"
														json_builder_add_string_value (_tmp382_, _tmp388_);
#line 673 "../core/Services/Todoist.vala"
														_g_free0 (_tmp388_);
#line 675 "../core/Services/Todoist.vala"
														_tmp389_ = builder;
#line 675 "../core/Services/Todoist.vala"
														json_builder_end_object (_tmp389_);
#line 676 "../core/Services/Todoist.vala"
														_tmp390_ = builder;
#line 676 "../core/Services/Todoist.vala"
														json_builder_end_object (_tmp390_);
#line 657 "../core/Services/Todoist.vala"
														_g_free0 (type);
#line 6588 "Todoist.c"
													} else {
														gboolean _tmp391_ = FALSE;
														ObjectsQueue* _tmp392_;
														const gchar* _tmp393_;
														const gchar* _tmp394_;
#line 677 "../core/Services/Todoist.vala"
														_tmp392_ = q;
#line 677 "../core/Services/Todoist.vala"
														_tmp393_ = objects_queue_get_query (_tmp392_);
#line 677 "../core/Services/Todoist.vala"
														_tmp394_ = _tmp393_;
#line 677 "../core/Services/Todoist.vala"
														if (g_strcmp0 (_tmp394_, "item_complete") == 0) {
#line 677 "../core/Services/Todoist.vala"
															_tmp391_ = TRUE;
#line 6604 "Todoist.c"
														} else {
															ObjectsQueue* _tmp395_;
															const gchar* _tmp396_;
															const gchar* _tmp397_;
#line 677 "../core/Services/Todoist.vala"
															_tmp395_ = q;
#line 677 "../core/Services/Todoist.vala"
															_tmp396_ = objects_queue_get_query (_tmp395_);
#line 677 "../core/Services/Todoist.vala"
															_tmp397_ = _tmp396_;
#line 677 "../core/Services/Todoist.vala"
															_tmp391_ = g_strcmp0 (_tmp397_, "item_uncomplete") == 0;
#line 6617 "Todoist.c"
														}
#line 677 "../core/Services/Todoist.vala"
														if (_tmp391_) {
#line 6621 "Todoist.c"
															JsonBuilder* _tmp398_;
															JsonBuilder* _tmp399_;
															ObjectsQueue* _tmp400_;
															const gchar* _tmp401_;
															const gchar* _tmp402_;
															JsonBuilder* _tmp403_;
															JsonBuilder* _tmp404_;
															ObjectsQueue* _tmp405_;
															const gchar* _tmp406_;
															const gchar* _tmp407_;
															JsonBuilder* _tmp408_;
															JsonBuilder* _tmp409_;
															JsonBuilder* _tmp410_;
															JsonBuilder* _tmp411_;
															ObjectsQueue* _tmp412_;
															const gchar* _tmp413_;
															const gchar* _tmp414_;
															gchar* _tmp415_;
															gchar* _tmp416_;
															JsonBuilder* _tmp417_;
															JsonBuilder* _tmp418_;
#line 678 "../core/Services/Todoist.vala"
															_tmp398_ = builder;
#line 678 "../core/Services/Todoist.vala"
															json_builder_set_member_name (_tmp398_, "type");
#line 679 "../core/Services/Todoist.vala"
															_tmp399_ = builder;
#line 679 "../core/Services/Todoist.vala"
															_tmp400_ = q;
#line 679 "../core/Services/Todoist.vala"
															_tmp401_ = objects_queue_get_query (_tmp400_);
#line 679 "../core/Services/Todoist.vala"
															_tmp402_ = _tmp401_;
#line 679 "../core/Services/Todoist.vala"
															json_builder_add_string_value (_tmp399_, _tmp402_);
#line 681 "../core/Services/Todoist.vala"
															_tmp403_ = builder;
#line 681 "../core/Services/Todoist.vala"
															json_builder_set_member_name (_tmp403_, "uuid");
#line 682 "../core/Services/Todoist.vala"
															_tmp404_ = builder;
#line 682 "../core/Services/Todoist.vala"
															_tmp405_ = q;
#line 682 "../core/Services/Todoist.vala"
															_tmp406_ = objects_queue_get_uuid (_tmp405_);
#line 682 "../core/Services/Todoist.vala"
															_tmp407_ = _tmp406_;
#line 682 "../core/Services/Todoist.vala"
															json_builder_add_string_value (_tmp404_, _tmp407_);
#line 684 "../core/Services/Todoist.vala"
															_tmp408_ = builder;
#line 684 "../core/Services/Todoist.vala"
															json_builder_set_member_name (_tmp408_, "args");
#line 685 "../core/Services/Todoist.vala"
															_tmp409_ = builder;
#line 685 "../core/Services/Todoist.vala"
															json_builder_begin_object (_tmp409_);
#line 687 "../core/Services/Todoist.vala"
															_tmp410_ = builder;
#line 687 "../core/Services/Todoist.vala"
															json_builder_set_member_name (_tmp410_, "id");
#line 688 "../core/Services/Todoist.vala"
															_tmp411_ = builder;
#line 688 "../core/Services/Todoist.vala"
															_tmp412_ = q;
#line 688 "../core/Services/Todoist.vala"
															_tmp413_ = objects_queue_get_args (_tmp412_);
#line 688 "../core/Services/Todoist.vala"
															_tmp414_ = _tmp413_;
#line 688 "../core/Services/Todoist.vala"
															_tmp415_ = services_todoist_get_string_member_by_object (self, _tmp414_, "id");
#line 688 "../core/Services/Todoist.vala"
															_tmp416_ = _tmp415_;
#line 688 "../core/Services/Todoist.vala"
															json_builder_add_string_value (_tmp411_, _tmp416_);
#line 688 "../core/Services/Todoist.vala"
															_g_free0 (_tmp416_);
#line 690 "../core/Services/Todoist.vala"
															_tmp417_ = builder;
#line 690 "../core/Services/Todoist.vala"
															json_builder_end_object (_tmp417_);
#line 691 "../core/Services/Todoist.vala"
															_tmp418_ = builder;
#line 691 "../core/Services/Todoist.vala"
															json_builder_end_object (_tmp418_);
#line 6707 "Todoist.c"
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 694 "../core/Services/Todoist.vala"
			_tmp419_ = builder;
#line 694 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp419_);
#line 435 "../core/Services/Todoist.vala"
			_g_object_unref0 (q);
#line 6726 "Todoist.c"
		}
	}
#line 697 "../core/Services/Todoist.vala"
	_tmp420_ = builder;
#line 697 "../core/Services/Todoist.vala"
	json_builder_end_array (_tmp420_);
#line 698 "../core/Services/Todoist.vala"
	_tmp421_ = builder;
#line 698 "../core/Services/Todoist.vala"
	json_builder_end_object (_tmp421_);
#line 700 "../core/Services/Todoist.vala"
	_tmp422_ = json_generator_new ();
#line 700 "../core/Services/Todoist.vala"
	generator = _tmp422_;
#line 701 "../core/Services/Todoist.vala"
	_tmp423_ = builder;
#line 701 "../core/Services/Todoist.vala"
	_tmp424_ = json_builder_get_root (_tmp423_);
#line 701 "../core/Services/Todoist.vala"
	root = _tmp424_;
#line 702 "../core/Services/Todoist.vala"
	json_generator_set_root (generator, root);
#line 704 "../core/Services/Todoist.vala"
	_tmp425_ = json_generator_to_data (generator, NULL);
#line 704 "../core/Services/Todoist.vala"
	result = _tmp425_;
#line 704 "../core/Services/Todoist.vala"
	__vala_JsonNode_free0 (root);
#line 704 "../core/Services/Todoist.vala"
	_g_object_unref0 (generator);
#line 704 "../core/Services/Todoist.vala"
	_g_object_unref0 (builder);
#line 704 "../core/Services/Todoist.vala"
	return result;
#line 6761 "Todoist.c"
}

JsonObject*
services_todoist_get_object_by_string (ServicesTodoist* self,
                                       const gchar* object)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* _tmp3_;
	JsonObject* _tmp4_;
	JsonObject* _tmp5_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
#line 707 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 707 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 708 "../core/Services/Todoist.vala"
	_tmp0_ = json_parser_new ();
#line 708 "../core/Services/Todoist.vala"
	parser = _tmp0_;
#line 6783 "Todoist.c"
	{
#line 711 "../core/Services/Todoist.vala"
		json_parser_load_from_data (parser, object, (gssize) -1, &_inner_error0_);
#line 711 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6789 "Todoist.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 710 "../core/Services/Todoist.vala"
		e = _inner_error0_;
#line 710 "../core/Services/Todoist.vala"
		_inner_error0_ = NULL;
#line 713 "../core/Services/Todoist.vala"
		_tmp1_ = e;
#line 713 "../core/Services/Todoist.vala"
		_tmp2_ = _tmp1_->message;
#line 713 "../core/Services/Todoist.vala"
		g_debug ("Todoist.vala:713: %s", _tmp2_);
#line 710 "../core/Services/Todoist.vala"
		_g_error_free0 (e);
#line 6811 "Todoist.c"
	}
	__finally0:
#line 710 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "../core/Services/Todoist.vala"
		_g_object_unref0 (parser);
#line 710 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 710 "../core/Services/Todoist.vala"
		g_clear_error (&_inner_error0_);
#line 710 "../core/Services/Todoist.vala"
		return NULL;
#line 6824 "Todoist.c"
	}
#line 716 "../core/Services/Todoist.vala"
	_tmp3_ = json_parser_get_root (parser);
#line 716 "../core/Services/Todoist.vala"
	_tmp4_ = json_node_get_object (_tmp3_);
#line 716 "../core/Services/Todoist.vala"
	_tmp5_ = _json_object_ref0 (_tmp4_);
#line 716 "../core/Services/Todoist.vala"
	result = _tmp5_;
#line 716 "../core/Services/Todoist.vala"
	_g_object_unref0 (parser);
#line 716 "../core/Services/Todoist.vala"
	return result;
#line 6838 "Todoist.c"
}

gint64
services_todoist_get_int_member_by_object (ServicesTodoist* self,
                                           const gchar* object,
                                           const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	gint64 _tmp2_;
	gint64 result;
#line 719 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 719 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, 0LL);
#line 719 "../core/Services/Todoist.vala"
	g_return_val_if_fail (member != NULL, 0LL);
#line 720 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist_get_object_by_string (self, object);
#line 720 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 720 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_int_member (_tmp1_, member);
#line 720 "../core/Services/Todoist.vala"
	_json_object_unref0 (_tmp1_);
#line 720 "../core/Services/Todoist.vala"
	result = _tmp2_;
#line 720 "../core/Services/Todoist.vala"
	return result;
#line 6868 "Todoist.c"
}

gchar*
services_todoist_get_string_member_by_object (ServicesTodoist* self,
                                              const gchar* object,
                                              const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 723 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 723 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 723 "../core/Services/Todoist.vala"
	g_return_val_if_fail (member != NULL, NULL);
#line 724 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist_get_object_by_string (self, object);
#line 724 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 724 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_string_member (_tmp1_, member);
#line 724 "../core/Services/Todoist.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 724 "../core/Services/Todoist.vala"
	_tmp4_ = _tmp3_;
#line 724 "../core/Services/Todoist.vala"
	_json_object_unref0 (_tmp1_);
#line 724 "../core/Services/Todoist.vala"
	result = _tmp4_;
#line 724 "../core/Services/Todoist.vala"
	return result;
#line 6904 "Todoist.c"
}

JsonObject*
services_todoist_get_object_member_by_object (ServicesTodoist* self,
                                              const gchar* object,
                                              const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
	JsonObject* _tmp3_;
	JsonObject* _tmp4_;
	JsonObject* result;
#line 727 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 727 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 727 "../core/Services/Todoist.vala"
	g_return_val_if_fail (member != NULL, NULL);
#line 728 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist_get_object_by_string (self, object);
#line 728 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 728 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_object_member (_tmp1_, member);
#line 728 "../core/Services/Todoist.vala"
	_tmp3_ = _json_object_ref0 (_tmp2_);
#line 728 "../core/Services/Todoist.vala"
	_tmp4_ = _tmp3_;
#line 728 "../core/Services/Todoist.vala"
	_json_object_unref0 (_tmp1_);
#line 728 "../core/Services/Todoist.vala"
	result = _tmp4_;
#line 728 "../core/Services/Todoist.vala"
	return result;
#line 6940 "Todoist.c"
}

GType
services_todoist_get_type_by_member (ServicesTodoist* self,
                                     const gchar* object,
                                     const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonNode* _tmp2_;
	GType _tmp3_;
	GType result;
#line 731 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 731 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, 0UL);
#line 731 "../core/Services/Todoist.vala"
	g_return_val_if_fail (member != NULL, 0UL);
#line 732 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist_get_object_by_string (self, object);
#line 732 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 732 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_member (_tmp1_, member);
#line 732 "../core/Services/Todoist.vala"
	_tmp3_ = json_node_get_value_type (_tmp2_);
#line 732 "../core/Services/Todoist.vala"
	_json_object_unref0 (_tmp1_);
#line 732 "../core/Services/Todoist.vala"
	result = _tmp3_;
#line 732 "../core/Services/Todoist.vala"
	return result;
#line 6973 "Todoist.c"
}

gboolean
services_todoist_is_null_member (ServicesTodoist* self,
                                 const gchar* object,
                                 const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 735 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 735 "../core/Services/Todoist.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 735 "../core/Services/Todoist.vala"
	g_return_val_if_fail (member != NULL, FALSE);
#line 736 "../core/Services/Todoist.vala"
	_tmp0_ = services_todoist_get_object_by_string (self, object);
#line 736 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 736 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_null_member (_tmp1_, member);
#line 736 "../core/Services/Todoist.vala"
	_json_object_unref0 (_tmp1_);
#line 736 "../core/Services/Todoist.vala"
	result = _tmp2_;
#line 736 "../core/Services/Todoist.vala"
	return result;
#line 7003 "Todoist.c"
}

static void
services_todoist_add_item_if_not_exists (ServicesTodoist* self,
                                         JsonNode* node)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp11_;
#line 739 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 739 "../core/Services/Todoist.vala"
	g_return_if_fail (node != NULL);
#line 740 "../core/Services/Todoist.vala"
	_tmp0_ = json_node_get_object (node);
#line 740 "../core/Services/Todoist.vala"
	if (!json_object_get_null_member (_tmp0_, "parent_id")) {
#line 7020 "Todoist.c"
		ObjectsItem* item = NULL;
		ServicesStore* _tmp1_;
		JsonObject* _tmp2_;
		const gchar* _tmp3_;
		ObjectsItem* _tmp4_;
		ObjectsItem* _tmp5_;
#line 741 "../core/Services/Todoist.vala"
		_tmp1_ = services_store_instance ();
#line 741 "../core/Services/Todoist.vala"
		_tmp2_ = json_node_get_object (node);
#line 741 "../core/Services/Todoist.vala"
		_tmp3_ = json_object_get_string_member (_tmp2_, "parent_id");
#line 741 "../core/Services/Todoist.vala"
		_tmp4_ = services_store_get_item (_tmp1_, _tmp3_);
#line 741 "../core/Services/Todoist.vala"
		item = _tmp4_;
#line 742 "../core/Services/Todoist.vala"
		_tmp5_ = item;
#line 742 "../core/Services/Todoist.vala"
		if (_tmp5_ != NULL) {
#line 7041 "Todoist.c"
			ObjectsItem* _tmp6_;
			ObjectsItem* _tmp7_;
			ObjectsItem* _tmp8_;
			ObjectsItem* _tmp9_;
			ObjectsItem* _tmp10_;
#line 743 "../core/Services/Todoist.vala"
			_tmp6_ = item;
#line 743 "../core/Services/Todoist.vala"
			_tmp7_ = objects_item_new_from_json (node);
#line 743 "../core/Services/Todoist.vala"
			_tmp8_ = _tmp7_;
#line 743 "../core/Services/Todoist.vala"
			_tmp9_ = objects_item_add_item_if_not_exists (_tmp6_, _tmp8_, TRUE);
#line 743 "../core/Services/Todoist.vala"
			_tmp10_ = _tmp9_;
#line 743 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp10_);
#line 743 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp8_);
#line 7061 "Todoist.c"
		}
#line 746 "../core/Services/Todoist.vala"
		_g_object_unref0 (item);
#line 746 "../core/Services/Todoist.vala"
		return;
#line 7067 "Todoist.c"
	}
#line 749 "../core/Services/Todoist.vala"
	_tmp11_ = json_node_get_object (node);
#line 749 "../core/Services/Todoist.vala"
	if (!json_object_get_null_member (_tmp11_, "section_id")) {
#line 7073 "Todoist.c"
		ObjectsSection* section = NULL;
		ServicesStore* _tmp12_;
		JsonObject* _tmp13_;
		const gchar* _tmp14_;
		ObjectsSection* _tmp15_;
		ObjectsSection* _tmp16_;
#line 750 "../core/Services/Todoist.vala"
		_tmp12_ = services_store_instance ();
#line 750 "../core/Services/Todoist.vala"
		_tmp13_ = json_node_get_object (node);
#line 750 "../core/Services/Todoist.vala"
		_tmp14_ = json_object_get_string_member (_tmp13_, "section_id");
#line 750 "../core/Services/Todoist.vala"
		_tmp15_ = services_store_get_section (_tmp12_, _tmp14_);
#line 750 "../core/Services/Todoist.vala"
		section = _tmp15_;
#line 751 "../core/Services/Todoist.vala"
		_tmp16_ = section;
#line 751 "../core/Services/Todoist.vala"
		if (_tmp16_ != NULL) {
#line 7094 "Todoist.c"
			ObjectsSection* _tmp17_;
			ObjectsItem* _tmp18_;
			ObjectsItem* _tmp19_;
			ObjectsItem* _tmp20_;
			ObjectsItem* _tmp21_;
#line 752 "../core/Services/Todoist.vala"
			_tmp17_ = section;
#line 752 "../core/Services/Todoist.vala"
			_tmp18_ = objects_item_new_from_json (node);
#line 752 "../core/Services/Todoist.vala"
			_tmp19_ = _tmp18_;
#line 752 "../core/Services/Todoist.vala"
			_tmp20_ = objects_section_add_item_if_not_exists (_tmp17_, _tmp19_, TRUE);
#line 752 "../core/Services/Todoist.vala"
			_tmp21_ = _tmp20_;
#line 752 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp21_);
#line 752 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp19_);
#line 7114 "Todoist.c"
		}
#line 749 "../core/Services/Todoist.vala"
		_g_object_unref0 (section);
#line 7118 "Todoist.c"
	} else {
		ObjectsProject* project = NULL;
		ServicesStore* _tmp22_;
		JsonObject* _tmp23_;
		const gchar* _tmp24_;
		ObjectsProject* _tmp25_;
		ObjectsProject* _tmp26_;
#line 755 "../core/Services/Todoist.vala"
		_tmp22_ = services_store_instance ();
#line 755 "../core/Services/Todoist.vala"
		_tmp23_ = json_node_get_object (node);
#line 755 "../core/Services/Todoist.vala"
		_tmp24_ = json_object_get_string_member (_tmp23_, "project_id");
#line 755 "../core/Services/Todoist.vala"
		_tmp25_ = services_store_get_project (_tmp22_, _tmp24_);
#line 755 "../core/Services/Todoist.vala"
		project = _tmp25_;
#line 756 "../core/Services/Todoist.vala"
		_tmp26_ = project;
#line 756 "../core/Services/Todoist.vala"
		if (_tmp26_ != NULL) {
#line 7140 "Todoist.c"
			ObjectsProject* _tmp27_;
			ObjectsItem* _tmp28_;
			ObjectsItem* _tmp29_;
			ObjectsItem* _tmp30_;
			ObjectsItem* _tmp31_;
#line 757 "../core/Services/Todoist.vala"
			_tmp27_ = project;
#line 757 "../core/Services/Todoist.vala"
			_tmp28_ = objects_item_new_from_json (node);
#line 757 "../core/Services/Todoist.vala"
			_tmp29_ = _tmp28_;
#line 757 "../core/Services/Todoist.vala"
			_tmp30_ = objects_project_add_item_if_not_exists (_tmp27_, _tmp29_, TRUE);
#line 757 "../core/Services/Todoist.vala"
			_tmp31_ = _tmp30_;
#line 757 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp31_);
#line 757 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp29_);
#line 7160 "Todoist.c"
		}
#line 749 "../core/Services/Todoist.vala"
		_g_object_unref0 (project);
#line 7164 "Todoist.c"
	}
}

static void
services_todoist_add_data_free (gpointer _data)
{
	ServicesTodoistAddData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistAddData, _data_);
#line 7181 "Todoist.c"
}

void
services_todoist_add (ServicesTodoist* self,
                      ObjectsBaseObject* object,
                      GAsyncReadyCallback _callback_,
                      gpointer _user_data_)
{
	ServicesTodoistAddData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (object != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistAddData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_add_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (object);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_data_->object = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_add_co (_data_);
#line 7215 "Todoist.c"
}

HttpResponse*
services_todoist_add_finish (ServicesTodoist* self,
                             GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistAddData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 7232 "Todoist.c"
}

static void
services_todoist_add_ready (GObject* source_object,
                            GAsyncResult* _res_,
                            gpointer _user_data_)
{
	ServicesTodoistAddData* _data_;
#line 778 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 778 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 778 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 778 "../core/Services/Todoist.vala"
	services_todoist_add_co (_data_);
#line 7249 "Todoist.c"
}

static gboolean
services_todoist_add_co (ServicesTodoistAddData* _data_)
{
#line 762 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 762 "../core/Services/Todoist.vala"
		case 0:
#line 7259 "Todoist.c"
		goto _state_0;
#line 762 "../core/Services/Todoist.vala"
		case 1:
#line 7263 "Todoist.c"
		goto _state_1;
		default:
#line 762 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 7268 "Todoist.c"
	}
	_state_0:
#line 763 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 763 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 763 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 763 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 763 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 763 "../core/Services/Todoist.vala"
	_data_->temp_id = _data_->_tmp3_;
#line 764 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = util_get_default ();
#line 764 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 764 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = util_generate_string (_data_->_tmp5_);
#line 764 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 764 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp5_);
#line 764 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp7_;
#line 766 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _data_->temp_id;
#line 766 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->uuid;
#line 766 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = objects_base_object_get_add_json (_data_->object, _data_->_tmp8_, _data_->_tmp9_);
#line 766 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp10_;
#line 768 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 768 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp11_;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->message;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = soup_message_get_request_headers (_data_->_tmp12_);
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = objects_base_object_get_source (_data_->object);
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = objects_source_get_todoist_data (_data_->_tmp16_);
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = objects_source_todoist_data_get_access_token (_data_->_tmp18_);
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = g_strdup_printf ("Bearer %s", _data_->_tmp20_);
#line 769 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 769 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp14_, "Authorization", _data_->_tmp22_);
#line 769 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp22_);
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = _data_->message;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->json;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = 0;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = string_get_data (_data_->_tmp24_, &_data_->_tmp26_);
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp25__length1 = _data_->_tmp26_;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = _data_->_tmp25_;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp27__length1 = _data_->_tmp25__length1;
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp28_ = g_bytes_new (_data_->_tmp27_, _data_->_tmp27__length1);
#line 773 "../core/Services/Todoist.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 773 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp23_, "application/json", _data_->_tmp29_);
#line 773 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp29_);
#line 775 "../core/Services/Todoist.vala"
	_data_->_tmp30_ = http_response_new ();
#line 775 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp30_;
#line 7359 "Todoist.c"
	{
#line 778 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->self->priv->session;
#line 778 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->message;
#line 778 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 778 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_HIGH, NULL, services_todoist_add_ready, _data_);
#line 778 "../core/Services/Todoist.vala"
		return FALSE;
#line 7371 "Todoist.c"
		_state_1:
#line 778 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
#line 778 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp33_;
#line 778 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7379 "Todoist.c"
			goto __catch0_g_error;
		}
#line 779 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->self->priv->parser;
#line 779 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->stream;
#line 779 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = 0;
#line 779 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
#line 779 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
#line 779 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 779 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 7396 "Todoist.c"
			goto __catch0_g_error;
		}
#line 782 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = _data_->self->priv->parser;
#line 782 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
#line 782 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
#line 784 "../core/Services/Todoist.vala"
		_data_->_tmp40_ = _data_->message;
#line 784 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp40_, "status-code", &_data_->_tmp41_, NULL);
#line 784 "../core/Services/Todoist.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 784 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp42_)) {
#line 785 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->response;
#line 785 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = _data_->self->priv->parser;
#line 785 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = json_parser_get_root (_data_->_tmp44_);
#line 785 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp43_, _data_->_tmp45_);
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->message;
#line 787 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = _data_->message;
#line 787 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp49_, "status-code", &_data_->_tmp50_, NULL);
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = _data_->_tmp50_;
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp51_);
#line 787 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = _data_->_tmp52_;
#line 787 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp48_, _data_->_tmp53_);
#line 787 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp53_);
#line 7441 "Todoist.c"
		} else {
#line 792 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = _data_->self->priv->parser;
#line 792 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = json_parser_get_root (_data_->_tmp54_);
#line 792 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = json_node_get_object (_data_->_tmp55_);
#line 792 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = json_object_get_object_member (_data_->_tmp56_, "sync_status");
#line 792 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = _json_object_ref0 (_data_->_tmp57_);
#line 792 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp58_;
#line 793 "../core/Services/Todoist.vala"
			_data_->_tmp59_ = _data_->sync_status;
#line 793 "../core/Services/Todoist.vala"
			_data_->_tmp60_ = _data_->uuid;
#line 793 "../core/Services/Todoist.vala"
			_data_->_tmp61_ = json_object_get_member (_data_->_tmp59_, _data_->_tmp60_);
#line 793 "../core/Services/Todoist.vala"
			_data_->_tmp62_ = __vala_JsonNode_copy0 (_data_->_tmp61_);
#line 793 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp62_;
#line 795 "../core/Services/Todoist.vala"
			_data_->_tmp63_ = _data_->uuid_member;
#line 795 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp63_) == JSON_NODE_VALUE) {
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = objects_base_object_get_source (_data_->object);
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = _data_->_tmp64_;
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = objects_source_get_todoist_data (_data_->_tmp65_);
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = _data_->_tmp66_;
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = _data_->self->priv->parser;
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = json_parser_get_root (_data_->_tmp68_);
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = json_node_get_object (_data_->_tmp69_);
#line 796 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = json_object_get_string_member (_data_->_tmp70_, "sync_token");
#line 796 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_sync_token (_data_->_tmp67_, _data_->_tmp71_);
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = objects_base_object_get_source (_data_->object);
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = _data_->_tmp72_;
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = g_date_time_new_now_local ();
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = _data_->_tmp74_;
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = g_date_time_to_string (_data_->_tmp75_);
#line 797 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = _data_->_tmp76_;
#line 797 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp73_, _data_->_tmp77_);
#line 797 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp77_);
#line 797 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp75_);
#line 798 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = objects_base_object_get_source (_data_->object);
#line 798 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = _data_->_tmp78_;
#line 798 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp79_);
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = _data_->self->priv->parser;
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = json_parser_get_root (_data_->_tmp80_);
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = json_node_get_object (_data_->_tmp81_);
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp82_, "temp_id_mapping");
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = _data_->temp_id;
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = json_object_get_string_member (_data_->_tmp83_, _data_->_tmp84_);
#line 800 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = g_strdup (_data_->_tmp85_);
#line 800 "../core/Services/Todoist.vala"
				_g_free0 (_data_->id);
#line 800 "../core/Services/Todoist.vala"
				_data_->id = _data_->_tmp86_;
#line 802 "../core/Services/Todoist.vala"
				_data_->_tmp87_ = _data_->response;
#line 802 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp87_, TRUE);
#line 803 "../core/Services/Todoist.vala"
				_data_->_tmp88_ = _data_->response;
#line 803 "../core/Services/Todoist.vala"
				_data_->_tmp89_ = _data_->id;
#line 803 "../core/Services/Todoist.vala"
				http_response_set_data (_data_->_tmp88_, _data_->_tmp89_);
#line 7539 "Todoist.c"
			} else {
#line 805 "../core/Services/Todoist.vala"
				_data_->_tmp90_ = _data_->response;
#line 805 "../core/Services/Todoist.vala"
				_data_->_tmp91_ = _data_->sync_status;
#line 805 "../core/Services/Todoist.vala"
				_data_->_tmp92_ = _data_->uuid;
#line 805 "../core/Services/Todoist.vala"
				_data_->_tmp93_ = json_object_get_object_member (_data_->_tmp91_, _data_->_tmp92_);
#line 805 "../core/Services/Todoist.vala"
				_data_->_tmp94_ = json_object_get_string_member (_data_->_tmp93_, "error");
#line 805 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp90_, _data_->_tmp94_);
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp95_ = _data_->sync_status;
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp96_ = _data_->uuid;
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp97_ = json_object_get_object_member (_data_->_tmp95_, _data_->_tmp96_);
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp98_ = _data_->sync_status;
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp99_ = _data_->uuid;
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp100_ = json_object_get_object_member (_data_->_tmp98_, _data_->_tmp99_);
#line 807 "../core/Services/Todoist.vala"
				_data_->_tmp101_ = json_object_get_string_member (_data_->_tmp100_, "error");
#line 807 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp97_, "http_code"), _data_->_tmp101_);
#line 7569 "Todoist.c"
			}
#line 784 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 784 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 7575 "Todoist.c"
		}
#line 777 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 7579 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 777 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 777 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 814 "../core/Services/Todoist.vala"
		_data_->_tmp102_ = _data_->message;
#line 814 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp102_, "status-code", &_data_->_tmp103_, NULL);
#line 814 "../core/Services/Todoist.vala"
		_data_->_tmp104_ = _data_->_tmp103_;
#line 814 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp104_)) {
#line 815 "../core/Services/Todoist.vala"
			_data_->_tmp105_ = _data_->response;
#line 815 "../core/Services/Todoist.vala"
			_data_->_tmp106_ = _data_->e;
#line 815 "../core/Services/Todoist.vala"
			_data_->_tmp107_ = _data_->_tmp106_->message;
#line 815 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp105_, _data_->_tmp107_);
#line 817 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = _data_->message;
#line 817 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp108_, "status-code", &_data_->_tmp109_, NULL);
#line 817 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = _data_->_tmp109_;
#line 817 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = _data_->e;
#line 817 "../core/Services/Todoist.vala"
			_data_->_tmp112_ = _data_->_tmp111_->message;
#line 817 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp110_, _data_->_tmp112_);
#line 7616 "Todoist.c"
		} else {
#line 822 "../core/Services/Todoist.vala"
			_data_->_tmp113_ = util_get_default ();
#line 822 "../core/Services/Todoist.vala"
			_data_->_tmp114_ = _data_->_tmp113_;
#line 822 "../core/Services/Todoist.vala"
			_data_->_tmp115_ = util_generate_id (_data_->_tmp114_, _data_->object);
#line 822 "../core/Services/Todoist.vala"
			_g_free0 (_data_->id);
#line 822 "../core/Services/Todoist.vala"
			_data_->id = _data_->_tmp115_;
#line 822 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp114_);
#line 824 "../core/Services/Todoist.vala"
			_data_->_tmp116_ = objects_queue_new ();
#line 824 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp116_;
#line 825 "../core/Services/Todoist.vala"
			_data_->_tmp117_ = _data_->queue;
#line 825 "../core/Services/Todoist.vala"
			_data_->_tmp118_ = _data_->uuid;
#line 825 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp117_, _data_->_tmp118_);
#line 826 "../core/Services/Todoist.vala"
			_data_->_tmp119_ = _data_->queue;
#line 826 "../core/Services/Todoist.vala"
			_data_->_tmp120_ = _data_->id;
#line 826 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp119_, _data_->_tmp120_);
#line 827 "../core/Services/Todoist.vala"
			_data_->_tmp121_ = _data_->queue;
#line 827 "../core/Services/Todoist.vala"
			_data_->_tmp122_ = _data_->temp_id;
#line 827 "../core/Services/Todoist.vala"
			objects_queue_set_temp_id (_data_->_tmp121_, _data_->_tmp122_);
#line 828 "../core/Services/Todoist.vala"
			_data_->_tmp123_ = _data_->queue;
#line 828 "../core/Services/Todoist.vala"
			_data_->_tmp124_ = objects_base_object_get_type_add (_data_->object);
#line 828 "../core/Services/Todoist.vala"
			_data_->_tmp125_ = _data_->_tmp124_;
#line 828 "../core/Services/Todoist.vala"
			objects_queue_set_query (_data_->_tmp123_, _data_->_tmp125_);
#line 829 "../core/Services/Todoist.vala"
			_data_->_tmp126_ = _data_->queue;
#line 829 "../core/Services/Todoist.vala"
			_data_->_tmp127_ = objects_base_object_to_json (_data_->object);
#line 829 "../core/Services/Todoist.vala"
			_data_->_tmp128_ = _data_->_tmp127_;
#line 829 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp126_, _data_->_tmp128_);
#line 829 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp128_);
#line 831 "../core/Services/Todoist.vala"
			_data_->_tmp129_ = services_database_get_default ();
#line 831 "../core/Services/Todoist.vala"
			_data_->_tmp130_ = _data_->_tmp129_;
#line 831 "../core/Services/Todoist.vala"
			_data_->_tmp131_ = _data_->queue;
#line 831 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp130_, _data_->_tmp131_);
#line 831 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp130_);
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp132_ = services_database_get_default ();
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp133_ = _data_->_tmp132_;
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp134_ = objects_base_object_get_id (_data_->object);
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp135_ = _data_->_tmp134_;
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp136_ = _data_->temp_id;
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp137_ = objects_base_object_get_object_type_string (_data_->object);
#line 832 "../core/Services/Todoist.vala"
			_data_->_tmp138_ = _data_->_tmp137_;
#line 832 "../core/Services/Todoist.vala"
			services_database_insert_CurTempIds (_data_->_tmp133_, _data_->_tmp135_, _data_->_tmp136_, _data_->_tmp138_);
#line 832 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp133_);
#line 834 "../core/Services/Todoist.vala"
			_data_->_tmp139_ = _data_->response;
#line 834 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp139_, TRUE);
#line 835 "../core/Services/Todoist.vala"
			_data_->_tmp140_ = _data_->response;
#line 835 "../core/Services/Todoist.vala"
			_data_->_tmp141_ = _data_->queue;
#line 835 "../core/Services/Todoist.vala"
			_data_->_tmp142_ = objects_queue_get_object_id (_data_->_tmp141_);
#line 835 "../core/Services/Todoist.vala"
			_data_->_tmp143_ = _data_->_tmp142_;
#line 835 "../core/Services/Todoist.vala"
			http_response_set_data (_data_->_tmp140_, _data_->_tmp143_);
#line 814 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 7714 "Todoist.c"
		}
#line 777 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 7718 "Todoist.c"
	}
	__finally0:
#line 777 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 777 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 777 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 777 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 777 "../core/Services/Todoist.vala"
		_g_free0 (_data_->id);
#line 777 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 777 "../core/Services/Todoist.vala"
		_g_free0 (_data_->temp_id);
#line 777 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 777 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 777 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 777 "../core/Services/Todoist.vala"
		return FALSE;
#line 7743 "Todoist.c"
	}
#line 839 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 839 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 839 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 839 "../core/Services/Todoist.vala"
	_g_free0 (_data_->id);
#line 839 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 839 "../core/Services/Todoist.vala"
	_g_free0 (_data_->temp_id);
#line 839 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 839 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 839 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 839 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7765 "Todoist.c"
		}
	}
#line 839 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 839 "../core/Services/Todoist.vala"
	return FALSE;
#line 7772 "Todoist.c"
}

static void
services_todoist_debug_error (ServicesTodoist* self,
                              guint status_code,
                              const gchar* message)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 842 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 842 "../core/Services/Todoist.vala"
	g_return_if_fail (message != NULL);
#line 843 "../core/Services/Todoist.vala"
	_tmp0_ = g_strdup_printf ("%u", status_code);
#line 843 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 843 "../core/Services/Todoist.vala"
	_tmp2_ = g_strdup_printf ("Code: %s - %s", _tmp1_, message);
#line 843 "../core/Services/Todoist.vala"
	_tmp3_ = _tmp2_;
#line 843 "../core/Services/Todoist.vala"
	g_debug ("Todoist.vala:843: %s", _tmp3_);
#line 843 "../core/Services/Todoist.vala"
	_g_free0 (_tmp3_);
#line 843 "../core/Services/Todoist.vala"
	_g_free0 (_tmp1_);
#line 7802 "Todoist.c"
}

static void
services_todoist_update_data_free (gpointer _data)
{
	ServicesTodoistUpdateData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistUpdateData, _data_);
#line 7818 "Todoist.c"
}

void
services_todoist_update (ServicesTodoist* self,
                         ObjectsBaseObject* object,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	ServicesTodoistUpdateData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (object != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistUpdateData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_update_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (object);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_data_->object = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_update_co (_data_);
#line 7852 "Todoist.c"
}

HttpResponse*
services_todoist_update_finish (ServicesTodoist* self,
                                GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistUpdateData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 7869 "Todoist.c"
}

static void
services_todoist_update_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	ServicesTodoistUpdateData* _data_;
#line 861 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 861 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 861 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 861 "../core/Services/Todoist.vala"
	services_todoist_update_co (_data_);
#line 7886 "Todoist.c"
}

static gboolean
services_todoist_update_co (ServicesTodoistUpdateData* _data_)
{
#line 846 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 846 "../core/Services/Todoist.vala"
		case 0:
#line 7896 "Todoist.c"
		goto _state_0;
#line 846 "../core/Services/Todoist.vala"
		case 1:
#line 7900 "Todoist.c"
		goto _state_1;
		default:
#line 846 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 7905 "Todoist.c"
	}
	_state_0:
#line 847 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 847 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 847 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 847 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 847 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 847 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp3_;
#line 848 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->uuid;
#line 848 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = objects_base_object_get_update_json (_data_->object, _data_->_tmp4_, NULL);
#line 848 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp5_;
#line 849 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = objects_base_object_get_source (_data_->object);
#line 849 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 849 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 849 "../core/Services/Todoist.vala"
	_data_->source = _data_->_tmp8_;
#line 851 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 851 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp9_;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->message;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->source;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = objects_source_get_todoist_data (_data_->_tmp13_);
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = objects_source_todoist_data_get_access_token (_data_->_tmp15_);
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = g_strdup_printf ("Bearer %s", _data_->_tmp17_);
#line 852 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 852 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp19_);
#line 852 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp19_);
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->message;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = _data_->json;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = 0;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = string_get_data (_data_->_tmp21_, &_data_->_tmp23_);
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp22__length1 = _data_->_tmp23_;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->_tmp22_;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp24__length1 = _data_->_tmp22__length1;
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = g_bytes_new (_data_->_tmp24_, _data_->_tmp24__length1);
#line 856 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 856 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp20_, "application/json", _data_->_tmp26_);
#line 856 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp26_);
#line 858 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = http_response_new ();
#line 858 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp27_;
#line 7988 "Todoist.c"
	{
#line 861 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = _data_->self->priv->session;
#line 861 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = _data_->message;
#line 861 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 861 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp28_, _data_->_tmp29_, G_PRIORITY_HIGH, NULL, services_todoist_update_ready, _data_);
#line 861 "../core/Services/Todoist.vala"
		return FALSE;
#line 8000 "Todoist.c"
		_state_1:
#line 861 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = soup_session_send_and_read_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
#line 861 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp30_;
#line 861 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8008 "Todoist.c"
			goto __catch0_g_error;
		}
#line 862 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->self->priv->parser;
#line 862 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->stream;
#line 862 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = 0;
#line 862 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = g_bytes_get_data (_data_->_tmp32_, &_data_->_tmp33_);
#line 862 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp31_, (const gchar*) _data_->_tmp34_, (gssize) -1, &_data_->_inner_error0_);
#line 862 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 862 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 8025 "Todoist.c"
			goto __catch0_g_error;
		}
#line 865 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->self->priv->parser;
#line 865 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
#line 865 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp36_);
#line 867 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = _data_->message;
#line 867 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
#line 867 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 867 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp39_)) {
#line 868 "../core/Services/Todoist.vala"
			_data_->_tmp40_ = _data_->response;
#line 868 "../core/Services/Todoist.vala"
			_data_->_tmp41_ = _data_->self->priv->parser;
#line 868 "../core/Services/Todoist.vala"
			_data_->_tmp42_ = json_parser_get_root (_data_->_tmp41_);
#line 868 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp40_, _data_->_tmp42_);
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->message;
#line 870 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp43_, "status-code", &_data_->_tmp44_, NULL);
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = _data_->_tmp44_;
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->message;
#line 870 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp48_);
#line 870 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = _data_->_tmp49_;
#line 870 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp45_, _data_->_tmp50_);
#line 870 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp50_);
#line 8070 "Todoist.c"
		} else {
#line 875 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = _data_->self->priv->parser;
#line 875 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = json_parser_get_root (_data_->_tmp51_);
#line 875 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = json_node_get_object (_data_->_tmp52_);
#line 875 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
#line 875 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = _json_object_ref0 (_data_->_tmp54_);
#line 875 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp55_;
#line 876 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = _data_->sync_status;
#line 876 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = _data_->uuid;
#line 876 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = json_object_get_member (_data_->_tmp56_, _data_->_tmp57_);
#line 876 "../core/Services/Todoist.vala"
			_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
#line 876 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp59_;
#line 878 "../core/Services/Todoist.vala"
			_data_->_tmp60_ = _data_->uuid_member;
#line 878 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp61_ = _data_->source;
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp62_ = objects_source_get_todoist_data (_data_->_tmp61_);
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp63_ = _data_->_tmp62_;
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = _data_->self->priv->parser;
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = json_parser_get_root (_data_->_tmp64_);
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = json_node_get_object (_data_->_tmp65_);
#line 879 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "sync_token");
#line 879 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_sync_token (_data_->_tmp63_, _data_->_tmp67_);
#line 880 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = _data_->response;
#line 880 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp68_, TRUE);
#line 882 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = _data_->source;
#line 882 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = g_date_time_new_now_local ();
#line 882 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 882 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
#line 882 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = _data_->_tmp72_;
#line 882 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
#line 882 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp73_);
#line 882 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp71_);
#line 883 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = _data_->source;
#line 883 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp74_);
#line 8138 "Todoist.c"
			} else {
#line 885 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = _data_->response;
#line 885 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = _data_->sync_status;
#line 885 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = _data_->uuid;
#line 885 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = json_object_get_object_member (_data_->_tmp76_, _data_->_tmp77_);
#line 885 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = json_object_get_string_member (_data_->_tmp78_, "error");
#line 885 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp75_, _data_->_tmp79_);
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = _data_->sync_status;
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = _data_->uuid;
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = json_object_get_object_member (_data_->_tmp80_, _data_->_tmp81_);
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = _data_->sync_status;
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = _data_->uuid;
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
#line 887 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = json_object_get_string_member (_data_->_tmp85_, "error");
#line 887 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp82_, "http_code"), _data_->_tmp86_);
#line 8168 "Todoist.c"
			}
#line 867 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 867 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 8174 "Todoist.c"
		}
#line 860 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 8178 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 860 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 860 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 894 "../core/Services/Todoist.vala"
		_data_->_tmp87_ = _data_->message;
#line 894 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp87_, "status-code", &_data_->_tmp88_, NULL);
#line 894 "../core/Services/Todoist.vala"
		_data_->_tmp89_ = _data_->_tmp88_;
#line 894 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp89_)) {
#line 895 "../core/Services/Todoist.vala"
			_data_->_tmp90_ = _data_->response;
#line 895 "../core/Services/Todoist.vala"
			_data_->_tmp91_ = _data_->e;
#line 895 "../core/Services/Todoist.vala"
			_data_->_tmp92_ = _data_->_tmp91_->message;
#line 895 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp90_, _data_->_tmp92_);
#line 897 "../core/Services/Todoist.vala"
			_data_->_tmp93_ = _data_->message;
#line 897 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp93_, "status-code", &_data_->_tmp94_, NULL);
#line 897 "../core/Services/Todoist.vala"
			_data_->_tmp95_ = _data_->_tmp94_;
#line 897 "../core/Services/Todoist.vala"
			_data_->_tmp96_ = _data_->e;
#line 897 "../core/Services/Todoist.vala"
			_data_->_tmp97_ = _data_->_tmp96_->message;
#line 897 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp95_, _data_->_tmp97_);
#line 8215 "Todoist.c"
		} else {
#line 902 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = objects_queue_new ();
#line 902 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp98_;
#line 903 "../core/Services/Todoist.vala"
			_data_->_tmp99_ = _data_->queue;
#line 903 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = _data_->uuid;
#line 903 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp99_, _data_->_tmp100_);
#line 904 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = _data_->queue;
#line 904 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = objects_base_object_get_id (_data_->object);
#line 904 "../core/Services/Todoist.vala"
			_data_->_tmp103_ = _data_->_tmp102_;
#line 904 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp101_, _data_->_tmp103_);
#line 905 "../core/Services/Todoist.vala"
			_data_->_tmp104_ = _data_->queue;
#line 905 "../core/Services/Todoist.vala"
			_data_->_tmp105_ = objects_base_object_get_type_update (_data_->object);
#line 905 "../core/Services/Todoist.vala"
			_data_->_tmp106_ = _data_->_tmp105_;
#line 905 "../core/Services/Todoist.vala"
			objects_queue_set_query (_data_->_tmp104_, _data_->_tmp106_);
#line 906 "../core/Services/Todoist.vala"
			_data_->_tmp107_ = _data_->queue;
#line 906 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = objects_base_object_to_json (_data_->object);
#line 906 "../core/Services/Todoist.vala"
			_data_->_tmp109_ = _data_->_tmp108_;
#line 906 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp107_, _data_->_tmp109_);
#line 906 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp109_);
#line 908 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = services_database_get_default ();
#line 908 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = _data_->_tmp110_;
#line 908 "../core/Services/Todoist.vala"
			_data_->_tmp112_ = _data_->queue;
#line 908 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp111_, _data_->_tmp112_);
#line 908 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp111_);
#line 909 "../core/Services/Todoist.vala"
			_data_->_tmp113_ = _data_->response;
#line 909 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp113_, TRUE);
#line 894 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 8269 "Todoist.c"
		}
#line 860 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 8273 "Todoist.c"
	}
	__finally0:
#line 860 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 860 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 860 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 860 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->source);
#line 860 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 860 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 860 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 860 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 860 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 860 "../core/Services/Todoist.vala"
		return FALSE;
#line 8296 "Todoist.c"
	}
#line 913 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 913 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 913 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 913 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 913 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 913 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 913 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 913 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 913 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8316 "Todoist.c"
		}
	}
#line 913 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 913 "../core/Services/Todoist.vala"
	return FALSE;
#line 8323 "Todoist.c"
}

static void
services_todoist_update_items_data_free (gpointer _data)
{
	ServicesTodoistUpdateItemsData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->objects);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistUpdateItemsData, _data_);
#line 8337 "Todoist.c"
}

void
services_todoist_update_items (ServicesTodoist* self,
                               GeeArrayList* objects,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ServicesTodoistUpdateItemsData* _data_;
	ServicesTodoist* _tmp0_;
	GeeArrayList* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (objects != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistUpdateItemsData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_update_items_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (objects);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->objects);
#line 22 "../core/Services/Todoist.vala"
	_data_->objects = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_update_items_co (_data_);
#line 8371 "Todoist.c"
}

void
services_todoist_update_items_finish (ServicesTodoist* self,
                                      GAsyncResult* _res_)
{
	ServicesTodoistUpdateItemsData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8381 "Todoist.c"
}

static void
services_todoist_update_items_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ServicesTodoistUpdateItemsData* _data_;
#line 927 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 927 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 927 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 927 "../core/Services/Todoist.vala"
	services_todoist_update_items_co (_data_);
#line 8398 "Todoist.c"
}

static gboolean
services_todoist_update_items_co (ServicesTodoistUpdateItemsData* _data_)
{
#line 916 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 916 "../core/Services/Todoist.vala"
		case 0:
#line 8408 "Todoist.c"
		goto _state_0;
#line 916 "../core/Services/Todoist.vala"
		case 1:
#line 8412 "Todoist.c"
		goto _state_1;
		default:
#line 916 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 8417 "Todoist.c"
	}
	_state_0:
#line 917 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = services_todoist_get_update_items_json (_data_->self, _data_->objects);
#line 917 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp0_;
#line 919 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 919 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp1_;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = _data_->message;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = soup_message_get_request_headers (_data_->_tmp2_);
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = services_settings_get_default ();
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_->settings;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = g_settings_get_string (_data_->_tmp7_, "todoist-access-token");
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = g_strdup_printf ("Bearer %s", _data_->_tmp9_);
#line 920 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 920 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp4_, "Authorization", _data_->_tmp11_);
#line 920 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp11_);
#line 920 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp9_);
#line 920 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->message;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->json;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = 0;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = string_get_data (_data_->_tmp13_, &_data_->_tmp15_);
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp14__length1 = _data_->_tmp15_;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = _data_->_tmp14_;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp16__length1 = _data_->_tmp14__length1;
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = g_bytes_new (_data_->_tmp16_, _data_->_tmp16__length1);
#line 924 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 924 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp12_, "application/json", _data_->_tmp18_);
#line 924 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp18_);
#line 8478 "Todoist.c"
	{
#line 927 "../core/Services/Todoist.vala"
		_data_->_tmp19_ = _data_->self->priv->session;
#line 927 "../core/Services/Todoist.vala"
		_data_->_tmp20_ = _data_->message;
#line 927 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 927 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp19_, _data_->_tmp20_, G_PRIORITY_HIGH, NULL, services_todoist_update_items_ready, _data_);
#line 927 "../core/Services/Todoist.vala"
		return FALSE;
#line 8490 "Todoist.c"
		_state_1:
#line 927 "../core/Services/Todoist.vala"
		_data_->_tmp21_ = soup_session_send_and_read_finish (_data_->_tmp19_, _data_->_res_, &_data_->_inner_error0_);
#line 927 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp21_;
#line 927 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8498 "Todoist.c"
			goto __catch0_g_error;
		}
#line 928 "../core/Services/Todoist.vala"
		_data_->_tmp22_ = _data_->self->priv->parser;
#line 928 "../core/Services/Todoist.vala"
		_data_->_tmp23_ = _data_->stream;
#line 928 "../core/Services/Todoist.vala"
		_data_->_tmp24_ = 0;
#line 928 "../core/Services/Todoist.vala"
		_data_->_tmp25_ = g_bytes_get_data (_data_->_tmp23_, &_data_->_tmp24_);
#line 928 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp22_, (const gchar*) _data_->_tmp25_, (gssize) -1, &_data_->_inner_error0_);
#line 928 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 928 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 8515 "Todoist.c"
			goto __catch0_g_error;
		}
#line 931 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = _data_->self->priv->parser;
#line 931 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = json_parser_get_root (_data_->_tmp26_);
#line 931 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp27_);
#line 933 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = _data_->message;
#line 933 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp28_, "status-code", &_data_->_tmp29_, NULL);
#line 933 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 933 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp30_)) {
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp31_ = _data_->message;
#line 934 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp31_, "status-code", &_data_->_tmp32_, NULL);
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp34_ = _data_->message;
#line 934 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp34_, "status-code", &_data_->_tmp35_, NULL);
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp36_ = _data_->_tmp35_;
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp37_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp36_);
#line 934 "../core/Services/Todoist.vala"
			_data_->_tmp38_ = _data_->_tmp37_;
#line 934 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp33_, _data_->_tmp38_);
#line 934 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp38_);
#line 8552 "Todoist.c"
		} else {
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp39_ = services_settings_get_default ();
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp40_ = _data_->_tmp39_;
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp41_ = _data_->_tmp40_->settings;
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp42_ = _data_->self->priv->parser;
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = json_parser_get_root (_data_->_tmp42_);
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = json_node_get_object (_data_->_tmp43_);
#line 939 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = json_object_get_string_member (_data_->_tmp44_, "sync_token");
#line 939 "../core/Services/Todoist.vala"
			g_settings_set_string (_data_->_tmp41_, "todoist-sync-token", _data_->_tmp45_);
#line 939 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp40_);
#line 8572 "Todoist.c"
		}
#line 926 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 8576 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 926 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 926 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 945 "../core/Services/Todoist.vala"
		_data_->_tmp46_ = _data_->e->message;
#line 945 "../core/Services/Todoist.vala"
		g_error ("Todoist.vala:945: %s", _data_->_tmp46_);
#line 926 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 8591 "Todoist.c"
	}
	__finally0:
#line 926 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 926 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 926 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 926 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 926 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 926 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 926 "../core/Services/Todoist.vala"
		return FALSE;
#line 8608 "Todoist.c"
	}
#line 916 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 916 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 916 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 916 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 916 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 916 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8622 "Todoist.c"
		}
	}
#line 916 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 916 "../core/Services/Todoist.vala"
	return FALSE;
#line 8629 "Todoist.c"
}

gchar*
services_todoist_get_update_items_json (ServicesTodoist* self,
                                        GeeArrayList* objects)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp88_;
	JsonBuilder* _tmp89_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp90_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp91_;
	JsonNode* _tmp92_;
	gchar* _tmp93_;
	gchar* result;
#line 949 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 949 "../core/Services/Todoist.vala"
	g_return_val_if_fail (objects != NULL, NULL);
#line 950 "../core/Services/Todoist.vala"
	_tmp0_ = json_builder_new ();
#line 950 "../core/Services/Todoist.vala"
	builder = _tmp0_;
#line 952 "../core/Services/Todoist.vala"
	_tmp1_ = builder;
#line 952 "../core/Services/Todoist.vala"
	json_builder_begin_object (_tmp1_);
#line 953 "../core/Services/Todoist.vala"
	_tmp2_ = builder;
#line 953 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp2_, "commands");
#line 955 "../core/Services/Todoist.vala"
	_tmp3_ = builder;
#line 955 "../core/Services/Todoist.vala"
	json_builder_begin_array (_tmp3_);
#line 8670 "Todoist.c"
	{
		GeeArrayList* _item_list = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _item_index = 0;
#line 956 "../core/Services/Todoist.vala"
		_item_list = objects;
#line 956 "../core/Services/Todoist.vala"
		_tmp4_ = _item_list;
#line 956 "../core/Services/Todoist.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 956 "../core/Services/Todoist.vala"
		_tmp6_ = _tmp5_;
#line 956 "../core/Services/Todoist.vala"
		_item_size = _tmp6_;
#line 956 "../core/Services/Todoist.vala"
		_item_index = -1;
#line 956 "../core/Services/Todoist.vala"
		while (TRUE) {
#line 8692 "Todoist.c"
			gint _tmp7_;
			gint _tmp8_;
			ObjectsItem* item = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonBuilder* _tmp11_;
			JsonBuilder* _tmp12_;
			JsonBuilder* _tmp13_;
			JsonBuilder* _tmp14_;
			JsonBuilder* _tmp15_;
			Util* _tmp16_;
			Util* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			JsonBuilder* _tmp20_;
			JsonBuilder* _tmp21_;
			JsonBuilder* _tmp22_;
			JsonBuilder* _tmp23_;
			ObjectsItem* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			JsonBuilder* _tmp27_;
			JsonBuilder* _tmp28_;
			Util* _tmp29_;
			Util* _tmp30_;
			ObjectsItem* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			JsonBuilder* _tmp36_;
			JsonBuilder* _tmp37_;
			Util* _tmp38_;
			Util* _tmp39_;
			ObjectsItem* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			JsonBuilder* _tmp45_;
			ObjectsItem* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
			ObjectsItem* _tmp54_;
			gboolean _tmp55_;
			gboolean _tmp56_;
			JsonBuilder* _tmp69_;
			JsonBuilder* _tmp70_;
			JsonBuilder* _tmp85_;
			JsonBuilder* _tmp86_;
			JsonBuilder* _tmp87_;
#line 956 "../core/Services/Todoist.vala"
			_item_index = _item_index + 1;
#line 956 "../core/Services/Todoist.vala"
			_tmp7_ = _item_index;
#line 956 "../core/Services/Todoist.vala"
			_tmp8_ = _item_size;
#line 956 "../core/Services/Todoist.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 956 "../core/Services/Todoist.vala"
				break;
#line 8754 "Todoist.c"
			}
#line 956 "../core/Services/Todoist.vala"
			_tmp9_ = _item_list;
#line 956 "../core/Services/Todoist.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 956 "../core/Services/Todoist.vala"
			item = (ObjectsItem*) _tmp10_;
#line 957 "../core/Services/Todoist.vala"
			_tmp11_ = builder;
#line 957 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp11_);
#line 959 "../core/Services/Todoist.vala"
			_tmp12_ = builder;
#line 959 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp12_, "type");
#line 960 "../core/Services/Todoist.vala"
			_tmp13_ = builder;
#line 960 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp13_, "item_update");
#line 962 "../core/Services/Todoist.vala"
			_tmp14_ = builder;
#line 962 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp14_, "uuid");
#line 963 "../core/Services/Todoist.vala"
			_tmp15_ = builder;
#line 963 "../core/Services/Todoist.vala"
			_tmp16_ = util_get_default ();
#line 963 "../core/Services/Todoist.vala"
			_tmp17_ = _tmp16_;
#line 963 "../core/Services/Todoist.vala"
			_tmp18_ = util_generate_string (_tmp17_);
#line 963 "../core/Services/Todoist.vala"
			_tmp19_ = _tmp18_;
#line 963 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp15_, _tmp19_);
#line 963 "../core/Services/Todoist.vala"
			_g_free0 (_tmp19_);
#line 963 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp17_);
#line 965 "../core/Services/Todoist.vala"
			_tmp20_ = builder;
#line 965 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp20_, "args");
#line 966 "../core/Services/Todoist.vala"
			_tmp21_ = builder;
#line 966 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp21_);
#line 968 "../core/Services/Todoist.vala"
			_tmp22_ = builder;
#line 968 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp22_, "id");
#line 969 "../core/Services/Todoist.vala"
			_tmp23_ = builder;
#line 969 "../core/Services/Todoist.vala"
			_tmp24_ = item;
#line 969 "../core/Services/Todoist.vala"
			_tmp25_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp24_);
#line 969 "../core/Services/Todoist.vala"
			_tmp26_ = _tmp25_;
#line 969 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp23_, _tmp26_);
#line 971 "../core/Services/Todoist.vala"
			_tmp27_ = builder;
#line 971 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp27_, "content");
#line 972 "../core/Services/Todoist.vala"
			_tmp28_ = builder;
#line 972 "../core/Services/Todoist.vala"
			_tmp29_ = util_get_default ();
#line 972 "../core/Services/Todoist.vala"
			_tmp30_ = _tmp29_;
#line 972 "../core/Services/Todoist.vala"
			_tmp31_ = item;
#line 972 "../core/Services/Todoist.vala"
			_tmp32_ = objects_item_get_content (_tmp31_);
#line 972 "../core/Services/Todoist.vala"
			_tmp33_ = _tmp32_;
#line 972 "../core/Services/Todoist.vala"
			_tmp34_ = util_get_encode_text (_tmp30_, _tmp33_);
#line 972 "../core/Services/Todoist.vala"
			_tmp35_ = _tmp34_;
#line 972 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp28_, _tmp35_);
#line 972 "../core/Services/Todoist.vala"
			_g_free0 (_tmp35_);
#line 972 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp30_);
#line 974 "../core/Services/Todoist.vala"
			_tmp36_ = builder;
#line 974 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp36_, "description");
#line 975 "../core/Services/Todoist.vala"
			_tmp37_ = builder;
#line 975 "../core/Services/Todoist.vala"
			_tmp38_ = util_get_default ();
#line 975 "../core/Services/Todoist.vala"
			_tmp39_ = _tmp38_;
#line 975 "../core/Services/Todoist.vala"
			_tmp40_ = item;
#line 975 "../core/Services/Todoist.vala"
			_tmp41_ = objects_item_get_description (_tmp40_);
#line 975 "../core/Services/Todoist.vala"
			_tmp42_ = _tmp41_;
#line 975 "../core/Services/Todoist.vala"
			_tmp43_ = util_get_encode_text (_tmp39_, _tmp42_);
#line 975 "../core/Services/Todoist.vala"
			_tmp44_ = _tmp43_;
#line 975 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp37_, _tmp44_);
#line 975 "../core/Services/Todoist.vala"
			_g_free0 (_tmp44_);
#line 975 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp39_);
#line 977 "../core/Services/Todoist.vala"
			_tmp45_ = builder;
#line 977 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp45_, "priority");
#line 978 "../core/Services/Todoist.vala"
			_tmp46_ = item;
#line 978 "../core/Services/Todoist.vala"
			_tmp47_ = objects_item_get_priority (_tmp46_);
#line 978 "../core/Services/Todoist.vala"
			_tmp48_ = _tmp47_;
#line 978 "../core/Services/Todoist.vala"
			if (_tmp48_ == 0) {
#line 8880 "Todoist.c"
				JsonBuilder* _tmp49_;
#line 979 "../core/Services/Todoist.vala"
				_tmp49_ = builder;
#line 979 "../core/Services/Todoist.vala"
				json_builder_add_int_value (_tmp49_, (gint64) CONSTANTS_PRIORITY_4);
#line 8886 "Todoist.c"
			} else {
				JsonBuilder* _tmp50_;
				ObjectsItem* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
#line 981 "../core/Services/Todoist.vala"
				_tmp50_ = builder;
#line 981 "../core/Services/Todoist.vala"
				_tmp51_ = item;
#line 981 "../core/Services/Todoist.vala"
				_tmp52_ = objects_item_get_priority (_tmp51_);
#line 981 "../core/Services/Todoist.vala"
				_tmp53_ = _tmp52_;
#line 981 "../core/Services/Todoist.vala"
				json_builder_add_int_value (_tmp50_, (gint64) _tmp53_);
#line 8902 "Todoist.c"
			}
#line 984 "../core/Services/Todoist.vala"
			_tmp54_ = item;
#line 984 "../core/Services/Todoist.vala"
			_tmp55_ = objects_item_get_has_due (_tmp54_);
#line 984 "../core/Services/Todoist.vala"
			_tmp56_ = _tmp55_;
#line 984 "../core/Services/Todoist.vala"
			if (_tmp56_) {
#line 8912 "Todoist.c"
				JsonBuilder* _tmp57_;
				JsonBuilder* _tmp58_;
				JsonBuilder* _tmp59_;
				JsonBuilder* _tmp60_;
				ObjectsItem* _tmp61_;
				ObjectsDueDate* _tmp62_;
				ObjectsDueDate* _tmp63_;
				const gchar* _tmp64_;
				const gchar* _tmp65_;
				JsonBuilder* _tmp66_;
#line 985 "../core/Services/Todoist.vala"
				_tmp57_ = builder;
#line 985 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp57_, "due");
#line 986 "../core/Services/Todoist.vala"
				_tmp58_ = builder;
#line 986 "../core/Services/Todoist.vala"
				json_builder_begin_object (_tmp58_);
#line 988 "../core/Services/Todoist.vala"
				_tmp59_ = builder;
#line 988 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp59_, "date");
#line 989 "../core/Services/Todoist.vala"
				_tmp60_ = builder;
#line 989 "../core/Services/Todoist.vala"
				_tmp61_ = item;
#line 989 "../core/Services/Todoist.vala"
				_tmp62_ = objects_item_get_due (_tmp61_);
#line 989 "../core/Services/Todoist.vala"
				_tmp63_ = _tmp62_;
#line 989 "../core/Services/Todoist.vala"
				_tmp64_ = objects_due_date_get_date (_tmp63_);
#line 989 "../core/Services/Todoist.vala"
				_tmp65_ = _tmp64_;
#line 989 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp60_, _tmp65_);
#line 991 "../core/Services/Todoist.vala"
				_tmp66_ = builder;
#line 991 "../core/Services/Todoist.vala"
				json_builder_end_object (_tmp66_);
#line 8953 "Todoist.c"
			} else {
				JsonBuilder* _tmp67_;
				JsonBuilder* _tmp68_;
#line 993 "../core/Services/Todoist.vala"
				_tmp67_ = builder;
#line 993 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp67_, "due");
#line 994 "../core/Services/Todoist.vala"
				_tmp68_ = builder;
#line 994 "../core/Services/Todoist.vala"
				json_builder_add_null_value (_tmp68_);
#line 8965 "Todoist.c"
			}
#line 997 "../core/Services/Todoist.vala"
			_tmp69_ = builder;
#line 997 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp69_, "labels");
#line 998 "../core/Services/Todoist.vala"
			_tmp70_ = builder;
#line 998 "../core/Services/Todoist.vala"
			json_builder_begin_array (_tmp70_);
#line 8975 "Todoist.c"
			{
				GeeArrayList* _label_list = NULL;
				ObjectsItem* _tmp71_;
				GeeArrayList* _tmp72_;
				GeeArrayList* _tmp73_;
				gint _label_size = 0;
				GeeArrayList* _tmp74_;
				gint _tmp75_;
				gint _tmp76_;
				gint _label_index = 0;
#line 999 "../core/Services/Todoist.vala"
				_tmp71_ = item;
#line 999 "../core/Services/Todoist.vala"
				_tmp72_ = objects_item_get_labels (_tmp71_);
#line 999 "../core/Services/Todoist.vala"
				_tmp73_ = _tmp72_;
#line 999 "../core/Services/Todoist.vala"
				_label_list = _tmp73_;
#line 999 "../core/Services/Todoist.vala"
				_tmp74_ = _label_list;
#line 999 "../core/Services/Todoist.vala"
				_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
#line 999 "../core/Services/Todoist.vala"
				_tmp76_ = _tmp75_;
#line 999 "../core/Services/Todoist.vala"
				_label_size = _tmp76_;
#line 999 "../core/Services/Todoist.vala"
				_label_index = -1;
#line 999 "../core/Services/Todoist.vala"
				while (TRUE) {
#line 9006 "Todoist.c"
					gint _tmp77_;
					gint _tmp78_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp79_;
					gpointer _tmp80_;
					JsonBuilder* _tmp81_;
					ObjectsLabel* _tmp82_;
					const gchar* _tmp83_;
					const gchar* _tmp84_;
#line 999 "../core/Services/Todoist.vala"
					_label_index = _label_index + 1;
#line 999 "../core/Services/Todoist.vala"
					_tmp77_ = _label_index;
#line 999 "../core/Services/Todoist.vala"
					_tmp78_ = _label_size;
#line 999 "../core/Services/Todoist.vala"
					if (!(_tmp77_ < _tmp78_)) {
#line 999 "../core/Services/Todoist.vala"
						break;
#line 9026 "Todoist.c"
					}
#line 999 "../core/Services/Todoist.vala"
					_tmp79_ = _label_list;
#line 999 "../core/Services/Todoist.vala"
					_tmp80_ = gee_abstract_list_get ((GeeAbstractList*) _tmp79_, _label_index);
#line 999 "../core/Services/Todoist.vala"
					label = (ObjectsLabel*) _tmp80_;
#line 1000 "../core/Services/Todoist.vala"
					_tmp81_ = builder;
#line 1000 "../core/Services/Todoist.vala"
					_tmp82_ = label;
#line 1000 "../core/Services/Todoist.vala"
					_tmp83_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp82_);
#line 1000 "../core/Services/Todoist.vala"
					_tmp84_ = _tmp83_;
#line 1000 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp81_, _tmp84_);
#line 999 "../core/Services/Todoist.vala"
					_g_object_unref0 (label);
#line 9046 "Todoist.c"
				}
			}
#line 1002 "../core/Services/Todoist.vala"
			_tmp85_ = builder;
#line 1002 "../core/Services/Todoist.vala"
			json_builder_end_array (_tmp85_);
#line 1003 "../core/Services/Todoist.vala"
			_tmp86_ = builder;
#line 1003 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp86_);
#line 1004 "../core/Services/Todoist.vala"
			_tmp87_ = builder;
#line 1004 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp87_);
#line 956 "../core/Services/Todoist.vala"
			_g_object_unref0 (item);
#line 9063 "Todoist.c"
		}
	}
#line 1006 "../core/Services/Todoist.vala"
	_tmp88_ = builder;
#line 1006 "../core/Services/Todoist.vala"
	json_builder_end_array (_tmp88_);
#line 1007 "../core/Services/Todoist.vala"
	_tmp89_ = builder;
#line 1007 "../core/Services/Todoist.vala"
	json_builder_end_object (_tmp89_);
#line 1009 "../core/Services/Todoist.vala"
	_tmp90_ = json_generator_new ();
#line 1009 "../core/Services/Todoist.vala"
	generator = _tmp90_;
#line 1010 "../core/Services/Todoist.vala"
	_tmp91_ = builder;
#line 1010 "../core/Services/Todoist.vala"
	_tmp92_ = json_builder_get_root (_tmp91_);
#line 1010 "../core/Services/Todoist.vala"
	root = _tmp92_;
#line 1011 "../core/Services/Todoist.vala"
	json_generator_set_root (generator, root);
#line 1012 "../core/Services/Todoist.vala"
	_tmp93_ = json_generator_to_data (generator, NULL);
#line 1012 "../core/Services/Todoist.vala"
	result = _tmp93_;
#line 1012 "../core/Services/Todoist.vala"
	__vala_JsonNode_free0 (root);
#line 1012 "../core/Services/Todoist.vala"
	_g_object_unref0 (generator);
#line 1012 "../core/Services/Todoist.vala"
	_g_object_unref0 (builder);
#line 1012 "../core/Services/Todoist.vala"
	return result;
#line 9098 "Todoist.c"
}

static void
services_todoist_delete_data_free (gpointer _data)
{
	ServicesTodoistDeleteData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistDeleteData, _data_);
#line 9114 "Todoist.c"
}

void
services_todoist_delete (ServicesTodoist* self,
                         ObjectsBaseObject* object,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	ServicesTodoistDeleteData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (object != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistDeleteData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_delete_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (object);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->object);
#line 22 "../core/Services/Todoist.vala"
	_data_->object = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_delete_co (_data_);
#line 9148 "Todoist.c"
}

HttpResponse*
services_todoist_delete_finish (ServicesTodoist* self,
                                GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistDeleteData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 9165 "Todoist.c"
}

static void
services_todoist_delete_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	ServicesTodoistDeleteData* _data_;
#line 1029 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 1029 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 1029 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 1029 "../core/Services/Todoist.vala"
	services_todoist_delete_co (_data_);
#line 9182 "Todoist.c"
}

static gboolean
services_todoist_delete_co (ServicesTodoistDeleteData* _data_)
{
#line 1015 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 1015 "../core/Services/Todoist.vala"
		case 0:
#line 9192 "Todoist.c"
		goto _state_0;
#line 1015 "../core/Services/Todoist.vala"
		case 1:
#line 9196 "Todoist.c"
		goto _state_1;
		default:
#line 1015 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 9201 "Todoist.c"
	}
	_state_0:
#line 1016 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 1016 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1016 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 1016 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 1016 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 1016 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp3_;
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = objects_base_object_get_id (_data_->object);
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = objects_base_object_get_type_delete (_data_->object);
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _data_->uuid;
#line 1017 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = services_todoist_get_delete_json (_data_->self, _data_->_tmp5_, _data_->_tmp7_, _data_->_tmp8_);
#line 1017 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp9_;
#line 1019 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 1019 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp10_;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _data_->message;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = soup_message_get_request_headers (_data_->_tmp11_);
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = objects_base_object_get_source (_data_->object);
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = objects_source_get_todoist_data (_data_->_tmp15_);
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = objects_source_todoist_data_get_access_token (_data_->_tmp17_);
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = g_strdup_printf ("Bearer %s", _data_->_tmp19_);
#line 1020 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = _data_->_tmp20_;
#line 1020 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp13_, "Authorization", _data_->_tmp21_);
#line 1020 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp21_);
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = _data_->message;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = _data_->json;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = 0;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = string_get_data (_data_->_tmp23_, &_data_->_tmp25_);
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp24__length1 = _data_->_tmp25_;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = _data_->_tmp24_;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp26__length1 = _data_->_tmp24__length1;
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = g_bytes_new (_data_->_tmp26_, _data_->_tmp26__length1);
#line 1024 "../core/Services/Todoist.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 1024 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp22_, "application/json", _data_->_tmp28_);
#line 1024 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp28_);
#line 1026 "../core/Services/Todoist.vala"
	_data_->_tmp29_ = http_response_new ();
#line 1026 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp29_;
#line 9286 "Todoist.c"
	{
#line 1029 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->self->priv->session;
#line 1029 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->message;
#line 1029 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 1029 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp30_, _data_->_tmp31_, G_PRIORITY_HIGH, NULL, services_todoist_delete_ready, _data_);
#line 1029 "../core/Services/Todoist.vala"
		return FALSE;
#line 9298 "Todoist.c"
		_state_1:
#line 1029 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = soup_session_send_and_read_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error0_);
#line 1029 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp32_;
#line 1029 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9306 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1030 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = _data_->self->priv->parser;
#line 1030 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->stream;
#line 1030 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = 0;
#line 1030 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = g_bytes_get_data (_data_->_tmp34_, &_data_->_tmp35_);
#line 1030 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp33_, (const gchar*) _data_->_tmp36_, (gssize) -1, &_data_->_inner_error0_);
#line 1030 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1030 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 9323 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1033 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = _data_->self->priv->parser;
#line 1033 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = json_parser_get_root (_data_->_tmp37_);
#line 1033 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp38_);
#line 1035 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = _data_->message;
#line 1035 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp39_, "status-code", &_data_->_tmp40_, NULL);
#line 1035 "../core/Services/Todoist.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 1035 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp41_)) {
#line 1036 "../core/Services/Todoist.vala"
			_data_->_tmp42_ = _data_->response;
#line 1036 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->self->priv->parser;
#line 1036 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = json_parser_get_root (_data_->_tmp43_);
#line 1036 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp42_, _data_->_tmp44_);
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = _data_->message;
#line 1038 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp45_, "status-code", &_data_->_tmp46_, NULL);
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp47_ = _data_->_tmp46_;
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->message;
#line 1038 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp48_, "status-code", &_data_->_tmp49_, NULL);
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = _data_->_tmp49_;
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp50_);
#line 1038 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = _data_->_tmp51_;
#line 1038 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp47_, _data_->_tmp52_);
#line 1038 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp52_);
#line 9368 "Todoist.c"
		} else {
#line 1043 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = _data_->self->priv->parser;
#line 1043 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = json_parser_get_root (_data_->_tmp53_);
#line 1043 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = json_node_get_object (_data_->_tmp54_);
#line 1043 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = json_object_get_object_member (_data_->_tmp55_, "sync_status");
#line 1043 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = _json_object_ref0 (_data_->_tmp56_);
#line 1043 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp57_;
#line 1044 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = _data_->sync_status;
#line 1044 "../core/Services/Todoist.vala"
			_data_->_tmp59_ = _data_->uuid;
#line 1044 "../core/Services/Todoist.vala"
			_data_->_tmp60_ = json_object_get_member (_data_->_tmp58_, _data_->_tmp59_);
#line 1044 "../core/Services/Todoist.vala"
			_data_->_tmp61_ = __vala_JsonNode_copy0 (_data_->_tmp60_);
#line 1044 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp61_;
#line 1046 "../core/Services/Todoist.vala"
			_data_->_tmp62_ = _data_->uuid_member;
#line 1046 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp62_) == JSON_NODE_VALUE) {
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp63_ = objects_base_object_get_source (_data_->object);
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = _data_->_tmp63_;
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = objects_source_get_todoist_data (_data_->_tmp64_);
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = _data_->_tmp65_;
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = _data_->self->priv->parser;
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = json_parser_get_root (_data_->_tmp67_);
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = json_node_get_object (_data_->_tmp68_);
#line 1047 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = json_object_get_string_member (_data_->_tmp69_, "sync_token");
#line 1047 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_sync_token (_data_->_tmp66_, _data_->_tmp70_);
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = objects_base_object_get_source (_data_->object);
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = _data_->_tmp71_;
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = g_date_time_new_now_local ();
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = _data_->_tmp73_;
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = g_date_time_to_string (_data_->_tmp74_);
#line 1048 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = _data_->_tmp75_;
#line 1048 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp72_, _data_->_tmp76_);
#line 1048 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp76_);
#line 1048 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp74_);
#line 1049 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = objects_base_object_get_source (_data_->object);
#line 1049 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = _data_->_tmp77_;
#line 1049 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp78_);
#line 1051 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = _data_->response;
#line 1051 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp79_, TRUE);
#line 9442 "Todoist.c"
			} else {
#line 1053 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = _data_->response;
#line 1053 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = _data_->sync_status;
#line 1053 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = _data_->uuid;
#line 1053 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp81_, _data_->_tmp82_);
#line 1053 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = json_object_get_string_member (_data_->_tmp83_, "error");
#line 1053 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp80_, _data_->_tmp84_);
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = _data_->sync_status;
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = _data_->uuid;
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp87_ = json_object_get_object_member (_data_->_tmp85_, _data_->_tmp86_);
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp88_ = _data_->sync_status;
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp89_ = _data_->uuid;
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp90_ = json_object_get_object_member (_data_->_tmp88_, _data_->_tmp89_);
#line 1055 "../core/Services/Todoist.vala"
				_data_->_tmp91_ = json_object_get_string_member (_data_->_tmp90_, "error");
#line 1055 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp87_, "http_code"), _data_->_tmp91_);
#line 9472 "Todoist.c"
			}
#line 1035 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 1035 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 9478 "Todoist.c"
		}
#line 1028 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 9482 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1028 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 1028 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 1062 "../core/Services/Todoist.vala"
		_data_->_tmp92_ = _data_->message;
#line 1062 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp92_, "status-code", &_data_->_tmp93_, NULL);
#line 1062 "../core/Services/Todoist.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 1062 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp94_)) {
#line 1063 "../core/Services/Todoist.vala"
			_data_->_tmp95_ = _data_->response;
#line 1063 "../core/Services/Todoist.vala"
			_data_->_tmp96_ = _data_->e;
#line 1063 "../core/Services/Todoist.vala"
			_data_->_tmp97_ = _data_->_tmp96_->message;
#line 1063 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp95_, _data_->_tmp97_);
#line 1065 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = _data_->message;
#line 1065 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp98_, "status-code", &_data_->_tmp99_, NULL);
#line 1065 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = _data_->_tmp99_;
#line 1065 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = _data_->e;
#line 1065 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = _data_->_tmp101_->message;
#line 1065 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp100_, _data_->_tmp102_);
#line 9519 "Todoist.c"
		} else {
#line 1070 "../core/Services/Todoist.vala"
			_data_->_tmp103_ = objects_queue_new ();
#line 1070 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp103_;
#line 1071 "../core/Services/Todoist.vala"
			_data_->_tmp104_ = _data_->queue;
#line 1071 "../core/Services/Todoist.vala"
			_data_->_tmp105_ = _data_->uuid;
#line 1071 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp104_, _data_->_tmp105_);
#line 1072 "../core/Services/Todoist.vala"
			_data_->_tmp106_ = _data_->queue;
#line 1072 "../core/Services/Todoist.vala"
			_data_->_tmp107_ = objects_base_object_get_id (_data_->object);
#line 1072 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = _data_->_tmp107_;
#line 1072 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp106_, _data_->_tmp108_);
#line 1073 "../core/Services/Todoist.vala"
			_data_->_tmp109_ = _data_->queue;
#line 1073 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = objects_base_object_get_type_delete (_data_->object);
#line 1073 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = _data_->_tmp110_;
#line 1073 "../core/Services/Todoist.vala"
			objects_queue_set_query (_data_->_tmp109_, _data_->_tmp111_);
#line 1074 "../core/Services/Todoist.vala"
			_data_->_tmp112_ = _data_->queue;
#line 1074 "../core/Services/Todoist.vala"
			_data_->_tmp113_ = objects_base_object_to_json (_data_->object);
#line 1074 "../core/Services/Todoist.vala"
			_data_->_tmp114_ = _data_->_tmp113_;
#line 1074 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp112_, _data_->_tmp114_);
#line 1074 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp114_);
#line 1076 "../core/Services/Todoist.vala"
			_data_->_tmp115_ = services_database_get_default ();
#line 1076 "../core/Services/Todoist.vala"
			_data_->_tmp116_ = _data_->_tmp115_;
#line 1076 "../core/Services/Todoist.vala"
			_data_->_tmp117_ = _data_->queue;
#line 1076 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp116_, _data_->_tmp117_);
#line 1076 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp116_);
#line 1077 "../core/Services/Todoist.vala"
			_data_->_tmp118_ = _data_->response;
#line 1077 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp118_, TRUE);
#line 1062 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 9573 "Todoist.c"
		}
#line 1028 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 9577 "Todoist.c"
	}
	__finally0:
#line 1028 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1028 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 1028 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 1028 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 1028 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 1028 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1028 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1028 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 1028 "../core/Services/Todoist.vala"
		return FALSE;
#line 9598 "Todoist.c"
	}
#line 1081 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 1081 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 1081 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 1081 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 1081 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1081 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 1081 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1081 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9616 "Todoist.c"
		}
	}
#line 1081 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 1081 "../core/Services/Todoist.vala"
	return FALSE;
#line 9623 "Todoist.c"
}

static void
services_todoist_add_section_if_not_exists (ServicesTodoist* self,
                                            JsonNode* node)
{
	gchar* _id = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	ObjectsProject* project = NULL;
	ServicesStore* _tmp3_;
	const gchar* _tmp4_;
	ObjectsProject* _tmp5_;
	ObjectsProject* _tmp6_;
#line 1088 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1088 "../core/Services/Todoist.vala"
	g_return_if_fail (node != NULL);
#line 1089 "../core/Services/Todoist.vala"
	_tmp0_ = json_node_get_object (node);
#line 1089 "../core/Services/Todoist.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "project_id");
#line 1089 "../core/Services/Todoist.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1089 "../core/Services/Todoist.vala"
	_id = _tmp2_;
#line 1090 "../core/Services/Todoist.vala"
	_tmp3_ = services_store_instance ();
#line 1090 "../core/Services/Todoist.vala"
	_tmp4_ = _id;
#line 1090 "../core/Services/Todoist.vala"
	_tmp5_ = services_store_get_project (_tmp3_, _tmp4_);
#line 1090 "../core/Services/Todoist.vala"
	project = _tmp5_;
#line 1091 "../core/Services/Todoist.vala"
	_tmp6_ = project;
#line 1091 "../core/Services/Todoist.vala"
	if (_tmp6_ != NULL) {
#line 9663 "Todoist.c"
		ObjectsProject* _tmp7_;
		ObjectsSection* _tmp8_;
		ObjectsSection* _tmp9_;
		ObjectsSection* _tmp10_;
		ObjectsSection* _tmp11_;
#line 1092 "../core/Services/Todoist.vala"
		_tmp7_ = project;
#line 1092 "../core/Services/Todoist.vala"
		_tmp8_ = objects_section_new_from_json (node);
#line 1092 "../core/Services/Todoist.vala"
		_tmp9_ = _tmp8_;
#line 1092 "../core/Services/Todoist.vala"
		_tmp10_ = objects_project_add_section_if_not_exists (_tmp7_, _tmp9_);
#line 1092 "../core/Services/Todoist.vala"
		_tmp11_ = _tmp10_;
#line 1092 "../core/Services/Todoist.vala"
		_g_object_unref0 (_tmp11_);
#line 1092 "../core/Services/Todoist.vala"
		_g_object_unref0 (_tmp9_);
#line 9683 "Todoist.c"
	}
#line 1088 "../core/Services/Todoist.vala"
	_g_object_unref0 (project);
#line 1088 "../core/Services/Todoist.vala"
	_g_free0 (_id);
#line 9689 "Todoist.c"
}

static void
services_todoist_complete_item_data_free (gpointer _data)
{
	ServicesTodoistCompleteItemData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->item);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistCompleteItemData, _data_);
#line 9705 "Todoist.c"
}

void
services_todoist_complete_item (ServicesTodoist* self,
                                ObjectsItem* item,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ServicesTodoistCompleteItemData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsItem* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (item != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistCompleteItemData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_complete_item_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (item);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->item);
#line 22 "../core/Services/Todoist.vala"
	_data_->item = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_complete_item_co (_data_);
#line 9739 "Todoist.c"
}

HttpResponse*
services_todoist_complete_item_finish (ServicesTodoist* self,
                                       GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistCompleteItemData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 9756 "Todoist.c"
}

static void
services_todoist_complete_item_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ServicesTodoistCompleteItemData* _data_;
#line 1115 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 1115 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 1115 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 1115 "../core/Services/Todoist.vala"
	services_todoist_complete_item_co (_data_);
#line 9773 "Todoist.c"
}

static gboolean
services_todoist_complete_item_co (ServicesTodoistCompleteItemData* _data_)
{
#line 1100 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 1100 "../core/Services/Todoist.vala"
		case 0:
#line 9783 "Todoist.c"
		goto _state_0;
#line 1100 "../core/Services/Todoist.vala"
		case 1:
#line 9787 "Todoist.c"
		goto _state_1;
		default:
#line 1100 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 9792 "Todoist.c"
	}
	_state_0:
#line 1101 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 1101 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1101 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 1101 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 1101 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 1101 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp3_;
#line 1102 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = objects_item_get_checked (_data_->item);
#line 1102 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 1102 "../core/Services/Todoist.vala"
	if (_data_->_tmp6_) {
#line 1102 "../core/Services/Todoist.vala"
		_data_->_tmp4_ = "item_complete";
#line 9815 "Todoist.c"
	} else {
#line 1102 "../core/Services/Todoist.vala"
		_data_->_tmp4_ = "item_uncomplete";
#line 9819 "Todoist.c"
	}
#line 1102 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->uuid;
#line 1102 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = objects_item_get_check_json (_data_->item, _data_->_tmp7_, _data_->_tmp4_);
#line 1102 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp8_;
#line 1103 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = objects_base_object_get_source ((ObjectsBaseObject*) _data_->item);
#line 1103 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 1103 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 1103 "../core/Services/Todoist.vala"
	_data_->source = _data_->_tmp11_;
#line 1105 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 1105 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp12_;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->message;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = soup_message_get_request_headers (_data_->_tmp13_);
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = _data_->source;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = objects_source_get_todoist_data (_data_->_tmp16_);
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = objects_source_todoist_data_get_access_token (_data_->_tmp18_);
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = g_strdup_printf ("Bearer %s", _data_->_tmp20_);
#line 1106 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 1106 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp15_, "Authorization", _data_->_tmp22_);
#line 1106 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp22_);
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = _data_->message;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->json;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = 0;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = string_get_data (_data_->_tmp24_, &_data_->_tmp26_);
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp25__length1 = _data_->_tmp26_;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = _data_->_tmp25_;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp27__length1 = _data_->_tmp25__length1;
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp28_ = g_bytes_new (_data_->_tmp27_, _data_->_tmp27__length1);
#line 1110 "../core/Services/Todoist.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 1110 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp23_, "application/json", _data_->_tmp29_);
#line 1110 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp29_);
#line 1112 "../core/Services/Todoist.vala"
	_data_->_tmp30_ = http_response_new ();
#line 1112 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp30_;
#line 9889 "Todoist.c"
	{
#line 1115 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->self->priv->session;
#line 1115 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->message;
#line 1115 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 1115 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_HIGH, NULL, services_todoist_complete_item_ready, _data_);
#line 1115 "../core/Services/Todoist.vala"
		return FALSE;
#line 9901 "Todoist.c"
		_state_1:
#line 1115 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
#line 1115 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp33_;
#line 1115 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9909 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1116 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = _data_->self->priv->parser;
#line 1116 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->stream;
#line 1116 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = 0;
#line 1116 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
#line 1116 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
#line 1116 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1116 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 9926 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1119 "../core/Services/Todoist.vala"
		_data_->_tmp38_ = _data_->self->priv->parser;
#line 1119 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
#line 1119 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
#line 1121 "../core/Services/Todoist.vala"
		_data_->_tmp40_ = _data_->message;
#line 1121 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp40_, "status-code", &_data_->_tmp41_, NULL);
#line 1121 "../core/Services/Todoist.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 1121 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp42_)) {
#line 1122 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->response;
#line 1122 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = _data_->self->priv->parser;
#line 1122 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = json_parser_get_root (_data_->_tmp44_);
#line 1122 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp43_, _data_->_tmp45_);
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->message;
#line 1124 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = _data_->message;
#line 1124 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp49_, "status-code", &_data_->_tmp50_, NULL);
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = _data_->_tmp50_;
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp51_);
#line 1124 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = _data_->_tmp52_;
#line 1124 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp48_, _data_->_tmp53_);
#line 1124 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp53_);
#line 9971 "Todoist.c"
		} else {
#line 1129 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = _data_->self->priv->parser;
#line 1129 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = json_parser_get_root (_data_->_tmp54_);
#line 1129 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = json_node_get_object (_data_->_tmp55_);
#line 1129 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = json_object_get_object_member (_data_->_tmp56_, "sync_status");
#line 1129 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = _json_object_ref0 (_data_->_tmp57_);
#line 1129 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp58_;
#line 1130 "../core/Services/Todoist.vala"
			_data_->_tmp59_ = _data_->sync_status;
#line 1130 "../core/Services/Todoist.vala"
			_data_->_tmp60_ = _data_->uuid;
#line 1130 "../core/Services/Todoist.vala"
			_data_->_tmp61_ = json_object_get_member (_data_->_tmp59_, _data_->_tmp60_);
#line 1130 "../core/Services/Todoist.vala"
			_data_->_tmp62_ = __vala_JsonNode_copy0 (_data_->_tmp61_);
#line 1130 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp62_;
#line 1132 "../core/Services/Todoist.vala"
			_data_->_tmp63_ = _data_->uuid_member;
#line 1132 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp63_) == JSON_NODE_VALUE) {
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = _data_->source;
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = objects_source_get_todoist_data (_data_->_tmp64_);
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = _data_->_tmp65_;
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = _data_->self->priv->parser;
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = json_parser_get_root (_data_->_tmp67_);
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = json_node_get_object (_data_->_tmp68_);
#line 1133 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = json_object_get_string_member (_data_->_tmp69_, "sync_token");
#line 1133 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_sync_token (_data_->_tmp66_, _data_->_tmp70_);
#line 1134 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = _data_->response;
#line 1134 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp71_, TRUE);
#line 1136 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = _data_->source;
#line 1136 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = g_date_time_new_now_local ();
#line 1136 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = _data_->_tmp73_;
#line 1136 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = g_date_time_to_string (_data_->_tmp74_);
#line 1136 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = _data_->_tmp75_;
#line 1136 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp72_, _data_->_tmp76_);
#line 1136 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp76_);
#line 1136 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp74_);
#line 1137 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = _data_->source;
#line 1137 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp77_);
#line 10039 "Todoist.c"
			} else {
#line 1139 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = _data_->response;
#line 1139 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = _data_->sync_status;
#line 1139 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = _data_->uuid;
#line 1139 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = json_object_get_object_member (_data_->_tmp79_, _data_->_tmp80_);
#line 1139 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = json_object_get_string_member (_data_->_tmp81_, "error");
#line 1139 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp78_, _data_->_tmp82_);
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = _data_->sync_status;
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = _data_->uuid;
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = _data_->sync_status;
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp87_ = _data_->uuid;
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp88_ = json_object_get_object_member (_data_->_tmp86_, _data_->_tmp87_);
#line 1141 "../core/Services/Todoist.vala"
				_data_->_tmp89_ = json_object_get_string_member (_data_->_tmp88_, "error");
#line 1141 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp85_, "http_code"), _data_->_tmp89_);
#line 10069 "Todoist.c"
			}
#line 1121 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 1121 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 10075 "Todoist.c"
		}
#line 1114 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 10079 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1114 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 1114 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 1148 "../core/Services/Todoist.vala"
		_data_->_tmp90_ = _data_->message;
#line 1148 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp90_, "status-code", &_data_->_tmp91_, NULL);
#line 1148 "../core/Services/Todoist.vala"
		_data_->_tmp92_ = _data_->_tmp91_;
#line 1148 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp92_)) {
#line 1149 "../core/Services/Todoist.vala"
			_data_->_tmp93_ = _data_->response;
#line 1149 "../core/Services/Todoist.vala"
			_data_->_tmp94_ = _data_->e;
#line 1149 "../core/Services/Todoist.vala"
			_data_->_tmp95_ = _data_->_tmp94_->message;
#line 1149 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp93_, _data_->_tmp95_);
#line 1151 "../core/Services/Todoist.vala"
			_data_->_tmp96_ = _data_->message;
#line 1151 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp96_, "status-code", &_data_->_tmp97_, NULL);
#line 1151 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = _data_->_tmp97_;
#line 1151 "../core/Services/Todoist.vala"
			_data_->_tmp99_ = _data_->e;
#line 1151 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = _data_->_tmp99_->message;
#line 1151 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp98_, _data_->_tmp100_);
#line 10116 "Todoist.c"
		} else {
#line 1156 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = objects_queue_new ();
#line 1156 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp101_;
#line 1157 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = _data_->queue;
#line 1157 "../core/Services/Todoist.vala"
			_data_->_tmp103_ = _data_->uuid;
#line 1157 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp102_, _data_->_tmp103_);
#line 1158 "../core/Services/Todoist.vala"
			_data_->_tmp104_ = _data_->queue;
#line 1158 "../core/Services/Todoist.vala"
			_data_->_tmp105_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->item);
#line 1158 "../core/Services/Todoist.vala"
			_data_->_tmp106_ = _data_->_tmp105_;
#line 1158 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp104_, _data_->_tmp106_);
#line 1159 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = objects_item_get_checked (_data_->item);
#line 1159 "../core/Services/Todoist.vala"
			_data_->_tmp109_ = _data_->_tmp108_;
#line 1159 "../core/Services/Todoist.vala"
			if (_data_->_tmp109_) {
#line 1159 "../core/Services/Todoist.vala"
				_data_->_tmp107_ = "item_complete";
#line 10144 "Todoist.c"
			} else {
#line 1159 "../core/Services/Todoist.vala"
				_data_->_tmp107_ = "item_uncomplete";
#line 10148 "Todoist.c"
			}
#line 1159 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = _data_->queue;
#line 1159 "../core/Services/Todoist.vala"
			objects_queue_set_query (_data_->_tmp110_, _data_->_tmp107_);
#line 1160 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = _data_->queue;
#line 1160 "../core/Services/Todoist.vala"
			_data_->_tmp112_ = objects_base_object_to_json ((ObjectsBaseObject*) _data_->item);
#line 1160 "../core/Services/Todoist.vala"
			_data_->_tmp113_ = _data_->_tmp112_;
#line 1160 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp111_, _data_->_tmp113_);
#line 1160 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp113_);
#line 1162 "../core/Services/Todoist.vala"
			_data_->_tmp114_ = services_database_get_default ();
#line 1162 "../core/Services/Todoist.vala"
			_data_->_tmp115_ = _data_->_tmp114_;
#line 1162 "../core/Services/Todoist.vala"
			_data_->_tmp116_ = _data_->queue;
#line 1162 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp115_, _data_->_tmp116_);
#line 1162 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp115_);
#line 1163 "../core/Services/Todoist.vala"
			_data_->_tmp117_ = _data_->response;
#line 1163 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp117_, TRUE);
#line 1148 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 10180 "Todoist.c"
		}
#line 1114 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 10184 "Todoist.c"
	}
	__finally0:
#line 1114 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1114 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 1114 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 1114 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->source);
#line 1114 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 1114 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 1114 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1114 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1114 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 1114 "../core/Services/Todoist.vala"
		return FALSE;
#line 10207 "Todoist.c"
	}
#line 1167 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 1167 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 1167 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 1167 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 1167 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 1167 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1167 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 1167 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1167 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10227 "Todoist.c"
		}
	}
#line 1167 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 1167 "../core/Services/Todoist.vala"
	return FALSE;
#line 10234 "Todoist.c"
}

static void
services_todoist_print_root (ServicesTodoist* self,
                             JsonNode* root)
{
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 1170 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1170 "../core/Services/Todoist.vala"
	g_return_if_fail (root != NULL);
#line 1171 "../core/Services/Todoist.vala"
	_tmp0_ = json_generator_new ();
#line 1171 "../core/Services/Todoist.vala"
	generator = _tmp0_;
#line 1172 "../core/Services/Todoist.vala"
	json_generator_set_root (generator, root);
#line 1173 "../core/Services/Todoist.vala"
	_tmp1_ = json_generator_to_data (generator, NULL);
#line 1173 "../core/Services/Todoist.vala"
	_tmp2_ = _tmp1_;
#line 1173 "../core/Services/Todoist.vala"
	_tmp3_ = g_strconcat (_tmp2_, "\n", NULL);
#line 1173 "../core/Services/Todoist.vala"
	_tmp4_ = _tmp3_;
#line 1173 "../core/Services/Todoist.vala"
	g_print ("%s", _tmp4_);
#line 1173 "../core/Services/Todoist.vala"
	_g_free0 (_tmp4_);
#line 1173 "../core/Services/Todoist.vala"
	_g_free0 (_tmp2_);
#line 1170 "../core/Services/Todoist.vala"
	_g_object_unref0 (generator);
#line 10273 "Todoist.c"
}

gchar*
services_todoist_get_delete_json (ServicesTodoist* self,
                                  const gchar* id,
                                  const gchar* type,
                                  const gchar* uuid)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp1_;
	JsonNode* root = NULL;
	JsonNode* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 1176 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1176 "../core/Services/Todoist.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1176 "../core/Services/Todoist.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 1176 "../core/Services/Todoist.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1177 "../core/Services/Todoist.vala"
	_tmp0_ = json_builder_new ();
#line 1177 "../core/Services/Todoist.vala"
	builder = _tmp0_;
#line 1178 "../core/Services/Todoist.vala"
	json_builder_begin_object (builder);
#line 1179 "../core/Services/Todoist.vala"
	json_builder_set_member_name (builder, "commands");
#line 1180 "../core/Services/Todoist.vala"
	json_builder_begin_array (builder);
#line 1181 "../core/Services/Todoist.vala"
	json_builder_begin_object (builder);
#line 1184 "../core/Services/Todoist.vala"
	json_builder_set_member_name (builder, "type");
#line 1185 "../core/Services/Todoist.vala"
	json_builder_add_string_value (builder, type);
#line 1187 "../core/Services/Todoist.vala"
	json_builder_set_member_name (builder, "uuid");
#line 1188 "../core/Services/Todoist.vala"
	json_builder_add_string_value (builder, uuid);
#line 1190 "../core/Services/Todoist.vala"
	json_builder_set_member_name (builder, "args");
#line 1191 "../core/Services/Todoist.vala"
	json_builder_begin_object (builder);
#line 1193 "../core/Services/Todoist.vala"
	json_builder_set_member_name (builder, "id");
#line 1194 "../core/Services/Todoist.vala"
	json_builder_add_string_value (builder, id);
#line 1196 "../core/Services/Todoist.vala"
	json_builder_end_object (builder);
#line 1198 "../core/Services/Todoist.vala"
	json_builder_end_object (builder);
#line 1199 "../core/Services/Todoist.vala"
	json_builder_end_array (builder);
#line 1200 "../core/Services/Todoist.vala"
	json_builder_end_object (builder);
#line 1202 "../core/Services/Todoist.vala"
	_tmp1_ = json_generator_new ();
#line 1202 "../core/Services/Todoist.vala"
	generator = _tmp1_;
#line 1203 "../core/Services/Todoist.vala"
	_tmp2_ = json_builder_get_root (builder);
#line 1203 "../core/Services/Todoist.vala"
	root = _tmp2_;
#line 1204 "../core/Services/Todoist.vala"
	json_generator_set_root (generator, root);
#line 1206 "../core/Services/Todoist.vala"
	_tmp3_ = json_generator_to_data (generator, NULL);
#line 1206 "../core/Services/Todoist.vala"
	result = _tmp3_;
#line 1206 "../core/Services/Todoist.vala"
	__vala_JsonNode_free0 (root);
#line 1206 "../core/Services/Todoist.vala"
	_g_object_unref0 (generator);
#line 1206 "../core/Services/Todoist.vala"
	_g_object_unref0 (builder);
#line 1206 "../core/Services/Todoist.vala"
	return result;
#line 10356 "Todoist.c"
}

static void
services_todoist_move_item_data_free (gpointer _data)
{
	ServicesTodoistMoveItemData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->item);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->type);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->id);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistMoveItemData, _data_);
#line 10376 "Todoist.c"
}

void
services_todoist_move_item (ServicesTodoist* self,
                            ObjectsItem* item,
                            const gchar* type,
                            const gchar* id,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	ServicesTodoistMoveItemData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsItem* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (item != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (type != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (id != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistMoveItemData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_move_item_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (item);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->item);
#line 22 "../core/Services/Todoist.vala"
	_data_->item = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	_tmp2_ = g_strdup (type);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->type);
#line 22 "../core/Services/Todoist.vala"
	_data_->type = _tmp2_;
#line 22 "../core/Services/Todoist.vala"
	_tmp3_ = g_strdup (id);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->id);
#line 22 "../core/Services/Todoist.vala"
	_data_->id = _tmp3_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_move_item_co (_data_);
#line 10430 "Todoist.c"
}

HttpResponse*
services_todoist_move_item_finish (ServicesTodoist* self,
                                   GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistMoveItemData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 10447 "Todoist.c"
}

static void
services_todoist_move_item_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	ServicesTodoistMoveItemData* _data_;
#line 1224 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 1224 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 1224 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 1224 "../core/Services/Todoist.vala"
	services_todoist_move_item_co (_data_);
#line 10464 "Todoist.c"
}

static gboolean
services_todoist_move_item_co (ServicesTodoistMoveItemData* _data_)
{
#line 1209 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 1209 "../core/Services/Todoist.vala"
		case 0:
#line 10474 "Todoist.c"
		goto _state_0;
#line 1209 "../core/Services/Todoist.vala"
		case 1:
#line 10478 "Todoist.c"
		goto _state_1;
		default:
#line 1209 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 10483 "Todoist.c"
	}
	_state_0:
#line 1210 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 1210 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1210 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 1210 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 1210 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 1210 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp3_;
#line 1211 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->uuid;
#line 1211 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = objects_item_get_move_item (_data_->item, _data_->_tmp4_, _data_->type, _data_->id);
#line 1211 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp5_;
#line 1212 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = objects_base_object_get_source ((ObjectsBaseObject*) _data_->item);
#line 1212 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1212 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 1212 "../core/Services/Todoist.vala"
	_data_->source = _data_->_tmp8_;
#line 1214 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 1214 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp9_;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->message;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->source;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = objects_source_get_todoist_data (_data_->_tmp13_);
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = objects_source_todoist_data_get_access_token (_data_->_tmp15_);
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = g_strdup_printf ("Bearer %s", _data_->_tmp17_);
#line 1215 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 1215 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp19_);
#line 1215 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp19_);
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = _data_->message;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = _data_->json;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = 0;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = string_get_data (_data_->_tmp21_, &_data_->_tmp23_);
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp22__length1 = _data_->_tmp23_;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->_tmp22_;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp24__length1 = _data_->_tmp22__length1;
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = g_bytes_new (_data_->_tmp24_, _data_->_tmp24__length1);
#line 1219 "../core/Services/Todoist.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 1219 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp20_, "application/json", _data_->_tmp26_);
#line 1219 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp26_);
#line 1221 "../core/Services/Todoist.vala"
	_data_->_tmp27_ = http_response_new ();
#line 1221 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp27_;
#line 10566 "Todoist.c"
	{
#line 1224 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = _data_->self->priv->session;
#line 1224 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = _data_->message;
#line 1224 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 1224 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp28_, _data_->_tmp29_, G_PRIORITY_HIGH, NULL, services_todoist_move_item_ready, _data_);
#line 1224 "../core/Services/Todoist.vala"
		return FALSE;
#line 10578 "Todoist.c"
		_state_1:
#line 1224 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = soup_session_send_and_read_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
#line 1224 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp30_;
#line 1224 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 10586 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1225 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = _data_->self->priv->parser;
#line 1225 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->stream;
#line 1225 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = 0;
#line 1225 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = g_bytes_get_data (_data_->_tmp32_, &_data_->_tmp33_);
#line 1225 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp31_, (const gchar*) _data_->_tmp34_, (gssize) -1, &_data_->_inner_error0_);
#line 1225 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1225 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 10603 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1227 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->self->priv->parser;
#line 1227 "../core/Services/Todoist.vala"
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
#line 1227 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp36_);
#line 1229 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = _data_->message;
#line 1229 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
#line 1229 "../core/Services/Todoist.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 1229 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp39_)) {
#line 1230 "../core/Services/Todoist.vala"
			_data_->_tmp40_ = _data_->response;
#line 1230 "../core/Services/Todoist.vala"
			_data_->_tmp41_ = _data_->self->priv->parser;
#line 1230 "../core/Services/Todoist.vala"
			_data_->_tmp42_ = json_parser_get_root (_data_->_tmp41_);
#line 1230 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp40_, _data_->_tmp42_);
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->message;
#line 1232 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp43_, "status-code", &_data_->_tmp44_, NULL);
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp45_ = _data_->_tmp44_;
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->message;
#line 1232 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp48_);
#line 1232 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = _data_->_tmp49_;
#line 1232 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp45_, _data_->_tmp50_);
#line 1232 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp50_);
#line 10648 "Todoist.c"
		} else {
#line 1237 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = _data_->self->priv->parser;
#line 1237 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = json_parser_get_root (_data_->_tmp51_);
#line 1237 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = json_node_get_object (_data_->_tmp52_);
#line 1237 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
#line 1237 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = _json_object_ref0 (_data_->_tmp54_);
#line 1237 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp55_;
#line 1238 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = _data_->sync_status;
#line 1238 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = _data_->uuid;
#line 1238 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = json_object_get_member (_data_->_tmp56_, _data_->_tmp57_);
#line 1238 "../core/Services/Todoist.vala"
			_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
#line 1238 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp59_;
#line 1240 "../core/Services/Todoist.vala"
			_data_->_tmp60_ = _data_->uuid_member;
#line 1240 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp61_ = _data_->source;
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp62_ = objects_source_get_todoist_data (_data_->_tmp61_);
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp63_ = _data_->_tmp62_;
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = _data_->self->priv->parser;
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = json_parser_get_root (_data_->_tmp64_);
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = json_node_get_object (_data_->_tmp65_);
#line 1241 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "sync_token");
#line 1241 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_sync_token (_data_->_tmp63_, _data_->_tmp67_);
#line 1242 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = _data_->response;
#line 1242 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp68_, TRUE);
#line 1244 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = _data_->source;
#line 1244 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = g_date_time_new_now_local ();
#line 1244 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 1244 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
#line 1244 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = _data_->_tmp72_;
#line 1244 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
#line 1244 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp73_);
#line 1244 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp71_);
#line 1245 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = _data_->source;
#line 1245 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp74_);
#line 10716 "Todoist.c"
			} else {
#line 1247 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = _data_->response;
#line 1247 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = _data_->sync_status;
#line 1247 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = _data_->uuid;
#line 1247 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = json_object_get_object_member (_data_->_tmp76_, _data_->_tmp77_);
#line 1247 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = json_object_get_string_member (_data_->_tmp78_, "error");
#line 1247 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp75_, _data_->_tmp79_);
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = _data_->sync_status;
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = _data_->uuid;
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = json_object_get_object_member (_data_->_tmp80_, _data_->_tmp81_);
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = _data_->sync_status;
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = _data_->uuid;
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
#line 1249 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = json_object_get_string_member (_data_->_tmp85_, "error");
#line 1249 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp82_, "http_code"), _data_->_tmp86_);
#line 10746 "Todoist.c"
			}
#line 1229 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 1229 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 10752 "Todoist.c"
		}
#line 1223 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 10756 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1223 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 1223 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 1256 "../core/Services/Todoist.vala"
		_data_->_tmp87_ = _data_->message;
#line 1256 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp87_, "status-code", &_data_->_tmp88_, NULL);
#line 1256 "../core/Services/Todoist.vala"
		_data_->_tmp89_ = _data_->_tmp88_;
#line 1256 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp89_)) {
#line 1257 "../core/Services/Todoist.vala"
			_data_->_tmp90_ = _data_->response;
#line 1257 "../core/Services/Todoist.vala"
			_data_->_tmp91_ = _data_->e;
#line 1257 "../core/Services/Todoist.vala"
			_data_->_tmp92_ = _data_->_tmp91_->message;
#line 1257 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp90_, _data_->_tmp92_);
#line 1259 "../core/Services/Todoist.vala"
			_data_->_tmp93_ = _data_->message;
#line 1259 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp93_, "status-code", &_data_->_tmp94_, NULL);
#line 1259 "../core/Services/Todoist.vala"
			_data_->_tmp95_ = _data_->_tmp94_;
#line 1259 "../core/Services/Todoist.vala"
			_data_->_tmp96_ = _data_->e;
#line 1259 "../core/Services/Todoist.vala"
			_data_->_tmp97_ = _data_->_tmp96_->message;
#line 1259 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp95_, _data_->_tmp97_);
#line 10793 "Todoist.c"
		} else {
#line 1264 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = objects_queue_new ();
#line 1264 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp98_;
#line 1265 "../core/Services/Todoist.vala"
			_data_->_tmp99_ = _data_->queue;
#line 1265 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = _data_->uuid;
#line 1265 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp99_, _data_->_tmp100_);
#line 1266 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = _data_->queue;
#line 1266 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->item);
#line 1266 "../core/Services/Todoist.vala"
			_data_->_tmp103_ = _data_->_tmp102_;
#line 1266 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp101_, _data_->_tmp103_);
#line 1267 "../core/Services/Todoist.vala"
			_data_->_tmp104_ = _data_->queue;
#line 1267 "../core/Services/Todoist.vala"
			objects_queue_set_query (_data_->_tmp104_, "item_move");
#line 1268 "../core/Services/Todoist.vala"
			_data_->_tmp105_ = _data_->queue;
#line 1268 "../core/Services/Todoist.vala"
			_data_->_tmp106_ = objects_item_to_move_json (_data_->item, _data_->type, _data_->id);
#line 1268 "../core/Services/Todoist.vala"
			_data_->_tmp107_ = _data_->_tmp106_;
#line 1268 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp105_, _data_->_tmp107_);
#line 1268 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp107_);
#line 1270 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = services_database_get_default ();
#line 1270 "../core/Services/Todoist.vala"
			_data_->_tmp109_ = _data_->_tmp108_;
#line 1270 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = _data_->queue;
#line 1270 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp109_, _data_->_tmp110_);
#line 1270 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp109_);
#line 1271 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = _data_->response;
#line 1271 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp111_, TRUE);
#line 1256 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 10843 "Todoist.c"
		}
#line 1223 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 10847 "Todoist.c"
	}
	__finally0:
#line 1223 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1223 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 1223 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 1223 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->source);
#line 1223 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 1223 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 1223 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1223 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1223 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 1223 "../core/Services/Todoist.vala"
		return FALSE;
#line 10870 "Todoist.c"
	}
#line 1275 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 1275 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 1275 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->source);
#line 1275 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 1275 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 1275 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1275 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 1275 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1275 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10890 "Todoist.c"
		}
	}
#line 1275 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 1275 "../core/Services/Todoist.vala"
	return FALSE;
#line 10897 "Todoist.c"
}

static void
services_todoist_move_project_section_data_free (gpointer _data)
{
	ServicesTodoistMoveProjectSectionData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->base_object);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->project_id);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistMoveProjectSectionData, _data_);
#line 10915 "Todoist.c"
}

void
services_todoist_move_project_section (ServicesTodoist* self,
                                       ObjectsBaseObject* base_object,
                                       const gchar* project_id,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ServicesTodoistMoveProjectSectionData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
	gchar* _tmp2_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (base_object != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (project_id != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistMoveProjectSectionData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_move_project_section_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (base_object);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->base_object);
#line 22 "../core/Services/Todoist.vala"
	_data_->base_object = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	_tmp2_ = g_strdup (project_id);
#line 22 "../core/Services/Todoist.vala"
	_g_free0 (_data_->project_id);
#line 22 "../core/Services/Todoist.vala"
	_data_->project_id = _tmp2_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_move_project_section_co (_data_);
#line 10959 "Todoist.c"
}

HttpResponse*
services_todoist_move_project_section_finish (ServicesTodoist* self,
                                              GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistMoveProjectSectionData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 10976 "Todoist.c"
}

static void
services_todoist_move_project_section_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ServicesTodoistMoveProjectSectionData* _data_;
#line 1292 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 1292 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 1292 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 1292 "../core/Services/Todoist.vala"
	services_todoist_move_project_section_co (_data_);
#line 10993 "Todoist.c"
}

static gboolean
services_todoist_move_project_section_co (ServicesTodoistMoveProjectSectionData* _data_)
{
#line 1278 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 1278 "../core/Services/Todoist.vala"
		case 0:
#line 11003 "Todoist.c"
		goto _state_0;
#line 1278 "../core/Services/Todoist.vala"
		case 1:
#line 11007 "Todoist.c"
		goto _state_1;
		default:
#line 1278 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 11012 "Todoist.c"
	}
	_state_0:
#line 1279 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = util_get_default ();
#line 1279 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1279 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
#line 1279 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 1279 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 1279 "../core/Services/Todoist.vala"
	_data_->uuid = _data_->_tmp3_;
#line 1280 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->uuid;
#line 1280 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = objects_base_object_get_move_json (_data_->base_object, _data_->_tmp4_, _data_->project_id);
#line 1280 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp5_;
#line 1282 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 1282 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp6_;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = _data_->message;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = soup_message_get_request_headers (_data_->_tmp7_);
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = objects_base_object_get_source (_data_->base_object);
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = objects_source_get_todoist_data (_data_->_tmp11_);
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = objects_source_todoist_data_get_access_token (_data_->_tmp13_);
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = g_strdup_printf ("Bearer %s", _data_->_tmp15_);
#line 1283 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 1283 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp9_, "Authorization", _data_->_tmp17_);
#line 1283 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp17_);
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = _data_->message;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->json;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp21_ = 0;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = string_get_data (_data_->_tmp19_, &_data_->_tmp21_);
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp20__length1 = _data_->_tmp21_;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp22_ = _data_->_tmp20_;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp22__length1 = _data_->_tmp20__length1;
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp23_ = g_bytes_new (_data_->_tmp22_, _data_->_tmp22__length1);
#line 1287 "../core/Services/Todoist.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 1287 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp18_, "application/json", _data_->_tmp24_);
#line 1287 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp24_);
#line 1289 "../core/Services/Todoist.vala"
	_data_->_tmp25_ = http_response_new ();
#line 1289 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp25_;
#line 11089 "Todoist.c"
	{
#line 1292 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = _data_->self->priv->session;
#line 1292 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = _data_->message;
#line 1292 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 1292 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp26_, _data_->_tmp27_, G_PRIORITY_HIGH, NULL, services_todoist_move_project_section_ready, _data_);
#line 1292 "../core/Services/Todoist.vala"
		return FALSE;
#line 11101 "Todoist.c"
		_state_1:
#line 1292 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = soup_session_send_and_read_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
#line 1292 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp28_;
#line 1292 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 11109 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1293 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = _data_->self->priv->parser;
#line 1293 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->stream;
#line 1293 "../core/Services/Todoist.vala"
		_data_->_tmp31_ = 0;
#line 1293 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = g_bytes_get_data (_data_->_tmp30_, &_data_->_tmp31_);
#line 1293 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp29_, (const gchar*) _data_->_tmp32_, (gssize) -1, &_data_->_inner_error0_);
#line 1293 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1293 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 11126 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1295 "../core/Services/Todoist.vala"
		_data_->_tmp33_ = _data_->self->priv->parser;
#line 1295 "../core/Services/Todoist.vala"
		_data_->_tmp34_ = json_parser_get_root (_data_->_tmp33_);
#line 1295 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp34_);
#line 1297 "../core/Services/Todoist.vala"
		_data_->_tmp35_ = _data_->message;
#line 1297 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp35_, "status-code", &_data_->_tmp36_, NULL);
#line 1297 "../core/Services/Todoist.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 1297 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp37_)) {
#line 1298 "../core/Services/Todoist.vala"
			_data_->_tmp38_ = _data_->response;
#line 1298 "../core/Services/Todoist.vala"
			_data_->_tmp39_ = _data_->self->priv->parser;
#line 1298 "../core/Services/Todoist.vala"
			_data_->_tmp40_ = json_parser_get_root (_data_->_tmp39_);
#line 1298 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp38_, _data_->_tmp40_);
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp41_ = _data_->message;
#line 1300 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp41_, "status-code", &_data_->_tmp42_, NULL);
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->_tmp42_;
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = _data_->message;
#line 1300 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp44_, "status-code", &_data_->_tmp45_, NULL);
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp46_ = _data_->_tmp45_;
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp47_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp46_);
#line 1300 "../core/Services/Todoist.vala"
			_data_->_tmp48_ = _data_->_tmp47_;
#line 1300 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp43_, _data_->_tmp48_);
#line 1300 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp48_);
#line 11171 "Todoist.c"
		} else {
#line 1305 "../core/Services/Todoist.vala"
			_data_->_tmp49_ = _data_->self->priv->parser;
#line 1305 "../core/Services/Todoist.vala"
			_data_->_tmp50_ = json_parser_get_root (_data_->_tmp49_);
#line 1305 "../core/Services/Todoist.vala"
			_data_->_tmp51_ = json_node_get_object (_data_->_tmp50_);
#line 1305 "../core/Services/Todoist.vala"
			_data_->_tmp52_ = json_object_get_object_member (_data_->_tmp51_, "sync_status");
#line 1305 "../core/Services/Todoist.vala"
			_data_->_tmp53_ = _json_object_ref0 (_data_->_tmp52_);
#line 1305 "../core/Services/Todoist.vala"
			_data_->sync_status = _data_->_tmp53_;
#line 1306 "../core/Services/Todoist.vala"
			_data_->_tmp54_ = _data_->sync_status;
#line 1306 "../core/Services/Todoist.vala"
			_data_->_tmp55_ = _data_->uuid;
#line 1306 "../core/Services/Todoist.vala"
			_data_->_tmp56_ = json_object_get_member (_data_->_tmp54_, _data_->_tmp55_);
#line 1306 "../core/Services/Todoist.vala"
			_data_->_tmp57_ = __vala_JsonNode_copy0 (_data_->_tmp56_);
#line 1306 "../core/Services/Todoist.vala"
			_data_->uuid_member = _data_->_tmp57_;
#line 1308 "../core/Services/Todoist.vala"
			_data_->_tmp58_ = _data_->uuid_member;
#line 1308 "../core/Services/Todoist.vala"
			if (json_node_get_node_type (_data_->_tmp58_) == JSON_NODE_VALUE) {
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp59_ = objects_base_object_get_source (_data_->base_object);
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp60_ = _data_->_tmp59_;
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp61_ = objects_source_get_todoist_data (_data_->_tmp60_);
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp62_ = _data_->_tmp61_;
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp63_ = _data_->self->priv->parser;
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp64_ = json_parser_get_root (_data_->_tmp63_);
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp65_ = json_node_get_object (_data_->_tmp64_);
#line 1309 "../core/Services/Todoist.vala"
				_data_->_tmp66_ = json_object_get_string_member (_data_->_tmp65_, "sync_token");
#line 1309 "../core/Services/Todoist.vala"
				objects_source_todoist_data_set_access_token (_data_->_tmp62_, _data_->_tmp66_);
#line 1310 "../core/Services/Todoist.vala"
				_data_->_tmp67_ = _data_->response;
#line 1310 "../core/Services/Todoist.vala"
				http_response_set_status (_data_->_tmp67_, TRUE);
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp68_ = objects_base_object_get_source (_data_->base_object);
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp69_ = _data_->_tmp68_;
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp70_ = g_date_time_new_now_local ();
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
#line 1312 "../core/Services/Todoist.vala"
				_data_->_tmp73_ = _data_->_tmp72_;
#line 1312 "../core/Services/Todoist.vala"
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
#line 1312 "../core/Services/Todoist.vala"
				_g_free0 (_data_->_tmp73_);
#line 1312 "../core/Services/Todoist.vala"
				_g_date_time_unref0 (_data_->_tmp71_);
#line 1313 "../core/Services/Todoist.vala"
				_data_->_tmp74_ = objects_base_object_get_source (_data_->base_object);
#line 1313 "../core/Services/Todoist.vala"
				_data_->_tmp75_ = _data_->_tmp74_;
#line 1313 "../core/Services/Todoist.vala"
				objects_source_save (_data_->_tmp75_);
#line 11245 "Todoist.c"
			} else {
#line 1315 "../core/Services/Todoist.vala"
				_data_->_tmp76_ = _data_->response;
#line 1315 "../core/Services/Todoist.vala"
				_data_->_tmp77_ = _data_->sync_status;
#line 1315 "../core/Services/Todoist.vala"
				_data_->_tmp78_ = _data_->uuid;
#line 1315 "../core/Services/Todoist.vala"
				_data_->_tmp79_ = json_object_get_object_member (_data_->_tmp77_, _data_->_tmp78_);
#line 1315 "../core/Services/Todoist.vala"
				_data_->_tmp80_ = json_object_get_string_member (_data_->_tmp79_, "error");
#line 1315 "../core/Services/Todoist.vala"
				http_response_set_error (_data_->_tmp76_, _data_->_tmp80_);
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp81_ = _data_->sync_status;
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp82_ = _data_->uuid;
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp81_, _data_->_tmp82_);
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp84_ = _data_->sync_status;
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp85_ = _data_->uuid;
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp86_ = json_object_get_object_member (_data_->_tmp84_, _data_->_tmp85_);
#line 1317 "../core/Services/Todoist.vala"
				_data_->_tmp87_ = json_object_get_string_member (_data_->_tmp86_, "error");
#line 1317 "../core/Services/Todoist.vala"
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp83_, "http_code"), _data_->_tmp87_);
#line 11275 "Todoist.c"
			}
#line 1297 "../core/Services/Todoist.vala"
			__vala_JsonNode_free0 (_data_->uuid_member);
#line 1297 "../core/Services/Todoist.vala"
			_json_object_unref0 (_data_->sync_status);
#line 11281 "Todoist.c"
		}
#line 1291 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 11285 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1291 "../core/Services/Todoist.vala"
		_data_->e = _data_->_inner_error0_;
#line 1291 "../core/Services/Todoist.vala"
		_data_->_inner_error0_ = NULL;
#line 1324 "../core/Services/Todoist.vala"
		_data_->_tmp88_ = _data_->message;
#line 1324 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp88_, "status-code", &_data_->_tmp89_, NULL);
#line 1324 "../core/Services/Todoist.vala"
		_data_->_tmp90_ = _data_->_tmp89_;
#line 1324 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp90_)) {
#line 1325 "../core/Services/Todoist.vala"
			_data_->_tmp91_ = _data_->response;
#line 1325 "../core/Services/Todoist.vala"
			_data_->_tmp92_ = _data_->e;
#line 1325 "../core/Services/Todoist.vala"
			_data_->_tmp93_ = _data_->_tmp92_->message;
#line 1325 "../core/Services/Todoist.vala"
			http_response_set_error (_data_->_tmp91_, _data_->_tmp93_);
#line 1327 "../core/Services/Todoist.vala"
			_data_->_tmp94_ = _data_->message;
#line 1327 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp94_, "status-code", &_data_->_tmp95_, NULL);
#line 1327 "../core/Services/Todoist.vala"
			_data_->_tmp96_ = _data_->_tmp95_;
#line 1327 "../core/Services/Todoist.vala"
			_data_->_tmp97_ = _data_->e;
#line 1327 "../core/Services/Todoist.vala"
			_data_->_tmp98_ = _data_->_tmp97_->message;
#line 1327 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp96_, _data_->_tmp98_);
#line 11322 "Todoist.c"
		} else {
#line 1332 "../core/Services/Todoist.vala"
			_data_->_tmp99_ = objects_queue_new ();
#line 1332 "../core/Services/Todoist.vala"
			_data_->queue = _data_->_tmp99_;
#line 1333 "../core/Services/Todoist.vala"
			_data_->_tmp100_ = _data_->queue;
#line 1333 "../core/Services/Todoist.vala"
			_data_->_tmp101_ = _data_->uuid;
#line 1333 "../core/Services/Todoist.vala"
			objects_queue_set_uuid (_data_->_tmp100_, _data_->_tmp101_);
#line 1334 "../core/Services/Todoist.vala"
			_data_->_tmp102_ = _data_->queue;
#line 1334 "../core/Services/Todoist.vala"
			_data_->_tmp103_ = objects_base_object_get_id (_data_->base_object);
#line 1334 "../core/Services/Todoist.vala"
			_data_->_tmp104_ = _data_->_tmp103_;
#line 1334 "../core/Services/Todoist.vala"
			objects_queue_set_object_id (_data_->_tmp102_, _data_->_tmp104_);
#line 1335 "../core/Services/Todoist.vala"
			if (OBJECTS_IS_PROJECT (_data_->base_object)) {
#line 1336 "../core/Services/Todoist.vala"
				_data_->_tmp105_ = _data_->queue;
#line 1336 "../core/Services/Todoist.vala"
				objects_queue_set_query (_data_->_tmp105_, "project_move");
#line 11348 "Todoist.c"
			} else {
#line 1338 "../core/Services/Todoist.vala"
				_data_->_tmp106_ = _data_->queue;
#line 1338 "../core/Services/Todoist.vala"
				objects_queue_set_query (_data_->_tmp106_, "section_move");
#line 11354 "Todoist.c"
			}
#line 1341 "../core/Services/Todoist.vala"
			_data_->_tmp107_ = _data_->queue;
#line 1341 "../core/Services/Todoist.vala"
			_data_->_tmp108_ = objects_base_object_to_json (_data_->base_object);
#line 1341 "../core/Services/Todoist.vala"
			_data_->_tmp109_ = _data_->_tmp108_;
#line 1341 "../core/Services/Todoist.vala"
			objects_queue_set_args (_data_->_tmp107_, _data_->_tmp109_);
#line 1341 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp109_);
#line 1342 "../core/Services/Todoist.vala"
			_data_->_tmp110_ = _data_->response;
#line 1342 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp110_, TRUE);
#line 1344 "../core/Services/Todoist.vala"
			_data_->_tmp111_ = services_database_get_default ();
#line 1344 "../core/Services/Todoist.vala"
			_data_->_tmp112_ = _data_->_tmp111_;
#line 1344 "../core/Services/Todoist.vala"
			_data_->_tmp113_ = _data_->queue;
#line 1344 "../core/Services/Todoist.vala"
			services_database_insert_queue (_data_->_tmp112_, _data_->_tmp113_);
#line 1344 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->_tmp112_);
#line 1324 "../core/Services/Todoist.vala"
			_g_object_unref0 (_data_->queue);
#line 11382 "Todoist.c"
		}
#line 1291 "../core/Services/Todoist.vala"
		_g_error_free0 (_data_->e);
#line 11386 "Todoist.c"
	}
	__finally0:
#line 1291 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1291 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 1291 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 1291 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 1291 "../core/Services/Todoist.vala"
		_g_free0 (_data_->uuid);
#line 1291 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1291 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1291 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 1291 "../core/Services/Todoist.vala"
		return FALSE;
#line 11407 "Todoist.c"
	}
#line 1348 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 1348 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 1348 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 1348 "../core/Services/Todoist.vala"
	_g_free0 (_data_->uuid);
#line 1348 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1348 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 1348 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1348 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11425 "Todoist.c"
		}
	}
#line 1348 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 1348 "../core/Services/Todoist.vala"
	return FALSE;
#line 11432 "Todoist.c"
}

static void
services_todoist_duplicate_project_data_free (gpointer _data)
{
	ServicesTodoistDuplicateProjectData* _data_;
	_data_ = _data;
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->project);
#line 22 "../core/Services/Todoist.vala"
	_http_response_unref0 (_data_->result);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../core/Services/Todoist.vala"
	g_slice_free (ServicesTodoistDuplicateProjectData, _data_);
#line 11448 "Todoist.c"
}

void
services_todoist_duplicate_project (ServicesTodoist* self,
                                    ObjectsProject* project,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ServicesTodoistDuplicateProjectData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsProject* _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 22 "../core/Services/Todoist.vala"
	g_return_if_fail (project != NULL);
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_slice_new0 (ServicesTodoistDuplicateProjectData);
#line 22 "../core/Services/Todoist.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../core/Services/Todoist.vala"
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_duplicate_project_data_free);
#line 22 "../core/Services/Todoist.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../core/Services/Todoist.vala"
	_data_->self = _tmp0_;
#line 22 "../core/Services/Todoist.vala"
	_tmp1_ = _g_object_ref0 (project);
#line 22 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->project);
#line 22 "../core/Services/Todoist.vala"
	_data_->project = _tmp1_;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_duplicate_project_co (_data_);
#line 11482 "Todoist.c"
}

HttpResponse*
services_todoist_duplicate_project_finish (ServicesTodoist* self,
                                           GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistDuplicateProjectData* _data_;
#line 22 "../core/Services/Todoist.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../core/Services/Todoist.vala"
	result = _data_->result;
#line 22 "../core/Services/Todoist.vala"
	_data_->result = NULL;
#line 22 "../core/Services/Todoist.vala"
	return result;
#line 11499 "Todoist.c"
}

static void
services_todoist_duplicate_project_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ServicesTodoistDuplicateProjectData* _data_;
#line 1364 "../core/Services/Todoist.vala"
	_data_ = _user_data_;
#line 1364 "../core/Services/Todoist.vala"
	_data_->_source_object_ = source_object;
#line 1364 "../core/Services/Todoist.vala"
	_data_->_res_ = _res_;
#line 1364 "../core/Services/Todoist.vala"
	services_todoist_duplicate_project_co (_data_);
#line 11516 "Todoist.c"
}

static gboolean
services_todoist_duplicate_project_co (ServicesTodoistDuplicateProjectData* _data_)
{
#line 1351 "../core/Services/Todoist.vala"
	switch (_data_->_state_) {
#line 1351 "../core/Services/Todoist.vala"
		case 0:
#line 11526 "Todoist.c"
		goto _state_0;
#line 1351 "../core/Services/Todoist.vala"
		case 1:
#line 11530 "Todoist.c"
		goto _state_1;
		default:
#line 1351 "../core/Services/Todoist.vala"
		g_assert_not_reached ();
#line 11535 "Todoist.c"
	}
	_state_0:
#line 1352 "../core/Services/Todoist.vala"
	_data_->_tmp0_ = services_todoist_get_duplicate_project_json (_data_->self, _data_->project);
#line 1352 "../core/Services/Todoist.vala"
	_data_->json = _data_->_tmp0_;
#line 1354 "../core/Services/Todoist.vala"
	_data_->_tmp1_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
#line 1354 "../core/Services/Todoist.vala"
	_data_->message = _data_->_tmp1_;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp2_ = _data_->message;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp3_ = soup_message_get_request_headers (_data_->_tmp2_);
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp5_ = objects_project_get_source (_data_->project);
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp7_ = objects_source_get_todoist_data (_data_->_tmp6_);
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp9_ = objects_source_todoist_data_get_access_token (_data_->_tmp8_);
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp11_ = g_strdup_printf ("Bearer %s", _data_->_tmp10_);
#line 1355 "../core/Services/Todoist.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 1355 "../core/Services/Todoist.vala"
	soup_message_headers_append (_data_->_tmp4_, "Authorization", _data_->_tmp12_);
#line 1355 "../core/Services/Todoist.vala"
	_g_free0 (_data_->_tmp12_);
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp13_ = _data_->message;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp14_ = _data_->json;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp16_ = 0;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp15_ = string_get_data (_data_->_tmp14_, &_data_->_tmp16_);
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp15__length1 = _data_->_tmp16_;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp17_ = _data_->_tmp15_;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp17__length1 = _data_->_tmp15__length1;
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp18_ = g_bytes_new (_data_->_tmp17_, _data_->_tmp17__length1);
#line 1359 "../core/Services/Todoist.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 1359 "../core/Services/Todoist.vala"
	soup_message_set_request_body_from_bytes (_data_->_tmp13_, "application/json", _data_->_tmp19_);
#line 1359 "../core/Services/Todoist.vala"
	_g_bytes_unref0 (_data_->_tmp19_);
#line 1361 "../core/Services/Todoist.vala"
	_data_->_tmp20_ = http_response_new ();
#line 1361 "../core/Services/Todoist.vala"
	_data_->response = _data_->_tmp20_;
#line 11598 "Todoist.c"
	{
#line 1364 "../core/Services/Todoist.vala"
		_data_->_tmp21_ = _data_->self->priv->session;
#line 1364 "../core/Services/Todoist.vala"
		_data_->_tmp22_ = _data_->message;
#line 1364 "../core/Services/Todoist.vala"
		_data_->_state_ = 1;
#line 1364 "../core/Services/Todoist.vala"
		soup_session_send_and_read_async (_data_->_tmp21_, _data_->_tmp22_, G_PRIORITY_HIGH, NULL, services_todoist_duplicate_project_ready, _data_);
#line 1364 "../core/Services/Todoist.vala"
		return FALSE;
#line 11610 "Todoist.c"
		_state_1:
#line 1364 "../core/Services/Todoist.vala"
		_data_->_tmp23_ = soup_session_send_and_read_finish (_data_->_tmp21_, _data_->_res_, &_data_->_inner_error0_);
#line 1364 "../core/Services/Todoist.vala"
		_data_->stream = _data_->_tmp23_;
#line 1364 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 11618 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1365 "../core/Services/Todoist.vala"
		_data_->_tmp24_ = _data_->self->priv->parser;
#line 1365 "../core/Services/Todoist.vala"
		_data_->_tmp25_ = _data_->stream;
#line 1365 "../core/Services/Todoist.vala"
		_data_->_tmp26_ = 0;
#line 1365 "../core/Services/Todoist.vala"
		_data_->_tmp27_ = g_bytes_get_data (_data_->_tmp25_, &_data_->_tmp26_);
#line 1365 "../core/Services/Todoist.vala"
		json_parser_load_from_data (_data_->_tmp24_, (const gchar*) _data_->_tmp27_, (gssize) -1, &_data_->_inner_error0_);
#line 1365 "../core/Services/Todoist.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1365 "../core/Services/Todoist.vala"
			_g_bytes_unref0 (_data_->stream);
#line 11635 "Todoist.c"
			goto __catch0_g_error;
		}
#line 1367 "../core/Services/Todoist.vala"
		_data_->_tmp28_ = _data_->self->priv->parser;
#line 1367 "../core/Services/Todoist.vala"
		_data_->_tmp29_ = json_parser_get_root (_data_->_tmp28_);
#line 1367 "../core/Services/Todoist.vala"
		services_todoist_print_root (_data_->self, _data_->_tmp29_);
#line 1369 "../core/Services/Todoist.vala"
		_data_->_tmp30_ = _data_->message;
#line 1369 "../core/Services/Todoist.vala"
		g_object_get (_data_->_tmp30_, "status-code", &_data_->_tmp31_, NULL);
#line 1369 "../core/Services/Todoist.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 1369 "../core/Services/Todoist.vala"
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp32_)) {
#line 1370 "../core/Services/Todoist.vala"
			_data_->_tmp33_ = _data_->response;
#line 1370 "../core/Services/Todoist.vala"
			_data_->_tmp34_ = _data_->self->priv->parser;
#line 1370 "../core/Services/Todoist.vala"
			_data_->_tmp35_ = json_parser_get_root (_data_->_tmp34_);
#line 1370 "../core/Services/Todoist.vala"
			http_response_from_error_json (_data_->_tmp33_, _data_->_tmp35_);
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp36_ = _data_->message;
#line 1372 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp36_, "status-code", &_data_->_tmp37_, NULL);
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp38_ = _data_->_tmp37_;
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp39_ = _data_->message;
#line 1372 "../core/Services/Todoist.vala"
			g_object_get (_data_->_tmp39_, "status-code", &_data_->_tmp40_, NULL);
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp42_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp41_);
#line 1372 "../core/Services/Todoist.vala"
			_data_->_tmp43_ = _data_->_tmp42_;
#line 1372 "../core/Services/Todoist.vala"
			services_todoist_debug_error (_data_->self, _data_->_tmp38_, _data_->_tmp43_);
#line 1372 "../core/Services/Todoist.vala"
			_g_free0 (_data_->_tmp43_);
#line 11680 "Todoist.c"
		} else {
#line 1377 "../core/Services/Todoist.vala"
			_data_->_tmp44_ = _data_->response;
#line 1377 "../core/Services/Todoist.vala"
			http_response_set_status (_data_->_tmp44_, TRUE);
#line 11686 "Todoist.c"
		}
#line 1363 "../core/Services/Todoist.vala"
		_g_bytes_unref0 (_data_->stream);
#line 11690 "Todoist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1363 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 11697 "Todoist.c"
	}
	__finally0:
#line 1363 "../core/Services/Todoist.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1363 "../core/Services/Todoist.vala"
		_http_response_unref0 (_data_->response);
#line 1363 "../core/Services/Todoist.vala"
		_g_object_unref0 (_data_->message);
#line 1363 "../core/Services/Todoist.vala"
		_g_free0 (_data_->json);
#line 1363 "../core/Services/Todoist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1363 "../core/Services/Todoist.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1363 "../core/Services/Todoist.vala"
		g_object_unref (_data_->_async_result);
#line 1363 "../core/Services/Todoist.vala"
		return FALSE;
#line 11716 "Todoist.c"
	}
#line 1383 "../core/Services/Todoist.vala"
	_data_->result = _data_->response;
#line 1383 "../core/Services/Todoist.vala"
	_g_object_unref0 (_data_->message);
#line 1383 "../core/Services/Todoist.vala"
	_g_free0 (_data_->json);
#line 1383 "../core/Services/Todoist.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1383 "../core/Services/Todoist.vala"
	if (_data_->_state_ != 0) {
#line 1383 "../core/Services/Todoist.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1383 "../core/Services/Todoist.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11732 "Todoist.c"
		}
	}
#line 1383 "../core/Services/Todoist.vala"
	g_object_unref (_data_->_async_result);
#line 1383 "../core/Services/Todoist.vala"
	return FALSE;
#line 11739 "Todoist.c"
}

static gchar*
services_todoist_get_duplicate_project_json (ServicesTodoist* self,
                                             ObjectsProject* project)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	JsonBuilder* _tmp13_;
	JsonBuilder* _tmp14_;
	Util* _tmp15_;
	Util* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp20_;
	JsonBuilder* _tmp21_;
	JsonBuilder* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	JsonBuilder* _tmp25_;
	JsonBuilder* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	JsonBuilder* _tmp29_;
	JsonBuilder* _tmp30_;
	JsonBuilder* _tmp178_;
	JsonBuilder* _tmp179_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp180_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp181_;
	JsonNode* _tmp182_;
	gchar* _tmp183_;
	gchar* result;
#line 1386 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1386 "../core/Services/Todoist.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 1387 "../core/Services/Todoist.vala"
	_tmp0_ = json_builder_new ();
#line 1387 "../core/Services/Todoist.vala"
	builder = _tmp0_;
#line 1389 "../core/Services/Todoist.vala"
	_tmp1_ = builder;
#line 1389 "../core/Services/Todoist.vala"
	json_builder_begin_object (_tmp1_);
#line 1390 "../core/Services/Todoist.vala"
	_tmp2_ = builder;
#line 1390 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp2_, "commands");
#line 1391 "../core/Services/Todoist.vala"
	_tmp3_ = builder;
#line 1391 "../core/Services/Todoist.vala"
	json_builder_begin_array (_tmp3_);
#line 1393 "../core/Services/Todoist.vala"
	_tmp4_ = builder;
#line 1393 "../core/Services/Todoist.vala"
	json_builder_begin_object (_tmp4_);
#line 1395 "../core/Services/Todoist.vala"
	_tmp5_ = builder;
#line 1395 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp5_, "type");
#line 1396 "../core/Services/Todoist.vala"
	_tmp6_ = builder;
#line 1396 "../core/Services/Todoist.vala"
	json_builder_add_string_value (_tmp6_, "project_add");
#line 1398 "../core/Services/Todoist.vala"
	_tmp7_ = builder;
#line 1398 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp7_, "temp_id");
#line 1399 "../core/Services/Todoist.vala"
	_tmp8_ = builder;
#line 1399 "../core/Services/Todoist.vala"
	_tmp9_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 1399 "../core/Services/Todoist.vala"
	_tmp10_ = _tmp9_;
#line 1399 "../core/Services/Todoist.vala"
	_tmp11_ = g_strconcat ("_", _tmp10_, NULL);
#line 1399 "../core/Services/Todoist.vala"
	_tmp12_ = _tmp11_;
#line 1399 "../core/Services/Todoist.vala"
	json_builder_add_string_value (_tmp8_, _tmp12_);
#line 1399 "../core/Services/Todoist.vala"
	_g_free0 (_tmp12_);
#line 1401 "../core/Services/Todoist.vala"
	_tmp13_ = builder;
#line 1401 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp13_, "uuid");
#line 1402 "../core/Services/Todoist.vala"
	_tmp14_ = builder;
#line 1402 "../core/Services/Todoist.vala"
	_tmp15_ = util_get_default ();
#line 1402 "../core/Services/Todoist.vala"
	_tmp16_ = _tmp15_;
#line 1402 "../core/Services/Todoist.vala"
	_tmp17_ = util_generate_string (_tmp16_);
#line 1402 "../core/Services/Todoist.vala"
	_tmp18_ = _tmp17_;
#line 1402 "../core/Services/Todoist.vala"
	json_builder_add_string_value (_tmp14_, _tmp18_);
#line 1402 "../core/Services/Todoist.vala"
	_g_free0 (_tmp18_);
#line 1402 "../core/Services/Todoist.vala"
	_g_object_unref0 (_tmp16_);
#line 1404 "../core/Services/Todoist.vala"
	_tmp19_ = builder;
#line 1404 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp19_, "args");
#line 1405 "../core/Services/Todoist.vala"
	_tmp20_ = builder;
#line 1405 "../core/Services/Todoist.vala"
	json_builder_begin_object (_tmp20_);
#line 1407 "../core/Services/Todoist.vala"
	_tmp21_ = builder;
#line 1407 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp21_, "name");
#line 1408 "../core/Services/Todoist.vala"
	_tmp22_ = builder;
#line 1408 "../core/Services/Todoist.vala"
	_tmp23_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 1408 "../core/Services/Todoist.vala"
	_tmp24_ = _tmp23_;
#line 1408 "../core/Services/Todoist.vala"
	json_builder_add_string_value (_tmp22_, _tmp24_);
#line 1410 "../core/Services/Todoist.vala"
	_tmp25_ = builder;
#line 1410 "../core/Services/Todoist.vala"
	json_builder_set_member_name (_tmp25_, "color");
#line 1411 "../core/Services/Todoist.vala"
	_tmp26_ = builder;
#line 1411 "../core/Services/Todoist.vala"
	_tmp27_ = objects_project_get_color (project);
#line 1411 "../core/Services/Todoist.vala"
	_tmp28_ = _tmp27_;
#line 1411 "../core/Services/Todoist.vala"
	json_builder_add_string_value (_tmp26_, _tmp28_);
#line 1413 "../core/Services/Todoist.vala"
	_tmp29_ = builder;
#line 1413 "../core/Services/Todoist.vala"
	json_builder_end_object (_tmp29_);
#line 1414 "../core/Services/Todoist.vala"
	_tmp30_ = builder;
#line 1414 "../core/Services/Todoist.vala"
	json_builder_end_object (_tmp30_);
#line 11897 "Todoist.c"
	{
		GeeArrayList* _section_list = NULL;
		GeeArrayList* _tmp31_;
		GeeArrayList* _tmp32_;
		gint _section_size = 0;
		GeeArrayList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gint _section_index = 0;
#line 1417 "../core/Services/Todoist.vala"
		_tmp31_ = objects_project_get_sections (project);
#line 1417 "../core/Services/Todoist.vala"
		_tmp32_ = _tmp31_;
#line 1417 "../core/Services/Todoist.vala"
		_section_list = _tmp32_;
#line 1417 "../core/Services/Todoist.vala"
		_tmp33_ = _section_list;
#line 1417 "../core/Services/Todoist.vala"
		_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 1417 "../core/Services/Todoist.vala"
		_tmp35_ = _tmp34_;
#line 1417 "../core/Services/Todoist.vala"
		_section_size = _tmp35_;
#line 1417 "../core/Services/Todoist.vala"
		_section_index = -1;
#line 1417 "../core/Services/Todoist.vala"
		while (TRUE) {
#line 11925 "Todoist.c"
			gint _tmp36_;
			gint _tmp37_;
			ObjectsSection* section = NULL;
			GeeArrayList* _tmp38_;
			gpointer _tmp39_;
			JsonBuilder* _tmp40_;
			JsonBuilder* _tmp41_;
			JsonBuilder* _tmp42_;
			JsonBuilder* _tmp43_;
			JsonBuilder* _tmp44_;
			ObjectsSection* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			JsonBuilder* _tmp50_;
			JsonBuilder* _tmp51_;
			Util* _tmp52_;
			Util* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			JsonBuilder* _tmp56_;
			JsonBuilder* _tmp57_;
			JsonBuilder* _tmp58_;
			JsonBuilder* _tmp59_;
			ObjectsSection* _tmp60_;
			const gchar* _tmp61_;
			const gchar* _tmp62_;
			JsonBuilder* _tmp63_;
			JsonBuilder* _tmp64_;
			ObjectsSection* _tmp65_;
			const gchar* _tmp66_;
			const gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			JsonBuilder* _tmp70_;
			JsonBuilder* _tmp71_;
#line 1417 "../core/Services/Todoist.vala"
			_section_index = _section_index + 1;
#line 1417 "../core/Services/Todoist.vala"
			_tmp36_ = _section_index;
#line 1417 "../core/Services/Todoist.vala"
			_tmp37_ = _section_size;
#line 1417 "../core/Services/Todoist.vala"
			if (!(_tmp36_ < _tmp37_)) {
#line 1417 "../core/Services/Todoist.vala"
				break;
#line 11973 "Todoist.c"
			}
#line 1417 "../core/Services/Todoist.vala"
			_tmp38_ = _section_list;
#line 1417 "../core/Services/Todoist.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp38_, _section_index);
#line 1417 "../core/Services/Todoist.vala"
			section = (ObjectsSection*) _tmp39_;
#line 1418 "../core/Services/Todoist.vala"
			_tmp40_ = builder;
#line 1418 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp40_);
#line 1420 "../core/Services/Todoist.vala"
			_tmp41_ = builder;
#line 1420 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp41_, "type");
#line 1421 "../core/Services/Todoist.vala"
			_tmp42_ = builder;
#line 1421 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp42_, "section_add");
#line 1423 "../core/Services/Todoist.vala"
			_tmp43_ = builder;
#line 1423 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp43_, "temp_id");
#line 1424 "../core/Services/Todoist.vala"
			_tmp44_ = builder;
#line 1424 "../core/Services/Todoist.vala"
			_tmp45_ = section;
#line 1424 "../core/Services/Todoist.vala"
			_tmp46_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp45_);
#line 1424 "../core/Services/Todoist.vala"
			_tmp47_ = _tmp46_;
#line 1424 "../core/Services/Todoist.vala"
			_tmp48_ = g_strconcat ("_", _tmp47_, NULL);
#line 1424 "../core/Services/Todoist.vala"
			_tmp49_ = _tmp48_;
#line 1424 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp44_, _tmp49_);
#line 1424 "../core/Services/Todoist.vala"
			_g_free0 (_tmp49_);
#line 1426 "../core/Services/Todoist.vala"
			_tmp50_ = builder;
#line 1426 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp50_, "uuid");
#line 1427 "../core/Services/Todoist.vala"
			_tmp51_ = builder;
#line 1427 "../core/Services/Todoist.vala"
			_tmp52_ = util_get_default ();
#line 1427 "../core/Services/Todoist.vala"
			_tmp53_ = _tmp52_;
#line 1427 "../core/Services/Todoist.vala"
			_tmp54_ = util_generate_string (_tmp53_);
#line 1427 "../core/Services/Todoist.vala"
			_tmp55_ = _tmp54_;
#line 1427 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp51_, _tmp55_);
#line 1427 "../core/Services/Todoist.vala"
			_g_free0 (_tmp55_);
#line 1427 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp53_);
#line 1429 "../core/Services/Todoist.vala"
			_tmp56_ = builder;
#line 1429 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp56_, "args");
#line 1430 "../core/Services/Todoist.vala"
			_tmp57_ = builder;
#line 1430 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp57_);
#line 1431 "../core/Services/Todoist.vala"
			_tmp58_ = builder;
#line 1431 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp58_, "name");
#line 1432 "../core/Services/Todoist.vala"
			_tmp59_ = builder;
#line 1432 "../core/Services/Todoist.vala"
			_tmp60_ = section;
#line 1432 "../core/Services/Todoist.vala"
			_tmp61_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp60_);
#line 1432 "../core/Services/Todoist.vala"
			_tmp62_ = _tmp61_;
#line 1432 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp59_, _tmp62_);
#line 1434 "../core/Services/Todoist.vala"
			_tmp63_ = builder;
#line 1434 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp63_, "project_id");
#line 1435 "../core/Services/Todoist.vala"
			_tmp64_ = builder;
#line 1435 "../core/Services/Todoist.vala"
			_tmp65_ = section;
#line 1435 "../core/Services/Todoist.vala"
			_tmp66_ = objects_section_get_project_id (_tmp65_);
#line 1435 "../core/Services/Todoist.vala"
			_tmp67_ = _tmp66_;
#line 1435 "../core/Services/Todoist.vala"
			_tmp68_ = g_strconcat ("_", _tmp67_, NULL);
#line 1435 "../core/Services/Todoist.vala"
			_tmp69_ = _tmp68_;
#line 1435 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp64_, _tmp69_);
#line 1435 "../core/Services/Todoist.vala"
			_g_free0 (_tmp69_);
#line 1436 "../core/Services/Todoist.vala"
			_tmp70_ = builder;
#line 1436 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp70_);
#line 1437 "../core/Services/Todoist.vala"
			_tmp71_ = builder;
#line 1437 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp71_);
#line 1417 "../core/Services/Todoist.vala"
			_g_object_unref0 (section);
#line 12085 "Todoist.c"
		}
	}
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp72_;
		GeeArrayList* _tmp73_;
		gint _item_size = 0;
		GeeArrayList* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _item_index = 0;
#line 1441 "../core/Services/Todoist.vala"
		_tmp72_ = objects_project_get_all_items (project);
#line 1441 "../core/Services/Todoist.vala"
		_tmp73_ = _tmp72_;
#line 1441 "../core/Services/Todoist.vala"
		_item_list = _tmp73_;
#line 1441 "../core/Services/Todoist.vala"
		_tmp74_ = _item_list;
#line 1441 "../core/Services/Todoist.vala"
		_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
#line 1441 "../core/Services/Todoist.vala"
		_tmp76_ = _tmp75_;
#line 1441 "../core/Services/Todoist.vala"
		_item_size = _tmp76_;
#line 1441 "../core/Services/Todoist.vala"
		_item_index = -1;
#line 1441 "../core/Services/Todoist.vala"
		while (TRUE) {
#line 12115 "Todoist.c"
			gint _tmp77_;
			gint _tmp78_;
			ObjectsItem* item = NULL;
			GeeArrayList* _tmp79_;
			gpointer _tmp80_;
			JsonBuilder* _tmp81_;
			JsonBuilder* _tmp82_;
			JsonBuilder* _tmp83_;
			JsonBuilder* _tmp84_;
			JsonBuilder* _tmp85_;
			ObjectsItem* _tmp86_;
			const gchar* _tmp87_;
			const gchar* _tmp88_;
			gchar* _tmp89_;
			gchar* _tmp90_;
			JsonBuilder* _tmp91_;
			JsonBuilder* _tmp92_;
			Util* _tmp93_;
			Util* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			JsonBuilder* _tmp97_;
			JsonBuilder* _tmp98_;
			JsonBuilder* _tmp99_;
			JsonBuilder* _tmp100_;
			ObjectsItem* _tmp101_;
			const gchar* _tmp102_;
			const gchar* _tmp103_;
			JsonBuilder* _tmp104_;
			JsonBuilder* _tmp105_;
			ObjectsItem* _tmp106_;
			const gchar* _tmp107_;
			const gchar* _tmp108_;
			JsonBuilder* _tmp109_;
			JsonBuilder* _tmp110_;
			ObjectsItem* _tmp111_;
			const gchar* _tmp112_;
			const gchar* _tmp113_;
			gchar* _tmp114_;
			gchar* _tmp115_;
			ObjectsItem* _tmp116_;
			const gchar* _tmp117_;
			const gchar* _tmp118_;
			ObjectsItem* _tmp126_;
			const gchar* _tmp127_;
			const gchar* _tmp128_;
			JsonBuilder* _tmp136_;
			ObjectsItem* _tmp137_;
			gint _tmp138_;
			gint _tmp139_;
			ObjectsItem* _tmp145_;
			gboolean _tmp146_;
			gboolean _tmp147_;
			JsonBuilder* _tmp158_;
			JsonBuilder* _tmp159_;
			JsonBuilder* _tmp174_;
			JsonBuilder* _tmp175_;
			JsonBuilder* _tmp176_;
			JsonBuilder* _tmp177_;
#line 1441 "../core/Services/Todoist.vala"
			_item_index = _item_index + 1;
#line 1441 "../core/Services/Todoist.vala"
			_tmp77_ = _item_index;
#line 1441 "../core/Services/Todoist.vala"
			_tmp78_ = _item_size;
#line 1441 "../core/Services/Todoist.vala"
			if (!(_tmp77_ < _tmp78_)) {
#line 1441 "../core/Services/Todoist.vala"
				break;
#line 12185 "Todoist.c"
			}
#line 1441 "../core/Services/Todoist.vala"
			_tmp79_ = _item_list;
#line 1441 "../core/Services/Todoist.vala"
			_tmp80_ = gee_abstract_list_get ((GeeAbstractList*) _tmp79_, _item_index);
#line 1441 "../core/Services/Todoist.vala"
			item = (ObjectsItem*) _tmp80_;
#line 1442 "../core/Services/Todoist.vala"
			_tmp81_ = builder;
#line 1442 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp81_);
#line 1444 "../core/Services/Todoist.vala"
			_tmp82_ = builder;
#line 1444 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp82_, "type");
#line 1445 "../core/Services/Todoist.vala"
			_tmp83_ = builder;
#line 1445 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp83_, "item_add");
#line 1447 "../core/Services/Todoist.vala"
			_tmp84_ = builder;
#line 1447 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp84_, "temp_id");
#line 1448 "../core/Services/Todoist.vala"
			_tmp85_ = builder;
#line 1448 "../core/Services/Todoist.vala"
			_tmp86_ = item;
#line 1448 "../core/Services/Todoist.vala"
			_tmp87_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp86_);
#line 1448 "../core/Services/Todoist.vala"
			_tmp88_ = _tmp87_;
#line 1448 "../core/Services/Todoist.vala"
			_tmp89_ = g_strconcat ("_", _tmp88_, NULL);
#line 1448 "../core/Services/Todoist.vala"
			_tmp90_ = _tmp89_;
#line 1448 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp85_, _tmp90_);
#line 1448 "../core/Services/Todoist.vala"
			_g_free0 (_tmp90_);
#line 1450 "../core/Services/Todoist.vala"
			_tmp91_ = builder;
#line 1450 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp91_, "uuid");
#line 1451 "../core/Services/Todoist.vala"
			_tmp92_ = builder;
#line 1451 "../core/Services/Todoist.vala"
			_tmp93_ = util_get_default ();
#line 1451 "../core/Services/Todoist.vala"
			_tmp94_ = _tmp93_;
#line 1451 "../core/Services/Todoist.vala"
			_tmp95_ = util_generate_string (_tmp94_);
#line 1451 "../core/Services/Todoist.vala"
			_tmp96_ = _tmp95_;
#line 1451 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp92_, _tmp96_);
#line 1451 "../core/Services/Todoist.vala"
			_g_free0 (_tmp96_);
#line 1451 "../core/Services/Todoist.vala"
			_g_object_unref0 (_tmp94_);
#line 1453 "../core/Services/Todoist.vala"
			_tmp97_ = builder;
#line 1453 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp97_, "args");
#line 1454 "../core/Services/Todoist.vala"
			_tmp98_ = builder;
#line 1454 "../core/Services/Todoist.vala"
			json_builder_begin_object (_tmp98_);
#line 1455 "../core/Services/Todoist.vala"
			_tmp99_ = builder;
#line 1455 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp99_, "content");
#line 1456 "../core/Services/Todoist.vala"
			_tmp100_ = builder;
#line 1456 "../core/Services/Todoist.vala"
			_tmp101_ = item;
#line 1456 "../core/Services/Todoist.vala"
			_tmp102_ = objects_item_get_content (_tmp101_);
#line 1456 "../core/Services/Todoist.vala"
			_tmp103_ = _tmp102_;
#line 1456 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp100_, _tmp103_);
#line 1458 "../core/Services/Todoist.vala"
			_tmp104_ = builder;
#line 1458 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp104_, "description");
#line 1459 "../core/Services/Todoist.vala"
			_tmp105_ = builder;
#line 1459 "../core/Services/Todoist.vala"
			_tmp106_ = item;
#line 1459 "../core/Services/Todoist.vala"
			_tmp107_ = objects_item_get_description (_tmp106_);
#line 1459 "../core/Services/Todoist.vala"
			_tmp108_ = _tmp107_;
#line 1459 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp105_, _tmp108_);
#line 1461 "../core/Services/Todoist.vala"
			_tmp109_ = builder;
#line 1461 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp109_, "project_id");
#line 1462 "../core/Services/Todoist.vala"
			_tmp110_ = builder;
#line 1462 "../core/Services/Todoist.vala"
			_tmp111_ = item;
#line 1462 "../core/Services/Todoist.vala"
			_tmp112_ = objects_item_get_project_id (_tmp111_);
#line 1462 "../core/Services/Todoist.vala"
			_tmp113_ = _tmp112_;
#line 1462 "../core/Services/Todoist.vala"
			_tmp114_ = g_strconcat ("_", _tmp113_, NULL);
#line 1462 "../core/Services/Todoist.vala"
			_tmp115_ = _tmp114_;
#line 1462 "../core/Services/Todoist.vala"
			json_builder_add_string_value (_tmp110_, _tmp115_);
#line 1462 "../core/Services/Todoist.vala"
			_g_free0 (_tmp115_);
#line 1464 "../core/Services/Todoist.vala"
			_tmp116_ = item;
#line 1464 "../core/Services/Todoist.vala"
			_tmp117_ = objects_item_get_parent_id (_tmp116_);
#line 1464 "../core/Services/Todoist.vala"
			_tmp118_ = _tmp117_;
#line 1464 "../core/Services/Todoist.vala"
			if (g_strcmp0 (_tmp118_, "") != 0) {
#line 12309 "Todoist.c"
				JsonBuilder* _tmp119_;
				JsonBuilder* _tmp120_;
				ObjectsItem* _tmp121_;
				const gchar* _tmp122_;
				const gchar* _tmp123_;
				gchar* _tmp124_;
				gchar* _tmp125_;
#line 1465 "../core/Services/Todoist.vala"
				_tmp119_ = builder;
#line 1465 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp119_, "parent_id");
#line 1466 "../core/Services/Todoist.vala"
				_tmp120_ = builder;
#line 1466 "../core/Services/Todoist.vala"
				_tmp121_ = item;
#line 1466 "../core/Services/Todoist.vala"
				_tmp122_ = objects_item_get_parent_id (_tmp121_);
#line 1466 "../core/Services/Todoist.vala"
				_tmp123_ = _tmp122_;
#line 1466 "../core/Services/Todoist.vala"
				_tmp124_ = g_strconcat ("_", _tmp123_, NULL);
#line 1466 "../core/Services/Todoist.vala"
				_tmp125_ = _tmp124_;
#line 1466 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp120_, _tmp125_);
#line 1466 "../core/Services/Todoist.vala"
				_g_free0 (_tmp125_);
#line 12337 "Todoist.c"
			}
#line 1469 "../core/Services/Todoist.vala"
			_tmp126_ = item;
#line 1469 "../core/Services/Todoist.vala"
			_tmp127_ = objects_item_get_section_id (_tmp126_);
#line 1469 "../core/Services/Todoist.vala"
			_tmp128_ = _tmp127_;
#line 1469 "../core/Services/Todoist.vala"
			if (g_strcmp0 (_tmp128_, "") != 0) {
#line 12347 "Todoist.c"
				JsonBuilder* _tmp129_;
				JsonBuilder* _tmp130_;
				ObjectsItem* _tmp131_;
				const gchar* _tmp132_;
				const gchar* _tmp133_;
				gchar* _tmp134_;
				gchar* _tmp135_;
#line 1470 "../core/Services/Todoist.vala"
				_tmp129_ = builder;
#line 1470 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp129_, "section_id");
#line 1471 "../core/Services/Todoist.vala"
				_tmp130_ = builder;
#line 1471 "../core/Services/Todoist.vala"
				_tmp131_ = item;
#line 1471 "../core/Services/Todoist.vala"
				_tmp132_ = objects_item_get_section_id (_tmp131_);
#line 1471 "../core/Services/Todoist.vala"
				_tmp133_ = _tmp132_;
#line 1471 "../core/Services/Todoist.vala"
				_tmp134_ = g_strconcat ("_", _tmp133_, NULL);
#line 1471 "../core/Services/Todoist.vala"
				_tmp135_ = _tmp134_;
#line 1471 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp130_, _tmp135_);
#line 1471 "../core/Services/Todoist.vala"
				_g_free0 (_tmp135_);
#line 12375 "Todoist.c"
			}
#line 1474 "../core/Services/Todoist.vala"
			_tmp136_ = builder;
#line 1474 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp136_, "priority");
#line 1475 "../core/Services/Todoist.vala"
			_tmp137_ = item;
#line 1475 "../core/Services/Todoist.vala"
			_tmp138_ = objects_item_get_priority (_tmp137_);
#line 1475 "../core/Services/Todoist.vala"
			_tmp139_ = _tmp138_;
#line 1475 "../core/Services/Todoist.vala"
			if (_tmp139_ == 0) {
#line 12389 "Todoist.c"
				JsonBuilder* _tmp140_;
#line 1476 "../core/Services/Todoist.vala"
				_tmp140_ = builder;
#line 1476 "../core/Services/Todoist.vala"
				json_builder_add_int_value (_tmp140_, (gint64) CONSTANTS_PRIORITY_4);
#line 12395 "Todoist.c"
			} else {
				JsonBuilder* _tmp141_;
				ObjectsItem* _tmp142_;
				gint _tmp143_;
				gint _tmp144_;
#line 1478 "../core/Services/Todoist.vala"
				_tmp141_ = builder;
#line 1478 "../core/Services/Todoist.vala"
				_tmp142_ = item;
#line 1478 "../core/Services/Todoist.vala"
				_tmp143_ = objects_item_get_priority (_tmp142_);
#line 1478 "../core/Services/Todoist.vala"
				_tmp144_ = _tmp143_;
#line 1478 "../core/Services/Todoist.vala"
				json_builder_add_int_value (_tmp141_, (gint64) _tmp144_);
#line 12411 "Todoist.c"
			}
#line 1481 "../core/Services/Todoist.vala"
			_tmp145_ = item;
#line 1481 "../core/Services/Todoist.vala"
			_tmp146_ = objects_item_get_has_due (_tmp145_);
#line 1481 "../core/Services/Todoist.vala"
			_tmp147_ = _tmp146_;
#line 1481 "../core/Services/Todoist.vala"
			if (_tmp147_) {
#line 12421 "Todoist.c"
				JsonBuilder* _tmp148_;
				JsonBuilder* _tmp149_;
				JsonBuilder* _tmp150_;
				JsonBuilder* _tmp151_;
				ObjectsItem* _tmp152_;
				ObjectsDueDate* _tmp153_;
				ObjectsDueDate* _tmp154_;
				const gchar* _tmp155_;
				const gchar* _tmp156_;
				JsonBuilder* _tmp157_;
#line 1482 "../core/Services/Todoist.vala"
				_tmp148_ = builder;
#line 1482 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp148_, "due");
#line 1483 "../core/Services/Todoist.vala"
				_tmp149_ = builder;
#line 1483 "../core/Services/Todoist.vala"
				json_builder_begin_object (_tmp149_);
#line 1485 "../core/Services/Todoist.vala"
				_tmp150_ = builder;
#line 1485 "../core/Services/Todoist.vala"
				json_builder_set_member_name (_tmp150_, "date");
#line 1486 "../core/Services/Todoist.vala"
				_tmp151_ = builder;
#line 1486 "../core/Services/Todoist.vala"
				_tmp152_ = item;
#line 1486 "../core/Services/Todoist.vala"
				_tmp153_ = objects_item_get_due (_tmp152_);
#line 1486 "../core/Services/Todoist.vala"
				_tmp154_ = _tmp153_;
#line 1486 "../core/Services/Todoist.vala"
				_tmp155_ = objects_due_date_get_date (_tmp154_);
#line 1486 "../core/Services/Todoist.vala"
				_tmp156_ = _tmp155_;
#line 1486 "../core/Services/Todoist.vala"
				json_builder_add_string_value (_tmp151_, _tmp156_);
#line 1488 "../core/Services/Todoist.vala"
				_tmp157_ = builder;
#line 1488 "../core/Services/Todoist.vala"
				json_builder_end_object (_tmp157_);
#line 12462 "Todoist.c"
			}
#line 1491 "../core/Services/Todoist.vala"
			_tmp158_ = builder;
#line 1491 "../core/Services/Todoist.vala"
			json_builder_set_member_name (_tmp158_, "labels");
#line 1492 "../core/Services/Todoist.vala"
			_tmp159_ = builder;
#line 1492 "../core/Services/Todoist.vala"
			json_builder_begin_array (_tmp159_);
#line 12472 "Todoist.c"
			{
				GeeArrayList* _label_list = NULL;
				ObjectsItem* _tmp160_;
				GeeArrayList* _tmp161_;
				GeeArrayList* _tmp162_;
				gint _label_size = 0;
				GeeArrayList* _tmp163_;
				gint _tmp164_;
				gint _tmp165_;
				gint _label_index = 0;
#line 1493 "../core/Services/Todoist.vala"
				_tmp160_ = item;
#line 1493 "../core/Services/Todoist.vala"
				_tmp161_ = objects_item_get_labels (_tmp160_);
#line 1493 "../core/Services/Todoist.vala"
				_tmp162_ = _tmp161_;
#line 1493 "../core/Services/Todoist.vala"
				_label_list = _tmp162_;
#line 1493 "../core/Services/Todoist.vala"
				_tmp163_ = _label_list;
#line 1493 "../core/Services/Todoist.vala"
				_tmp164_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp163_);
#line 1493 "../core/Services/Todoist.vala"
				_tmp165_ = _tmp164_;
#line 1493 "../core/Services/Todoist.vala"
				_label_size = _tmp165_;
#line 1493 "../core/Services/Todoist.vala"
				_label_index = -1;
#line 1493 "../core/Services/Todoist.vala"
				while (TRUE) {
#line 12503 "Todoist.c"
					gint _tmp166_;
					gint _tmp167_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp168_;
					gpointer _tmp169_;
					JsonBuilder* _tmp170_;
					ObjectsLabel* _tmp171_;
					const gchar* _tmp172_;
					const gchar* _tmp173_;
#line 1493 "../core/Services/Todoist.vala"
					_label_index = _label_index + 1;
#line 1493 "../core/Services/Todoist.vala"
					_tmp166_ = _label_index;
#line 1493 "../core/Services/Todoist.vala"
					_tmp167_ = _label_size;
#line 1493 "../core/Services/Todoist.vala"
					if (!(_tmp166_ < _tmp167_)) {
#line 1493 "../core/Services/Todoist.vala"
						break;
#line 12523 "Todoist.c"
					}
#line 1493 "../core/Services/Todoist.vala"
					_tmp168_ = _label_list;
#line 1493 "../core/Services/Todoist.vala"
					_tmp169_ = gee_abstract_list_get ((GeeAbstractList*) _tmp168_, _label_index);
#line 1493 "../core/Services/Todoist.vala"
					label = (ObjectsLabel*) _tmp169_;
#line 1494 "../core/Services/Todoist.vala"
					_tmp170_ = builder;
#line 1494 "../core/Services/Todoist.vala"
					_tmp171_ = label;
#line 1494 "../core/Services/Todoist.vala"
					_tmp172_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp171_);
#line 1494 "../core/Services/Todoist.vala"
					_tmp173_ = _tmp172_;
#line 1494 "../core/Services/Todoist.vala"
					json_builder_add_string_value (_tmp170_, _tmp173_);
#line 1493 "../core/Services/Todoist.vala"
					_g_object_unref0 (label);
#line 12543 "Todoist.c"
				}
			}
#line 1496 "../core/Services/Todoist.vala"
			_tmp174_ = builder;
#line 1496 "../core/Services/Todoist.vala"
			json_builder_end_array (_tmp174_);
#line 1497 "../core/Services/Todoist.vala"
			_tmp175_ = builder;
#line 1497 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp175_);
#line 1498 "../core/Services/Todoist.vala"
			_tmp176_ = builder;
#line 1498 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp176_);
#line 1499 "../core/Services/Todoist.vala"
			_tmp177_ = builder;
#line 1499 "../core/Services/Todoist.vala"
			json_builder_end_object (_tmp177_);
#line 1441 "../core/Services/Todoist.vala"
			_g_object_unref0 (item);
#line 12564 "Todoist.c"
		}
	}
#line 1501 "../core/Services/Todoist.vala"
	_tmp178_ = builder;
#line 1501 "../core/Services/Todoist.vala"
	json_builder_end_array (_tmp178_);
#line 1502 "../core/Services/Todoist.vala"
	_tmp179_ = builder;
#line 1502 "../core/Services/Todoist.vala"
	json_builder_end_object (_tmp179_);
#line 1503 "../core/Services/Todoist.vala"
	_tmp180_ = json_generator_new ();
#line 1503 "../core/Services/Todoist.vala"
	generator = _tmp180_;
#line 1504 "../core/Services/Todoist.vala"
	_tmp181_ = builder;
#line 1504 "../core/Services/Todoist.vala"
	_tmp182_ = json_builder_get_root (_tmp181_);
#line 1504 "../core/Services/Todoist.vala"
	root = _tmp182_;
#line 1505 "../core/Services/Todoist.vala"
	json_generator_set_root (generator, root);
#line 1507 "../core/Services/Todoist.vala"
	_tmp183_ = json_generator_to_data (generator, NULL);
#line 1507 "../core/Services/Todoist.vala"
	result = _tmp183_;
#line 1507 "../core/Services/Todoist.vala"
	__vala_JsonNode_free0 (root);
#line 1507 "../core/Services/Todoist.vala"
	_g_object_unref0 (generator);
#line 1507 "../core/Services/Todoist.vala"
	_g_object_unref0 (builder);
#line 1507 "../core/Services/Todoist.vala"
	return result;
#line 12599 "Todoist.c"
}

gboolean
services_todoist_is_todoist_error (ServicesTodoist* self,
                                   guint status_code)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result;
#line 1510 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1511 "../core/Services/Todoist.vala"
	if (status_code == ((guint) 400)) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp5_ = TRUE;
#line 12619 "Todoist.c"
	} else {
#line 1511 "../core/Services/Todoist.vala"
		_tmp5_ = status_code == ((guint) 401);
#line 12623 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	if (_tmp5_) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp4_ = TRUE;
#line 12629 "Todoist.c"
	} else {
#line 1512 "../core/Services/Todoist.vala"
		_tmp4_ = status_code == ((guint) 403);
#line 12633 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	if (_tmp4_) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp3_ = TRUE;
#line 12639 "Todoist.c"
	} else {
#line 1512 "../core/Services/Todoist.vala"
		_tmp3_ = status_code == ((guint) 404);
#line 12643 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	if (_tmp3_) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp2_ = TRUE;
#line 12649 "Todoist.c"
	} else {
#line 1513 "../core/Services/Todoist.vala"
		_tmp2_ = status_code == ((guint) 429);
#line 12653 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	if (_tmp2_) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp1_ = TRUE;
#line 12659 "Todoist.c"
	} else {
#line 1513 "../core/Services/Todoist.vala"
		_tmp1_ = status_code == ((guint) 500);
#line 12663 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	if (_tmp1_) {
#line 1511 "../core/Services/Todoist.vala"
		_tmp0_ = TRUE;
#line 12669 "Todoist.c"
	} else {
#line 1514 "../core/Services/Todoist.vala"
		_tmp0_ = status_code == ((guint) 503);
#line 12673 "Todoist.c"
	}
#line 1511 "../core/Services/Todoist.vala"
	result = _tmp0_;
#line 1511 "../core/Services/Todoist.vala"
	return result;
#line 12679 "Todoist.c"
}

gchar*
services_todoist_get_todoist_error (ServicesTodoist* self,
                                    guint code)
{
	GeeHashMap* messages = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	gchar* _tmp8_ = NULL;
	GeeHashMap* _tmp9_;
	gchar* result;
#line 1517 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1518 "../core/Services/Todoist.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1518 "../core/Services/Todoist.vala"
	messages = _tmp0_;
#line 1520 "../core/Services/Todoist.vala"
	_tmp1_ = messages;
#line 1520 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) 400), _ ("The request was incorrect."));
#line 1521 "../core/Services/Todoist.vala"
	_tmp2_ = messages;
#line 1521 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) 401), _ ("Authentication is required, and has failed, or has not yet been provid" \
"ed."));
#line 1522 "../core/Services/Todoist.vala"
	_tmp3_ = messages;
#line 1522 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((guintptr) 403), _ ("The request was valid, but for something that is forbidden."));
#line 1523 "../core/Services/Todoist.vala"
	_tmp4_ = messages;
#line 1523 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((guintptr) 404), _ ("The requested resource could not be found."));
#line 1524 "../core/Services/Todoist.vala"
	_tmp5_ = messages;
#line 1524 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) 429), _ ("The user has sent too many requests in a given amount of time."));
#line 1525 "../core/Services/Todoist.vala"
	_tmp6_ = messages;
#line 1525 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) 500), _ ("The request failed due to a server error."));
#line 1526 "../core/Services/Todoist.vala"
	_tmp7_ = messages;
#line 1526 "../core/Services/Todoist.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) 503), _ ("The server is currently unable to handle the request."));
#line 1528 "../core/Services/Todoist.vala"
	_tmp9_ = messages;
#line 1528 "../core/Services/Todoist.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, (gpointer) ((guintptr) code))) {
#line 12736 "Todoist.c"
		GeeHashMap* _tmp10_;
		gpointer _tmp11_;
#line 1528 "../core/Services/Todoist.vala"
		_tmp10_ = messages;
#line 1528 "../core/Services/Todoist.vala"
		_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) code));
#line 1528 "../core/Services/Todoist.vala"
		_g_free0 (_tmp8_);
#line 1528 "../core/Services/Todoist.vala"
		_tmp8_ = (gchar*) _tmp11_;
#line 12747 "Todoist.c"
	} else {
		gchar* _tmp12_;
#line 1528 "../core/Services/Todoist.vala"
		_tmp12_ = g_strdup (_ ("Unknown error"));
#line 1528 "../core/Services/Todoist.vala"
		_g_free0 (_tmp8_);
#line 1528 "../core/Services/Todoist.vala"
		_tmp8_ = _tmp12_;
#line 12756 "Todoist.c"
	}
#line 1528 "../core/Services/Todoist.vala"
	result = _tmp8_;
#line 1528 "../core/Services/Todoist.vala"
	_g_object_unref0 (messages);
#line 1528 "../core/Services/Todoist.vala"
	return result;
#line 12764 "Todoist.c"
}

static void
services_todoist_class_init (ServicesTodoistClass * klass,
                             gpointer klass_data)
{
#line 22 "../core/Services/Todoist.vala"
	services_todoist_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/Todoist.vala"
	g_type_class_adjust_private_offset (klass, &ServicesTodoist_private_offset);
#line 22 "../core/Services/Todoist.vala"
	G_OBJECT_CLASS (klass)->finalize = services_todoist_finalize;
#line 22 "../core/Services/Todoist.vala"
	services_todoist_signals[SERVICES_TODOIST_SYNC_STARTED_SIGNAL] = g_signal_new ("sync-started", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Todoist.vala"
	services_todoist_signals[SERVICES_TODOIST_SYNC_FINISHED_SIGNAL] = g_signal_new ("sync-finished", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Todoist.vala"
	services_todoist_signals[SERVICES_TODOIST_FIRST_SYNC_STARTED_SIGNAL] = g_signal_new ("first-sync-started", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Todoist.vala"
	services_todoist_signals[SERVICES_TODOIST_FIRST_SYNC_FINISHED_SIGNAL] = g_signal_new ("first-sync-finished", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12785 "Todoist.c"
}

static void
services_todoist_instance_init (ServicesTodoist * self,
                                gpointer klass)
{
#line 22 "../core/Services/Todoist.vala"
	self->priv = services_todoist_get_instance_private (self);
#line 12794 "Todoist.c"
}

static void
services_todoist_finalize (GObject * obj)
{
	ServicesTodoist * self;
#line 22 "../core/Services/Todoist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_TODOIST, ServicesTodoist);
#line 23 "../core/Services/Todoist.vala"
	_g_object_unref0 (self->priv->session);
#line 24 "../core/Services/Todoist.vala"
	_g_object_unref0 (self->priv->parser);
#line 22 "../core/Services/Todoist.vala"
	G_OBJECT_CLASS (services_todoist_parent_class)->finalize (obj);
#line 12809 "Todoist.c"
}

static GType
services_todoist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesTodoistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_todoist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesTodoist), 0, (GInstanceInitFunc) services_todoist_instance_init, NULL };
	GType services_todoist_type_id;
	services_todoist_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesTodoist", &g_define_type_info, 0);
	ServicesTodoist_private_offset = g_type_add_instance_private (services_todoist_type_id, sizeof (ServicesTodoistPrivate));
	return services_todoist_type_id;
}

GType
services_todoist_get_type (void)
{
	static volatile gsize services_todoist_type_id__once = 0;
	if (g_once_init_enter (&services_todoist_type_id__once)) {
		GType services_todoist_type_id;
		services_todoist_type_id = services_todoist_get_type_once ();
		g_once_init_leave (&services_todoist_type_id__once, services_todoist_type_id);
	}
	return services_todoist_type_id__once;
}

static inline gpointer
http_response_get_instance_private (HttpResponse* self)
{
	return G_STRUCT_MEMBER_P (self, HttpResponse_private_offset);
}

void
http_response_from_error_json (HttpResponse* self,
                               JsonNode* node)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	JsonObject* _tmp3_;
#line 1541 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1541 "../core/Services/Todoist.vala"
	g_return_if_fail (node != NULL);
#line 1542 "../core/Services/Todoist.vala"
	http_response_set_status (self, FALSE);
#line 1543 "../core/Services/Todoist.vala"
	_tmp0_ = json_node_get_object (node);
#line 1543 "../core/Services/Todoist.vala"
	http_response_set_error_code (self, (gint) json_object_get_int_member (_tmp0_, "error_code"));
#line 1544 "../core/Services/Todoist.vala"
	_tmp1_ = json_node_get_object (node);
#line 1544 "../core/Services/Todoist.vala"
	_tmp2_ = json_object_get_string_member (_tmp1_, "error");
#line 1544 "../core/Services/Todoist.vala"
	http_response_set_error (self, _tmp2_);
#line 1545 "../core/Services/Todoist.vala"
	_tmp3_ = json_node_get_object (node);
#line 1545 "../core/Services/Todoist.vala"
	http_response_set_http_code (self, (gint) json_object_get_int_member (_tmp3_, "http_code"));
#line 12868 "Todoist.c"
}

void
http_response_from_error_xml (HttpResponse* self,
                              GXmlDomDocument* doc,
                              gint error_code)
{
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	GXmlDomElement* _tmp2_;
	GXmlDomElement* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 1548 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1548 "../core/Services/Todoist.vala"
	g_return_if_fail (doc != NULL);
#line 1549 "../core/Services/Todoist.vala"
	http_response_set_status (self, FALSE);
#line 1550 "../core/Services/Todoist.vala"
	http_response_set_error_code (self, error_code);
#line 1551 "../core/Services/Todoist.vala"
	http_response_set_http_code (self, error_code);
#line 1552 "../core/Services/Todoist.vala"
	_tmp0_ = gxml_dom_document_get_elements_by_tag_name (doc, "o:hint");
#line 1552 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 1552 "../core/Services/Todoist.vala"
	_tmp2_ = gxml_dom_html_collection_get_element (_tmp1_, 0);
#line 1552 "../core/Services/Todoist.vala"
	_tmp3_ = _tmp2_;
#line 1552 "../core/Services/Todoist.vala"
	_tmp4_ = gxml_dom_node_get_text_content ((GXmlDomNode*) _tmp3_);
#line 1552 "../core/Services/Todoist.vala"
	_tmp5_ = _tmp4_;
#line 1552 "../core/Services/Todoist.vala"
	_tmp6_ = _tmp5_;
#line 1552 "../core/Services/Todoist.vala"
	http_response_set_error (self, _tmp6_);
#line 1552 "../core/Services/Todoist.vala"
	_g_free0 (_tmp6_);
#line 1552 "../core/Services/Todoist.vala"
	_g_object_unref0 (_tmp3_);
#line 1552 "../core/Services/Todoist.vala"
	_g_object_unref0 (_tmp1_);
#line 12915 "Todoist.c"
}

HttpResponse*
http_response_construct (GType object_type)
{
	HttpResponse* self = NULL;
#line 1532 "../core/Services/Todoist.vala"
	self = (HttpResponse*) g_type_create_instance (object_type);
#line 1532 "../core/Services/Todoist.vala"
	return self;
#line 12926 "Todoist.c"
}

HttpResponse*
http_response_new (void)
{
#line 1532 "../core/Services/Todoist.vala"
	return http_response_construct (TYPE_HTTP_RESPONSE);
#line 12934 "Todoist.c"
}

gboolean
http_response_get_status (HttpResponse* self)
{
	gboolean result;
#line 1533 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1533 "../core/Services/Todoist.vala"
	result = self->priv->_status;
#line 1533 "../core/Services/Todoist.vala"
	return result;
#line 12947 "Todoist.c"
}

void
http_response_set_status (HttpResponse* self,
                          gboolean value)
{
#line 1533 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1533 "../core/Services/Todoist.vala"
	self->priv->_status = value;
#line 12958 "Todoist.c"
}

const gchar*
http_response_get_error (HttpResponse* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1534 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "../core/Services/Todoist.vala"
	_tmp0_ = self->priv->_error;
#line 1534 "../core/Services/Todoist.vala"
	result = _tmp0_;
#line 1534 "../core/Services/Todoist.vala"
	return result;
#line 12974 "Todoist.c"
}

void
http_response_set_error (HttpResponse* self,
                         const gchar* value)
{
	gchar* _tmp0_;
#line 1534 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1534 "../core/Services/Todoist.vala"
	_tmp0_ = g_strdup (value);
#line 1534 "../core/Services/Todoist.vala"
	_g_free0 (self->priv->_error);
#line 1534 "../core/Services/Todoist.vala"
	self->priv->_error = _tmp0_;
#line 12990 "Todoist.c"
}

gint
http_response_get_error_code (HttpResponse* self)
{
	gint result;
#line 1535 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1535 "../core/Services/Todoist.vala"
	result = self->priv->_error_code;
#line 1535 "../core/Services/Todoist.vala"
	return result;
#line 13003 "Todoist.c"
}

void
http_response_set_error_code (HttpResponse* self,
                              gint value)
{
#line 1535 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1535 "../core/Services/Todoist.vala"
	self->priv->_error_code = value;
#line 13014 "Todoist.c"
}

gint
http_response_get_http_code (HttpResponse* self)
{
	gint result;
#line 1536 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1536 "../core/Services/Todoist.vala"
	result = self->priv->_http_code;
#line 1536 "../core/Services/Todoist.vala"
	return result;
#line 13027 "Todoist.c"
}

void
http_response_set_http_code (HttpResponse* self,
                             gint value)
{
#line 1536 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1536 "../core/Services/Todoist.vala"
	self->priv->_http_code = value;
#line 13038 "Todoist.c"
}

const gchar*
http_response_get_data (HttpResponse* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1538 "../core/Services/Todoist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1538 "../core/Services/Todoist.vala"
	_tmp0_ = self->priv->_data;
#line 1538 "../core/Services/Todoist.vala"
	result = _tmp0_;
#line 1538 "../core/Services/Todoist.vala"
	return result;
#line 13054 "Todoist.c"
}

void
http_response_set_data (HttpResponse* self,
                        const gchar* value)
{
	gchar* _tmp0_;
#line 1538 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1538 "../core/Services/Todoist.vala"
	_tmp0_ = g_strdup (value);
#line 1538 "../core/Services/Todoist.vala"
	_g_free0 (self->priv->_data);
#line 1538 "../core/Services/Todoist.vala"
	self->priv->_data = _tmp0_;
#line 13070 "Todoist.c"
}

void
http_response_get_data_object (HttpResponse* self,
                               GValue * result)
{
	GValue _tmp0_;
#line 1539 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1539 "../core/Services/Todoist.vala"
	_tmp0_ = self->priv->_data_object;
#line 1539 "../core/Services/Todoist.vala"
	*result = _tmp0_;
#line 1539 "../core/Services/Todoist.vala"
	return;
#line 13086 "Todoist.c"
}

void
http_response_set_data_object (HttpResponse* self,
                               GValue * value)
{
	GValue _tmp0_;
	GValue _tmp1_;
	GValue _tmp2_ = {0};
#line 1539 "../core/Services/Todoist.vala"
	g_return_if_fail (self != NULL);
#line 1539 "../core/Services/Todoist.vala"
	_tmp0_ = *value;
#line 1539 "../core/Services/Todoist.vala"
	_tmp1_ = _tmp0_;
#line 1539 "../core/Services/Todoist.vala"
	if (G_IS_VALUE (&_tmp1_)) {
#line 1539 "../core/Services/Todoist.vala"
		g_value_init (&_tmp2_, G_VALUE_TYPE (&_tmp1_));
#line 1539 "../core/Services/Todoist.vala"
		g_value_copy (&_tmp1_, &_tmp2_);
#line 13108 "Todoist.c"
	} else {
#line 1539 "../core/Services/Todoist.vala"
		_tmp2_ = _tmp1_;
#line 13112 "Todoist.c"
	}
#line 1539 "../core/Services/Todoist.vala"
	G_IS_VALUE (&self->priv->_data_object) ? (g_value_unset (&self->priv->_data_object), NULL) : NULL;
#line 1539 "../core/Services/Todoist.vala"
	self->priv->_data_object = _tmp2_;
#line 13118 "Todoist.c"
}

static void
value_http_response_init (GValue* value)
{
#line 1532 "../core/Services/Todoist.vala"
	value->data[0].v_pointer = NULL;
#line 13126 "Todoist.c"
}

static void
value_http_response_free_value (GValue* value)
{
#line 1532 "../core/Services/Todoist.vala"
	if (value->data[0].v_pointer) {
#line 1532 "../core/Services/Todoist.vala"
		http_response_unref (value->data[0].v_pointer);
#line 13136 "Todoist.c"
	}
}

static void
value_http_response_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 1532 "../core/Services/Todoist.vala"
	if (src_value->data[0].v_pointer) {
#line 1532 "../core/Services/Todoist.vala"
		dest_value->data[0].v_pointer = http_response_ref (src_value->data[0].v_pointer);
#line 13148 "Todoist.c"
	} else {
#line 1532 "../core/Services/Todoist.vala"
		dest_value->data[0].v_pointer = NULL;
#line 13152 "Todoist.c"
	}
}

static gpointer
value_http_response_peek_pointer (const GValue* value)
{
#line 1532 "../core/Services/Todoist.vala"
	return value->data[0].v_pointer;
#line 13161 "Todoist.c"
}

static gchar*
value_http_response_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 1532 "../core/Services/Todoist.vala"
	if (collect_values[0].v_pointer) {
#line 13172 "Todoist.c"
		HttpResponse * object;
		object = collect_values[0].v_pointer;
#line 1532 "../core/Services/Todoist.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1532 "../core/Services/Todoist.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13179 "Todoist.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1532 "../core/Services/Todoist.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13183 "Todoist.c"
		}
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = http_response_ref (object);
#line 13187 "Todoist.c"
	} else {
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = NULL;
#line 13191 "Todoist.c"
	}
#line 1532 "../core/Services/Todoist.vala"
	return NULL;
#line 13195 "Todoist.c"
}

static gchar*
value_http_response_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	HttpResponse ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1532 "../core/Services/Todoist.vala"
	if (!object_p) {
#line 1532 "../core/Services/Todoist.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 13210 "Todoist.c"
	}
#line 1532 "../core/Services/Todoist.vala"
	if (!value->data[0].v_pointer) {
#line 1532 "../core/Services/Todoist.vala"
		*object_p = NULL;
#line 13216 "Todoist.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1532 "../core/Services/Todoist.vala"
		*object_p = value->data[0].v_pointer;
#line 13220 "Todoist.c"
	} else {
#line 1532 "../core/Services/Todoist.vala"
		*object_p = http_response_ref (value->data[0].v_pointer);
#line 13224 "Todoist.c"
	}
#line 1532 "../core/Services/Todoist.vala"
	return NULL;
#line 13228 "Todoist.c"
}

GParamSpec*
param_spec_http_response (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecHttpResponse* spec;
#line 1532 "../core/Services/Todoist.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HTTP_RESPONSE), NULL);
#line 1532 "../core/Services/Todoist.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1532 "../core/Services/Todoist.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1532 "../core/Services/Todoist.vala"
	return G_PARAM_SPEC (spec);
#line 13247 "Todoist.c"
}

gpointer
value_get_http_response (const GValue* value)
{
#line 1532 "../core/Services/Todoist.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE), NULL);
#line 1532 "../core/Services/Todoist.vala"
	return value->data[0].v_pointer;
#line 13257 "Todoist.c"
}

void
value_set_http_response (GValue* value,
                         gpointer v_object)
{
	HttpResponse * old;
#line 1532 "../core/Services/Todoist.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE));
#line 1532 "../core/Services/Todoist.vala"
	old = value->data[0].v_pointer;
#line 1532 "../core/Services/Todoist.vala"
	if (v_object) {
#line 1532 "../core/Services/Todoist.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTTP_RESPONSE));
#line 1532 "../core/Services/Todoist.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = v_object;
#line 1532 "../core/Services/Todoist.vala"
		http_response_ref (value->data[0].v_pointer);
#line 13279 "Todoist.c"
	} else {
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = NULL;
#line 13283 "Todoist.c"
	}
#line 1532 "../core/Services/Todoist.vala"
	if (old) {
#line 1532 "../core/Services/Todoist.vala"
		http_response_unref (old);
#line 13289 "Todoist.c"
	}
}

void
value_take_http_response (GValue* value,
                          gpointer v_object)
{
	HttpResponse * old;
#line 1532 "../core/Services/Todoist.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE));
#line 1532 "../core/Services/Todoist.vala"
	old = value->data[0].v_pointer;
#line 1532 "../core/Services/Todoist.vala"
	if (v_object) {
#line 1532 "../core/Services/Todoist.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTTP_RESPONSE));
#line 1532 "../core/Services/Todoist.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = v_object;
#line 13310 "Todoist.c"
	} else {
#line 1532 "../core/Services/Todoist.vala"
		value->data[0].v_pointer = NULL;
#line 13314 "Todoist.c"
	}
#line 1532 "../core/Services/Todoist.vala"
	if (old) {
#line 1532 "../core/Services/Todoist.vala"
		http_response_unref (old);
#line 13320 "Todoist.c"
	}
}

static void
http_response_class_init (HttpResponseClass * klass,
                          gpointer klass_data)
{
#line 1532 "../core/Services/Todoist.vala"
	http_response_parent_class = g_type_class_peek_parent (klass);
#line 1532 "../core/Services/Todoist.vala"
	((HttpResponseClass *) klass)->finalize = http_response_finalize;
#line 1532 "../core/Services/Todoist.vala"
	g_type_class_adjust_private_offset (klass, &HttpResponse_private_offset);
#line 13334 "Todoist.c"
}

static void
http_response_instance_init (HttpResponse * self,
                             gpointer klass)
{
	gchar* _tmp0_;
#line 1532 "../core/Services/Todoist.vala"
	self->priv = http_response_get_instance_private (self);
#line 1534 "../core/Services/Todoist.vala"
	_tmp0_ = g_strdup ("");
#line 1534 "../core/Services/Todoist.vala"
	self->priv->_error = _tmp0_;
#line 1535 "../core/Services/Todoist.vala"
	self->priv->_error_code = 0;
#line 1536 "../core/Services/Todoist.vala"
	self->priv->_http_code = 0;
#line 1532 "../core/Services/Todoist.vala"
	self->ref_count = 1;
#line 13354 "Todoist.c"
}

static void
http_response_finalize (HttpResponse * obj)
{
	HttpResponse * self;
#line 1532 "../core/Services/Todoist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HTTP_RESPONSE, HttpResponse);
#line 1532 "../core/Services/Todoist.vala"
	g_signal_handlers_destroy (self);
#line 1534 "../core/Services/Todoist.vala"
	_g_free0 (self->priv->_error);
#line 1538 "../core/Services/Todoist.vala"
	_g_free0 (self->priv->_data);
#line 1539 "../core/Services/Todoist.vala"
	G_IS_VALUE (&self->priv->_data_object) ? (g_value_unset (&self->priv->_data_object), NULL) : NULL;
#line 13371 "Todoist.c"
}

static GType
http_response_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_http_response_init, value_http_response_free_value, value_http_response_copy_value, value_http_response_peek_pointer, "p", value_http_response_collect_value, "p", value_http_response_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HttpResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) http_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HttpResponse), 0, (GInstanceInitFunc) http_response_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType http_response_type_id;
	http_response_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HttpResponse", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HttpResponse_private_offset = g_type_add_instance_private (http_response_type_id, sizeof (HttpResponsePrivate));
	return http_response_type_id;
}

GType
http_response_get_type (void)
{
	static volatile gsize http_response_type_id__once = 0;
	if (g_once_init_enter (&http_response_type_id__once)) {
		GType http_response_type_id;
		http_response_type_id = http_response_get_type_once ();
		g_once_init_leave (&http_response_type_id__once, http_response_type_id);
	}
	return http_response_type_id__once;
}

gpointer
http_response_ref (gpointer instance)
{
	HttpResponse * self;
	self = instance;
#line 1532 "../core/Services/Todoist.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1532 "../core/Services/Todoist.vala"
	return instance;
#line 13407 "Todoist.c"
}

void
http_response_unref (gpointer instance)
{
	HttpResponse * self;
	self = instance;
#line 1532 "../core/Services/Todoist.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1532 "../core/Services/Todoist.vala"
		HTTP_RESPONSE_GET_CLASS (self)->finalize (self);
#line 1532 "../core/Services/Todoist.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 13421 "Todoist.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

